angular.module('btapp',[ 'ionic', 'ngCordova','pascalprecht.translate', 'btapp.controllers', 'btapp.services',
		'btapp.config','btapp.factorys','ionic-datepicker','ionic-timepicker','btapp.caches']).run(
	function($ionicPlatform,$rootScope,$location,$cordovaToast,$ionicHistory,$timeout,$ionicPopup,$ionicLoading,
			$cordovaAppVersion, $cordovaFileTransfer, $cordovaFile, $cordovaFileOpener2, $cordovaNetwork, hlService, ENV) {
		$ionicPlatform.ready(function() {
			if (window.cordova && window.cordova.plugins
					&& window.cordova.plugins.Keyboard) {
				cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
				cordova.plugins.Keyboard.disableScroll(true);
			}
			if (window.cordova && StatusBar){
		        StatusBar.backgroundColorByHexString('#071F3B');
			}
			if(window.cordova && window.cordova.InAppBrowser){
				
				window.open = window.cordova.InAppBrowser.open;
			}
			if(ionic.Platform.isAndroid()){
				// 检查更新
			    checkUpdate();
			}
			
			document.addEventListener('deviceready', function () {
				cordova.plugins.backgroundMode.setDefaults({ 
					title : '提示',
					text : '程序将在后台运行',
					ticker : '运行提示'
				});
				cordova.plugins.backgroundMode.enable();
			    cordova.plugins.backgroundMode.onactivate = function () {
			        setTimeout(function () {
			        	cordova.plugins.backgroundMode.configure({
			                text:'Running in background for more than 5s now.'
			            });
			        }, 60000);
			    };
			    
			    $rootScope.networkState = $cordovaNetwork.getNetwork();

			    // 监听手机网络在线事件
			    $rootScope.$on('$cordovaNetwork:online', function(event, networkState){
			    	$rootScope.networkState = networkState;
			    });

			    // 监听手机网络离线事件
			    $rootScope.$on('$cordovaNetwork:offline', function(event, networkState){
			    	$rootScope.networkState = networkState;
			    });
			    
			}, false);
		}); 
		$ionicPlatform.registerBackButtonAction(function(e) {
			// 判断处于哪个页面时双击退出
			
			if (containsRootPath($location.path())) {
				if ($rootScope.backButtonPressedOnceToExit) {
					if($rootScope.bluetooth){
						$rootScope.bluetooth.disconnect();
						$rootScope.bluetooth="";
					}
					var now = new Date();
					var random = now.getTime();
					/*hlService.home.syncSeverTime(random).get(function(res){
						window.localStorage.upateTime = res.time;
						ionic.Platform.exitApp();
					}, function(res){
						ionic.Platform.exitApp();
					});*/
					ionic.Platform.exitApp();
					
				} else {
					$rootScope.backButtonPressedOnceToExit = true;
					$cordovaToast.showShortBottom(constantDefine.app_backMsg);
					setTimeout(function() {
						$rootScope.backButtonPressedOnceToExit = false;
					}, 2000);
				}
			} else if ($ionicHistory.backView()) {
				$rootScope.bluetooth.isInstalling = false;
				$ionicHistory.goBack();
			} else {
				$rootScope.backButtonPressedOnceToExit = true;
				$cordovaToast.showShortBottom(constantDefine.app_backMsg);
				setTimeout(function() {
					$rootScope.backButtonPressedOnceToExit = false;
				}, 2000);
			}
			e.preventDefault();
			return false;
		}, 101);

		// 退出系统时判断退出的条件
		function containsRootPath(path) {
			if (path == '/login' || path == '/home' || path == '/testHome') {
				return true;
			}
			return false;
		}
		
		// 检查更新
	    function checkUpdate() {
	        //获取版本
	    	window.cordova.getAppVersion.getVersionNumber(function(version) {
	    		var downloadDir = ENV.useplace;
	        	hlService.appVersion.release(downloadDir).get({},function(res){
	        		if(res.versionNumber != version){
	                	showUpdateConfirm(res);
	            	}
	        	},function(res){});
	        });
	    }
	    // 显示是否更新对话框
	    function showUpdateConfirm(appVersion) {
	        var confirmPopup = $ionicPopup.confirm({
	            title: constantDefine.app_updateTitle,
	            template: appVersion.logs, //从服务端获取更新的内容
	            cancelText: constantDefine.app_updateCancleText,
	            okText: constantDefine.app_updateOkText
	        });
	        confirmPopup.then(function (res) {
	            if (res) {
	                $ionicLoading.show({
	                    template: constantDefine.app_downloadProgress + "0%"
	                });
	                var url = ENV.download + '/' + appVersion.apkName; //从服务端获取更新APP的路径
	                var targetPath = "file:///storage/sdcard0/Download/" + appVersion.apkName; //APP下载存放的路径
	                var trustHosts = true;
	                var options = {};
	        		$cordovaFile.createDir(cordova.file.externalRootDirectory, "leaf", true)
	        	      .then(function (success) {
	        	    	  targetPath = success.nativeURL + appVersion.apkName;
	        	    	  $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function (result) {
	        	    		  // 打开下载下来的APP
	                          $cordovaFileOpener2.open(result.nativeURL, 'application/vnd.android.package-archive')
	                          .then(function () {
	                              // 成功
	                          	//alert("版本更新日志输出");
	                          }, function (err) {
	                              // 错误
	                        	  $cordovaToast.showShortCenter(constantDefine.app_installErr + JSON.stringify(err));
	                          });
	                          
	                          $ionicLoading.hide();
	                          
	                      }, function (err) {
	                    	  $cordovaToast.showShortCenter(constantDefine.app_downloadErr + JSON.stringify(err));
	                          $ionicLoading.hide();
	                      }, function (progress) {
	                          //进度，这里使用文字显示下载百分比
	                          $timeout(function () {
	                              var downloadProgress = (progress.loaded / progress.total) * 100;
	                              $ionicLoading.show({
	                                  template: constantDefine.app_downloadProgress + Math.floor(downloadProgress) + "%"
	                              });
	                              if (downloadProgress > 99) {
	                                  $ionicLoading.hide();
	                              }
	                          });
	                      });
	        
	        	      }, function (err) {
	        	    	  $cordovaToast.showShortCenter(constantDefine.app_createDirErr + JSON.stringify(err));
	        	    	  $ionicLoading.hide();
	        	      });
	            } else {
	                // 取消更新
	            }
	        });
	    }
})

.config(function($stateProvider, $urlRouterProvider,$ionicConfigProvider,$translateProvider) {
	//禁用苹果左边框右滑返回功能
	$ionicConfigProvider.views.swipeBackEnabled(false);		
	
	//设置本地化语言
    $translateProvider
    .translations('zh-cn', zh_CN) //注册语言
    .translations('en-us',en_US);
    if(navigator.language){  //获取本地语言环境
    	$translateProvider.preferredLanguage(navigator.language.toLocaleLowerCase() ); //设置语言
    }else{
    	$translateProvider.preferredLanguage("zh-cn"); //默认设置为中文
    }
	
	$stateProvider.state('login', {
		cache : false,
		url : "/login",
		templateUrl : "pages/login.html",
		controller : "common.login"
	}).state('home', {
		cache : false,
		url : "/home",
		templateUrl : "pages/home1.html",
		controller : "common.home"
	}).state('testHome', {
		cache : false,
		url : "/testHome",
		templateUrl : "pages/testHome.html",
		controller : "common.home"
	}).state('monitor', {
		url : '/monitor',
		templateUrl : 'pages/monitor.html',
		controller : 'MonitorCtrl'
	}).state('hisData',{
		cache : false,
		url : "/hisData",
		templateUrl : 'pages/hisData.html',
		controller : 'common.hisData'
	}).state('hisDataAdmin',{//fangrong 新增管理员特殊权限
		cache : true,
		url : "/hisDataAdmin",
		templateUrl : 'pages/hisDataAdmin.html',
		controller : 'common.hisDataAdmin'
	}).state('hisDataAdmin1',{
		cache : true,
		url : "/hisDataAdmin1",
		templateUrl : 'pages/hisDataAdmin1.html',
		controller : 'common.hisDataAdmin1'
	}).state('hisdatas',{
		cache : true,
		url : "/hisdatas",
		templateUrl : 'pages/hisdatas.html',
		controller : 'common.hisdatas'
	}).state('permData',{
		cache : false,
		url : "/permData",
		templateUrl : 'pages/permData.html',
		controller : 'common.permData'
	}).state('permissions',{
		cache : true,
		url : "/permissions",
		templateUrl : 'pages/permissions.html',
		controller : 'common.permissions'
	}).state('locationData',{
		cache : false,
		url : "/locationData/:lng/:lat",
		templateUrl : 'pages/location.html',
		controller : 'common.mapData'
	}).state('mapLead',{
		cache : false,
		url : "/mapLead",
		templateUrl : 'pages/leadMap.html',
		controller : 'common.mapLead'
	}).state('installLocksetView',{
		cache : false,
		url : "/installLocksetView",
		templateUrl : 'pages/installLocksetView.html',
		controller : 'common.installLocksetView'
	}).state('installLockset',{
		cache : false,
		url : "/installLockset",
		templateUrl : 'pages/installLockset.html',
		controller : 'common.installLockset'
	}).state('installLockset1',{
		cache : false,
		url : "/installLockset1",
		templateUrl : 'pages/installLockset1.html',
		controller : 'common.installLockset1'
	}).state('installLocksetResult',{
		cache : false,
		url : "/installLocksetResult/:lockId/:success",
		templateUrl : 'pages/installLocksetResult.html',
		controller : 'common.installLocksetResult'
	}).state('selectDevice',{
		cache : false,
		url : "/selectDevice",
		templateUrl : 'pages/selectDevice.html',
		controller : 'common.selectDevice'
	}).state('recoverLocksetView',{
		cache : false,
		url : "/recoverLocksetView",
		templateUrl : 'pages/recoverLocksetView.html',
		controller : 'common.recoverLocksetView'
	}).state('recoverLockset',{
		cache : false,
		url : "/recoverLockset",
		templateUrl : 'pages/recoverLockset.html',
		controller : 'common.recoverLockset'
	}).state('recoverLocksetResult',{
		cache : false,
		url : "/recoverLocksetResult/:lockId/:success",
		templateUrl : 'pages/recoverLocksetResult.html',
		controller : 'common.recoverLocksetResult'
	}).state('initLocksetDepend0',{
		cache : false,
		url : "/initLocksetDepend0",
		templateUrl : 'pages/initLocksetDepend0.html',
		controller : 'common.initLocksetDepend0'
	}).state('initLocksetDepend1',{
		cache : false,
		url : "/initLocksetDepend1",
		templateUrl : 'pages/initLocksetDepend1.html',
		controller : 'common.initLocksetDepend1'
	}).state('keyManage', {
		cache : false,
		url : "/keyManage",
		templateUrl : "pages/manage/keyManage.html",
		controller : "manage.key"
	}).state('addKey', {
		cache : false,
		url : "/addOrUpdate/:keyId/:name/:macAddr",
		templateUrl : "pages/manage/addOrUpdateKey.html",
		controller : "manage.addKey"
	}).state('deviceManage', {
		cache : false,
		url : "/deviceManage",
		templateUrl : "pages/manage/deviceManage.html",
		controller : "manage.device"
	}).state('addDevice', {
		cache : false,
		url : "/addOrUpdateDevice/:deviceId/:deviceName/:areaId/:location",
		templateUrl : "pages/manage/addOrUpdateDevice.html",
		controller : "manage.addDevice"
	}).state('userManage', {
		cache : false,
		url : "/userManage",
		templateUrl : "pages/manage/userManage.html",
		controller : "manage.user"
	}).state('addUser', {
		cache : false,
		url : "/addOrUpdateUser/:user",
		templateUrl : "pages/manage/addOrUpdateUser.html",
		controller : "manage.addUser"
	}).state('userGroupList', {
		cache : false,
		url : "/userGroupList/:user",
		templateUrl : "pages/manage/userGroupList.html",
		controller : "manage.userGroupList"
	}).state('userTitleList', {
		cache : false,
		url : "/userTitleList/:user",
		templateUrl : "pages/manage/userTitleList.html",
		controller : "manage.userTitleList"
	}).state('blKeyList', {
		cache : false,
		url : "/blKeyList/:user",
		templateUrl : "pages/manage/blKeyList.html",
		controller : "manage.blKeyList"
	}).state('permissionManage', {
		cache : false,
		url : "/permissionManage",
		templateUrl : "pages/manage/permissionManage.html",
		controller : "manage.permission"
	}).state('addPermission', {
		cache : false,
		url : "/addOrUpdatePermission/:permission",
		templateUrl : "pages/manage/addOrUpdatePerm.html",
		controller : "manage.addPerm"
	}).state('selectDeviceList', {
		cache : false,
		url : "/selectDeviceList/:permission",
		templateUrl : "pages/manage/pubDeviceSelectList.html",
		controller : "manage.selectDevice"
	}).state('selectUserList', {
		cache : false,
		url : "/selectUserList/:permission",
		templateUrl : "pages/manage/teamUserSelectList.html",
		controller : "manage.selectUser"
	}).state('areaManage', {
		cache : false,
		url : "/areaManage",
		templateUrl : "pages/manage/areaManage.html",
		controller : "manage.area"
	}).state('addArea', {
		cache : false,
		url : "/addOrUpdateArea/:areaId/:description",
		templateUrl : "pages/manage/addOrUpdateArea.html",
		controller : "manage.addArea"
	}).state('groupManage', {
		cache : false,
		url : "/groupManage",
		templateUrl : "pages/manage/groupManage.html",
		controller : "manage.group"
	}).state('addGroup', {
		cache : false,
		url : "/addOrUpdateGroup/:groupId/:description",
		templateUrl : "pages/manage/addOrUpdateGroup.html",
		controller : "manage.addGroup"
	}).state('titleManage', {
		cache : false,
		url : "/titleManage",
		templateUrl : "pages/manage/titleManage.html",
		controller : "manage.title"
	}).state('addTitle', {
		cache : false,
		url : "/addOrUpdateTitle/:titleId/:description",
		templateUrl : "pages/manage/addOrUpdateTitle.html",
		controller : "manage.addTitle"
	}).state('forget', {
        cache:false,
        url: "/forget",
        templateUrl: "pages/forget.html",
        controller: "common.forget"
    }).state('resetPassword',{
        cache : false,
        url : "/resetPassword",
        templateUrl : 'pages/resetPassword.html',
        controller:"common.resetPassword"
    });

	// if none of the above states are matched, use this as the fallback
	$urlRouterProvider.otherwise('/login');

});

angular.module('btapp.controllers', [ 'btapp.services','btapp.caches','btapp.factorys' ]);
angular.module('btapp.services', [ 'ngResource', 'btapp.config' ]);
angular.module('btapp.config',[]);
angular.module('btapp.caches',[]);
angular.module('btapp.factorys',['btapp.caches','btapp.services']);

