angular.module('btapp.factorys',[]).factory('ssBlKey', function($rootScope,$cordovaToast,hlService) {
		
		var Bluetooth = {
			/**
			 * 蓝牙设备连接名
			 * */
			keyName : '',
			/**
	    	 * 蓝牙设备id
	    	 * */
	    	deviceId : '',
	    	/**
    		 * 是否进行蓝牙扫描
    		 * */
	    	scanFlag : true,
	    	/**
	    	 * 是否网络在线
	    	 * */
	    	online : true, 
	    	/**
	    	 * 是否连接过
	    	 * */
	    	connected : false, 
	    	/**
	    	 * 是否为挂锁模式
	    	 * */
	    	isInstalling : false,
	    	/**
	    	 * 是否初始化入库模式
	    	 * */
	    	isInit : false,
	    	/**
	    	 * 是否维护模式
	    	 * */
	    	isMain : true, 
	    	/**
	    	 * 是否回收模式
	    	 * */
	    	isReturn : false,
	    	/**
	    	 * 异或校验算法钥匙信息
	    	 * */
	    	key : "00 01 02 03 04 05 06 07",
	    	/**
	    	 * 通信连接状态
	    	 * */
	    	status : '',
	    	
		    scanDevice : function(){
		    	//$rootScope.Object = this;
		    	ble.scan([], 5,this.onScanDevice, this.scanError);
		    },
		    
		    onScanDevice : function(device){
		    	if(device.name == $rootScope.bluetooth.keyName){
		    		$rootScope.bluetooth.deviceId = device.id;
		    		$rootScope.bluetooth.connect();
		    	}
		    },
		    
		    scanError : function(res){
		    	$rootScope.bluetooth.status = "扫描失败";
		    	
		    },
		    connError : function(res){
		    	$rootScope.bluetooth.status = "扫描连接失败";
		    },
		    
		    
		    onError : function(reason){
		    	$rootScope.bluetooth.status = "通信出错";
		    	//$rootScope.bluetooth.disconnect();
		    },
		    
		    connect: function() {
		        ble.connect(this.deviceId, this.onConnect, this.connError);
		    },
		    /**
			 * 蓝牙通讯连接后启动通道监听
			 * */
			onConnect : function(peripheral){
				$rootScope.bluetooth.determineServiceType(peripheral);
				ble.startNotification($rootScope.bluetooth.deviceId, $rootScope.bluetooth.serviceUUID, $rootScope.bluetooth.notifyCharacteristicUUID, $rootScope.bluetooth.onData, $rootScope.bluetooth.onError);
				$rootScope.bluetooth.status = "已连接";
			},
			/**
			 * 通道信息解析
			 * */
			determineServiceType: function(peripheral) {
				peripheral.characteristics.filter(function(element) {
					var properties = element.properties;
					for(var i=0;i<properties.length;i++){
						var prop = properties[i];
						if("notify" == prop.toLowerCase()){
							$rootScope.bluetooth.serviceUUID = element.service;
							$rootScope.bluetooth.notifyCharacteristicUUID = element.characteristic;
						} else if("write" == prop.toLowerCase()){
							$rootScope.bluetooth.serviceUUID = element.service;
							$rootScope.bluetooth.characteristicUUID = element.characteristic;
						}
					}
					if($rootScope.bluetooth.notifyCharacteristicUUID && $rootScope.bluetooth.characteristicUUID){
						return;
					}
		        })[0];
		    },
			/**
			 * 通知监听处理
			 * */
		    onData : function(buffer){
		    	$rootScope.bluetooth.parseResult($rootScope.bluetooth.bytesToString(buffer));
		    },
		    /**
		     * 参数： 十六进制数
		     * 异或校验运算 结果返回十进制数
		     * */
		    XorCheck : function(Data,Length){
	    	    var sum=0,i;
	    	    for(var i=0; i<Length; i++)
	    	    {
	    	        sum ^= Data[i]; 
	    	    }
	    	    return sum;
	    	},
	    	/**
	    	 * 参数： 十六进制数
	    	 * 加密算法  结果返回十进制数
	    	 * */
		    HloveyRC4 : function(aInput, aKey) {
		    	var iS = new Uint8Array(256);
	    	    var iK = new Uint8Array(256);
	    	    for (var i = 0; i < 256; i++)
	    	        iS[i] = i;
	    	    var j = 1;
	    	    for (var i = 0; i < 256; i++){
	    	        iK[i] = aKey[(i % aKey.length)];
	    	    }
	    	    j = 0;
	    	    for (var i = 0; i < 256; i++) {
	    	        j = (j + iS[i]&0xff + iK[i]&0xff) % 256;
	    	        var temp = iS[i];
	    	        iS[i] = iS[j];
	    	        iS[j] = temp;
	    	    }
	    	    var i = 0;
	    	    j = 0;
	    	    var iOutputChar = new Uint8Array(aInput.length);
	    	    for (var x = 0; x < iOutputChar.length; x++) {
	    	        i = (i + 1) % 256;
	    	        j = (j + iS[i]&0xff) % 256;
	    	        var temp = iS[i]&0xff;
	    	        iS[i] = iS[j];
	    	        iS[j] = temp;
	    	        var t = (iS[i] + (iS[j]&0xff % 256)) % 256;
	    	        var iY = iS[t]&0xff;
	    	        var iCY =  iY;
	    	        iOutputChar[x] = aInput[x] ^ iCY;
	    	    }
	    	    return iOutputChar;
			},
			/**
			 * 参数：ArrayBuffer
			 * 结果：十进制转十六进制
			 * */
		    bytesToString : function(buffer) {
		    	var a = new Uint8Array(buffer);
				 var data = [];
				 for(var i=0;i<a.length;i++){
					 data[i] = $rootScope.bluetooth.decimalRadixToHex(a[i]);
				 }
				 return data;
			},
			/**
			 * 参数：十六进制参数字符串，已空格分开
			 * 结果：无符号十六进制数数组
			 * */
			stringToBytes : function(string) {
				 var arr = string.split(" ");
				 var array = new Uint8Array(arr.length);
				 for (var i = 0; i < arr.length;i++) {
					 array[i] = '0x' + arr[i];
				 }
				 return array;
			},
			/**
			 * 十六进制转十进制数
			 * 参数：十六进制数
			 * 结果：十进制数
			 * */
			hexRadixToDecimal : function(num){
				return parseInt(num, 16);
			},
			/**
			 * 十进制数转十六进制数
			 * 参数：十进制数
			 * 结果：十六进制数
			 * */
			decimalRadixToHex : function(num){
				return num.toString(16);
			},
			
			/**
			 * 安装锁具地址信息获取操作
			 * */
			installLock : function(installTime,timeFormate){
				if(this.online){
					var geolocation = new BMap.Geolocation();
	    			geolocation.getCurrentPosition(function(r){
	    				if(this.getStatus() == BMAP_STATUS_SUCCESS){
	    					var geoc = new BMap.Geocoder();  
	    					var point = new BMap.Point(r.point.lng,r.point.lat);
	    					geoc.getLocation(point, function(rs){
	    						var addComp = rs.addressComponents;
	    						
		    					$rootScope.Lockset = {
		    						lockId : $rootScope.lockId,
		    						installer : window.localStorage.userId,
		    						installName : window.localStorage.userName,
		    						time : installTime,
		    						timeFormate : timeFormate,
		    						longitude : r.point.lng,
		    						latitude : r.point.lat,
		    						location : addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber
		    					}
	    					});
	    				} else {
	    					$rootScope.showPopup("地址定位失败：" + this.getStatus());
	    				}        
	    			},{enableHighAccuracy: true});
				} else {
					$rootScope.Lockset = {
						lockId : $rootScope.lockId,
						installer : window.localStorage.userId,
						installName : window.localStorage.userName,
						time : installTime,
						timeFormate : timeFormate
						//longitude : r.point.lng,
						//latitude : r.point.lat,
						//location : addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber
					}
				}
			},
			/**
			 * 回收锁具参数设置
			 * */
			setRecoverParams : function(res){
				var device = res.device;
    			var time = res.device["time"] * 1000;
				var dateTime = new Date(time);
				var m = (dateTime.getMonth()+1) < 10 ? '0'+(dateTime.getMonth()+1) : (dateTime.getMonth()+1);
		    	var d = dateTime.getDate() < 10 ? '0'+ dateTime.getDate() : dateTime.getDate();
		    	var h = dateTime.getHours() < 10 ? '0' + dateTime.getHours() : dateTime.getHours();
		    	var min = dateTime.getMinutes() < 10 ? '0' + dateTime.getMinutes() : dateTime.getMinutes();
		    	var s = dateTime.getSeconds() < 10 ? '0' + dateTime.getSeconds() : dateTime.getSeconds();
				var timeFormate = dateTime.getFullYear()+"-"+m+"-"+d+" "
								+ h + ":" + min + ":" + s;
				
				$rootScope.recover = {
					lockId : $rootScope.lockId,
					deviceId : device.deviceId,
					deviceName : device.deviceName,
					installer : device.installer,
					installName : device.installUser.name,
					time : device.time,
					timeFormate : timeFormate,
					longitude : device.longitude,
					latitude : device.latitude,
					location : device.location
				}
			},
			/**
			 * 接收报文解析
			 * */
		    parseResult : function(result){
		    	var that = this;
		    	if(result[0] == 6){
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n接收到报文—— (1)");
		    		var dataLength = parseInt(result[1]);//报文数据长度
		    		var bwDatas = [];
		    		for(var i=0;i<dataLength;i++){
		    			var bwData = result[i+2];
		    			bwDatas.push(bwData);  //十六进制数据位
		    		}
		    		var secretData = that.HloveyRC4(that.stringToBytes(bwDatas.join(" ")), that.stringToBytes(that.key));
		    		var secretCheck = that.XorCheck(secretData.subarray(0,secretData.length-1), secretData.length-1);
		    		var newSecretData = new Uint8Array(secretData.length + 1);
		    		secretData[secretData.length-1] = secretCheck; //修改最后一位值为校验位的值{0:248,1:246,2:249,3:244,4:230,5:229}
		    		var sendDataInfo = [04,05]; //发送数据
		    		for(var i=0;i<secretData.length;i++){
		    			var d = secretData[i].toString(16);
		    			sendDataInfo[i+2] = d;
		    		}
		    		var j = 2 + dataLength;
		    		var checkData = result[j]; //校验位16进制
		    		var judgeCheck = that.XorCheck(that.stringToBytes(bwDatas.join(" ")), bwDatas.length); //十进制
		    		if(that.decimalRadixToHex(judgeCheck) != checkData){
		    			$rootScope.showPopup("报文数据校验位不一致，操作终止!!!");
		    		} else {
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n校验位校验成功—— (2)");
		    			var date = new Date();
	    				var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
	    				var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    			    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    			    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    			    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
// var logDate = date.getFullYear()+"-"+month+"-"+day+" "
//	+ hours + ":" + minutes + ":" + seconds;   			    	
			    		//解析报文获取锁具编码
			    		var lockId = "";
			    		lockId = that.hexRadixToDecimal(result[2])*Math.pow(256,3) 
			    					+ that.hexRadixToDecimal(result[3])*Math.pow(256,2) 
			    					+ that.hexRadixToDecimal(result[4])*256 
			    					+ that.hexRadixToDecimal(result[5]);
			    		$rootScope.lockId = lockId;
			    		//是否初始化入库状态
			    		if(that.isInit){
			    			if(that.online){
			    				
			    				hlService.home.savePubLocksetData().save({               
				    				lockId : lockId,
				    				lockName : '新锁'+ that.decimalRadixToHex(lockId),
				    				compId : window.localStorage.groupId
				    	      	},function(res){
				    	      		if(res.NUM == -1){
				    	      			$rootScope.showPopup("锁具已在库中!!!");
				    	      		}else{
				    	      			that.sendData(sendDataInfo.join(" "));
				    	      			$rootScope.showPopup("入库成功!!!");
				    	      		}
				    	      	},function(res){
				    	      		$rootScope.showPopup("网络偷懒啦!!!");
				    	      	});
			    			} else{
			    				$rootScope.showPopup("离线状态不支持该功能操作!!!");
			    			}
			    			
			    		} else { //非入库状态
			    			
			    			//判断锁具状态
				    		hlService.home.getPubLocksetByLockId(lockId).get(function(res){
				    			if(res.lockId == null || res.lockId ==""){
				    				$rootScope.showPopup("该锁具未入库，请先入库操作!");
				    				return;
				    			}
				    			var installStatus = res.installStatus;
				    			var assignStatus = res.assignStatus;
				    			if(assignStatus != 1){
				    				$rootScope.showPopup("该锁具未分配,请联系主站管理员!");
				    			} else {
				    				//挂锁模式
					    			if(that.isInstalling){
					    				var installTime = (date/1000).toFixed(0);
					    				if(installStatus == 1 ){
					    					$rootScope.showPopup("该锁具已使用,不用进行此操作!");
					    				} else {
					    					//判断该锁具是否在用户名下
					    					hlService.home.getLockUserRelByUserIdLockId(lockId,window.localStorage.userId).get(function(res){
					    						if(res.id == null){
					    							$rootScope.showPopup("该锁具未分配到用户下，操作终止!");
					    						}else{
					    							$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
					    							var timeFormate = date.getFullYear()+"-"+month+"-"+day+" "
													+ hours + ":" + minutes + ":" + seconds;
					    							that.installLock((date/1000).toFixed(0),timeFormate);
					    						}
					    					},function(res){
					    						$cordovaToast.showShortCenter("已转离线模式");
					    						var locksets = JSON.parse(window.localStorage.locksets);
					    						var isContain = false;
					    						for(var i=0;i<locksets.length;i++){
					    							var lockset = locksets[i];
					    							if(lockset.lockId == lockId){
					    								isContain = true;
					    								break;
					    							}
					    						}
					    						if(isContain){
					    							$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
					    							var timeFormate = date.getFullYear()+"-"+month+"-"+day+" "
													+ hours + ":" + minutes + ":" + seconds;
					    							that.installLock((date/1000).toFixed(0),timeFormate);
					    						}else{
					    							$rootScope.showPopup("该锁具未分配到用户下，操作终止!");
					    						}
					    					});
					    				}
					    			}else { //回收和开锁维护模式
					    				if(installStatus != 1){
					    					$rootScope.showPopup("该锁具未使用安装,不进行此操作!");
					    				}else{
					    					//权限判断
					    					hlService.home.getDeviceUserRelByUserIdLockId(lockId,window.localStorage.userId).get(function(res){
					    						if(res.id == null){
					    							$rootScope.showPopup("用户对该设备无操作权限,请联系管理员!");
					    						} else{
					    							var ymd = "" + date.getFullYear() + month + day;
							    			    	var hms = "" + hours + minutes + seconds;
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限判断操作开始—— (3)");   		
							    			    	if(ymd >= res.startDate && ymd <= res.endDate){ //判断是否在规定时间段内维护
							    			    		if(res.type == 0 || res.type == 1){ //每天仅判断时分秒
							        			    		if(hms > res.startTime && hms < res.endTime){
							    	    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限校验通过，发送报文—— (4)");							        			    			
							    	    			    		that.sendData(sendDataInfo.join(" "));
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n报文发送成功，开锁结束:" + logDate + "—— (5)\r\n\r\n"); 
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n发送报文—— " + sendDataInfo.join(" "));
							    	    			    		if(that.isReturn){ // 回收模式，加载数据
							    	    			    			that.setRecoverParams(res);
							    	    			    		}
							    	    			    	}else{
							    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    	    			    	}
							    	    			    } else if(res.type == 2){//每周
							    	    			    	var reDay = res.reday;
							    	    			    	var reDays = reDay.split(",");
							    	    			    	var weekDay = date.getDay();
							    	    			    	var isPerm = false;
							    	    			    	for(var i=0;i<reDays.length;i++){
							    	    			    		if(weekDay == reDays[i]){
							    	    			    			isPerm = true;
							    	    			    			break;
							    	    			    		}
							    	    			    	}
							    	    			    	if(isPerm){
							    	    			    		if(hms > res.startTime && hms < res.endTime){
							    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限校验通过，发送报文—— (4)");							        			    			
								    	    			    		that.sendData(sendDataInfo.join(" "));
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n报文发送成功，开锁结束:" + logDate + "—— (5)\r\n\r\n"); 
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n发送报文—— " + sendDataInfo.join(" "));
							    		    			    		if(that.isReturn){ // 回收模式，加载数据
								    	    			    			that.setRecoverParams(res);
								    	    			    		}
							    		    			    	}else{
							    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    		    			    	}
							    	    			    	}else{
							    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    	    			    	}
							    	    			    }else if(res.type == 3){ //每月
							        			    		var reDay = res.reday;
							        			    		var reDays = reDay.split(",");
							        			    		var isPerm = false;
							    	    			    	for(var i=0;i<reDays.length;i++){
							    	    			    		if(day == reDays[i]){
							    	    			    			isPerm = true;
							    	    			    			break;
							    	    			    		}
							    	    			    	}
							        			    		if(isPerm){
							        			    			if(hms > res.startTime && hms < res.endTime){
							    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限校验通过，发送报文—— (4)");							        			    			
								    	    			    		that.sendData(sendDataInfo.join(" "));
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n报文发送成功，开锁结束:" + logDate + "—— (5)"); 
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n发送报文—— " + sendDataInfo.join(" "));
							    		    			    		if(that.isReturn){ // 回收模式，加载数据
								    	    			    			that.setRecoverParams(res);
								    	    			    		}
							    		    			    	}else{
							    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    		    			    	}
							        			    		}else{
							        			    			$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							        			    		}
							    	    			    }
							    			    		
							    			    	}else{
							    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    			    	}
					    						}
					    					},function(res){
					    						$rootScope.showPopup("网络偷懒啦!");
					    					});
					    				}
					    			}
				    			}
				    		},function(res){
				    			
				    			$cordovaToast.showShortCenter("网络连接不可用");
				    			//挂锁模式
				    			if(that.isInstalling){
				    				var locksets = JSON.parse(window.localStorage.locksets);
					    			var isContain = false;
					    			for(var i=0;i<locksets.length;i++){
					    				var record = locksets[i];
					    				if(record.lockId == $rootScope.lockId){
					    					isContain = true;
					    					$rootScope.outLineLockSet = record;
					    					break;
					    				}
					    			}
					    			if(!isContain){
					    				$rootScope.showPopup("该锁具不在库中或你没权限操作，请联网后再进一步操作!");
					    				$rootScope.outLineLockSet = null;
					    			} else {
					    				//判断锁具是否已使用且已在缓存数据中
					    				var hisRecord = JSON.parse(window.localStorage.lockInstallData);
				    		    		var lockContain = false;
				    		    		
				    		    		for(var i=0;i<hisRecord.length;i++){
				    		    			var record = hisRecord[i];
				    		    			if(record.lockId == lockId){
				    		    				lockContain = true;
				    		    			}
				    		    		}
				    		    		if(lockContain){
				    		    			$rootScope.showPopup("该锁具已使用且缓存，请重新选择!!!");
				    		    		} else{
				    		    			var installTime = (date/1000).toFixed(0);
						    				if($rootScope.outLineLockSet.lockSet.installStatus == 1 ){
						    					$rootScope.showPopup("该锁具已使用,不再进行此操作!");
						    				} else {
				    							$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
				    							var timeFormate = date.getFullYear()+"-"+month+"-"+day+" "
												+ hours + ":" + minutes + ":" + seconds;
				    							that.installLock((date/1000).toFixed(0),timeFormate);
						    				}
				    		    		}
					    			}
				    			}else{  // 开关维护及回收模式
				    				var devices = JSON.parse(window.localStorage.lockPerm);
				    				var isContain = false;
				    				for(var i=0;i<devices.length;i++){
				    					var record = devices[i];
				    					var realLockId = record.device.lockId;
				    					if(realLockId == lockId){
				    						isContain = true;
				    						$rootScope.outLineDevice = record;
				    						break;
				    					}
				    				}
				    				if(!isContain){
				    					$rootScope.showPopup("该锁具未安装或用户对该设备无操作权限，请联网后再进一步操作。");
				    					$rootScope.outLineDevice = null;
				    				}else{
				    					
				    					var ymd = "" + date.getFullYear() + month + day;
				    			    	var hms = "" + hours + minutes + seconds;
				    			    	if(ymd >= $rootScope.outLineDevice.startDate && ymd <= $rootScope.outLineDevice.endDate){ //判断是否在规定时间段内维护
				    			    		if($rootScope.outLineDevice.type == 0 || $rootScope.outLineDevice.type == 1){ //每天仅判断时分秒
				        			    		if(hms > $rootScope.outLineDevice.startTime && hms < $rootScope.outLineDevice.endTime){
				    	    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
				    	    			    		that.sendData(sendDataInfo.join(" "));
				    	    			    		if(that.isReturn){ // 回收模式，加载数据
				    	    			    			that.setRecoverParams($rootScope.outLineDevice);
				    	    			    		}
				    	    			    	}else{
				    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    	    			    	}
				    	    			    } else if($rootScope.outLineDevice.type == 2){//每周
				    	    			    	var reDay = $rootScope.outLineDevice.reday;
				    	    			    	var reDays = reDay.split(",");
				    	    			    	var weekDay = date.getDay();
				    	    			    	var isPerm = false;
				    	    			    	for(var i=0;i<reDays.length;i++){
				    	    			    		if(weekDay == reDays[i]){
				    	    			    			isPerm = true;
				    	    			    			break;
				    	    			    		}
				    	    			    	}
				    	    			    	if(isPerm){
				    	    			    		if(hms > $rootScope.outLineDevice.startTime && hms < $rootScope.outLineDevice.endTime){
				    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
				    		    			    		that.sendData(sendDataInfo.join(" "));
				    		    			    		if(that.isReturn){ // 回收模式，加载数据
					    	    			    			that.setRecoverParams(res);
					    	    			    		}
				    		    			    	}else{
				    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    		    			    	}
				    	    			    	}else{
				    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    	    			    	}
				    	    			    }else if($rootScope.outLineDevice.type == 3){ //每月
				        			    		var reDay = $rootScope.outLineDevice.reday;
				        			    		var reDays = reDay.split(",");
				        			    		var isPerm = false;
				    	    			    	for(var i=0;i<reDays.length;i++){
				    	    			    		if(day == reDays[i]){
				    	    			    			isPerm = true;
				    	    			    			break;
				    	    			    		}
				    	    			    	}
				        			    		if(isPerm){
				        			    			if(hms > $rootScope.outLineDevice.startTime && hms < $rootScope.outLineDevice.endTime){
				    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
				    		    			    		that.sendData(sendDataInfo.join(" "));
				    		    			    		if(that.isReturn){ // 回收模式，加载数据
					    	    			    			that.setRecoverParams(res);
					    	    			    		}
				    		    			    	}else{
				    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    		    			    	}
				        			    		}else{
				        			    			$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				        			    		}
				    	    			    }
				    			    	}else{
				    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    			    	}
				    			    	
				    				}
				    				
				    			}
				    			
				    		});
			    		}
		    		}
		    	}
		    	else if(result[0]==1){
		    		that.keyInfo = result;
		    	}
		    	else if(result[0]==4){
		    		var date = new Date();
					var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
			    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
			    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
			    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
			    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
		    		//判断是否开锁维护状态
		    		if(that.isMain){
		    			var ymd = date.getFullYear() + "-" + month + "-" + day;
				    	var hms = hours + ":" + minutes + ":" + seconds;
			    		$rootScope.openLog = "用户" + window.localStorage.userName + "于" + ymd + " " + hms +"有开启智能锁。"
			    		if(that.online){

			    			hlService.home.savePubHisData().save({
				          		userId : window.localStorage.userId, 
				          		lockId : $rootScope.lockId,
				          		optDate : (date/1000).toFixed(0)
				          	},function(res){
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n保存开锁日志—— (6)\r\n\r\n");
				          	});
			    		}else{
			    			var hisRecord = JSON.parse(window.localStorage.hisData);
			    			var record = {
		    					userId : window.localStorage.userId, 
				          		lockId : $rootScope.lockId,
				          		optDate : (date/1000).toFixed(0)	
			    			}
		    				window.localStorage.hisData = JSON.stringify(hisRecord.concat(record));
		    				$rootScope.showPopup("已缓存开锁记录!!!");
			    		}
		    		}
		    	}
		    },
		    /**
			 * 写数据,外传回调函数
			 * */
		    sendData1 : function(data, fn, efn){
				ble.write($rootScope.bluetooth.deviceId, $rootScope.bluetooth.serviceUUID, $rootScope.bluetooth.characteristicUUID,
	    				$rootScope.bluetooth.stringToBytes(data).buffer, fn,efn);
			},
		    /**
			 * 写数据
			 * */
		    sendData : function(data){
				ble.write($rootScope.bluetooth.deviceId, $rootScope.bluetooth.serviceUUID, $rootScope.bluetooth.characteristicUUID,
	    				$rootScope.bluetooth.stringToBytes(data).buffer, function(res){
				},$rootScope.bluetooth.onError);
			},
		    disconnect : function(){
		    	ble.disconnect($rootScope.bluetooth.deviceId,function(){
		    		$rootScope.bluetooth.status = "未连接";
				},function(){});
		    },
		    isConnected : function(deviceId,fn,efn){
		    	ble.isConnected(deviceId,fn,efn);
		    }
	    };
		return Bluetooth;
	
});
