angular.module('btapp.factorys').factory('ssSecondBlKey', function($rootScope,$cordovaToast,$log,blcache, hlService) {
		//用 Factory 就是创建一个对象，为它添加属性，
		//然后把这个对象返回出来。你把 service 传进 controller 之后，
		//在 controller 里这个对象里的属性就可以通过 factory 使用了。
		//工厂方法，返回一个bluetooth对象
		var Bluetooth = {
			/**
			 * 蓝牙设备连接名
			 * */
			keyName : '',
			/**
	    	 * 蓝牙设备id
	    	 * */
	    	deviceId : '',
	    	/**
    		 * 是否进行蓝牙扫描
    		 * */
	    	scanFlag : true,
	    	/**
	    	 * 是否网络在线
	    	 * */
	    	online : true, 
	    	/**
	    	 * 是否扫描到指定设备
	    	 * */
	    	isScanSuccess : false,
	    	/**
	    	 * 是否连接过
	    	 * */
	    	connected : false,
	    	/**
	    	 * 已经连接但是通讯监听异常，该标志用来是否重新连接。
	    	 */
	    	notifyError : false,
	    	/**
	    	 * 是否重连标志（如果一次扫描完成可以设置为true，代表可以重连，否则需要等待）
	    	 */
	    	isReconnecting : false,
	    	/**
	    	 * 是否为挂锁模式
	    	 * */
	    	isInstalling : false,
	    	/**
	    	 * 是否初始化入库模式
	    	 * */
	    	isInit : false,
	    	/**
	    	 * 是否维护模式
	    	 * */
	    	isMain : true, 
	    	/**
	    	 * 是否回收模式
	    	 * */
	    	isReturn : false,
	    	/**
	    	 * 异或校验算法钥匙信息
	    	 * */
	    	key : "00 01 02 03 04 05 06 07",
	    	/**
	    	 * 根秘钥
	    	 * */
	    	gKey : "a0a1a2a3a4a5a6a7",
	    	/**
	    	 * 控制秘钥
	    	 * */
	    	controlKey : 'b0b1b2b3b4b5b6b7',
	    	/**
	    	 * 通信连接状态
	    	 * */
	    	status : '',
	    	/**
	    	 * 入库方式0-锁设备分离，1-锁设备关联
	    	 */
	    	switchDepend : 0,
	    	 /**
		     * 随机生成8位动态密钥-->例如,29 ac 43 23 a2 3b 6c 8c
		     * */
		    initDynamicSecretKey : function(){
		    	var num = '';
		    	 for (i = 0; i < 16; i++)
		    	 {
		    	    var tmp = Math.ceil(Math.random()*15);//--->[0-15]对应16进制
		    	    if(tmp > 9){//--->16进制中10-15分别用a,b,c,d,e,f表示
		    	           switch(tmp){ 
		    	               case(10):
		    	                   num+='a';
		    	                   break;
		    	               case(11):
		    	                   num+='b';
		    	                   break;
		    	               case(12):
		    	                   num+='c';
		    	                   break;
		    	               case(13):
		    	                   num+='d';
		    	                   break;
		    	               case(14):
		    	                   num+='e';
		    	                   break;
		    	               case(15):
		    	                   num+='f';
		    	                   break;
		    	           }
		    	        }else{
		    	           num+=tmp;
		    	        }
		    	 }
		    	 num = num.replace(/(.{2})/g, "$1 ");
		    	 return(num);
		    },
		    /**
		     * 参数： 十六进制数
		     * 异或校验运算 结果返回十进制数
		     * */
		    XorCheck : function(Data,Length){
	    	    var sum=0,i;
	    	    for(var i=0; i<Length; i++)
	    	    {
	    	        sum ^= Data[i]; 
	    	        
	    	    }
	    	    return sum;
	    	},
	    	/**
	    	 * 参数： 十六进制数
	    	 * 加密算法  结果返回十进制数
	    	 * */
		    HloveyRC4 : function(aInput, aKey) {
		    	var iS = new Uint8Array(256);
	    	    var iK = new Uint8Array(256);
	    	    for (var i = 0; i < 256; i++)
	    	        iS[i] = i;
	    	    var j = 1;
	    	    for (var i = 0; i < 256; i++){
	    	        iK[i] = aKey[(i % aKey.length)];
	    	    }
	    	    j = 0;
	    	    for (var i = 0; i < 256; i++) {
	    	        j = (j + iS[i]&0xff + iK[i]&0xff) % 256;
	    	        var temp = iS[i];
	    	        iS[i] = iS[j];
	    	        iS[j] = temp;
	    	    }
	    	    var i = 0;
	    	    j = 0;
	    	    var iOutputChar = new Uint8Array(aInput.length);
	    	    for (var x = 0; x < iOutputChar.length; x++) {
	    	        i = (i + 1) % 256;
	    	        j = (j + iS[i]&0xff) % 256;
	    	        var temp = iS[i]&0xff;
	    	        iS[i] = iS[j];
	    	        iS[j] = temp;
	    	        var t = (iS[i] + (iS[j]&0xff % 256)) % 256;
	    	        var iY = iS[t]&0xff;
	    	        var iCY =  iY;
	    	        iOutputChar[x] = aInput[x] ^ iCY;
	    	    }
	    	    return iOutputChar;
			},
			
			/**
			 * 参数：ArrayBuffer
			 * 结果：十进制转十六进制
			 * */
		    bytesToString : function(buffer) {
		    	var a = new Uint8Array(buffer);
				 var data = [];
				 for(var i=0;i<a.length;i++){
					 data[i] = $rootScope.bluetooth.decimalRadixToHex(a[i]);
				 }
				 return data;
			},
			/**
			 * 参数：十六进制参数字符串，已空格分开
			 * 结果：无符号十六进制数数组
			 * ee de ac 12 
			 * */
			stringToBytes : function(string) {
				 var arr = string.split(" ");
				 var array = new Uint8Array(arr.length);
				 for (var i = 0; i < arr.length;i++) {
					 array[i] = '0x' + arr[i];
				 }
				 return array;
			},
			
			/**
			 * 参数：十进制参数字符串，未加空格分开
			 * 结果：无符号十六进制数数组
			 *  eedeac12 长度32 16个字节
			 * */
			stringToBytesForNoSpace : function(string) {
				 var array = new Uint8Array(string.length/2);
				 for (var i = 0; i < string.length;) {
					 array[i/2] = '0x' + string.substring(i,i+2);
					 i = i + 2;
	
				 }
				 return array;
			},
			
			/**
			 * 十六进制转十进制数
			 * 参数：十六进制数
			 * 结果：十进制数
			 * */
			hexRadixToDecimal : function(num){
//$rootScope.openLog += "测试码 ：" + num + "/" + parseInt(num,16) + "@@";
				return parseInt(num, 16);
			},
			
			/**
			 * 十进制数转十六进制数
			 * 参数：十进制数
			 * 结果：十六进制数
			 * */
			decimalRadixToHex : function(num){
				return num.toString(16);
			},
			/**
			 * num - 数据
			 * n - 位数
			 */
			pad : function(num, n) {
				num = '' + num;
				return Array(n>num.length?(n-(''+num).length+1):0).join(0)+num; 
			},
	    	scanError : function(res){
		    	this.status = constantDefine.scan_error;//"扫描失败";
		    },
		    
		    scanDevice : function(){
		    	var that = this;
		    	that.isReconnecting = false;
		    	that.stopScanCallback(function(){
		    		that.scan();
		    	}, function(){
		    		that.scan();
		    	});
		    	
		    },
		    scan : function() {
		    	var that = this;
		    	ble.scan([], 5,function(device){
		    		that.onScanDevice(device);
		    	}, function(res){
		    		that.scanError(res);
		    		that.isReconnecting = true;
		    	});
		    	// 确保6秒后再打开重连标志
		    	that.reconnTimer = setTimeout(function(){
		    		that.isReconnecting = true;
		    	},6000);
		    },
		    clearReconnTimer : function() {
		    	if (this.reconnTimer) {
		    		clearTimeout(this.reconnTimer);
		    	}
		    },
		    onScanDevice : function(device){
		    	var that = this;
		    	//$rootScope.openLog = device.name + 'key:' + that.keyName;
		    	if(device.name == that.keyName){
		    		//$rootScope.openLog += '匹配了';
		    		that.isReconnecting = false;
		    		that.deviceId = device.id;
		    		window.localStorage.bleDeviceId = device.id;
		    		that.clearReconnTimer();
		    		that.stopScan();
		    		//that.connect();
		    	}
		    },
		    
		    connError : function(res){
		    	this.status = constantDefine.scan_error;//"扫描连接失败";
		    	this.isReconnecting = true;
		    },
		    
		    onError : function(reason){
		    	var that = this;
		    	that.status = constantDefine.communication_error;//"通信出错";
		    	that.notifyError = true;
		    	that.isReconnecting = true;
		    },
		    stopScanCallback : function(fn, en) {
		    	ble.stopScan(fn, en);
		    },
		    stopScan : function() {
		    	var that = this;
		    	ble.stopScan(function(){
		    		//$rootScope.openLog = '已经找到，停止扫描:' + that.deviceId;
		    		that.isReconnecting = false;
		    		that.connect();
		    	},function(){
		    		//$rootScope.openLog = '失败了，停止扫描:' + that.deviceId;
		    		that.isReconnecting = true;
		    	});
		    },
		    connect: function() {
		    	var that = this;
		        ble.connect(that.deviceId, function(peripheral){
		        	that.onConnect(peripheral);
		        }, function(res){
		        	//$rootScope.openLog += '连接失败了！' + JSON.stringify(res);
		        	that.connError(res);
		        });
		        //$rootScope.openLog += '+++connected';
		    },
		    /**
			 * 蓝牙通讯连接后启动通道监听
			 * */
			onConnect : function(peripheral){
				var that = this;
				that.determineServiceType(peripheral);
				ble.startNotification(that.deviceId, that.serviceUUID, that.notifyCharacteristicUUID, function(buffer){
					that.onData(buffer);
				}, function(reason){
					//$rootScope.openLog += constantDefine.monitor_error +  JSON.stringify(reason); //'监听通知出错了：'
					that.onError(reason);
				});
				that.onConnectHandler();
			},
			onConnectHandler : function() {
				var that = this;
				//that.status = "已连接";
				setTimeout(function(){
					var dynamicSecretKey = that.initDynamicSecretKey();
					var checkData =that.XorCheck(that.stringToBytes(dynamicSecretKey),8);
					var sendDataInfo = "02 08 " + dynamicSecretKey + " " + checkData; //发送数据
					that.key = dynamicSecretKey;
					//$rootScope.openLog += "发送动态密钥 ：" + sendDataInfo;
					that.sendData(sendDataInfo);
				},1000);
			},
			/**
			 * 通道信息解析(这个写死的目的是什么呢？？？？？）
			 * */
			determineServiceType: function(peripheral) {
				var that = this;
				peripheral.characteristics.filter(function(element) {
					var properties = element.properties;
					for(var i=0;i<properties.length;i++){
						var prop = properties[i];
//						if("notify" == prop.toLowerCase()){
//							$rootScope.bluetooth.serviceUUID = element.service;
//							$rootScope.bluetooth.notifyCharacteristicUUID = element.characteristic;
//						} else if("write" == prop.toLowerCase()){
//							$rootScope.bluetooth.serviceUUID = element.service;
//							$rootScope.bluetooth.characteristicUUID = element.characteristic;
//						}s
						that.serviceUUID = 'f000c0e0-0451-4000-b000-000000000000';
						that.notifyCharacteristicUUID = 'f000c0e1-0451-4000-b000-000000000000';
						that.characteristicUUID = 'f000c0e2-0451-4000-b000-000000000000';
					}
					if(that.notifyCharacteristicUUID && that.characteristicUUID){
						return;
					}
		        })[0];
		    },
			/**
			 * 通知监听处理
			 * */
		    onData : function(buffer){
		    	this.notifyError = false;
		    	//$rootScope.openLog += 'startNotification:' + JSON.stringify(buffer);
		    	this.parseResult(this.bytesToString(buffer));
                //this.testParseResult(this.bytesToString(buffer));
		    },
			
			/**
			 * 安装锁具地址信息获取操作
			 * */
			installLock : function(installTime,timeFormate, device){
				$rootScope.Lockset = {
					lockId : $rootScope.lockId,
					installer : window.localStorage.userId,
					installName : window.localStorage.userName,
					time : installTime,
					timeFormate : timeFormate,
					sysId : window.localStorage.sysId,
					refresh:true
				};
				if (device != null) {
					$rootScope.Lockset.deviceId = device.deviceId;
					$rootScope.Lockset.depend = device.depend;
				}
			},
			/**
			 * 回收锁具参数设置
			 * */
			setRecoverParams : function(res){
				var device = res;
				var dateTime = new Date();
				var timeFormate = this.getYmdHmsByDate(dateTime);
				$rootScope.recover = {
					lockId : $rootScope.lockId,
					deviceId : device.deviceId,
					deviceName : device.deviceName,
					installer : device.installer,
					installName : device.installUser ? device.installUser.name : device.installer,
					time : device.time,
					timeFormate : timeFormate,
					longitude : device.longitude,
					latitude : device.latitude,
					location : device.location,
					depend : device.depend
				};
			},
			testParseResult : function(result){
				var that = this;
				var ret = result[0] - 0; // 动作状态
		    	switch(ret) {
			    	case 1:
			    		
			    		//$rootScope.openLog += "（01命令码）信息: " + result;
			    		break;
			    	case 2:
			    		$rootScope.openLog += "（02命令码）信息: " + result;
			    		break;
			    	case 3:
			    		$rootScope.openLog += "（03命令码）信息: " + result;
			    		/************************报文校验（直接数据位密文校验）*****************************/
				    	var checkData = that.getCommandCheckText(result);
			    		var datas = that.getCommandText(result);

			    		
			    		if(!that.validateCommandText(datas, checkData)){
			    			$rootScope.showPopup(constantDefine.check_error);//"报文数据校验位不一致，操作终止!!!");
			    		} else {
			    			var object = that.getParseCommand03Text(datas);
			    			// 在全局页面开锁是使用
				    		$rootScope.lockId = object.lockId;
				    		$rootScope.openLog += '$rootScope.lockId:' + object.lockId;
//			    			//是否初始化入库状态
//				    		if(that.isInit){
//				    			that.savePubLockset(object.lockId, object.sendDataInfo);
//				    		} else { //非入库状态 : 开锁或者挂锁或者回收锁的操作
//				    			that.openOrRecoverOrInstallLockset(object.lockId, object.sendDataInfo);
//				    		}
			    		}
			    		break;
			    	case 4:
			    		$rootScope.openLog += "（04命令码）信息: " + result;
			    		break;
			    	case 5:
			    		$rootScope.openLog += "（05命令码）信息: " + result;
			    		break;
			    	case 6:
			    		$rootScope.openLog += "（06命令码）信息: " + result;
			    		break;
			    	case 7:
			    		$rootScope.openLog += "（07命令码）信息: " + result;
			    		break;
			    	case 8:
			    		$rootScope.openLog += "（08命令码）信息: " + result;
			    		break;
			    	case 9:
			    		$rootScope.openLog += "（09命令码）信息: " + result;
			    		break;
			    	case 10:
			    		$rootScope.openLog += "（10命令码）信息: " + result;
			    		break;
			    	default:
			    		$rootScope.showPopup(constantDefine.unknown_order);//"未知命令，结束操作");
			    		break;
		    	}
			},
			parseResultYs : function(result){
				var that = this;
				if(result[0] == 3){
					
//alert($rootScope.bluetooth.gKey);

//alert($rootScope.bluetooth.controlKey);
					
					$rootScope.openLog = "（03命令码）上传锁设备信息: " + result;
					
					var dataLength = parseInt(result[1]);//报文数据长度
		    		var bwDatas = [];
		    		for(var i=0;i<4;i++){      //前4位为锁设备号
		    			var bwData = result[i+2];
		    			bwDatas.push(bwData);  //十六进制数据位
		    		}
		    		//添加开锁动作位
		    		bwDatas.push(1);
		    		//that.key = "84 64 4c 5d 77 f1 7b d5";
$rootScope.openLog += " <br> 动态key值：" + that.key;
					var openKey = (that.key + that.controlKey).split(' ').join('');
$rootScope.openLog += " <br> 开关锁拼接key值：" + openKey;

// 去空格进行MD5加密
					var md5OpenKey = hex_md5(openKey);
$rootScope.openLog += " <br> 加密后key值：" + md5OpenKey;
					
$rootScope.openLog += "&&加密后key值十六进制数：" + JSON.stringify(that.stringToBytesForNoSpace(hex_md5(openKey)));

					//var secretData = that.HloveyRC4(that.stringToBytes(bwDatas.join(" ")), that.stringToBytes(that.key));
		    		var secretData = that.HloveyRC4(that.stringToBytes(bwDatas.join(" ")), that.stringToBytesForNoSpace(hex_md5(openKey)));

		    		var secretCheck = that.XorCheck(secretData, secretData.length);
		   
		    		var newSecretData = new Uint8Array(secretData.length + 1);//修改最后一位值为校验位的值{0:248,1:246,2:249,3:244,4:230,5:229}
		    		for(var i=0;i<secretData.length;i++){
		    			newSecretData[i] = secretData[i];
		    		}
		    		newSecretData[newSecretData.length-1] = secretCheck; 
		    		
		    		var sendDataInfo = [04,05]; //发送数据
		    		
		    		for(var i=0;i<newSecretData.length;i++){
		    			var d = newSecretData[i].toString(16);
		    			sendDataInfo[i+2] = d;
		    		}
					
					$rootScope.openLog += " <br> 04开锁命令码: " + sendDataInfo;
					this.sendData(sendDataInfo.join(" "));
				}
				else if(result[0]==1){
		    		that.keyInfo = result;
		    		//$rootScope.openLog += "（01命令码）返回钥匙设备信息:" + result;
		    	}
				else if(result[0]==2){
		    		//that.keyInfo = result;
		    		$rootScope.openLog += "（02命令码）返回动态密钥同步结果:" + result;
		    	}
		    	else if(result[0]==4){
		    		$rootScope.openLog += " <br>（04命令码）返回开关锁结果信息: " + result;
		    	}
			},
			
		    // 解析报文结果并执行相应的操作
		    parseResult : function(result) {
		    	var ret = result[0] - 0; // 动作状态
		    	switch(ret) {
			    	case 1:
			    		this.parseCommand01Code(result);
			    		break;
			    	case 2:
			    		this.parseCommand02Code(result);
			    		break;
			    	case 3:
			    		this.parseCommand03Code(result);
			    		break;
			    	case 4:
			    		this.parseCommand04Code(result);
			    		break;
			    	case 5:
			    		this.parseCommand05Code(result);
			    		break;
			    	case 6:
			    		this.parseCommand06Code(result);
			    		break;
			    	case 7:
			    		this.parseCommand07Code(result);
			    		break;
			    	case 8:
			    		this.parseCommand08Code(result);
			    		break;
			    	case 9:
			    		this.parseCommand09Code(result);
			    		break;
			    	
			    	default:
			    		$rootScope.showPopup(constantDefine.unknown_order);//"未知命令，结束操作");
			    		break;
		    	}
		    },
		    parseCommand01Code : function(result) {
		    	//$rootScope.openLog += "（01命令码）信息: " + result;
		    	this.keyInfo = result;
		    },
		    parseCommand02Code : function(result) {
		    	//$rootScope.openLog += "（02命令码）信息: " + result;
		    },
		    parseCommand03Code : function(result) {
		    	//$rootScope.openLog += "（03命令码）信息: " + result;
		    	var that = this;
		    	/************************报文校验（直接数据位密文校验）*****************************/
		    	var checkData = that.getCommandCheckText(result);
	    		var datas = that.getCommandText(result);

	    		
	    		if(!that.validateCommandText(datas, checkData)){
	    			$rootScope.showPopup(constantDefine.check_error);//"报文数据校验位不一致，操作终止!!!");
	    		} else {
	    			var object = that.getParseCommand03Text(datas);
	    			// 在全局页面开锁是使用
		    		$rootScope.lockId = object.lockId;
		    		//$rootScope.openLog = '$rootScope.lockId:' + object.lockId;
	    			//是否初始化入库状态
		    		if(that.isInit){
		    			that.savePubLockset(object.lockId, object.sendDataInfo);
		    		} else { //非入库状态 : 开锁或者挂锁或者回收锁的操作
		    			that.openOrRecoverOrInstallLockset(object.lockId, object.sendDataInfo);
		    		}
	    		}
		    },
		    testF: function() {
		    	this.isInit = false;
		    	this.isInstalling = false;
		    	var object = {
		    		lockId:8337,
		    		sendDataInfo:'fengyf'
		    	};
		    	var abc = blcache.getPubLocksetByLockId(object.lockId);
		    	console.log(abc);
		    	//this.openOrRecoverLockset(object.lockId, object.sendDataInfo);
		    },
		    // 获取报文长度  => result[1]中存储的是报文长度
		    getCommandTextLength : function(result) {
		    	var dataLength = parseInt(result[1]);//报文数据长度
		    	return dataLength;
		    },
		    // 获取报文的校验位 => 16进制
		    getCommandCheckText : function(result) {
		    	var j = 2 + this.getCommandTextLength(result);
	    		var checkData = result[j]; //校验位16进制
	    		return checkData;
		    },
		    // 从返回的结果中获取报文实际内容
		    getCommandText : function(result) {
		    	var dataLength = this.getCommandTextLength(result);
	    		var datas = [];
	    		for(var i=0;i<dataLength;i++){
	    			var data = result[i+2];
	    			datas.push(data);
	    		}
	    		return datas;
		    },
		    // 验证报文的合法性，是否是有效的报文
		    validateCommandText : function(datas, checkData) {
		    	var that = this;
	    		var judgeCheck = that.XorCheck(that.stringToBytes(datas.join(" ")), datas.length); //十进制
	    		if(that.decimalRadixToHex(judgeCheck) != checkData){
	    			return false;
	    		}
	    		return true;
		    },
		    // 解析03的报文内容，组装发送的报文内容和获取解析的lockId
		    // {lockId:newXXX, sendDataInfo : data}
		    getParseCommand03Text : function(datas) {
		    	var that = this;
		    	/**********************解密报文参数******************************/
    			var decryptData = that.getDecryptData(datas);
	    		/*************************拼接开锁命令码**********************************/
	    		var bwDatas = that.getOpenLockCommand(decryptData);
	    		/***********************为开锁报文数据段进行加密操作*************************************/
	    		var secretData = that.getEncodeSecretData(bwDatas);
	    		/***********************为开锁密文生成校验位用于校验*************************************/
	    		var secretCheck = that.getSecretCheck(secretData);
	    		/***********************重新组装发送报文 锁设备号+开关锁动作+校验位**********************/
	    		var newSecretData = that.buildNewSecretData(secretData, secretCheck);
	    		/***********************添加报文头[04，05] 锁设备号+开关锁动作+校验位*******************/
	    		var sendDataInfo = that.buildSendDataInfo(newSecretData);
    			/***********************以下所有为平台相关权限判断，是否发送该开锁命令码****************/ 	
	      		var lockId = that.getLockIdInfoByOpenCommand(bwDatas);
	      		return {
	      			lockId : lockId,
	      			sendDataInfo : sendDataInfo
	      		};
		    },
		    //解密密钥使用 动态密钥做高8字节、根密钥做低8字节组合成的新密要直接使用
		    getDecryptKey : function() {
		    	var that = this;
		    	//$rootScope.openLog += " <br> 动态key值：" + that.key;
		    	//$rootScope.openLog += " <br> 根key值：" + that.gKey;
    			var decryptKey = (that.key + that.gKey).split(" ").join('');
    			return decryptKey;
		    },
		    //开锁数据段加密密钥为动态密钥作为高8位+控制密钥作为低8位组合成的新密钥，经MD5加密后使用
		    getOpenKey : function() {
		    	var that = this;
		    	//$rootScope.openLog += " <br> 动态key值：" + that.key;
		    	//$rootScope.openLog += " <br> 控制key值：" + that.controlKey;
		    	var openKey = (that.key + that.controlKey).split(' ').join('');
		    	//$rootScope.openLog += " <br> 开关锁拼接key值：" + openKey;
		    	return openKey;
		    },
		    //解密得到报文数据位明文
		    getDecryptData : function(datas) {
		    	//$rootScope.openLog += " <br> 报文数据：" + JSON.stringify(datas);
		    	var that = this;
		    	var decryptKey = that.getDecryptKey();
		    	//$rootScope.openLog += " <br> 解密密钥：" + decryptKey;
		    	var decryptData = that.HloveyRC4(that.stringToBytes(datas.join(" ")), that.stringToBytesForNoSpace(decryptKey));
		    	//$rootScope.openLog += " <br> RC4解密明文(decryptData)：" + JSON.stringify(decryptData);
		    	return decryptData;
		    },
		    
		    // 拼接开锁命令码
		    getOpenLockCommand : function(decryptData) {
		    	var that = this;
		    	var bwDatas = [];
	    		for(var i=0;i<4;i++){
	    			var bwData = decryptData[i];
	    			bwDatas.push(that.decimalRadixToHex(bwData));  //十六进制数据位
	    		}
	    		//添加开锁动作位  1表示开锁，目前只有开锁动作
	    		bwDatas.push(that.decimalRadixToHex(1));
	    		//$rootScope.openLog += " <br> 开锁命令码(openLockCmd)：" + JSON.stringify(bwDatas);
	    		return bwDatas;
		    },
		    // 为开锁报文数据段进行加密操作
		    getEncodeSecretData : function(bwDatas) {
		    	var that = this;
		    	var openKey = that.getOpenKey();
		    	var secretData = that.HloveyRC4(that.stringToBytes(bwDatas.join(" ")), that.stringToBytesForNoSpace(hex_md5(openKey)));
		    	//$rootScope.openLog += " <br> 开锁加密报文数据(openLockSecData)：" + JSON.stringify(secretData);
		    	return secretData;
		    },
		    // 为开锁密文生成校验位用于校验
		    getSecretCheck : function(secretData) {
		    	var that = this;
	    		var secretCheck = that.XorCheck(secretData, secretData.length);
	    		//$rootScope.openLog += " <br> 开锁校验位(CheckBit)：" + JSON.stringify(secretCheck);
	    		return secretCheck;
		    },
		    //重新组装发送报文 锁设备号+开关锁动作+校验位
		    buildNewSecretData : function(secretData, secretCheck) {
		    	var newSecretData = new Uint8Array(secretData.length + 1);
	    		for(var i=0;i<secretData.length;i++){
	    			newSecretData[i] = secretData[i];
	    		}
	    		newSecretData[newSecretData.length-1] = secretCheck;
	    		//$rootScope.openLog += " <br> 最终开锁的报文内容(New)：" + JSON.stringify(newSecretData);
	    		return newSecretData;
		    },
		    // 添加报文头[04，05] 锁设备号+开关锁动作+校验位
		    buildSendDataInfo : function(newSecretData) {
		    	var sendDataInfo = [04,05]; 
	    		for(var i=0;i<newSecretData.length;i++){
	    			var d = newSecretData[i].toString(16);
	    			sendDataInfo[i+2] = d;
	    		}
	    		//$rootScope.openLog += " <br> 添加报文头[04，05] 锁设备号+开关锁动作+校验位(OK)：" + JSON.stringify(sendDataInfo);
	    		return sendDataInfo;
		    },
		    // 从报文中解析锁具编码
		    getLockIdInfoByOpenCommand : function(bwDatas) {
		    	var that = this;
		    	var lockId = "";
	    		var firstFourBytes = bwDatas.splice(0, 4);
	    		var fullBytes = '';
	      		for (var i =0; i < firstFourBytes.length; i++) {
	      			fullBytes += that.pad(firstFourBytes[i], 2);
	      		}
	      		lockId = that.hexRadixToDecimal(fullBytes);
	      		return lockId;
		    },
		    parseCommand04Code : function(result) {
		    	//$rootScope.openLog += "（04命令码）信息: " + result;
		    	var that = this;
		    	var date = new Date();
	    		//判断是否开锁维护状态
	    		if(that.isMain){
	    			var ymd = that.getYmdByDate(date);
			    	var hms = that.getHmsByDate(date);
			    	$rootScope.openLog = window.localStorage.userName +constantDefine.open_lock + ymd + " " + hms;
		    		//$rootScope.openLog = "用户" + window.localStorage.userName + "于" + ymd + " " + hms +"有开启智能锁。";
		    		if ($rootScope.networkState == 'none') {
		    			var record = {
	    					userId : window.localStorage.userId, 
			          		lockId : $rootScope.lockId,
			          		optDate : that.getSecondsByDate(date)	
		    			};
	    				blcache.insertPubHisData(record);
	    				$rootScope.showPopup(constantDefine.cache_records);//"已缓存开锁记录");
		    		} else {
		    			hlService.home.savePubHisData().save({
			          		userId : window.localStorage.userId, 
			          		lockId : $rootScope.lockId,
			          		optDate : that.getSecondsByDate(date)
			          	},function(res){
			          		// noting
			          	},function(res){
			          		var record = {
		    					userId : window.localStorage.userId, 
				          		lockId : $rootScope.lockId,
				          		optDate : that.getSecondsByDate(date)	
			    			};
		    				blcache.insertPubHisData(record);
		    				$rootScope.showPopup(constantDefine.cache_records);//"已缓存开锁记录");
			          	});
		    		}
	    		}
		    },
		    parseCommand05Code : function(result) {
		    	//$rootScope.openLog += "接收05命令码返回报文：" + result;
		    },
		    parseCommand06Code : function(result) {
		    	//$rootScope.openLog += "接收06命令码返回报文：" + result;
		    },
		    parseCommand07Code : function(result) {
		    	//$rootScope.openLog += "接收07命令码返回报文：" + result;
		    },
		    parseCommand08Code : function(result) {
		    	$rootScope.openLog += "接收08命令码返回报文：" + result;
		    },
		    parseCommand09Code : function(result) {
		    	$rootScope.openLog += "接收09命令码钥匙上传日志：" + result;
		    	
			    	//$rootScope.openLog += "（03命令码）信息: " + result;
			    	var that = this;
			    	/************************报文校验（直接数据位密文校验）*****************************/
			    	var checkData = that.getCommandCheckText(result);
		    		var datas = that.getCommandText(result);

		    		alert("数据段：");
		    		alert(datas);
		    		
		    		if(!that.validateCommandText(datas, checkData)){
		    			$rootScope.showPopup(constantDefine.check_error);//"报文数据校验位不一致，操作终止!!!");
		    		} else {
//		    			var object = that.getParseCommand03Text(datas);
//		    			// 在全局页面开锁是使用
//			    		$rootScope.lockId = object.lockId;
//			    		//$rootScope.openLog = '$rootScope.lockId:' + object.lockId;
//		    			//是否初始化入库状态
//			    		if(that.isInit){
//			    			that.savePubLockset(object.lockId, object.sendDataInfo);
//			    		} else { //非入库状态 : 开锁或者挂锁或者回收锁的操作
//			    			that.openOrRecoverOrInstallLockset(object.lockId, object.sendDataInfo);
//			    		}
		    			
		    			//解析数据段，入库开锁日志
		    		}
		    	
		    },
		    // 入库操作
		    savePubLockset : function(lockId, sendDataInfo) {
		    	var that = this;
		    	if($rootScope.networkState != 'none'){
    				hlService.home.savePubLocksetData().save({               
	    				lockId : lockId,
	    				lockName : '新锁'+ that.decimalRadixToHex(lockId),
	    				compId : window.localStorage.groupId,
	    				depend : that.switchDepend,
	    				sysId : window.localStorage.sysId
	    	      	},function(res){
	    	      		if(res.NUM == -1){
	    	      			$rootScope.showPopup(constantDefine.intostorage_log);//"该锁具已经入库，无需操作");
	    	      		}else if(res.NUM == -2){
	    	      			$rootScope.showPopup(constantDefine.no_authority_log);//"该锁具超出授权范围,无权限操作");
	    	      		} else {
	    	      			that.sendData(sendDataInfo.join(" "));
	    	      			$rootScope.showPopup(constantDefine.intostorage_success);//"已成功入库");
	    	      		}
	    	      	},function(res){
	    	      		$rootScope.showPopup(constantDefine.intostorage_fail);//"入库失败");
	    	      	});
    			} else{
    				$rootScope.showPopup(constantDefine.init_network_error);//"当前网络异常，请检查网络，新锁入库必须网络在线");
    			}
		    },
		    // 进行开锁，回收锁，挂锁等操作
		    openOrRecoverOrInstallLockset : function(lockId, sendDataInfo) {
		    	var that = this;
		    	if (!blcache.isDevTimeSync()) {
		    		$rootScope.showPopup(constantDefine.operation_time_error);
		    		return;
		    	}
		    	that.getPubLocksetByLockId(lockId, function(lockset){
		    		if(lockset == null || lockset.lockId == null || lockset.lockId ==""){
	    				$rootScope.showPopup(constantDefine.un_instorage_log);//"该锁具未入库，请先入库操作，如果当前网络不可用，请链接网络重新操作");
	    			} else {
	    				if(that.locksetIsXSystem(lockset)){ //// 判断该锁具是否是当前用户所属系统范围内的锁具
	    					that.openOrRecoverOrInstallLocksetByLockset(lockset, sendDataInfo);
	    				} else {
	    					$rootScope.showPopup(constantDefine.no_authority_log);//"该锁具超出授权范围,无权限操作");
	    				}	
	    			}
		    	});
		    },
		    // 判断锁具是否是当前用户所属系统内的锁具
		    locksetIsXSystem : function(lockset) {
		    	if (lockset.sysId == window.localStorage.sysId) {
		    		return true;
		    	}
		    	return false;
		    },
		    // 根据已经获取到的锁具进行正常的开锁，回收锁，挂锁等操作：： 取消之前的锁具分配的判断
		    openOrRecoverOrInstallLocksetByLockset : function(lockset, sendDataInfo) {
		    	var that = this;
		    	//挂锁模式
    			if(that.isInstalling){
    				that.installLockset(lockset, sendDataInfo);
    			} else { // 开锁或者回收锁
    				that.openOrRecoverLockset(lockset, sendDataInfo);
    			}
		    },
		    // 挂锁操作
		    installLockset : function(lockset, sendDataInfo) {
		    	var that = this;
		    	if(that.installedByLockset(lockset)){
					$rootScope.showPopup(constantDefine.lock_used_log);//"该锁具已使用,不用进行此操作");
				} else {
					that.installLocksetAndRefreshDeviceUserRela(lockset, sendDataInfo);
				}
		    },
		    // 挂锁并更新用户和设备授权关系
		    installLocksetAndRefreshDeviceUserRela : function(lockset, sendDataInfo) {
		    	var that = this;
		    	that.getDeviceUserRelByUserId(window.localStorage.userId, function(res){
		    		that.installLockByDeviceUserRelations(lockset, res, sendDataInfo);
		    	});
		    },
		    // 开锁或者回收锁操作
		    openOrRecoverLockset : function(lockset, sendDataInfo) {
		    	var that = this;
		    	if(that.installedByLockset(lockset)){
					that.openOrRecoverLocksetByDeviceUserRela(lockset, sendDataInfo);
				} else {
					$rootScope.showPopup(constantDefine.lock_unused_log);//"该锁具未使用安装,不进行此操作!");
				}
		    },
		    // 根据锁和设备的对应关系进行开锁或者回收锁操作
		    openOrRecoverLocksetByDeviceUserRela : function(lockset, sendDataInfo) {
		    	var that = this;
		    	that.getDeviceUserRelByUserIdLockId(lockset, sendDataInfo);
		    },
		    // 判断锁具是否已经分配
		    assignedByLockset : function(lockset) {
    			var assignStatus = lockset.assignStatus;//锁具--分配状态
    			if(assignStatus != 1){
    				return false;
    			}
    			return true;
		    },
		    // 是否已经安装？1=已安装，0=未安装
		    installedByLockset : function(lockset) {
		    	var installStatus = lockset.installStatus; // 锁具--安装状态
		    	if (installStatus == 1) {
		    		return true;
		    	}
		    	return false;
		    },
		    // 判断当前锁具是否入库并将入库结果获取处理
		    getPubLocksetByLockId : function(lockId, callback) {
		    	var that = this;
		    	if ($rootScope.networkState == 'none') {
		    		var lockset = that.getCachePubLocksetByLockId(lockId);
		    		callback(lockset);
		    	} else {
		    		hlService.home.getPubLocksetByLockId(lockId).get(function(res){
		    			callback(res);
			    	},function(res){
			    		var lockset = that.getCachePubLocksetByLockId(lockId);
			    		callback(lockset);
			    	});
		    	}
		    	
		    },
		    // 从缓存文件中获取该用户所属系统的所有锁具
		    getCachePubLocksetByLockId : function(lockId) {
		    	var lockset = blcache.getPubLocksetByLockId(lockId);
		    	return lockset;
		    },
		    // 先从回收锁的缓存中读取锁的信息
		    getCacheRecoverLocksetDataByLockId : function(lockId) {
		    	var recoverData = null;
		    	var datas = JSON.parse(window.localStorage.recoverData);
		    	if(datas != null && datas.length > 0) {
			    	for(var i = 0, len = datas.length; i < len; i++) {
			    		recoverData = datas[i];
			    		if (recoverData.lockId == lockId) {
			    			break;
			    		}
			    	}
			    	return recoverData;
		    	}
		    },
		    // 如果回收锁的缓存中没有对应的记录，则从登录时缓存的锁具列表中获得
		    getCacheLocksetDataByLockId : function(lockId, recoverData) {
		    	var locksets = JSON.parse(window.localStorage.locksets);
		    	if (locksets == null || locksets.length == 0) {
		    		return null;
		    	}
		    	var lockset = null;
		    	for(var i = 0, len = locksets.length; i < len; i++) {
		    		lockset = locksets[i];
		    		if (lockset.lockId == lockId) {
		    			break;
		    		}
		    	}
		    	// 如果当前锁已经被回收到缓存中，则需要将原有锁的信息状态更新为未安装标志
		    	if (lockset != null && recoverData != null) {
		    		if (recoverData.lockId == lockset.lockId) {
		    			lockset.installStatus = 0; // 标志为未安装
		    		}
		    	}
		    	return lockset;
		    },
		    // 开锁或者回收锁
		    openOrRecoverLock : function(devicerela, sendDataInfo) {
		    	if (this.allowedDateTimeRange(devicerela)) {
		    		if(devicerela.type == 0 || devicerela.type == 1){  //每天仅判断时分秒
		    			this.openOrRecoverLockByEventDayOfHms(devicerela, sendDataInfo);
		    		} else if(devicerela.type == 2){//每周
		    			this.openOrRecoverLockByEvenyWeek(devicerela, sendDataInfo);
		    		} else if(devicerela.type == 3){ //每月
		    			this.openOrRecoverLockByEvenyMonth(devicerela, sendDataInfo);
		    		} else {
		    			// nothing
		    		}
		    	} else {
		    		$rootScope.showPopup(constantDefine.not_at_work_time);
		    	}
		    },
		    // type = 0 or 1:
		    openOrRecoverLockByEventDayOfHms : function (devicerela, sendDataInfo) {
		    	var that = this;
		    	var date = new Date();
		    	var hms = that.getHmsByDate(date, true);
		    	if(hms > devicerela.startTime && hms < devicerela.endTime){
		    		that.sendData(sendDataInfo.join(" "));
		    		if(that.isReturn){ // 回收模式，加载数据
		    			that.setRecoverParams(devicerela.device);
		    		}
		    	}else{
		    		$rootScope.showPopup(constantDefine.not_at_work_time);
		    	}
		    },
		    // type= 2
		    openOrRecoverLockByEvenyWeek : function(devicerela, sendDataInfo) {
		    	var that = this;
		    	var reDay = devicerela.reday;
		    	var reDays = reDay.split(",");
		    	var date = new Date();
		    	var weekDay = date.getDay();
		    	var isPerm = false;
		    	var hms = that.getHmsByDate(date, true);
		    	for(var i=0;i<reDays.length;i++){
		    		if(weekDay == reDays[i]){
		    			isPerm = true;
		    			break;
		    		}
		    	}
		    	if(isPerm){
		    		if(hms > devicerela.startTime && hms < devicerela.endTime){					        			    			
			    		that.sendData(sendDataInfo.join(" "));
			    		if(that.isReturn){ // 回收模式，加载数据
			    			that.setRecoverParams(devicerela.device);
			    		}
			    	}else{
			    		$rootScope.showPopup(constantDefine.not_at_work_time);//"超出授权时段范围，不予操作");
			    	}
		    	}else{
		    		$rootScope.showPopup(constantDefine.not_at_work_time);
		    	}
		    },
		    // type = 3
		    openOrRecoverLockByEvenyMonth : function(devicerela, sendDataInfo) {
		    	var that = this;
		    	var reDay = devicerela.reday;
	    		var reDays = reDay.split(",");
	    		var isPerm = false;
	    		var date = new Date();
		    	var day = date.getDate();
		    	var hms = that.getHmsByDate(date, true);
		    	for(var i=0;i<reDays.length;i++){
		    		if(day == reDays[i]){
		    			isPerm = true;
		    			break;
		    		}
		    	}
	    		if(isPerm){
	    			if(hms > devicerela.startTime && hms < devicerela.endTime){						        			    			
			    		that.sendData(sendDataInfo.join(" "));
			    		if(that.isReturn){ // 回收模式，加载数据
			    			that.setRecoverParams(devicerela.device);
			    		}
			    	}else{
			    		$rootScope.showPopup(constantDefine.not_at_work_time);
			    	}
	    		}else{
	    			$rootScope.showPopup(constantDefine.not_at_work_time);
	    		}
		    },
		    // 判断开锁时间是否在开锁允许的时间范围内
		    allowedDateTimeRange : function(devicerela) {
		    	var that = this;
		    	var date = new Date();
		    	var ymd = that.getYmdByDate(date, true);
		    	if(ymd >= devicerela.startDate && ymd <= devicerela.endDate){  //判断是否在规定时间段内维护
		    		return true;
		    	}
		    	return false;
		    },
		    // 根据用户id获取当前用户和设备的授权信息列表
		    getDeviceUserRelByUserId : function(userId, callback) {
		    	var that = this;
		    	if($rootScope.networkState == 'none') {
		    		var deviceUserRela = that.getCacheDeviceUserRela(userId);
		    		callback(deviceUserRela);
		    	} else {
		    		hlService.home.getDeviceUserRelByUserId(window.localStorage.userId).query(function(res){
			    		callback(res);
			    	}, function(res){
			    		var deviceUserRela = that.getCacheDeviceUserRela(userId);
			    		callback(deviceUserRela);
			    	});
		    	}
		    },
		    // 根据用户id从缓存中获取当前用户和设备的授权信息列表。
		    getCacheDeviceUserRela : function(userId) {
		    	var deviceUserRela = blcache.getDeviceUserRelationByUserId(userId);
		    	return deviceUserRela;
		    },
		    // 获取用户对设备的授权信息，并进行开锁或者回收锁
		    getDeviceUserRelByUserIdLockId : function(lockset, sendDataInfo) {
		    	var that = this;
		    	that.getDeviceUserRelByUserId(window.localStorage.userId, function(deviceUserRela){
		    		if (that.hasAllPermissions(deviceUserRela)){ // 拥有-100，则直接开锁或者挂锁
		    			that.getDeviceByLockset(lockset, function(device){
		    				that.sendData(sendDataInfo.join(" "));
				    		if(that.isReturn){ // 回收模式，加载数据
				    			that.setRecoverParams(device);
				    		}
			    		},true);
		    			
		    		} else { // 如果不拥有-100，则进行权限判断之后再进行开锁或者回收锁
		    			var devicerela = that.getDeviceUserRelByLockId(lockset.lockId, deviceUserRela);
		    			if (devicerela == null) {
		    				$rootScope.showPopup(constantDefine.device_permission_log);//"用户对该设备无操作权限,请联系管理员");
		    			} else {
		    				that.openOrRecoverLock(devicerela, sendDataInfo);
		    			}
		    		}
		    	});
		    },
		    hasAllPermissions : function(deviceUserRelations) {
		    	if (deviceUserRelations == null || deviceUserRelations.length == 0) {
		    		return false;
		    	}
		    	for (var i = 0;i < deviceUserRelations.length; i++) {
		    		var deviceUserRela = deviceUserRelations[i];
		    		if (deviceUserRela.deviceId == -100) { // -100代表拥有所有权限，直接返回true
		    			return true;
		    		}
		    	}
		    	return false;
		    },
		    getDeviceUserRelByLockId : function(lockId, deviceUserRelations) {
		    	if (deviceUserRelations == null || deviceUserRelations.length == 0) {
		    		return null;
		    	}
		    	for (var i = 0, len = deviceUserRelations.length; i < len; i++) {
		    		var deviceUserRela = deviceUserRelations[i];
		    		var device = deviceUserRela.device;
		    		if (lockId == device.lockId) {
		    			return deviceUserRela;
		    		}
		    	}
		    	return null;
		    },
		    /*
		     * 挂锁的时候根据界面配合情况来做的话，权限判断有问题，不应该判断权限
		     * 1.对于depend=1的情况，最大的作用就是事先不知道挂那个设备，因此在这个环节强制判断权限最终的效果就是不知所云。
		     * 2.对于depend=0的情况，为了判断权限，也应该在界面选择设备的时候再判断是否有权限，然后给与提示有否，也不应该在这里进行处理
		     * 
		     * 总结：对于depend=1的情况，就不要判断权限
		     *     对于depend=2的情况，在选择设备的时候判断权限
		     *     
		     * 改动结果：下面这个方法实际执行的内容，只要else的语句即可。
		     */ 
		    installLockByDeviceUserRelations : function(lockset, deviceUserRelations, sendDataInfo) {
		    	var that = this;
		    	var date = new Date();
		    	if (that.hasAllPermissions(deviceUserRelations)){ // 拥有-100，则直接挂锁
		    		that.getDeviceByLockset(lockset, function(device){ // 根据lockset中的depend判断如何加载设备 
		    			$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
						that.installLock(that.getSecondsByDate(date),that.getYmdHmsByDate(date),device);
		    		});
		    	} else { //如果不拥有-100，则进行权限判断之后在进行设备的挂锁操作---暂时不判断，逻辑上有点别扭
		    		if (lockset.depend == 0) {
			    		var device = {
			    			lockId:lockset.lockId,
			    			depend:0
			    		};
			    		$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
						that.installLock(that.getSecondsByDate(date),that.getYmdHmsByDate(date),device);
			    	} else { // 如果有人为的脏数据，有可能得不到device信息，正常入库模式（depend=1）操作的，设备信息肯定能获取到
			    		//判断用户是否对设备拥有权限 -------------by leaf
			    		var devicerela = that.getDeviceUserRelByLockId(lockset.lockId, deviceUserRelations);
		    			if (devicerela == null) {
		    				$rootScope.showPopup(constantDefine.device_permission_log);//"用户对该设备无操作权限,请联系管理员");
		    			} else {
		    				that.getDeviceByLockId(lockset.lockId, function(device){
				    			$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
								that.installLock(that.getSecondsByDate(date),that.getYmdHmsByDate(date),device);
				    		});
		    			}
			    	}
		    	}
		    },
		    // 先判断lockset中的depend的状态是否为0，如果为0则直接返回没有设备id，设备名的设备
		    // openRecoverFlag :代表回收或者开锁，当这两种模式的时候，直接从数据库中获取设备信息，必须有，如果没有记录，就是不正常的开锁或者挂锁
		    getDeviceByLockset : function(lockset, callback, openRecoverFlag) {
		    	var that = this;
		    	if (openRecoverFlag) {
		    		that.getDeviceByLockId(lockset.lockId, function(device){
		    			callback(device);
		    		});
		    	} else {
		    		if (lockset.depend == 0) {
			    		var device = {
			    			lockId:lockset.lockId,
			    			depend:0
			    		};
			    		callback(device);
			    	} else { // 如果有人为的脏数据，有可能得不到device信息，正常入库模式（depend=1）操作的，设备信息肯定能获取到
			    		that.getDeviceByLockId(lockset.lockId, function(device){
			    			callback(device);
			    		});
			    	}
		    	}
		    	
		    },
		    // 该方法的目的，就是为了找depend=1的设备信息
		    getDeviceByLockId : function(lockId, callback) {
		    	var that = this;
		    	if ($rootScope.networkState == 'none') {
		    		var device = that.getCachePubDeviceByLockId(lockId);
		    		callback(device);
		    	} else {
		    		hlService.home.getDeviceByLockId(lockId).get(function(res){
			    		callback(res);
			    	}, function(res){
			    		var device = that.getCachePubDeviceByLockId(lockId);
			    		callback(device);
			    	});
		    	}
		    	
		    },
		    // 从缓存的设备列表中获取设备信息，这里一般depend=1的情况，depend=0的情况不会走到这个缓存中，因此忽略
		    getCachePubDeviceByLockId : function(lockId) {
		    	var device = blcache.getPubDeviceByLockId(lockId);
		    	return device;
		    },
		    // 获取时间的绝对秒
		    getSecondsByDate : function(date) {
		    	return date.getTime() / 1000;
		    },
		    // yyyy-MM-dd, if middleLine=true :yyyyMMdd
		    getYmdByDate : function(date, middleLine) {
		    	var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
		    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
		    	var ymd = "" + date.getFullYear() + month + day;
		    	var format = date.getFullYear()+ "-" + month + "-" + day;
		    	if (middleLine) {
		    		format = date.getFullYear()+ "" + month + "" + day;
		    	}
		    	return format;
		    },
		    // HH:mm:ss ,if middleDot=true : HHmmss
		    getHmsByDate : function(date, middleDot) {
		    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
		    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
		    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
		    	var format = hours + ":" + minutes + ":" + seconds;
		    	if (middleDot) {
		    		format = hours + "" + minutes + "" + seconds;
		    	}
		    	return format;
		    },
		    // yyyy-MM-dd HH:mm:ss
		    getYmdHmsByDate : function(date) {
		    	var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
		    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
		    	var ymd = "" + date.getFullYear() + month + day;
		    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
		    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
		    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
		    	var format = date.getFullYear()+ "-" + month + "-" + day + " "
					+ hours + ":" + minutes + ":" + seconds;
		    	return format;
		    },
		    /**
			 * 写数据,外传回调函数
			 * */
		    sendData1 : function(data, fn, efn){
		    	var that = this;
				ble.write(that.deviceId, that.serviceUUID, that.characteristicUUID,
						that.stringToBytes(data).buffer, fn,efn);
			},
		    /**
			 * 写数据
			 * */
		    sendData : function(data){
		    	var that = this;
				ble.write(that.deviceId, that.serviceUUID, that.characteristicUUID,
	    				that.stringToBytes(data).buffer, function(res){
					
				},function(res){
					//$rootScope.openLog = "命令发送失败!请重试或重新进行蓝牙连接。";
					//$rootScope.openLog += '<=sendData:' + JSON.stringify(res);
					that.status = constantDefine.send_data_error;//"传送数据失败";
					that.notifyError = true;
					that.isReconnecting = true;
				});
			},
		    disconnect : function(){
		    	var that = this;
		    	ble.disconnect(that.deviceId,function(){
		    		that.status = constantDefine.no_connect;//"未连接";
				},function(){});
		    },
		    disconnectcallback : function(fn, en) {
		    	var that = this;
		    	ble.disconnect(that.deviceId,fn,en);
		    },
		    reconnect : function() {
		    	var that = this;
		    	ble.disconnect(that.deviceId,function(){
		    		that.status = constantDefine.scan_connection//"扫描连接中……";
		    		//$rootScope.openLog = '重连-》' + $rootScope.timecounter;
		    		that.scanDevice();
				},function(){
					//$rootScope.openLog = '重连关闭失败了-》' + $rootScope.timecounter;
				});
		    },
		    isConnected : function(deviceId,fn,efn){
		    	ble.isConnected(deviceId,fn,efn);
		    }
	    };
		return Bluetooth;
	
});
