angular.module('btapp.controllers').service('CONSTANT', function($ionicLoading,$rootScope,$ionicPopup) {
	this.msg = "提示信息";
	this.duration = 3000;
    this.currentLat = "";
    this.currentLon = "";
	this.showConfirm = function(msg){
        $ionicPopup.confirm({
            title: '提示',
            template: msg,
            buttons : [{
                text : '确定',
                onTap : function(e){
                    alert("确定");
                }
            }]
        });
    };
	this.msgShow = function(msg,duration) {
		if(msg != null){
			this.msg = msg;
		}
		if(duration != null){
			this.duration = duration;
		}
		$ionicPopup.show({
            title : constantDefine.tips,
			template : this.msg,
			buttons : [{
                text : '确认',
                type: 'button-default',
                onTap : function(e){

                }
            }]
		});
    };
    
    this.msgHide = function(){
       $ionicLoading.hide();
	};
    
    this.getBaiduMapLocation = function(fn){
        var that = this;
        
        if(window.cordova != undefined){
            
            //先尝试gps定位，再用百度地图API功能 定位
            window.cordova.plugins.diagnostic.isLocationAvailable(function(available){
                
                if(available){
                    if(navigator.geolocation ){
                
                        navigator.geolocation.getCurrentPosition(function(position){
                            that.translatePoint(position,fn);
                        },function(res){
                        
                            if(res.code == 1){
                                that.msgShow("提示：地理位置授权未开启，请在手机设置中将应用权限打开,否则会影响部分功能使用。");
                                fn(null);
                            } else if(res.code == 2){
                            that.msgShow("提示：地理位置获取异常。");
                                fn(null);
                            } else if(res.code == 3){
                                that.msgShow("提示:GPS信号弱。");
                                fn(null);
                            } else {
                                that.locationError(res);
                            }
                            
                        },{ timeout:30000,enableHighAccuracy:true }); //通过手机的webKit定位（目前ios系统对非https网站不提供支持）,所以在locationError（）中使用BMap.Geolocation()
                    }
                    else{
                        
                        that.msgShow('浏览器不支持html5来获取地理位置信息');
                    }
                } else {
                    
                    that.msgShow("地理位置功能未开启,请在设置中将本应用的地理位置权限开启,否则会影响部分功能使用。");
                    
                }
            }, function(error){
                
                that.msgShow("地理位置功能未开启,请在设置中将本应用的地理位置权限开启，否则会影响部分功能使用。");
            });
        }
        
    };
    
    this.translatePoint = function(position,fn){
        
        currentLat = position.coords.latitude;
        currentLon = position.coords.longitude;
       
        var gpsPoint = new BMap.Point(currentLon, currentLat);
       
        window.BMap.Convertor.translate(gpsPoint, 0, function(point){
           
            fn(point);
        }); //转换坐标

    };
    
    this.locationError = function(fn){
        var geolocation = new BMap.Geolocation();
        geolocation.getCurrentPosition(function(r){
            if(this.getStatus()== BMAP_STATUS_SUCCESS){
                currentLat = r.point.lat;
                currentLon = r.point.lng;
                var gpsPoint = new BMap.Point(currentLon, currentLat);
                BMap.Convertor.translate(gpsPoint, 0, function(point){
                    fn(point);
                }); //转换坐标
            }
        });
    };
    this.privateMsg = "<p>&nbsp;&nbsp;&nbsp;&nbsp;  欢迎使用华立云锁App，您在使用本产品前，请认真阅读本<a href='javascript:void(0);' ng-click='"
                    + 'openLink("https://www.epowerplat.com/bllock/index.html")'
                    + "'><<隐私政策>></a>，通过隐私政策向您说明如下内容：</p>"
                    + "<p>一、我们如何收集和使用您的个人信息</p>"
                    + "<p>二、我们如何共享、转让、公开披露您的个人信息</p>"
                    + "<p>三、我们如何如何保护您的个人信息</p>"
                    + "<p>四、您管理个人信息的权力</p>"
                    + "<p>五、未成年人个人信息保护</p>"
                    + "<p>六、隐私政策的适用范围</p>"
                    + "<p>七、隐私政策的变更和修订</p>"
                    + "<p>八、如何联系我们</p>"
                    + "<p>九、隐私政策的生效</p>"
                    + "<p>&nbsp;&nbsp;&nbsp;&nbsp;  我们将按业界成熟的安全标准，采取相应的安全保护措施来保护您的个人信息，请您放心授权并同意我们收集和处理您的个人信息。若您不同意本隐私政策，将会影响应用的使用。</p>"
                    ;
    this.showPrivateMsg = function(){
        
        $ionicPopup.show({
            title: '温馨提示',
            template: this.privateMsg,
            buttons : [{
                text : '不同意',
                type: 'button-default',
                onTap : function(e){
                    console.log("不同意");
                }
            },{
                text : '同意',
                type: 'button-positive',
                onTap : function(e){
                    window.localStorage.firstFlag=true;
                    console.log("同意");
                }
            }]
        });
    };
	
    return this;
});
