angular.module('btapp.services').factory('APIHandler', function($resource, $log, ENV) {

  var isLocal = ENV.api === "local";

  return {
    handle: function(apiName, params, method, responseType) {
      var url = ENV.api + "/" + apiName;
      if (isLocal) {
        url = "data/" + apiName + ".json";
      }
      method = method || "get";
      responseType = responseType || "json";
      if (isLocal) {
        return $resource(url);

      } else {
        if (method === "post") {
          return $resource(url, {}, {
            apiName: {
              params: params,
              method: method,
              responseType : responseType
            }
          });
        } else {
          return $resource(url, params, {
            apiName: {
              method: method,
              responseType : responseType
            }
          });
        }
      }
    }
  };
});