/*
 * --leaf 2020-04-26 --
 * 1.创建service(服务),可以在整个应用中共享，只需要导入服务名即可。
 * 2.作用：获取分页数据。
 * 3.用法：;
 */
angular.module('btapp.services').factory('HLPages', function() {
	var hl_pages = {

		/**
		 * 起始页
		 */
		start : 0,

		/**
		 * 每页显示限制量
		 */
		limit : 10,

		noData : false,

	  	hasNextPage : false,
	 
		dataList : [],
		  
		queryDataList : function(getDataList,params,success,error){
			var that = this;
			getDataList(params).query(function(res){
				
				if(res){
					if(res.length == 0){
						that.noData = true;
						that.hasNextPage = false;
						if(that.dataList.length == 0){
							that.noData = true; //无相关分页结果集
						} else {
							that.noData = false; 
						}
					} else {
						if(res.length < that.limit){
							that.hasNextPage = false;
						} else {
							that.hasNextPage = true;
						}
						that.noData = false;
						for(var i=0;i<res.length;i++){
							that.dataList.push(res[i]);
						}

					}
				} else {
					that.hasNextPage = false;
					that.noData = true;
				}

				success(that.dataList);

			},function(res){
				error();
			});
		},

		doRefresh : function(getDataList,params,success,error){
			
			var that = this;
			that.dataList = [];
			that.start = 0;
			params.start = that.start;
			if(params.limit == null){
				params.limit = that.limit;
			}
			that.queryDataList(getDataList,params,success,error);
		},

		doLoadMore : function(getDataList,params,success,error){
			
			var that = this;
			if(params.limit == null){
				params.limit = that.limit;
			}
			if(that.dataList.length !=0 ){
				that.start = params.start + 1;
				params.start = that.start;
			}else{
				that.start = 0;
				params.start = that.start;
			}
			that.queryDataList(getDataList,params,success,error);
		}
	  
		
	};
    return hl_pages;
});