/*
 * --leaf 2020-04-24 --
 * 1.创建service(服务),可以在整个应用中共享，只需要导入服务名即可。
 * 2.作用：参数非法判断。
 * 3.用法：;
 */
angular.module('btapp.services').factory('HLVALIDATE', function() {
	var hl_validate = {

		/**
		 * 非法描述
		 */
		errorMsg : 'leaf',

		/**
		 * 必须包含字母数字特殊符号三种组合的正则表达式，8~20位
		 */
		NAME_REGX : /^(?=.*\d)(?=.*[a-zA-Z])(?=.*[~!@#$%^&*])[\da-zA-Z~!@#$%^&*]{8,20}$/,

		/**
		 * 手机号验证
		 */
		PHONE_REGX : /^1(3|4|5|7|8|9)\d{9}$/,

		/***
		 * 用户名或密码信息复杂度判断：
		 * 
		 * 至少大写字母、小写字母、数字、特殊字符中的三种组合
		 * 长度下限不能低于8位
		 * 长度上限不能超过20位
		 * 
		 * account: 待校验字符串
		 * 
		 * desc : 待校验字符串描述，用于信息提示中
		 
		 */
		judge_Account : function(account,desc){
			var that = this;			
			var paramDesc = "用户名";

			if(desc != null){
				paramDesc = desc;
			}
		
			if(account == null || account == "" || account == undefined){
				that.errorMsg = "请先输入" + paramDesc;
				
				return false;
			}
			
			if(account.length < 8){
				that.errorMsg = paramDesc + "长度不能低于8位";
				return false;
			}
			if(account.length > 20){
				that.errorMsg = paramDesc + "长度不能高于20位";
				return false;
			}

			if(!account.match(that.NAME_REGX)){
				that.errorMsg = paramDesc + "必须由字母数字及特殊符号组成，特殊符号包括~!@#$%^&";
				return false;
			}

			return true;
		},

		/**
		 * 密码除信息复杂度验证外，与用户名的相关判断
		 * 禁止用户口令与用户名相同
		 * 禁止用户口令包含用户名 
		 */
		judge_passwordSameName : function(password,userName){
			var that = this;
			if( password == userName || password.indexOf(userName) != -1 ){
				that.errorMsg = "密码不能与用户名相同或包含用户名";
				return true;
			}
			return false;
		},

		/**
		 * 判断手机号是否合法
		 */
		judge_isPhoneNum : function(number){
			var that = this;
			if(number == null){
				that.errorMsg = "请先输入手机号";
				return false;
			}
			if(!number.match(that.PHONE_REGX)){
				that.errorMsg = "请填写正确手机号";
				return false;
			}
			return true;
		} 


	};
    return hl_validate;
});