angular.module('btapp.services').factory('hlService', function(APIHandler) {
	return {
		//首页模块
		home:{
		  getDeviceByLockId : function(lockId){
			  return APIHandler.handle("home/getDeviceByLockId/:lockId",{
				  lockId : lockId
			  });
		  },			
		  //开锁记录  新版模块(管理查看权限扩展)---start----fangrong.wu--2017-7-11
		  getPubHisDataListByAdminPeople : function(sysId){
			  return APIHandler.handle("home/getPubHisDataListByAdminPeople/:sysId",{
				  sysId : sysId
			  });
		  },
		  getPubHisDataListByAdminPeopleByUserId : function(userId){
			  return APIHandler.handle("home/getPubHisDataListByAdminPeopleByUserId/:userId",{
				  userId : userId
			  });
		  },
		  getPubHisDataListByAdminDevice : function(sysId){
			  return APIHandler.handle("home/getPubHisDataListByAdminDevice/:sysId",{
				  sysId : sysId
			  });
		  },
		  getPubHisDataListByAdminDeviceByDeviceId : function(deviceId){
			  return APIHandler.handle("home/getPubHisDataListByAdminDeviceByDeviceId/:deviceId",{
				  deviceId : deviceId
			  });
		  },
		  //----------开锁记录  新版模块--------------end---------------fangrong.wu
		  
		  //-----------新版开锁模块：--start--根据钥匙获取的锁的ID，到这张表里面匹配lockid，能够匹配到就能打开锁
		  getDeviceIsOpenByLockId : function(lockId,sysId){
			  return APIHandler.handle("home/getDeviceIsOpenByLockId/:lockId/:sysId",{
				  lockId : lockId,
				  sysId : sysId
			  });
		  },		  
		  //--------新版开锁模块------end------------------------------
		  
		  getPermissionListCount : function(userId){
			  return APIHandler.handle("home/getPermissionCountByUserId/:userId",{
				  userId : userId
			  });
		  },
		  getPermissionListByUserId : function(userId){
			  return APIHandler.handle("home/getPermissionListByUserId/:userId",{
				  userId : userId
			  });
		  },
		  getPermissionPagesByUserId : function(userId, start, limit) {
			  return APIHandler.handle("home/getPermissionPagesByUserId/:userId/:start/:limit",{
				  userId : userId,
				  start : start,
				  limit : limit
			  });
		  },
		  getPubHisDataListByUserId : function(userId, start, limit){
			  return APIHandler.handle("home/getPubHisDataListByUserId/:userId/:start/:limit",{
				  userId : userId,
				  start : start,
				  limit : limit
			  });
		  },
		  getPubHisDataListBySysId : function(sysId, start, limit){
			  return APIHandler.handle("home/getPubHisDataListBySysId/:sysId/:start/:limit",{
				  sysId : sysId,
				  start : start,
				  limit : limit
			  });
		  },
		  getPubLocksetByUserId : function(userId){
			  return APIHandler.handle("home/getPubLocksetByUserId/:userId",{
				  userId : userId
			  });
		  },
		  getDeviceSelectsByUserId : function(userId){
			  return APIHandler.handle("home/getDeviceSelectsByUserId/:userId",{
				 userId : userId 
			  });
		  },
		  getPubLocksetNumByLockId : function(lockId){
			  return APIHandler.handle("home/getPubLocksetNumByLockId/:lockId",{
				 lockId : lockId 
			  });
		  },
		  getPubLocksetByLockId : function(lockId){
			  return APIHandler.handle("home/getPubLocksetByLockId/:lockId",{
				 lockId : lockId 
			  });
		  },
		  getPubAreaData : function(){
			  return APIHandler.handle("home/getPubAreaData");
		  },
		  savePubHisData : function(){
			  return APIHandler.handle("home/savePubHisDataByUserLockId",{},'post');
		  },
		  savePubHisDataList : function(){
			  return APIHandler.handle("home/savePubHisDataList",{},"post");
		  },
		  savePubLocksetData : function(){
			  return APIHandler.handle("home/savePubLocksetData",{},"post");
		  },
		  savePubLocksetFromCache : function() {
			  return APIHandler.handle("home/savePubLocksetFromCache",{},"post");
		  },
		  savePubDeviceFromCache : function() {
			  return APIHandler.handle("home/savePubDeviceFromCache",{},"post");
		  },
		  //------挂锁旧模块：接口保存，旧版使用--2017-7-11
		  updateInstallLocksetData : function(){
			  return APIHandler.handle("home/updateInstallLocksetData",{},"post");
		  },
		  //-----挂锁新版模块：新版使用。select-->input:update->insert--fangrong.wu--2017-7-11
		  saveInstallLocksetData : function(){
			  return APIHandler.handle("home/saveInstallLocksetData",{},"post");
		  },
		  updateRecoverLocksetData : function(){
			  return APIHandler.handle("home/updateRecoverLocksetData",{},"post");
		  },
		  updateRecoverLocksetDataList : function(){
			  return APIHandler.handle("home/updateRecoverLocksetDataList",{},"post");
		  },
		  updateKeysByKeyName : function(){
			  return APIHandler.handle("home/updateKeysByKeyName",{},"post");
		  },
		  savePubDeviceDataList : function(){
			  return APIHandler.handle("home/savePubDeviceDataList",{},"post");
		  },
		  getPubLocksetByPoint : function(userId,startLng,endLng,startLat,endLat){
			  return APIHandler.handle("home/getPubLocksetByPoint/:userId/:startLng/:endLng/:startLat/:endLat",{
				  userId : userId,
				  startLng : startLng,
				  endLng : endLng,
				  startLat : startLat,
				  endLat : endLat
			  });
		  },
		  getLockUserRelByUserIdLockId : function(lockId,userId){
			  return APIHandler.handle("home/getLockUserRelByUserIdLockId/:lockId/:userId",{
				 lockId : lockId,
				 userId : userId
			  });
		  },
		  getDeviceUserRelByUserIdLockId : function(lockId,userId){
			  return APIHandler.handle("home/getDeviceUserRelByUserIdLockId/:lockId/:userId",{
				 lockId : lockId,
				 userId : userId
			  });
		  },
		  getDeviceUserRelByUserId : function(userId){
			  return APIHandler.handle("home/getDeviceUserRelByUserId/:userId",{
				 userId : userId
			  });
		  },		  
		  getDeviceInstalled : function(deviceId){
			  return APIHandler.handle("home/getDeviceInstalled/:deviceId",{
				 deviceId : deviceId
			  });
		  },
		  syncSeverTime : function(random) {
			  return APIHandler.handle("home/syncSeverTime/:random",{
				  random : random
			  });
		  },
		  /**
		   * 用户所在系统下所有钥匙参数
		   * */
		  getPubBlKeyListByUserId : function(userId,keyWord,start,limit){
			  return APIHandler.handle("home/getPubBlKeyPagesList/:userId/:keyWord/:start/:limit",{
				  userId : userId,
				  keyWord : keyWord,
				  start : start,
				  limit : limit
			  });
		  },
		  savePubBlKey : function(){
			  return APIHandler.handle("home/savePubBlKey",{},"post");
		  },
		  deletePubBlKey : function(){
			  return APIHandler.handle("home/deletePubBlKey",{},"post");
		  },
		  /**
		   * 获取用户所在系统下所有设备参数
		   * */
		  getPubDeviceListBySysId : function(sysId,devName,start,limit){
			  return APIHandler.handle("home/getPubDeviceListBySysIdAndPages/:sysId/:devName/:start/:limit",{
				  sysId : sysId,
				  devName : devName,
				  start : start,
				  limit : limit
			  });
		  },
		  savePubDevice : function(){
			  return APIHandler.handle("home/savePubDevice",{},"post");
		  },
		  deletePubDevice : function(){
			  return APIHandler.handle("home/deletePubDevice",{},"post");
		  },
		  /**
		   * 获取用户所在系统下所有区域参数
		   * */
		  getPubAreaDataBySysId : function(sysId){
			  return APIHandler.handle("home/getPubAreaDataBySysId/:sysId",{
				  sysId : sysId
			  });
		  },
		  getTeamUserListBySysId : function(sysId,name,start,limit){
			  return APIHandler.handle("home/getTeamUserListBySysIdAndPages/:sysId/:name/:start/:limit",{
				  sysId : sysId,
				  name : name,
				  start : start,
				  limit : limit
			  });
		  },
		  /**
		   * 获取班组参数
		   * */
		  getUserGroupBySysId : function(sysId){
			  return APIHandler.handle("home/getUserGroupBySysId/:sysId",{
				  sysId : sysId
			  });
		  },
		  /**
		   * 获取职务参数
		   * */
		  getUserTitleBySysId : function(sysId){
			  return APIHandler.handle("home/getUserTitleBySysId/:sysId",{
				  sysId : sysId
			  });
		  },
		  /**
		   * 保存用户参数配置
		   * */
		  saveTeamUserData : function(){
			  return APIHandler.handle("home/saveTeamUserData",{},"post");
		  },
		  /**
		   * 删除用户信息
		   * */
		  deleteTeamUser : function(){
			  return APIHandler.handle("home/deleteTeamUser",{},"post");
		  },
		  getPermissionListBySysId : function(sysId,keyWord,start,limit){
			  return APIHandler.handle("home/getPermissionListBySysIdAndPages/:sysId/:keyWord/:start/:limit",{
				  sysId : sysId,
				  keyWord : keyWord,
				  start : start,
				  limit : limit
			  });
		  },
		  deleteDeviceUserRelations : function(){
			  return APIHandler.handle("home/deleteDeviceUserRelations",{},"post");
		  },
		  /**
		   * 保存权限参数配置
		   * */
		  savePermissionData : function(){
			  return APIHandler.handle("home/saveDeviceUserRelationData",{},"post");
		  },
		  /**
		   * 保存区域参数配置
		   * */
		  savePubArea : function(){
			  return APIHandler.handle("home/savePubArea",{},"post");
		  },
		  deletePubAreaData : function(){
			  return APIHandler.handle("home/deletePubAreaData",{},"post");
		  },
		  /**
		   * 保存班组参数配置
		   * */
		  saveUserGroup : function(){
			  return APIHandler.handle("home/saveUserGroup",{},"post");
		  },
		  deleteUserGroupData : function(){
			  return APIHandler.handle("home/deleteUserGroupData",{},"post");
		  },
		  /**
		   * 保存职务参数配置
		   * */
		  saveUserTitle : function(){
			  return APIHandler.handle("home/saveUserTitle",{},"post");
		  },
		  deleteUserTitleData : function(){
			  return APIHandler.handle("home/deleteUserTitleData",{},"post");
		  }
		},
	    //用户模块
	    user: {
	      //获取用户摘要信息,包含 用户信息，告警信息数量，任务数量...
	      summary: function(userId) {
	        return APIHandler.handle("user_summary", {
	          userId: userId
	        });
	      },

	      //获取用户详细信息
	      info: function(userId) {
	        return APIHandler.handle("auth/info/:userId", {
	          userId: userId
	        });
	      },

	      //获取用户电站信息
	      station: function(stattionId) {
	        return APIHandler.handle("user_station", {
	          userId: userId
	        });
	      },

	      //用户消息设置
	      messageSetting: function(userId) {
	        return APIHandler.handle("user_message_setting", {
	          userId: userId
	        });
	      },

	      //用户任务设置
	      taskSetting: function(userId) {
	        return APIHandler.handle("user_task_setting", {
	          userId: userId
	        });
	      },

	      //修改用户名
	      updateUserName: function(userId, userName) {
	        return APIHandler.handle("user_update_userName", {
	          userId: userId,
	          userName: userName
	        }, "post");
	      },

	      //修改用户密码
	      updatePassword: function(userId, password) {
	        return APIHandler.handle("user_update_password", {
	          userId: userId,
	          password: password
	        }, "post");
		  },
		  

	      //修改用户信息,包含 手机号码，邮箱，以及其他信息
	      updateUserInfo: function(userId, userInfo) {
	        return APIHandler.handle("user_update_userInfo", {
	          userId: userId,
	          userInfo: userInfo
	        }, "post");
	      },

	      //用户登录
	      /*login: function(groupName, userName, password) {
	        return APIHandler.handle("user_login", {
	          userName: userName,
	          password: password,
	          groupname: '用电用户',
	          isDebug : 'true'
	        },"POST");
	      },*/
	      
			// 用户登录
		  login : function() {
			return APIHandler.handle("auth/login",{},'post');
		  },
		  //根据用户名修改密码
		  resetPasswordByName : function(){
			return APIHandler.handle("auth/updatePasswordByName", {},"post");
		  },

		  //根据旧密码修改密码
		  updatePasswordByOldPassword : function(){
			  return APIHandler.handle("auth/updatePasswordByOldPassword", {},"post");
		  },
		  initUsersPassword : function(){
			return APIHandler.handle("auth/initUsersPassword", {},"post");
		  },
				
	      //用户退出
	      logout: function() {
	        return APIHandler.handle("user_logout");
	      },

	      //忘记密码
	      forgetPassword: function(userName) {
	        return APIHandler.handle("user_forget", {
	          userName: userName
	        });
	      },

	      //注册
	      register: function(userInfo) {
	        return APIHandler.handle("user_register", {
	          userInfo: userInfo
	        }, "post");
	      },
		  getPermissionsAndDevicesAndLocksetsByUserId : function(userId) {
			  return APIHandler.handle("auth/getPermissionsAndDevicesAndLocksetsByUserId/:userId",{
				  userId : userId
			  });
		  }
	    },
	    // app 版本
	    appVersion : {
	    	// 获取发布的版本
	    	release : function(downloadDir) {
	    		return APIHandler.handle("version/release/:downloadDir",{
	    			downloadDir : downloadDir
	    		});
	    	}
	    },
	    // 实时数据请求
	    proxyToWebHmi : {
	    	request : function(para) {
	    		return APIHandler.handle("proxyToWebHmi/request/:para", {
		          para: para
		        });
	    	}
	    }
	  };
});
