angular.module('btapp',[ 'ionic', 'ngCordova','pascalprecht.translate', 'btapp.controllers', 'btapp.services',
		'btapp.config','btapp.factorys','ionic-datepicker','ionic-timepicker','btapp.caches']).run(
	function($ionicPlatform,$rootScope,$location,$cordovaToast,$ionicHistory,$timeout,$ionicPopup,$ionicLoading,
			$cordovaAppVersion, $cordovaFileTransfer, $cordovaFile, $cordovaFileOpener2, $cordovaNetwork, hlService, ENV) {
		$ionicPlatform.ready(function() {
			if (window.cordova && window.cordova.plugins
					&& window.cordova.plugins.Keyboard) {
				cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
				cordova.plugins.Keyboard.disableScroll(true);
			}
			if (window.cordova && StatusBar){
		        StatusBar.backgroundColorByHexString('#071F3B');
			}
			if(window.cordova && window.cordova.InAppBrowser){
				
				window.open = window.cordova.InAppBrowser.open;
			}
			if(ionic.Platform.isAndroid()){
				// 检查更新
			    checkUpdate();
			}
			
			document.addEventListener('deviceready', function () {
				cordova.plugins.backgroundMode.setDefaults({ 
					title : '提示',
					text : '程序将在后台运行',
					ticker : '运行提示'
				});
				cordova.plugins.backgroundMode.enable();
			    cordova.plugins.backgroundMode.onactivate = function () {
			        setTimeout(function () {
			        	cordova.plugins.backgroundMode.configure({
			                text:'Running in background for more than 5s now.'
			            });
			        }, 60000);
			    };
			    
			    $rootScope.networkState = $cordovaNetwork.getNetwork();

			    // 监听手机网络在线事件
			    $rootScope.$on('$cordovaNetwork:online', function(event, networkState){
			    	$rootScope.networkState = networkState;
			    });

			    // 监听手机网络离线事件
			    $rootScope.$on('$cordovaNetwork:offline', function(event, networkState){
			    	$rootScope.networkState = networkState;
			    });
			    
			}, false);
		}); 
		$ionicPlatform.registerBackButtonAction(function(e) {
			// 判断处于哪个页面时双击退出
			
			if (containsRootPath($location.path())) {
				if ($rootScope.backButtonPressedOnceToExit) {
					if($rootScope.bluetooth){
						$rootScope.bluetooth.disconnect();
						$rootScope.bluetooth="";
					}
					var now = new Date();
					var random = now.getTime();
					/*hlService.home.syncSeverTime(random).get(function(res){
						window.localStorage.upateTime = res.time;
						ionic.Platform.exitApp();
					}, function(res){
						ionic.Platform.exitApp();
					});*/
					ionic.Platform.exitApp();
					
				} else {
					$rootScope.backButtonPressedOnceToExit = true;
					$cordovaToast.showShortBottom(constantDefine.app_backMsg);
					setTimeout(function() {
						$rootScope.backButtonPressedOnceToExit = false;
					}, 2000);
				}
			} else if ($ionicHistory.backView()) {
				$rootScope.bluetooth.isInstalling = false;
				$ionicHistory.goBack();
			} else {
				$rootScope.backButtonPressedOnceToExit = true;
				$cordovaToast.showShortBottom(constantDefine.app_backMsg);
				setTimeout(function() {
					$rootScope.backButtonPressedOnceToExit = false;
				}, 2000);
			}
			e.preventDefault();
			return false;
		}, 101);

		// 退出系统时判断退出的条件
		function containsRootPath(path) {
			if (path == '/login' || path == '/home' || path == '/testHome') {
				return true;
			}
			return false;
		}
		
		// 检查更新
	    function checkUpdate() {
	        //获取版本
	    	window.cordova.getAppVersion.getVersionNumber(function(version) {
	    		var downloadDir = ENV.useplace;
	        	hlService.appVersion.release(downloadDir).get({},function(res){
	        		if(res.versionNumber != version){
	                	showUpdateConfirm(res);
	            	}
	        	},function(res){});
	        });
	    }
	    // 显示是否更新对话框
	    function showUpdateConfirm(appVersion) {
	        var confirmPopup = $ionicPopup.confirm({
	            title: constantDefine.app_updateTitle,
	            template: appVersion.logs, //从服务端获取更新的内容
	            cancelText: constantDefine.app_updateCancleText,
	            okText: constantDefine.app_updateOkText
	        });
	        confirmPopup.then(function (res) {
	            if (res) {
	                $ionicLoading.show({
	                    template: constantDefine.app_downloadProgress + "0%"
	                });
	                var url = ENV.download + '/' + appVersion.apkName; //从服务端获取更新APP的路径
	                var targetPath = "file:///storage/sdcard0/Download/" + appVersion.apkName; //APP下载存放的路径
	                var trustHosts = true;
	                var options = {};
	        		$cordovaFile.createDir(cordova.file.externalRootDirectory, "leaf", true)
	        	      .then(function (success) {
	        	    	  targetPath = success.nativeURL + appVersion.apkName;
	        	    	  $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function (result) {
	        	    		  // 打开下载下来的APP
	                          $cordovaFileOpener2.open(result.nativeURL, 'application/vnd.android.package-archive')
	                          .then(function () {
	                              // 成功
	                          	//alert("版本更新日志输出");
	                          }, function (err) {
	                              // 错误
	                        	  $cordovaToast.showShortCenter(constantDefine.app_installErr + JSON.stringify(err));
	                          });
	                          
	                          $ionicLoading.hide();
	                          
	                      }, function (err) {
	                    	  $cordovaToast.showShortCenter(constantDefine.app_downloadErr + JSON.stringify(err));
	                          $ionicLoading.hide();
	                      }, function (progress) {
	                          //进度，这里使用文字显示下载百分比
	                          $timeout(function () {
	                              var downloadProgress = (progress.loaded / progress.total) * 100;
	                              $ionicLoading.show({
	                                  template: constantDefine.app_downloadProgress + Math.floor(downloadProgress) + "%"
	                              });
	                              if (downloadProgress > 99) {
	                                  $ionicLoading.hide();
	                              }
	                          });
	                      });
	        
	        	      }, function (err) {
	        	    	  $cordovaToast.showShortCenter(constantDefine.app_createDirErr + JSON.stringify(err));
	        	    	  $ionicLoading.hide();
	        	      });
	            } else {
	                // 取消更新
	            }
	        });
	    }
})

.config(function($stateProvider, $urlRouterProvider,$ionicConfigProvider,$translateProvider) {
	//禁用苹果左边框右滑返回功能
	$ionicConfigProvider.views.swipeBackEnabled(false);		
	
	//设置本地化语言
    $translateProvider
    .translations('zh-cn', zh_CN) //注册语言
    .translations('en-us',en_US);
    if(navigator.language){  //获取本地语言环境
    	$translateProvider.preferredLanguage(navigator.language.toLocaleLowerCase() ); //设置语言
    }else{
    	$translateProvider.preferredLanguage("zh-cn"); //默认设置为中文
    }
	
	$stateProvider.state('login', {
		cache : false,
		url : "/login",
		templateUrl : "pages/login.html",
		controller : "common.login"
	}).state('home', {
		cache : false,
		url : "/home",
		templateUrl : "pages/home1.html",
		controller : "common.home"
	}).state('testHome', {
		cache : false,
		url : "/testHome",
		templateUrl : "pages/testHome.html",
		controller : "common.home"
	}).state('monitor', {
		url : '/monitor',
		templateUrl : 'pages/monitor.html',
		controller : 'MonitorCtrl'
	}).state('hisData',{
		cache : false,
		url : "/hisData",
		templateUrl : 'pages/hisData.html',
		controller : 'common.hisData'
	}).state('hisDataAdmin',{//fangrong 新增管理员特殊权限
		cache : true,
		url : "/hisDataAdmin",
		templateUrl : 'pages/hisDataAdmin.html',
		controller : 'common.hisDataAdmin'
	}).state('hisDataAdmin1',{
		cache : true,
		url : "/hisDataAdmin1",
		templateUrl : 'pages/hisDataAdmin1.html',
		controller : 'common.hisDataAdmin1'
	}).state('hisdatas',{
		cache : true,
		url : "/hisdatas",
		templateUrl : 'pages/hisdatas.html',
		controller : 'common.hisdatas'
	}).state('permData',{
		cache : false,
		url : "/permData",
		templateUrl : 'pages/permData.html',
		controller : 'common.permData'
	}).state('permissions',{
		cache : true,
		url : "/permissions",
		templateUrl : 'pages/permissions.html',
		controller : 'common.permissions'
	}).state('locationData',{
		cache : false,
		url : "/locationData/:lng/:lat",
		templateUrl : 'pages/location.html',
		controller : 'common.mapData'
	}).state('mapLead',{
		cache : false,
		url : "/mapLead",
		templateUrl : 'pages/leadMap.html',
		controller : 'common.mapLead'
	}).state('installLocksetView',{
		cache : false,
		url : "/installLocksetView",
		templateUrl : 'pages/installLocksetView.html',
		controller : 'common.installLocksetView'
	}).state('installLockset',{
		cache : false,
		url : "/installLockset",
		templateUrl : 'pages/installLockset.html',
		controller : 'common.installLockset'
	}).state('installLockset1',{
		cache : false,
		url : "/installLockset1",
		templateUrl : 'pages/installLockset1.html',
		controller : 'common.installLockset1'
	}).state('installLocksetResult',{
		cache : false,
		url : "/installLocksetResult/:lockId/:success",
		templateUrl : 'pages/installLocksetResult.html',
		controller : 'common.installLocksetResult'
	}).state('selectDevice',{
		cache : false,
		url : "/selectDevice",
		templateUrl : 'pages/selectDevice.html',
		controller : 'common.selectDevice'
	}).state('recoverLocksetView',{
		cache : false,
		url : "/recoverLocksetView",
		templateUrl : 'pages/recoverLocksetView.html',
		controller : 'common.recoverLocksetView'
	}).state('recoverLockset',{
		cache : false,
		url : "/recoverLockset",
		templateUrl : 'pages/recoverLockset.html',
		controller : 'common.recoverLockset'
	}).state('recoverLocksetResult',{
		cache : false,
		url : "/recoverLocksetResult/:lockId/:success",
		templateUrl : 'pages/recoverLocksetResult.html',
		controller : 'common.recoverLocksetResult'
	}).state('initLocksetDepend0',{
		cache : false,
		url : "/initLocksetDepend0",
		templateUrl : 'pages/initLocksetDepend0.html',
		controller : 'common.initLocksetDepend0'
	}).state('initLocksetDepend1',{
		cache : false,
		url : "/initLocksetDepend1",
		templateUrl : 'pages/initLocksetDepend1.html',
		controller : 'common.initLocksetDepend1'
	}).state('keyManage', {
		cache : false,
		url : "/keyManage",
		templateUrl : "pages/manage/keyManage.html",
		controller : "manage.key"
	}).state('addKey', {
		cache : false,
		url : "/addOrUpdate/:keyId/:name/:macAddr",
		templateUrl : "pages/manage/addOrUpdateKey.html",
		controller : "manage.addKey"
	}).state('deviceManage', {
		cache : false,
		url : "/deviceManage",
		templateUrl : "pages/manage/deviceManage.html",
		controller : "manage.device"
	}).state('addDevice', {
		cache : false,
		url : "/addOrUpdateDevice/:deviceId/:deviceName/:areaId/:location",
		templateUrl : "pages/manage/addOrUpdateDevice.html",
		controller : "manage.addDevice"
	}).state('userManage', {
		cache : false,
		url : "/userManage",
		templateUrl : "pages/manage/userManage.html",
		controller : "manage.user"
	}).state('addUser', {
		cache : false,
		url : "/addOrUpdateUser/:user",
		templateUrl : "pages/manage/addOrUpdateUser.html",
		controller : "manage.addUser"
	}).state('userGroupList', {
		cache : false,
		url : "/userGroupList/:user",
		templateUrl : "pages/manage/userGroupList.html",
		controller : "manage.userGroupList"
	}).state('userTitleList', {
		cache : false,
		url : "/userTitleList/:user",
		templateUrl : "pages/manage/userTitleList.html",
		controller : "manage.userTitleList"
	}).state('blKeyList', {
		cache : false,
		url : "/blKeyList/:user",
		templateUrl : "pages/manage/blKeyList.html",
		controller : "manage.blKeyList"
	}).state('permissionManage', {
		cache : false,
		url : "/permissionManage",
		templateUrl : "pages/manage/permissionManage.html",
		controller : "manage.permission"
	}).state('addPermission', {
		cache : false,
		url : "/addOrUpdatePermission/:permission",
		templateUrl : "pages/manage/addOrUpdatePerm.html",
		controller : "manage.addPerm"
	}).state('selectDeviceList', {
		cache : false,
		url : "/selectDeviceList/:permission",
		templateUrl : "pages/manage/pubDeviceSelectList.html",
		controller : "manage.selectDevice"
	}).state('selectUserList', {
		cache : false,
		url : "/selectUserList/:permission",
		templateUrl : "pages/manage/teamUserSelectList.html",
		controller : "manage.selectUser"
	}).state('areaManage', {
		cache : false,
		url : "/areaManage",
		templateUrl : "pages/manage/areaManage.html",
		controller : "manage.area"
	}).state('addArea', {
		cache : false,
		url : "/addOrUpdateArea/:areaId/:description",
		templateUrl : "pages/manage/addOrUpdateArea.html",
		controller : "manage.addArea"
	}).state('groupManage', {
		cache : false,
		url : "/groupManage",
		templateUrl : "pages/manage/groupManage.html",
		controller : "manage.group"
	}).state('addGroup', {
		cache : false,
		url : "/addOrUpdateGroup/:groupId/:description",
		templateUrl : "pages/manage/addOrUpdateGroup.html",
		controller : "manage.addGroup"
	}).state('titleManage', {
		cache : false,
		url : "/titleManage",
		templateUrl : "pages/manage/titleManage.html",
		controller : "manage.title"
	}).state('addTitle', {
		cache : false,
		url : "/addOrUpdateTitle/:titleId/:description",
		templateUrl : "pages/manage/addOrUpdateTitle.html",
		controller : "manage.addTitle"
	}).state('forget', {
        cache:false,
        url: "/forget",
        templateUrl: "pages/forget.html",
        controller: "common.forget"
    }).state('resetPassword',{
        cache : false,
        url : "/resetPassword",
        templateUrl : 'pages/resetPassword.html',
        controller:"common.resetPassword"
    });

	// if none of the above states are matched, use this as the fallback
	$urlRouterProvider.otherwise('/login');

});

angular.module('btapp.controllers', [ 'btapp.services','btapp.caches','btapp.factorys' ]);
angular.module('btapp.services', [ 'ngResource', 'btapp.config' ]);
angular.module('btapp.config',[]);
angular.module('btapp.caches',[]);
angular.module('btapp.factorys',['btapp.caches','btapp.services']);


angular.module('btapp.caches').factory('blcache', function($rootScope,$cordovaToast) {
	/*
	 * 注意：所有缓存数据在原有基础上增加一个cache：true的字段，
	 *     标记为是缓存数据，将离线数据存储到数据库时只处理cache:true的数据
	 */
	var bluetoothCache = {
		// 存储当前用户所属系统的所有设备信息（字符串，需要的时候转换成JSON对象，为了考虑空间，考虑是否压缩数据）
		devices : window.localStorage.devices ? window.localStorage.devices : '[]',
		// 存储当前用户所属系统的所有锁具信息（字符串，需要的时候转换成JSON对象）
		locksets : window.localStorage.locksets ? window.localStorage.locksets : '[]',
		// 存储当前用户和设备的权限关系信息（字符串，需要的时候转换成JSON对象）
		deviceUserRelations : window.localStorage.lockPerm ? window.localStorage.lockPerm : '[]',
		// 存储开锁记录
		hisDatas : window.localStorage.hisData ? window.localStorage.hisData : '[]',
		
		// 根据锁具id获取锁具信息
		getPubLocksetByLockId : function(lockId) {
			var locksets = JSON.parse(window.localStorage.locksets);
			var lockset = null;
	    	for(var i = 0, len = locksets.length; i < len; i++) {
	    		if (locksets[i].lockId == lockId) {
	    			lockset = locksets[i];
	    			break;
	    		}
	    	}
	    	return lockset;
		},
		// 根据锁具id获取设备信息
		getPubDeviceByLockId : function(lockId) {
			var devices = JSON.parse(window.localStorage.devices);
	    	var device = null;
	    	for(var i = 0, len = devices.length; i < len; i++) {
    			if (devices[i].lockId == lockId) {
    				device = devices[i];
    				break;
    			}
    		}
	    	return device;
		},
		// 根据用户Id获取设备和用户的关系列表
		getDeviceUserRelationByUserId : function(userId) {
			var relations = [];
			var deviceUserRelations = JSON.parse(window.localStorage.lockPerm);
			for(var i = 0, len = deviceUserRelations.length; i < len; i++) {
				if (deviceUserRelations[i]['userId'] == userId) {
					//处理权限关系 设备为-100的设备
					var record = deviceUserRelations[i];
					if(record.deviceId == -100){
						record.device = {
							'deviceId':-100,
							'deviceName':'全部设备',
							'location':'不限地址'
						}
					}
					relations.push(record);
				}
			}
			return relations;
		},
		// 挂锁，把设备表中的状态根据depend进行更新，并更新锁具表中的安装状态及时间
		installPubDeviceAndPubLockset : function(device) {
			this.updatePubDevice(device);
			this.updatePubLockset(device.lockId, device.deviceName, 1, device.time);
			this.updateDeviceUserRelation(device);
			
		},
		// 回收锁具，把设备表中的状态根据depend进行更新，并更新锁具表中的安装状态及时间
		recoverPubDeviceAndPubLockset : function(device) {
			var lockId = device.lockId;
			if (device.depend == 0) {
				device.lockId = 0;
			} else {
				device.deviceName = device.lockId;
			}
			device.installer = 0;
			device.longitude = 0;
			device.latitude = 0;
			this.updatePubDevice(device);
			this.updatePubLockset(lockId, ('回收锁' + device.lockId), 0, device.time);
			this.updateDeviceUserRelation(device);
		},
		// 根据depend情况进行更新
		updatePubDevice : function(device) {
			var devices = JSON.parse(window.localStorage.devices);
	    	for(var i = 0, len = devices.length; i < len; i++) {
    			var tempDevice = devices[i];
    			if (tempDevice.deviceId == device.deviceId) {
    				device.cache = true; // 增加cache标志位
    				devices[i] = device;
    			}
    		}
	    	this.refreshDevicesCache(devices);
		},
		// 根据设备更新锁具信息，保持和设备信息匹配
		updatePubLockset : function(lockId, description, installStatus, time) {
			var locksets = JSON.parse(window.localStorage.locksets);
	    	for(var i = 0, len = locksets.length; i < len; i++) {
	    		var tempLockset = locksets[i];
	    		if (tempLockset.lockId == lockId) {
	    			locksets[i]['lockName'] = description;
	    			locksets[i]['installStatus'] = installStatus;
	    			locksets[i]['time'] = time;
	    			locksets[i]['cache'] = true;// 增加cache标志位
	    		}
	    	}
	    	this.refreshLocksetsCache(locksets);
		},
		// 更新设备关系表中的device的信息
		updateDeviceUserRelation : function(device) {
			var deviceUserRelations = JSON.parse(window.localStorage.lockPerm);
			for(var i = 0, len = deviceUserRelations.length; i < len; i++) {
				if (deviceUserRelations[i]['deviceId'] == -100) {
					continue;
				}
				var oldDevice = deviceUserRelations[i]['device'];
				if (oldDevice == null) {
					continue;
				}
				if (oldDevice.deviceId == device.deviceId) {
					deviceUserRelations[i]['device'] = device;
					break;
				}
			}
			this.refreshDeviceUserRelationCache(deviceUserRelations);
		},
		
		// 存储开锁记录
		insertPubHisData : function(pubHisData) {
			var hisDatas = JSON.parse(window.localStorage.hisData);
			hisDatas.push(pubHisData);
			this.hisDatas = JSON.stringify(hisDatas);
			window.localStorage.hisData = this.hisDatas;
		},
		clearPubHisDataCache : function() {
			this.hisDatas = '[]';
			window.localStorage.hisData = '[]';
		},
		refreshDevicesCache : function(newDevices) {
			this.devices = JSON.stringify(newDevices);
			window.localStorage.devices = this.devices;
		},
		refreshLocksetsCache : function(newLocksets) {
			this.locksets = JSON.stringify(newLocksets);
			window.localStorage.locksets = this.locksets;
		},
		refreshDeviceUserRelationCache : function(deviceUserRelations) {
			this.deviceUserRelations = JSON.stringify(deviceUserRelations);
			window.localStorage.lockPerm = this.deviceUserRelations;
		},
		refreshAllCache : function(res) {
			this.refreshDevicesCache(res.devices);
			this.refreshLocksetsCache(res.locksets);
			this.refreshDeviceUserRelationCache(res.permission);
		},
		// 查询cache == true的设备信息，需要同步到服务器
		getPubDeviceByCache : function() {
			var devices = JSON.parse(window.localStorage.devices);
			var cacheDevices = [];
			for(var i = 0, len = devices.length; i < len; i++) {
    			var tempDevice = devices[i]; //depend=1时会有deviceId = -100 的关系，此时device = null  ---by leaf
    			if (tempDevice != null && tempDevice.cache) {
    				delete tempDevice.cache;
    				cacheDevices.push(tempDevice);
    			}
    		}
			return cacheDevices;
		},
		// 查询cache == true的锁具信息，需要同步到服务器
		getPubLocksetByCache : function() {
			var locksets = JSON.parse(window.localStorage.locksets);
			var cacheLocksets = [];
	    	for(var i = 0, len = locksets.length; i < len; i++) {
	    		var tempLockset = locksets[i];
	    		if (tempLockset.cache) {
	    			delete tempLockset.cache;
	    			cacheLocksets.push(tempLockset);
	    		}
	    	}
	    	return cacheLocksets;
		},
		// 查询开锁记录，需要同步到服务器
		getPubHisDataByCache : function() {
			var datas = JSON.parse(window.localStorage.hisData);
			return datas;
		},
		getSecondByDate : function(date) {
			return date.getTime() / 1000;
		},
		getNowSecondTime : function() {
			return this.getSecondByDate(new Date());
		},
		getLastTime : function() {
	    	var date = new Date();
	    	return date.getTime();
	    },
		isDevTimeSync : function() {
			var updateTime = window.localStorage.upateTime;
	    	var nowTime = this.getLastTime();
	    	if (updateTime - 0 > 0) {
	    		if ((nowTime - updateTime) < -60000) { // 60s
	        		return false;
	        	}
	    	}
	    	return true;
	    }
	};
	return bluetoothCache;
});
angular.module("btapp.config", []).constant("$ionicLoadingConfig", {
  template: "请求中..."
}).constant("ENV", {
  version: "1.0.19",
  name: "development",
  debug: false,
  //api: "local"
  //api: "https://www.epowerplat.com/bllock/services",
  api : "https://www.epowerplat.com/bllock/services",
  // apk下载地址 ：download要与useplace保持一致
  download : "https://www.epowerplat.com/bllock/download/blapk",
  useplace : 'blapk'
});


angular.module('btapp.controllers', [])
.controller('common.login',function($scope,$rootScope,$cordovaToast,$stateParams,$state,$ionicPopup,
		$cordovaFileTransfer, $cordovaFile, $cordovaFileOpener2, $timeout, hlService){
	if(window.localStorage.userName!=null){
		$scope.user={
			username:window.localStorage.userName,
			password:window.localStorage.password
		}
	}
	if(window.localStorage.hisData == null){
		window.localStorage.hisData = '[]';
	}
	if(window.localStorage.lockInstallData == null){
		window.localStorage.lockInstallData = '[]';
	}
	if(window.localStorage.recoverData == null){
		window.localStorage.recoverData = '[]';
	}
	
	
	
	
/**
 * 本控制器中注释代码为报文交互过程跟踪日志代码
 * 全部释放后会生成日志文件可跟踪查询
 * 请勿删除 
 * leaf
 * */	
//$rootScope.fileName = "bltoothLog.txt";
//$rootScope.fileURL = cordova.file.externalRootDirectory;
//createFile($rootScope.fileName);
	


	function createFile(fileName){
		var dateTime = new Date();
		var m = (dateTime.getMonth()+1) < 10 ? '0'+(dateTime.getMonth()+1) : (dateTime.getMonth()+1);
    	var d = dateTime.getDate() < 10 ? '0'+ dateTime.getDate() : dateTime.getDate();
    	var h = dateTime.getHours() < 10 ? '0' + dateTime.getHours() : dateTime.getHours();
    	var min = dateTime.getMinutes() < 10 ? '0' + dateTime.getMinutes() : dateTime.getMinutes();
    	var s = dateTime.getSeconds() < 10 ? '0' + dateTime.getSeconds() : dateTime.getSeconds();
		var timeFormate = dateTime.getFullYear()+"-"+m+"-"+d+" "
						+ h + ":" + min + ":" + s;
		var datas = "日志文件创建：" + timeFormate;
    	$cordovaFile.writeFile(cordova.file.externalRootDirectory, fileName,datas, true);
    	
	}
	
	$rootScope.writeFile = function(path,file,data){
		$cordovaFile.writeExistingFile(path, file, data);
	}
	

	/**
	 * 登录按钮监听
	 * */
    $scope.signIn = function(user) {
		$rootScope.showPopup = function(popupText) {
	        // 自定义弹窗
	        var myPopup = $ionicPopup.show({
	        	title : '提示',
	            template: popupText,
	            scope: $rootScope
	        });
	        $timeout(function() {
	           myPopup.close(); // 3秒后关闭弹窗
	        }, 3000);
	    };
	    
    	hlService.user.login().save({
      		name:user.username, 
      		password:hex_md5(user.password) 
      	},
      	function(res){
	    	if (res.login) {
    			window.localStorage.userName = res.name; //用户名
    			window.localStorage.password = user.password; //密码
    			window.localStorage.userId = res.userId; //用户id
    			window.localStorage.groupId = res.grpId;
    			window.localStorage.keyName = res.keyMacAddr; //蓝牙钥匙连接名
    			window.localStorage.lockPerm = JSON.stringify(res.permission); //权限信息
    			window.localStorage.opt = res.opt; //用户配置下功能按钮权限
    			window.localStorage.locksets = JSON.stringify(res.locksets); //用户下锁具信息
    			var blueService = {
					'service_uuid':'f000c0e0-0451-4000-b000-000000000000',
					'notifyCharacteristic_uuid':'f000c0e1-0451-4000-b000-000000000000',
					'characteristic_uuid':'f000c0e2-0451-4000-b000-000000000000'
				};
				window.localStorage.service = JSON.stringify(blueService);
				$scope.keyName = res.keyMacAddr;
			    $scope.service = blueService;
			    $rootScope.lockPerm = res.permission;
			    
			    //保存离线状态下开锁历史数据信息
			    if(window.localStorage.hisData){
			    	var hisRecords = JSON.parse(window.localStorage.hisData);
			    	if(hisRecords.length !=0){
				    	hlService.home.savePubHisDataList().save(hisRecords,function(res){
				    		$rootScope.showPopup("开锁数据同步成功。");
				    		window.localStorage.hisData = '[]';
			          	});
				    }
			    }
			    //保存离线状态下锁具回收数据信息
			    if(window.localStorage.recoverData){
			    	var recoverRecords = JSON.parse(window.localStorage.recoverData);
			    	if(recoverRecords.length != 0){
			    		hlService.home.updateRecoverLocksetDataList().save(recoverRecords,function(res){
				    		$rootScope.showPopup("锁回收数据同步成功。");
				    		window.localStorage.recoverData = '[]';
			          	});
			    	}
			    }
			    //保存离线状态下锁具安装定位信息
			    if(window.localStorage.lockInstallData){
			    	var lockInstallRecords = JSON.parse(window.localStorage.lockInstallData);
			    	if(lockInstallRecords.length != 0){
			    		
			    		var geolocation = new BMap.Geolocation();
		    			geolocation.getCurrentPosition(function(r){
		    				if(this.getStatus() == BMAP_STATUS_SUCCESS){
		    					var longitude = r.point.lng;
		    					var latitude = r.point.lat;
		    					for(var i=0;i<lockInstallRecords.length;i++){
		    						var record = lockInstallRecords[i];
		    						record.longitude = longitude;
		    						record.latitude = latitude;
		    						lockInstallRecords[i] = record;
		    					}
		    					hlService.home.savePubDeviceDataList().save(lockInstallRecords,function(res){
					    			$rootScope.showPopup("锁具安装数据同步成功。");
					    			window.localStorage.lockInstallData = '[]';
					          	});
		    					
		    				} else {
		    					$rootScope.showPopup("地址定位失败：" + this.getStatus());
		    				}        
		    			},{enableHighAccuracy: true});
			    	}
			    }
			    $rootScope.bluetooth = new BluetoothFactory();
			    $rootScope.bluetooth.setOnline(true);
    			$state.go('home');
	    	} else {
	    		$scope.errMsg = '用户名或密码错误！';
	    		$state.go('login');
	    	}
      },function(res){
    	 
		  var blueService = {
			 'service_uuid':'f000c0e0-0451-4000-b000-000000000000',
			 'notifyCharacteristic_uuid':'f000c0e2-0451-4000-b000-000000000000',
			 'characteristic_uuid':'f000c0e1-0451-4000-b000-000000000000'
		  };
		    
    	  if(user.username == window.localStorage.userName && user.password == window.localStorage.password){
    		  $scope.keyName = window.localStorage.keyName;
    		  $scope.service = blueService;
    		  $rootScope.lockPerm = window.localStorage.lockPerm; 
    		  
    		  $rootScope.bluetooth = new BluetoothFactory();
			  $rootScope.bluetooth.setOnline(false);
    		  $state.go("home");
    	  }else{
    		  $state.go("login");
    	  }
      });
    };
    
    var BluetoothFactory = function(){
		var Bluetooth = {
	    	/**
    		 * 是否进行蓝牙扫描
    		 * */
	    	scanFlag : true,
	    	/**
	    	 * 是否网络在线
	    	 * */
	    	online : true, 
	    	connected : false, //蓝牙是否连接过
	    	isInstalling : false,//是否为挂锁模式
	    	isInit : false, //是否初始化入库模式
	    	isMain : true, //是否维护模式
	    	isReturn : false,//是否回收模式
	    	key : "00 01 02 03 04 05 06 07",//异或校验算法钥匙信息
	    	setOnline : function(isOnline){
	    		this.online = isOnline;
	    	},
		    scanDevice : function(){
		    	if(!this.online){
		    		$cordovaToast.showShortCenter("网络偷懒啦，转离线模式。");
		    	}
		    	
		    	ble.scan([], 5, this.onScanDevice, this.onError);
		    },
		    
		    onScanDevice : function(device){
		    	if(device.name == $scope.keyName){
		    		$rootScope.bluetooth.deviceId = device.id;
		    		$rootScope.bluetooth.connect();
		    	}
		    },
		    
		    onError : function(reason){
		    	$rootScope.status += "(通信出错)";
		    	//$rootScope.bluetooth.disconnect();
		    },
		    
		    connect: function() {
		        ble.connect(this.deviceId, this.onConnect, this.onError);
		    },
		    /**
			 * 蓝牙通讯连接后启动通道监听
			 * */
			onConnect : function(peripheral){
				$rootScope.bluetooth.determineServiceType(peripheral);
				ble.startNotification($rootScope.bluetooth.deviceId, $rootScope.bluetooth.serviceUUID, $rootScope.bluetooth.notifyCharacteristicUUID, $rootScope.bluetooth.onData, $rootScope.bluetooth.onError);
				$rootScope.status = "已连接";
			},
			/**
			 * 通道信息解析
			 * */
			determineServiceType: function(peripheral) {
				peripheral.characteristics.filter(function(element) {
					var properties = element.properties;
					for(var i=0;i<properties.length;i++){
						var prop = properties[i];
						if("notify" == prop.toLowerCase()){
							$rootScope.bluetooth.serviceUUID = element.service;
							$rootScope.bluetooth.notifyCharacteristicUUID = element.characteristic;
						} else if("write" == prop.toLowerCase()){
							$rootScope.bluetooth.serviceUUID = element.service;
							$rootScope.bluetooth.characteristicUUID = element.characteristic;
						}
					}
					if($rootScope.bluetooth.notifyCharacteristicUUID && $rootScope.bluetooth.characteristicUUID){
						return;
					}
		        })[0];
		    },
			/**
			 * 通知监听处理
			 * */
		    onData : function(buffer){
		    	$rootScope.bluetooth.parseResult($rootScope.bluetooth.bytesToString(buffer));
		    },
		    /**
		     * 参数： 十六进制数
		     * 异或校验运算 结果返回十进制数
		     * */
		    XorCheck : function(Data,Length){
	    	    var sum=0,i;
	    	    for(var i=0; i<Length; i++)
	    	    {
	    	        sum ^= Data[i]; 
	    	    }
	    	    return sum;
	    	},
	    	/**
	    	 * 参数： 十六进制数
	    	 * 加密算法  结果返回十进制数
	    	 * */
		    HloveyRC4 : function(aInput, aKey) {
		    	var iS = new Uint8Array(256);
	    	    var iK = new Uint8Array(256);
	    	    for (var i = 0; i < 256; i++)
	    	        iS[i] = i;
	    	    var j = 1;
	    	    for (var i = 0; i < 256; i++){
	    	        iK[i] = aKey[(i % aKey.length)];
	    	    }
	    	    j = 0;
	    	    for (var i = 0; i < 256; i++) {
	    	        j = (j + iS[i]&0xff + iK[i]&0xff) % 256;
	    	        var temp = iS[i];
	    	        iS[i] = iS[j];
	    	        iS[j] = temp;
	    	    }
	    	    var i = 0;
	    	    j = 0;
	    	    var iOutputChar = new Uint8Array(aInput.length);
	    	    for (var x = 0; x < iOutputChar.length; x++) {
	    	        i = (i + 1) % 256;
	    	        j = (j + iS[i]&0xff) % 256;
	    	        var temp = iS[i]&0xff;
	    	        iS[i] = iS[j];
	    	        iS[j] = temp;
	    	        var t = (iS[i] + (iS[j]&0xff % 256)) % 256;
	    	        var iY = iS[t]&0xff;
	    	        var iCY =  iY;
	    	        iOutputChar[x] = aInput[x] ^ iCY;
	    	    }
	    	    return iOutputChar;
			},
			/**
			 * 参数：ArrayBuffer
			 * 结果：十进制转十六进制
			 * */
		    bytesToString : function(buffer) {
		    	var a = new Uint8Array(buffer);
				 var data = [];
				 for(var i=0;i<a.length;i++){
					 data[i] = $rootScope.bluetooth.decimalRadixToHex(a[i]);
				 }
				 return data;
			},
			/**
			 * 参数：十六进制参数字符串，已空格分开
			 * 结果：无符号十六进制数数组
			 * */
			stringToBytes : function(string) {
				 var arr = string.split(" ");
				 var array = new Uint8Array(arr.length);
				 for (var i = 0; i < arr.length;i++) {
					 array[i] = '0x' + arr[i];
				 }
				 return array;
			},
			/**
			 * 十六进制转十进制数
			 * 参数：十六进制数
			 * 结果：十进制数
			 * */
			hexRadixToDecimal : function(num){
				return parseInt(num, 16);
			},
			/**
			 * 十进制数转十六进制数
			 * 参数：十进制数
			 * 结果：十六进制数
			 * */
			decimalRadixToHex : function(num){
				return num.toString(16);
			},
			
			/**
			 * 安装锁具地址信息获取操作
			 * */
			installLock : function(installTime,timeFormate){
				if(this.online){
					var geolocation = new BMap.Geolocation();
	    			geolocation.getCurrentPosition(function(r){
	    				if(this.getStatus() == BMAP_STATUS_SUCCESS){
	    					var geoc = new BMap.Geocoder();  
	    					var point = new BMap.Point(r.point.lng,r.point.lat);
	    					geoc.getLocation(point, function(rs){
	    						var addComp = rs.addressComponents;
	    						
		    					$rootScope.Lockset = {
		    						lockId : $rootScope.lockId,
		    						installer : window.localStorage.userId,
		    						installName : window.localStorage.userName,
		    						time : installTime,
		    						timeFormate : timeFormate,
		    						longitude : r.point.lng,
		    						latitude : r.point.lat,
		    						location : addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber
		    					}
	    					});
	    				} else {
	    					$rootScope.showPopup("地址定位失败：" + this.getStatus());
	    				}        
	    			},{enableHighAccuracy: true});
				} else {
					$rootScope.Lockset = {
						lockId : $rootScope.lockId,
						installer : window.localStorage.userId,
						installName : window.localStorage.userName,
						time : installTime,
						timeFormate : timeFormate
						//longitude : r.point.lng,
						//latitude : r.point.lat,
						//location : addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber
					}
				}
			},
			/**
			 * 回收锁具参数设置
			 * */
			setRecoverParams : function(res){
				var device = res.device;
    			var time = res.device["time"] * 1000;
				var dateTime = new Date(time);
				var m = (dateTime.getMonth()+1) < 10 ? '0'+(dateTime.getMonth()+1) : (dateTime.getMonth()+1);
		    	var d = dateTime.getDate() < 10 ? '0'+ dateTime.getDate() : dateTime.getDate();
		    	var h = dateTime.getHours() < 10 ? '0' + dateTime.getHours() : dateTime.getHours();
		    	var min = dateTime.getMinutes() < 10 ? '0' + dateTime.getMinutes() : dateTime.getMinutes();
		    	var s = dateTime.getSeconds() < 10 ? '0' + dateTime.getSeconds() : dateTime.getSeconds();
				var timeFormate = dateTime.getFullYear()+"-"+m+"-"+d+" "
								+ h + ":" + min + ":" + s;
				
				$rootScope.recover = {
					lockId : $rootScope.lockId,
					deviceId : device.deviceId,
					deviceName : device.deviceName,
					installer : device.installer,
					installName : device.installUser.name,
					time : device.time,
					timeFormate : timeFormate,
					longitude : device.longitude,
					latitude : device.latitude,
					location : device.location
				}
			},
			/**
			 * 接收报文解析
			 * */
		    parseResult : function(result){
		    	var that = this;
		    	if(result[0] == 6){
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n接收到报文—— (1)");
		    		var dataLength = parseInt(result[1]);//报文数据长度
		    		var bwDatas = [];
		    		for(var i=0;i<dataLength;i++){
		    			var bwData = result[i+2];
		    			bwDatas.push(bwData);  //十六进制数据位
		    		}
		    		var secretData = that.HloveyRC4(that.stringToBytes(bwDatas.join(" ")), that.stringToBytes(that.key));
		    		var secretCheck = that.XorCheck(secretData.subarray(0,secretData.length-1), secretData.length-1);
		    		var newSecretData = new Uint8Array(secretData.length + 1);
		    		secretData[secretData.length-1] = secretCheck; //修改最后一位值为校验位的值{0:248,1:246,2:249,3:244,4:230,5:229}
		    		var sendDataInfo = [04,05]; //发送数据
		    		for(var i=0;i<secretData.length;i++){
		    			var d = secretData[i].toString(16);
		    			sendDataInfo[i+2] = d;
		    		}
		    		var j = 2 + dataLength;
		    		var checkData = result[j]; //校验位16进制
		    		var judgeCheck = that.XorCheck(that.stringToBytes(bwDatas.join(" ")), bwDatas.length); //十进制
		    		if(that.decimalRadixToHex(judgeCheck) != checkData){
		    			$rootScope.showPopup("报文数据校验位不一致，操作终止!!!");
		    		} else {
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n校验位校验成功—— (2)");
		    			var date = new Date();
	    				var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
	    				var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    			    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    			    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    			    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
// var logDate = date.getFullYear()+"-"+month+"-"+day+" "
//	+ hours + ":" + minutes + ":" + seconds;   			    	
			    		//解析报文获取锁具编码
			    		var lockId = "";
			    		lockId = that.hexRadixToDecimal(result[2])*Math.pow(256,3) 
			    					+ that.hexRadixToDecimal(result[3])*Math.pow(256,2) 
			    					+ that.hexRadixToDecimal(result[4])*256 
			    					+ that.hexRadixToDecimal(result[5]);
			    		$rootScope.lockId = lockId;
			    		//是否初始化入库状态
			    		if(that.isInit){
			    			if(that.online){
			    				
			    				hlService.home.savePubLocksetData().save({               
				    				lockId : lockId,
				    				lockName : '新锁'+ that.decimalRadixToHex(lockId),
				    				compId : window.localStorage.groupId
				    	      	},function(res){
				    	      		if(res.NUM == -1){
				    	      			$rootScope.showPopup("锁具已在库中!!!");
				    	      		}else{
				    	      			that.sendData(sendDataInfo.join(" "));
				    	      			$rootScope.showPopup("入库成功!!!");
				    	      		}
				    	      	},function(res){
				    	      		$rootScope.showPopup("网络偷懒啦!!!");
				    	      	});
			    			} else{
			    				$rootScope.showPopup("离线状态不支持该功能操作!!!");
			    			}
			    			
			    		} else { //非入库状态
			    			
			    			//判断锁具状态
				    		hlService.home.getPubLocksetByLockId(lockId).get(function(res){
				    			if(res.lockId == null || res.lockId ==""){
				    				$rootScope.showPopup("该锁具未入库，请先入库操作!");
				    				return;
				    			}
				    			var installStatus = res.installStatus;
				    			var assignStatus = res.assignStatus;
				    			if(assignStatus != 1){
				    				$rootScope.showPopup("该锁具未分配,请联系主站管理员!");
				    			} else {
				    				//挂锁模式
					    			if(that.isInstalling){
					    				var installTime = (date/1000).toFixed(0);
					    				if(installStatus == 1 ){
					    					$rootScope.showPopup("该锁具已使用,不用进行此操作!");
					    				} else {
					    					//判断该锁具是否在用户名下
					    					hlService.home.getLockUserRelByUserIdLockId(lockId,window.localStorage.userId).get(function(res){
					    						if(res.id == null){
					    							$rootScope.showPopup("该锁具未分配到用户下，操作终止!");
					    						}else{
					    							$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
					    							var timeFormate = date.getFullYear()+"-"+month+"-"+day+" "
													+ hours + ":" + minutes + ":" + seconds;
					    							that.installLock((date/1000).toFixed(0),timeFormate);
					    						}
					    					},function(res){
					    						$cordovaToast.showShortCenter("已转离线模式");
					    						var locksets = JSON.parse(window.localStorage.locksets);
					    						var isContain = false;
					    						for(var i=0;i<locksets.length;i++){
					    							var lockset = locksets[i];
					    							if(lockset.lockId == lockId){
					    								isContain = true;
					    								break;
					    							}
					    						}
					    						if(isContain){
					    							$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
					    							var timeFormate = date.getFullYear()+"-"+month+"-"+day+" "
													+ hours + ":" + minutes + ":" + seconds;
					    							that.installLock((date/1000).toFixed(0),timeFormate);
					    						}else{
					    							$rootScope.showPopup("该锁具未分配到用户下，操作终止!");
					    						}
					    					});
					    				}
					    			}else { //回收和开锁维护模式
					    				if(installStatus != 1){
					    					$rootScope.showPopup("该锁具未使用安装,不进行此操作!");
					    				}else{
					    					//权限判断
					    					hlService.home.getDeviceUserRelByUserIdLockId(lockId,window.localStorage.userId).get(function(res){
					    						if(res.id == null){
					    							$rootScope.showPopup("用户对该设备无操作权限,请联系管理员!");
					    						} else{
					    							var ymd = "" + date.getFullYear() + month + day;
							    			    	var hms = "" + hours + minutes + seconds;
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限判断操作开始—— (3)");   		
							    			    	if(ymd >= res.startDate && ymd <= res.endDate){ //判断是否在规定时间段内维护
							    			    		if(res.type == 0 || res.type == 1){ //每天仅判断时分秒
							        			    		if(hms > res.startTime && hms < res.endTime){
							    	    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限校验通过，发送报文—— (4)");							        			    			
							    	    			    		that.sendData(sendDataInfo.join(" "));
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n报文发送成功，开锁结束:" + logDate + "—— (5)\r\n\r\n"); 
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n发送报文—— " + sendDataInfo.join(" "));
							    	    			    		if(that.isReturn){ // 回收模式，加载数据
							    	    			    			that.setRecoverParams(res);
							    	    			    		}
							    	    			    	}else{
							    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    	    			    	}
							    	    			    } else if(res.type == 2){//每周
							    	    			    	var reDay = res.reday;
							    	    			    	var reDays = reDay.split(",");
							    	    			    	var weekDay = date.getDay();
							    	    			    	var isPerm = false;
							    	    			    	for(var i=0;i<reDays.length;i++){
							    	    			    		if(weekDay == reDays[i]){
							    	    			    			isPerm = true;
							    	    			    			break;
							    	    			    		}
							    	    			    	}
							    	    			    	if(isPerm){
							    	    			    		if(hms > res.startTime && hms < res.endTime){
							    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限校验通过，发送报文—— (4)");							        			    			
								    	    			    		that.sendData(sendDataInfo.join(" "));
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n报文发送成功，开锁结束:" + logDate + "—— (5)\r\n\r\n"); 
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n发送报文—— " + sendDataInfo.join(" "));
							    		    			    		if(that.isReturn){ // 回收模式，加载数据
								    	    			    			that.setRecoverParams(res);
								    	    			    		}
							    		    			    	}else{
							    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    		    			    	}
							    	    			    	}else{
							    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    	    			    	}
							    	    			    }else if(res.type == 3){ //每月
							        			    		var reDay = res.reday;
							        			    		var reDays = reDay.split(",");
							        			    		var isPerm = false;
							    	    			    	for(var i=0;i<reDays.length;i++){
							    	    			    		if(day == reDays[i]){
							    	    			    			isPerm = true;
							    	    			    			break;
							    	    			    		}
							    	    			    	}
							        			    		if(isPerm){
							        			    			if(hms > res.startTime && hms < res.endTime){
							    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限校验通过，发送报文—— (4)");							        			    			
								    	    			    		that.sendData(sendDataInfo.join(" "));
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n报文发送成功，开锁结束:" + logDate + "—— (5)"); 
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n发送报文—— " + sendDataInfo.join(" "));
							    		    			    		if(that.isReturn){ // 回收模式，加载数据
								    	    			    			that.setRecoverParams(res);
								    	    			    		}
							    		    			    	}else{
							    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    		    			    	}
							        			    		}else{
							        			    			$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							        			    		}
							    	    			    }
							    			    		
							    			    	}else{
							    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    			    	}
					    						}
					    					},function(res){
					    						$rootScope.showPopup("网络偷懒啦!");
					    					});
					    				}
					    			}
				    			}
				    		},function(res){
				    			
				    			$cordovaToast.showShortCenter("网络连接不可用");
				    			//挂锁模式
				    			if(that.isInstalling){
				    				var locksets = JSON.parse(window.localStorage.locksets);
					    			var isContain = false;
					    			for(var i=0;i<locksets.length;i++){
					    				var record = locksets[i];
					    				if(record.lockId == $rootScope.lockId){
					    					isContain = true;
					    					$scope.outLineLockSet = record;
					    					break;
					    				}
					    			}
					    			if(!isContain){
					    				$rootScope.showPopup("该锁具不在库中或你没权限操作，请联网后再进一步操作!");
					    			} else {
					    				//判断锁具是否已使用且已在缓存数据中
					    				var hisRecord = JSON.parse(window.localStorage.lockInstallData);
				    		    		var lockContain = false;
				    		    		
				    		    		for(var i=0;i<hisRecord.length;i++){
				    		    			var record = hisRecord[i];
				    		    			if(record.lockId == lockId){
				    		    				lockContain = true;
				    		    			}
				    		    		}
				    		    		if(lockContain){
				    		    			$rootScope.showPopup("该锁具已使用且缓存，请重新选择!!!");
				    		    		} else{
				    		    			var installTime = (date/1000).toFixed(0);
						    				if($scope.outLineLockSet.lockSet.installStatus == 1 ){
						    					$rootScope.showPopup("该锁具已使用,不再进行此操作!");
						    				} else {
				    							$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
				    							var timeFormate = date.getFullYear()+"-"+month+"-"+day+" "
												+ hours + ":" + minutes + ":" + seconds;
				    							that.installLock((date/1000).toFixed(0),timeFormate);
						    				}
				    		    		}
					    			}
				    			}else{  // 开关维护及回收模式
				    				var devices = JSON.parse(window.localStorage.lockPerm);
				    				var isContain = false;
				    				for(var i=0;i<devices.length;i++){
				    					var record = devices[i];
				    					var realLockId = record.device.lockId;
				    					if(realLockId == lockId){
				    						isContain = true;
				    						$scope.outLineDevice = record;
				    						break;
				    					}
				    				}
				    				if(!isContain){
				    					$rootScope.showPopup("该锁具未安装或用户对该设备无操作权限，请联网后再进一步操作。");
				    				}else{
				    					
				    					var ymd = "" + date.getFullYear() + month + day;
				    			    	var hms = "" + hours + minutes + seconds;
				    			    	if(ymd >= $scope.outLineDevice.startDate && ymd <= $scope.outLineDevice.endDate){ //判断是否在规定时间段内维护
				    			    		if($scope.outLineDevice.type == 0 || $scope.outLineDevice.type == 1){ //每天仅判断时分秒
				        			    		if(hms > $scope.outLineDevice.startTime && hms < $scope.outLineDevice.endTime){
				    	    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
				    	    			    		that.sendData(sendDataInfo.join(" "));
				    	    			    		if(that.isReturn){ // 回收模式，加载数据
				    	    			    			that.setRecoverParams($scope.outLineDevice);
				    	    			    		}
				    	    			    	}else{
				    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    	    			    	}
				    	    			    } else if($scope.outLineDevice.type == 2){//每周
				    	    			    	var reDay = $scope.outLineDevice.reday;
				    	    			    	var reDays = reDay.split(",");
				    	    			    	var weekDay = date.getDay();
				    	    			    	var isPerm = false;
				    	    			    	for(var i=0;i<reDays.length;i++){
				    	    			    		if(weekDay == reDays[i]){
				    	    			    			isPerm = true;
				    	    			    			break;
				    	    			    		}
				    	    			    	}
				    	    			    	if(isPerm){
				    	    			    		if(hms > $scope.outLineDevice.startTime && hms < $scope.outLineDevice.endTime){
				    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
				    		    			    		that.sendData(sendDataInfo.join(" "));
				    		    			    		if(that.isReturn){ // 回收模式，加载数据
					    	    			    			that.setRecoverParams(res);
					    	    			    		}
				    		    			    	}else{
				    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    		    			    	}
				    	    			    	}else{
				    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    	    			    	}
				    	    			    }else if($scope.outLineDevice.type == 3){ //每月
				        			    		var reDay = $scope.outLineDevice.reday;
				        			    		var reDays = reDay.split(",");
				        			    		var isPerm = false;
				    	    			    	for(var i=0;i<reDays.length;i++){
				    	    			    		if(day == reDays[i]){
				    	    			    			isPerm = true;
				    	    			    			break;
				    	    			    		}
				    	    			    	}
				        			    		if(isPerm){
				        			    			if(hms > $scope.outLineDevice.startTime && hms < $scope.outLineDevice.endTime){
				    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
				    		    			    		that.sendData(sendDataInfo.join(" "));
				    		    			    		if(that.isReturn){ // 回收模式，加载数据
					    	    			    			that.setRecoverParams(res);
					    	    			    		}
				    		    			    	}else{
				    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    		    			    	}
				        			    		}else{
				        			    			$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				        			    		}
				    	    			    }
				    			    	}else{
				    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    			    	}
				    			    	
				    				}
				    				
				    			}
				    			
				    		});
			    		}
		    		}
		    	}
		    	else if(result[0]==1){
		    		that.keyInfo = result;
		    	}
		    	else if(result[0]==4){
		    		var date = new Date();
					var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
			    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
			    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
			    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
			    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
		    		//判断是否开锁维护状态
		    		if(that.isMain){
		    			var ymd = date.getFullYear() + "-" + month + "-" + day;
				    	var hms = hours + ":" + minutes + ":" + seconds;
			    		$rootScope.openLog = "用户" + window.localStorage.userName + "于" + ymd + " " + hms +"有开启智能锁。"
			    		if(that.online){

			    			hlService.home.savePubHisData().save({
				          		userId : window.localStorage.userId, 
				          		lockId : $rootScope.lockId,
				          		optDate : (date/1000).toFixed(0)
				          	},function(res){
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n保存开锁日志—— (6)\r\n\r\n");
				          	});
			    		}else{
			    			var hisRecord = JSON.parse(window.localStorage.hisData);
			    			var record = {
		    					userId : window.localStorage.userId, 
				          		lockId : $rootScope.lockId,
				          		optDate : (date/1000).toFixed(0)	
			    			}
		    				window.localStorage.hisData = JSON.stringify(hisRecord.concat(record));
		    				$rootScope.showPopup("已缓存开锁记录!!!");
			    		}
		    		}
		    	}
		    },
		    /**
			 * 写数据
			 * */
		    sendData : function(data){
				ble.write($rootScope.bluetooth.deviceId, $rootScope.bluetooth.serviceUUID, $rootScope.bluetooth.characteristicUUID,
	    				$rootScope.bluetooth.stringToBytes(data).buffer, function(res){
				},$rootScope.bluetooth.onError);
			},
		    disconnect : function(){
		    	ble.disconnect($rootScope.bluetooth.deviceId,function(){
		    		$rootScope.status = "未连接";
				},function(){});
		    }
	    };
		return Bluetooth;
	};
})
.controller('common.home',function($scope,$rootScope,$stateParams,$state,$interval,$ionicPopup,$timeout,$ionicPopover,hlService){
	$rootScope.bluetooth.isInstalling = false;
	$rootScope.bluetooth.isReturn = false;
	$rootScope.bluetooth.isInit = false;
	$rootScope.bluetooth.isMain = true;
    //1 …………………………………………………………连接设备
    if($rootScope.bluetooth.scanFlag){
    	$rootScope.status = "未连接";
        if(ionic.Platform.isIOS()){
            $rootScope.bluetooth.scanDevice();
        }else if(ionic.Platform.isAndroid()){
            ble.enable(function(){
                $rootScope.bluetooth.scanDevice();
            });
        }
    }
  
    //2 …………………………………………………………处理状态显示
    var getStatus = function(){
    	if($rootScope.status == "已连接"){
    		$scope.getKeyDetail();
    		$rootScope.bluetooth.connected = true;
    		//$scope.getPermissionListCount(); //实时更新权限数据
    	}else{
    		$rootScope.status = "未连接";
    		if($rootScope.bluetooth.connected){ //已连接中断，尝试二次连接
    			$rootScope.bluetooth.scanDevice();
    		}
    	}
    }
    //3 ……………………………………………………………获取连接钥匙基本信息
    $scope.getKeyDetail = function(){
    	var data = '01 00 00';
    	$rootScope.bluetooth.sendData(data);
    	
    	$timeout(function(){
    		var responseKeyInfo = $rootScope.bluetooth.keyInfo
    		if(responseKeyInfo){
    			var firstData = parseInt(responseKeyInfo[8],16);
    			var secondData = parseInt(responseKeyInfo[9],16);
    			var voltage = firstData * 256 + secondData;
    			$rootScope.version = "版本 : version1";
    			if(voltage > 4100){
    				$rootScope.voltage = "钥匙电量:100%";
    			} else if(voltage < 3700){
    				$rootScope.voltage = "钥匙电量:0%";
    			} else {
    				var quantity = (voltage - 3700) / (0.4 * 1000);
        			$rootScope.voltage = "钥匙电量:" + (quantity*100).toFixed(2) + "%";
    			}
    			
    		}
    	},5000);
    }
    var statusTimeout = $interval(getStatus,1000);
    /**
     * 处理页面功能按钮显示
     * */
    $scope.initBtnShow = false;
    $scope.installBtnShow = false;
    $scope.recoverBtnShow = false;
    $scope.mainBtnShow = false;
    var opts = window.localStorage.opt.split(",");
    for(var i=0;i<opts.length;i++){
    	var opt = opts[i];
    	if(opt == 0){
    		$scope.initBtnShow = true;
    	} else if(opt == 1){
    		$scope.installBtnShow = true;
    	} else if(opt == 2){
    		$scope.mainBtnShow = true;
    	}else if(opt ==3){
    		$scope.recoverBtnShow = true;
    	}
    }
    
    //4 ………………………………………………………………开锁记录页面
    $scope.getHisData = function(){
    	
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = true;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('hisData');
    	
    }
    
    //5 ………………………………………………………………用户权限页面
    $scope.getPermData = function(){
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = true;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('permData');
    }
    
   //6 ………………………………………………………………地图页面
    $scope.getLocationData = function(){
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = true;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('locationData');
    }
    
    //7 ………………………………………………………………获取权限记录数量 …………………………未使用
    $scope.getPermissionListCount = function(){
    	var userId = window.localStorage.userId;
    	hlService.home.getPermissionListCount(window.localStorage.userId).get(function(res){
    		var permCount = res.NUM;
    		if(permCount != $rootScope.lockPerm.length){
    			//获取新的权限列表信息	
    			hlService.home.getPermissionListByUserId(window.localStorage.userId).query(function(res){
    				$rootScope.lockPerm = res;
    				window.localStorage.lockPerm = JSON.stringify(res);
    	    	});
    		}
    	});
    };
    
    //8 ………………………………………………………………安装锁具
    $scope.installLockset = function(){
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = true;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('installLockset');
    }
    
    //9 ………………………………………………………………右上角弹出菜单
	$ionicPopover.fromTemplateUrl('pages/menu.html', {
      scope: $scope
    }).then(function(popover) {
        $scope.popover = popover;
    });
    $scope.openPopover = function($event) {
      $scope.popover.show($event);
    };
    $scope.closePopover = function() {
      $scope.popover.hide();
    };
    $scope.$on('$destroy', function() {
      $scope.popover.remove();
    });
    
    //10 ………………………………………………………………新锁具入库操作
    $scope.count = 0;
    $scope.noActive = true;
	$scope.isActive = false;
    $scope.initBtnHandler = function(){
    	$scope.count += 1; 
    	if($scope.count%2 != 0){
    		$scope.noActive = false;
        	$scope.isActive = true;
        	$rootScope.bluetooth.isInit = true;
        	$rootScope.bluetooth.isInstalling = false;
        	$rootScope.bluetooth.isMain = false;
        	$rootScope.bluetooth.isReturn = false;
        	
    	}else{
    		$scope.noActive = true;
        	$scope.isActive = false;
        	$rootScope.bluetooth.isInit = false;
        	$rootScope.bluetooth.isMain = true;
        	$rootScope.bluetooth.isReturn = false;
        	$rootScope.bluetooth.isInstalling = false;
    	}
    	
    }
    
    //11 …………………………………………………………………回收操作
    $scope.recoverLockset = function(){
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = true;
    	$state.go('recoverLockset');
    }
    
    //未上锁设备加载
    hlService.home.getDeviceSelectsByUserId(window.localStorage.userId).query(function(res){
		$scope.deviceList = res;
		window.localStorage.deviceList = JSON.stringify(res);
	},function(res){
		$scope.deviceList = JSON.parse(window.localStorage.deviceList);
	});
})
.controller('common.hisData',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService){
	
	$scope.getPubHisDataByUserId = function(){
		hlService.home.getPubHisDataListByUserId(window.localStorage.userId).query(function(res){
			for(var i=0;i<res.length;i++){
				var obj = res[i];
				obj.DATE = dateFormate(obj.OPT_DATE);
				res[i] = obj;
			}
			
			$scope.hisDataList = res;
			window.localStorage.hisDataList = JSON.stringify(res);
			$scope.$broadcast('scroll.refreshComplete');
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
			$scope.hisDataList = JSON.parse(window.localStorage.hisDataList);
		});
	};
	$scope.getPubHisDataByUserId();
	
	var dateFormate = function(time){
		var date = new Date(time*1000);
		return date.getFullYear() + "-" + (date.getMonth()+1) + "-" + date.getDate() + " "
				+ date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
	}
})
.controller('common.permData',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService){
	
	$scope.getPermListByUserId = function(){
		hlService.home.getPermissionListByUserId(window.localStorage.userId).query(function(res){
			for(var i=0;i<res.length;i++){
				var obj = res[i];
				obj.startDate = dateFormate(obj.startDate);
				obj.endDate = dateFormate(obj.endDate);
				obj.startTime = timeFormate(obj.startTime);
				obj.endTime = timeFormate(obj.endTime);
				obj.typeDesc = reTypeFormate(obj.type);
				obj.reday = reDayFormate(obj.type,obj.reday);
				res[i] = obj;
			}
			
			$scope.lockPermList = res;
			window.localStorage.lockPermList = JSON.stringify(res);
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
			$scope.lockPermList = JSON.parse(window.localStorage.lockPermList);
		});
	};
	$scope.getPermListByUserId();
	
	var dateFormate = function(date){
		date = date + " ";
		var year = date.substring(0,4);
		var month = date.substring(4,6);
		var day = date.substring(6,8);
		return year + "-" + month + "-" + day;
	}
	
	var timeFormate = function(time){
		time = time + "";
		if(time.length == 5){
			var hour = time.substring(0,1);
			var minutes = time.substring(1,3);
			var seconds = time.substring(3,5);
			return hour + ":" + minutes + ":" + seconds;
		}else if(time.length == 6){
			var hour = time.substring(0,2);
			var minutes = time.substring(2,4);
			var seconds = time.substring(4,6);
			return hour + ":" + minutes + ":" + seconds;
		}else{
			return time;
		}
	}
	
	var reTypeFormate = function(type){
		if(type == 0){
			return "不重复";
		} else if(type == 1){
			return "每天";
		} else if(type == 2){
			return "每周";
		} else if(type == 3){
			return "每月";
		}
	}
	
	var reDayFormate = function(type,reDay){
		if(reDay != null){
			if(type == 2){
				var day = ["周日","周一","周二","周三","周四","周五","周六"];
				var reDays = reDay.split(",");
				var format = "";
				for(var i=0;i<reDays.length;i++){
					format += day[reDays[i]] + ",";
				}
				return format.substring(0, format.length-1);
			}else if(type == 3){
				if((reDay.split(",")).length>8){
					var reDays = reDay.split(",");
					var format = "";
					for(var i=0;i<8;i++){
						format += reDays[i] + ",";
					}
					return format+"……";
				}else{
					return reDay + "号";
				}
				
			}
		}else{
			return "";
		}
		
	}
	
})
.controller('common.mapData',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService){
	var lng = $stateParams.lng;
	var lat = $stateParams.lat;
	var map = new BMap.Map("container");
    map.addControl(new BMap.MapTypeControl());
    map.enableScrollWheelZoom(false);    //启用滚轮放大缩小，默认禁用
    map.enableContinuousZoom();    //启用地图惯性拖拽，默认禁用
    map.addControl(new BMap.NavigationControl());  //添加默认缩放平移控件 
    map.addControl(new BMap.OverviewMapControl()); //添加默认缩略地图控件
    map.addControl(new BMap.OverviewMapControl({ isOpen: false, anchor: BMAP_ANCHOR_BOTTOM_RIGHT }));   //右下角，打开	
    var localSearch = new BMap.LocalSearch(map);
    localSearch.enableAutoViewport(); //允许自动调节窗体大小
    
    if(lng != "" && lat != ""){
    	var point = new BMap.Point(lng,lat);
    	map.centerAndZoom(point, 20);
    	var marker = new BMap.Marker(point);  
        map.addOverlay(marker);  
    } else {
    	//定位信息
    	var geolocation = new BMap.Geolocation();
    	geolocation.getCurrentPosition(function(r){
    		if(this.getStatus() == BMAP_STATUS_SUCCESS){
    			var longitude = r.point.lng;
    			var latitude = r.point.lat;
    			
    			var point = new BMap.Point(longitude,latitude);
    			map.centerAndZoom(point,20);
    			
    			var startLng = longitude - 0.01;
    			var endLng = longitude + 0.01;
    			var startLat = latitude - 0.01;
    			var endLat = latitude + 0.01;
    			//获取方圆范围内的点，后台已舍弃条件删选返回了所有点 -- leaf
    			hlService.home.getPubLocksetByPoint(window.localStorage.userId,startLng,endLng,startLat,endLat).query(function(res){
    				for(var i=0;i<res.length;i++){
    					var record = res[i];
    					var maker = addMarker(new window.BMap.Point(record.LONGITUDE, record.LATITUDE), i,record);  
                       // addInfoWindow(maker, record, i); 
    				}
    			},function(res){
    				$rootScope.showPopup("网络偷懒啦!!!");
    			});
    		} 
    		else {
    			$rootScope.showPopup("地址定位失败：" + this.getStatus());
    		}        
    	},{enableHighAccuracy: true});
    	
    }
	
 
    
    
	// 添加标注  
    function addMarker(point, index,record) {  
        var myIcon = new BMap.Icon("http://api.map.baidu.com/img/markers.png",  
            new BMap.Size(23, 25), {  
                offset: new BMap.Size(10, 25),  
                imageOffset: new BMap.Size(0, 0 - index * 25)  
            });  
        var marker = new BMap.Marker(point);  
        
        
        
        //pop弹窗标题  
        var title = '<div style="font-weight:bold;color:#CE5521;font-size:14px;text-align:center;">' + record.DEVNAME + '</div>';  
        //pop弹窗信息  
        var html = [];  
        html.push('<table cellspacing="0" style="table-layout:fixed;width:100%;font:12px arial,simsun,sans-serif"><tbody>');  
        html.push('<tr>');  
        html.push('<td style="vertical-align:top;line-height:16px;width:30%;white-space:nowrap;word-break:keep-all">位置:</td>');  
        html.push('<td style="vertical-align:top;line-height:16px">' + record.LOCATION + '</td>');  
        html.push('</tr>');
        html.push('<tr>');  
        html.push('<td style="vertical-align:top;line-height:16px;width:30%;margin-top:10px;">上锁时间:</td>');  
        html.push('<td style="vertical-align:top;line-height:16px;margin-top:10px;">' + dateFormate(record.TIME) + ' </td>');  
        html.push('</tr>');  
        html.push('</tbody></table>');  
        var searchInfoWindow = null;
    	searchInfoWindow = new BMapLib.SearchInfoWindow(map, html.join(""), {
			title  : title,      //标题
			width  : 290,             //宽度
			height : 85,              //高度
			panel  : "panel",         //检索结果面板
			enableSendToPhone:false,
			enableAutoPan : true,     //自动平移
			searchTypes   :[
				BMAPLIB_TAB_TO_HERE,  //到这里去
				BMAPLIB_TAB_FROM_HERE, //从这里出发
				BMAPLIB_TAB_SEARCH   //周边检索 
			],
			currentAddr : '上海浦东新区龙东大道3000号'        //自定义属性   -- by leaf
		});
        
    	marker.addEventListener("click", function(e){
    	    searchInfoWindow.open(marker);
        })
        
        
        map.addOverlay(marker);  
        
        marker.setLabel(new BMap.Label(record.DEVNAME,{offset:new BMap.Size(-20,20),position:point}));
        return marker;  
    }  
//
//    // 添加信息窗口  
//    function addInfoWindow(marker, record) {  
//    	
//        //pop弹窗标题  
//        var title = '<div style="font-weight:bold;color:#CE5521;font-size:14px;text-align:center;">' + record.DEVNAME + '</div>';  
//        //pop弹窗信息  
//        var html = [];  
//        html.push('<table cellspacing="0" style="table-layout:fixed;width:100%;font:12px arial,simsun,sans-serif"><tbody>');  
//        html.push('<tr>');  
//        html.push('<td style="vertical-align:top;line-height:16px;width:30%;white-space:nowrap;word-break:keep-all">上锁时间:</td>');  
//        html.push('<td style="vertical-align:top;line-height:16px">' + dateFormate(record.TIME) + ' </td>');  
//        html.push('</tr>');  
//        html.push('<tr>');  
//        html.push('<td style="vertical-align:top;line-height:16px;width:30%;white-space:nowrap;word-break:keep-all">地点:</td>');  
//        html.push('<td style="vertical-align:top;line-height:16px">' + record.LOCATION + '</td>');  
//        html.push('</tr>');
//        html.push('</tbody></table>');  
//        var infoWindow = new BMap.InfoWindow(html.join(""), { title: title, width: 200 });  
//        var openInfoWinFun = function () {  
//            marker.openInfoWindow(infoWindow);  
//        };  
//        marker.addEventListener("click", openInfoWinFun);  
//        return openInfoWinFun;
//    }
   
    var dateFormate = function(time){
		if(time !=0 && time != null){
			var date = new Date(time*1000);
			return date.getFullYear() + "-" + (date.getMonth()+1) + "-" + date.getDate();
		}else{
			return 0;
		}
	}
    
})
.controller('common.mapLead',['$scope','$rootScope','$stateParams','$interval','$timeout','$ionicPopup','hlService','$state',
    function($scope,$rootScope,$stateParams,$interval,$timeout,$ionicPopup,hlService,$state){
	
	
	
	
	
	
	var map = new BMap.Map("leadMap");
    map.addControl(new BMap.MapTypeControl());
    map.enableScrollWheelZoom(false);    //启用滚轮放大缩小，默认禁用
    map.enableContinuousZoom();    //启用地图惯性拖拽，默认禁用
    map.addControl(new BMap.NavigationControl());  //添加默认缩放平移控件 
    map.addControl(new BMap.OverviewMapControl()); //添加默认缩略地图控件
    map.addControl(new BMap.OverviewMapControl({ isOpen: false, anchor: BMAP_ANCHOR_BOTTOM_RIGHT }));   //右下角，打开	
    var localSearch = new BMap.LocalSearch(map);
    localSearch.enableAutoViewport(); //允许自动调节窗体大小
	
    var point = new BMap.Point(121.639940,31.228950);
	map.centerAndZoom(point, 20);
	var marker = new BMap.Marker(point);  
    map.addOverlay(marker);  
    
    
    
    
    
    
}])
.controller('common.installLockset',['$scope','$rootScope','$stateParams','$interval','$timeout','$ionicPopup','hlService','$state',
    function($scope,$rootScope,$stateParams,$interval,$timeout,$ionicPopup,hlService,$state){
	
	var dateFormate = function(time){
		if(time !=0 && time != null){
			var date = new Date(time*1000);
			return date.getFullYear() + "-" + (date.getMonth()+1) + "-" + date.getDate();
		}else{
			return 0;
		}
	}
	
	hlService.home.getPubAreaData().query(function(res){
		$scope.areaList = res;
		window.localStorage.areaDataList = JSON.stringify(res);
	},function(res){
		$scope.areaList = JSON.parse(window.localStorage.areaDataList);
	});
	
	hlService.home.getDeviceSelectsByUserId(window.localStorage.userId).query(function(res){
		$scope.deviceList = res;
		window.localStorage.deviceList = JSON.stringify(res);
	},function(res){
		$scope.deviceList = JSON.parse(window.localStorage.deviceList);
		
	});
	
	$scope.saveInstallInfo = function(lockset){
		if(lockset.device.DEVICEID===null || lockset.device.DEVICEID===""){
			$rootScope.showPopup("请先选择挂锁设备信息");
			return;
		}
		if($rootScope.bluetooth.online){
			var params = {
				lockId : lockset.lockId,
				deviceId : lockset.device.DEVICEID,
				deviceName : lockset.device.DEVNAME,
				location : lockset.location,
				installer : $rootScope.Lockset.installer,
				time : $rootScope.Lockset.time,
				longitude : lockset.longitude,
				latitude : lockset.latitude
			};
			hlService.home.updateInstallLocksetData().save(params,function(res){
	      		if(res.NUM == -1){
	      			$rootScope.showPopup("挂锁信息未成功入库!!!");
	      		}else{
	      			$rootScope.showPopup("保存成功!!!");
	      			$rootScope.Lockset={};
	      		}
	      	},function(res){
	      		$rootScope.showPopup("网络偷懒啦!!!");
	      	});
		}else{
			var hisRecord = JSON.parse(window.localStorage.lockInstallData);
    		var isContain = false;
    		for(var i=0;i<hisRecord.length;i++){
    			var record = hisRecord[i];
    			if(record.deviceId == lockset.device.DEVICEID){
    				isContain = true;
    			}
    		}
    		if(isContain){
    			$rootScope.showPopup("该设备已上锁且缓存，请重新选择!!!");
    		} else{
    			var locksetRecord = {
					lockId : lockset.lockId,
					deviceId : lockset.device.DEVICEID,
					deviceName : lockset.device.DEVNAME,
					location : lockset.location,
					installer : $rootScope.Lockset.installer,
					time : $rootScope.Lockset.time
		      	};
				window.localStorage.lockInstallData = JSON.stringify(hisRecord.concat(locksetRecord));
				$rootScope.showPopup("已缓存!!!");
				$rootScope.Lockset={};
    		}
		}
	}
	
	$scope.locationHandler = function(Lockset){
		if(Lockset.longitude!="" && Lockset.longitude!=null && Lockset.longitude!=undefined){
			$state.go("locationData",{lng:Lockset.longitude,lat:Lockset.latitude});
		}
		
	}
	
	$scope.judgeInstalled = function(device){
		var deviceId = device.DEVICEID;
		hlService.home.getDeviceInstalled(deviceId).get(function(res){
			//是否已上鎖
    	},function(res){
    		var hisRecord = JSON.parse(window.localStorage.lockInstallData);
    		var isContain = false;
    		for(var i=0;i<hisRecord.length;i++){
    			var record = hisRecord[i];
    			if(record.deviceId == deviceId){
    				isContain = true;
    				break;
    			}
    		}
    		if(isContain){
    			$rootScope.showPopup("该设备已上锁且缓存，请重新选择!!!");
    		} else{
    			$rootScope.Lockset.location = device.LOCATION;
    		}
    		
    	});
	}
	
	
}])
.controller('common.recoverLockset',['$scope','$rootScope','$cordovaToast','$stateParams','$interval','$timeout','$ionicPopup','hlService','$state',
    function($scope,$rootScope,$cordovaToast,$stateParams,$interval,$timeout,$ionicPopup,hlService,$state){
	$rootScope.recover = {};
	
	$scope.submitRecoverInfo = function(recover){
		var recover = $rootScope.recover;
		if(recover.lockId == "" || recover.lockId == null){
			return;
		}
		hlService.home.updateRecoverLocksetData().save({
			lockId : recover.lockId,
			deviceId : $rootScope.recover.deviceId,
			deviceName : recover.deviceName,
			location : $rootScope.recover.location,
			installer : '',
			time : 0,
			longitude : 0,
			latitude : 0
      	},function(res){
      		if(res.NUM == -1){
      			$rootScope.showPopup("锁具回收状态更新失败!!!");
      		}else{
      			$rootScope.showPopup("状态更新成功!!!");
      			$rootScope.recover={};
      		}
      	},function(res){
      		$cordovaToast.showShortCenter("网络连接不可用");
      		//$rootScope.showPopup("网络偷懒啦!!!");
      		//离线
      		var hisRecoverData = JSON.parse(window.localStorage.recoverData);
      		var recoverRecord = {
  				lockId : recover.lockId,
  				deviceId : $rootScope.recover.deviceId,
  				deviceName : recover.deviceName,
  				location : $rootScope.recover.location,
  				installer : '',
  				time : 0,
  				longitude : 0,
  				latitude : 0
	      	};
      		window.localStorage.recoverData = JSON.stringify(hisRecoverData.concat(recoverRecord));
			$rootScope.showPopup("已缓存!!!");
			$rootScope.recover={};
      	});
	}
}]);


angular.module('btapp.controllers', [])
.controller('common.login',function($scope,$rootScope,$cordovaToast,$stateParams,$state,$ionicPopup,
		$cordovaFileTransfer, $cordovaFile, $cordovaFileOpener2, $timeout, hlService,ssBlKey,ysBlKey,ssSecondBlKey, blcache,CONSTANT){
	/**
	 * 处理隐私政策
	 */
	if(window.localStorage.firstFlag == undefined || window.localStorage.firstFlag == null){
		CONSTANT.showPrivateMsg();
	}

	$rootScope.openLink = function (url) {
		
		window.open(url, '_self','location=yes');
	}
	
	if(window.localStorage.userName!=null){
		$scope.user={
			username:window.localStorage.userName,
			password:window.localStorage.password
		};
	};
	if(window.localStorage.hisData == null){
		window.localStorage.hisData = '[]';
	}
	$rootScope.timecounter = 0;

/**
 * 本控制器中注释代码为报文交互过程跟踪日志代码
 * 连同ssBlKey中注释代码全部释放后会生成日志文件可跟踪查询
 * 请勿删除 
 * leaf
 * */	
//$rootScope.fileName = "bltoothLog.txt";
//$rootScope.fileURL = cordova.file.externalRootDirectory;
//createFile($rootScope.fileName);
	


	function createFile(fileName){
		var dateTime = new Date();
		var m = (dateTime.getMonth()+1) < 10 ? '0'+(dateTime.getMonth()+1) : (dateTime.getMonth()+1);
    	var d = dateTime.getDate() < 10 ? '0'+ dateTime.getDate() : dateTime.getDate();
    	var h = dateTime.getHours() < 10 ? '0' + dateTime.getHours() : dateTime.getHours();
    	var min = dateTime.getMinutes() < 10 ? '0' + dateTime.getMinutes() : dateTime.getMinutes();
    	var s = dateTime.getSeconds() < 10 ? '0' + dateTime.getSeconds() : dateTime.getSeconds();
		var timeFormate = dateTime.getFullYear()+"-"+m+"-"+d+" "
						+ h + ":" + min + ":" + s;
		var datas = "日志文件创建：" + timeFormate;
    	$cordovaFile.writeFile(cordova.file.externalRootDirectory, fileName,datas, true);
    	
	}
	
	$rootScope.writeFile = function(path,file,data){
		$cordovaFile.writeExistingFile(path, file, data);
	};
	
	// 登录按钮监听 -- by 冯永发 2017-8-14
	$scope.signIn = function(user) {
		$rootScope.showPopup = function(popupText) {
	        // 自定义弹窗
	        var myPopup = $ionicPopup.show({
	        	title : constantDefine.tips,//'提示',
	            template: popupText,
	            scope: $rootScope
	        });
	        $timeout(function() {
	           myPopup.close(); // 3秒后关闭弹窗
	        }, 3000);
		};
		
		if(window.localStorage.firstFlag == undefined || window.localStorage.firstFlag == null){
			$rootScope.showPopup("您未同意隐私政策，将会影响应用的使用。您可尝试重新打开本应用。");
			return;
		}
		
	    var now = new Date();
	    var devTime = now.getTime();
        if(!user || user.username == null || user.username == undefined){
            $rootScope.showPopup(constantDefine.username_error);
            return;
        }
        if(!user || user.password == null || user.password == undefined){
            $rootScope.showPopup(constantDefine.password_error);
            return;
        }
	    hlService.user.login().save({
      		name:user.username, 
      		password:hex_md5(user.password),
      		devTime : devTime
      	},
      	function(res){
      		if(!res.timeSync) {
      			$cordovaToast.showShortCenter(constantDefine.login_time_error);//"您的手机时间不正确，请重新设置后登录";
      			window.localStorage.updateTime = res.updateTime;
	    		$state.go('login');
	    	} else if (res.login) { 
      			window.localStorage.userName = res.name; //用户名
    			window.localStorage.password = user.password; //密码
    			window.localStorage.updateTime = res.updateTime;
    			window.localStorage.userId = res.userId; //用户id
    			window.localStorage.admin= res.admin;//fangrong 新增是否为管理员
    			window.localStorage.sysId= res.sysId;//fangrong sysid系统id    			
    			window.localStorage.groupId = res.grpId;
    			window.localStorage.keyName = res.keyMacAddr; //蓝牙钥匙连接名
    			window.localStorage.lockPerm = JSON.stringify(res.permission); //权限信息
    			window.localStorage.opt = res.opt; //用户配置下功能按钮权限
    			window.localStorage.locksets = JSON.stringify(res.locksets); //用户所属系统内的所有锁具列表
    			window.localStorage.devices = JSON.stringify(res.devices); // 用户所属系统的所有设备或者权限范围内的设备
    			window.localStorage.keyBaseKey = res.keyBaseKey;
    			window.localStorage.keyControlKey = res.keyControlKey;
    			window.localStorage.lastLoginTime = getLastTime();
				$scope.keyName = res.keyMacAddr;
			    $rootScope.lockPerm = res.permission;
			  //不以TKL-开头命名的蓝牙钥匙默认为易锁厂家，测试钥匙TKL-000001c5除外
			    if($scope.keyName && ($scope.keyName == 'TKL-000001c5' || $scope.keyName.indexOf('TKL-') == -1)){
			    	$rootScope.bluetooth = ysBlKey;
			    } else if($scope.keyName && $scope.keyName.indexOf('HLTKL-') != -1) { //易锁协议二开发使用HLTKL-命名
			    	$rootScope.bluetooth = ssSecondBlKey;
			    } else { //兼容易锁厂家版本一
			    	$rootScope.bluetooth = ssBlKey;
			    }
			    $rootScope.bluetooth.online = true;
			    $rootScope.bluetooth.keyName = $scope.keyName;
			    //根密钥
			    if(isNotNullOrEmpty(res.keyBaseKey)){
			    	$rootScope.bluetooth.gKey = res.keyBaseKey;
			    } 
			    //控制密钥
			    if(isNotNullOrEmpty(res.keyControlKey)){
			    	$rootScope.bluetooth.controlKey = res.keyControlKey;
			    }
			    // 先同步离线数据
      			saveCacheData(res.userId);
      			
				refreshLocation();
    			$state.go('home');
	    	} else {
	    		$cordovaToast.showShortCenter(constantDefine.login_error);//"用户名或密码错误！");
	    		window.localStorage.updateTime = res.updateTime;
	    		$state.go('login');
	    	}
      	},
      	function(res){
      		//$cordovaToast.showShortCenter(constantDefine.network_error);//"网络连接不可用");
      		var blueService = {
      			'service_uuid':'f000c0e0-0451-4000-b000-000000000000',
	  			'notifyCharacteristic_uuid':'f000c0e2-0451-4000-b000-000000000000',
	  			'characteristic_uuid':'f000c0e1-0451-4000-b000-000000000000'
	  		};
      		if (isDevTimeSync(window.localStorage.updateTime)) {
      			if(user.username == window.localStorage.userName && user.password == window.localStorage.password){
    	      		/*if (isLongTimeOffline()) { // 是否长时间离线
    	      			$cordovaToast.showShortCenter('由于长时间未在线登录，请开启网络，重新登录');
    	      			$state.go("login");
    	      		} else {
    	      			offlineLoginHandler();
    	      		}*/
    	      		offlineLoginHandler();
    	      	}else{
    	      		$state.go("login");
    	      	}
      		} else {
      			$cordovaToast.showShortCenter(constantDefine.login_time_error);//"您的手机时间不正确，请重新设置后登录");
	    		$state.go('login');
      		}
      	});
	};
	function saveCacheData(userId) {
		savePubDeviceByCache(userId);
		savePubHisDataByCache();
	}
	function savePubDeviceByCache(userId) {
		var devices = blcache.getPubDeviceByCache();
		if (devices.length > 0) {
			hlService.home.savePubDeviceFromCache().save(devices,function(res){
				savePubLocksetByCache(userId);
	    		$rootScope.showPopup(constantDefine.device_sync);//"设备数据同步成功。");
          	});
		}
	}
	function savePubLocksetByCache(userId) {
		var locksets = blcache.getPubLocksetByCache();
    	if(locksets.length > 0){
    		hlService.home.savePubLocksetFromCache().save(locksets,function(res){
    			refreshAllCache();
	    		$rootScope.showPopup(constantDefine.lock_sync);//"锁具数据同步成功。");
          	});
	    }
	}
	function savePubHisDataByCache() {
		var hisRecords = blcache.getPubHisDataByCache();
    	if(hisRecords.length !=0){
	    	hlService.home.savePubHisDataList().save(hisRecords,function(res){
	    		window.localStorage.hisData = '[]';
	    		$rootScope.showPopup(constantDefine.lock_sync);//"开锁数据同步成功。");
          	});
	    }
	}
	function refreshAllCache() {
		hlService.user.getPermissionsAndDevicesAndLocksetsByUserId(window.localStorage.userId).get(function(res){
			blcache.refreshAllCache(res);
		},
		function(res){
			// tips:update cache error
			
		});
	}
	function refreshLocation() {
		if ($rootScope.networkState != 'none') {	
            CONSTANT.getBaiduMapLocation(function(point){
                if(point){
                    var geoc = new window.BMap.Geocoder();
                    geoc.getLocation(point, function(rs){
                        var addComp = rs.addressComponents;
                        window.localStorage.longitude = point.lng;
                        window.localStorage.latitude = point.lat;
                        window.localStorage.location = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
                    });
                }
            });
//            var geolocation = new window.BMap.Geolocation();
//			geolocation.getCurrentPosition(function(r){
//
//				if(this.getStatus() == BMAP_STATUS_SUCCESS){
//                    var geoc = new window.BMap.Geocoder();
//                    var point = new window.BMap.Point(r.point.lng,r.point.lat);
//					geoc.getLocation(point, function(rs){
//						var addComp = rs.addressComponents;
//						window.localStorage.longitude = r.point.lng;
//						window.localStorage.latitude = r.point.lat;
//						window.localStorage.location = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
//					});
//				}
//			},{enableHighAccuracy: true,timeout: 10000});
		}
	}
    // 离线登录操作
    function offlineLoginHandler() {
    	$scope.keyName = window.localStorage.keyName;
		  $rootScope.lockPerm = window.localStorage.lockPerm; 
		  //不以TKL-开头命名的蓝牙钥匙默认为易锁厂家，测试钥匙TKL-000001c5除外
		  if($scope.keyName == 'TKL-000001c5' || $scope.keyName.indexOf('TKL-') == -1){
		      $rootScope.bluetooth = ysBlKey;
		  } else if($scope.keyName.indexOf('HLTKL-') != -1) { //易锁协议二开发使用HLTKL-命名
		      $rootScope.bluetooth = ssSecondBlKey;
		  } else { //兼容易锁厂家版本一
		      $rootScope.bluetooth = ssBlKey;
		  }
		  //根密钥
	      if(isNotNullOrEmpty(window.localStorage.keyBaseKey)){
	    	$rootScope.bluetooth.gKey = window.localStorage.keyBaseKey;
	      } 
	      //控制密钥
	      if(isNotNullOrEmpty(window.localStorage.keyControlKey)){
	    	$rootScope.bluetooth.controlKey = window.localStorage.keyControlKey;
	      }
		  $rootScope.bluetooth.online = false;
		  $rootScope.networkState = 'none';
		  $rootScope.bluetooth.keyName = $scope.keyName;
		  window.localStorage.updateTime = getLastTime();
		  $state.go("home");
    }
    function isNullOrEmpty(str) {
    	if (str == null || str == 'null' || str =='') {
    		return true;
    	}
    	return false;
    }
    function isNotNullOrEmpty(str) {
    	return !isNullOrEmpty(str);
    }
    function getLastTime() {
    	var date = new Date();
    	return date.getTime();
    }
    // 暂时设置如果时间超过24小时认为长时间未登录，需要在线登录以便刷新最新的缓存
    function isLongTimeOffline() {
    	if (isNullOrEmpty(window.localStorage.lastLoginTime)) {
    		return true;
    	}
    	if (moreThanXHours()) {
    		return true;
    	}
    	return false;
    }
    // 超过X小时
    function moreThanXHours() {
    	var nowTime = getLastTime();
    	if ((nowTime - window.localStorage.lastLoginTime) > 86400000) { // 24h = 24 * 60m * 60s * 1000ms
    		return true;
    	}
    	return false;
    }
    function isDevTimeSync(updateTime) {
    	var nowTime = getLastTime();
    	if (updateTime - 0 > 0) {
    		if ((nowTime - updateTime) < -60000) { // 60s
        		return false;
        	}
    	}
    	return true;
    }
})
.controller('common.home',function($scope,$rootScope,$stateParams,$state,$interval,$ionicPopup,$timeout,$ionicPopover,hlService,blcache,$ionicSideMenuDelegate,CONSTANT,ENV){
	$scope.admin = window.localStorage.admin;
	$rootScope.bluetooth.isInstalling = false;
	$rootScope.bluetooth.isReturn = false;
	$rootScope.bluetooth.isInit = false;
	$rootScope.bluetooth.isMain = true;
	$rootScope.closed = 0;
    //1 …………………………………………………………连接设备
	$scope.scanKeyDevice = function(){
		
		if($rootScope.bluetooth.deviceId != "" && $rootScope.bluetooth.deviceId !=null && $rootScope.bluetooth.scanFlag){
			$rootScope.bluetooth.isConnected($rootScope.bluetooth.deviceId, function(res){
				//$rootScope.bluetooth.status = "已连接";
			}, function(res){
				scanBLE();
			});
	    }
	};
	function scanBLE() {
		$rootScope.bluetooth.status = "扫描连接中……";
        if(ionic.Platform.isIOS()){
        	ble.isEnabled(function(){
        	}, function(){
        		$ionicPopup.alert({
        			title: '提示',
        		    template: '您好，钥匙连接需要使用手机蓝牙，打开后点击主页钥匙图标即可重新连接。',
        		    buttons:[{
        		    	text:'确定',
        		    	type:'button-default'
        		    	
        		    }]
        		}).then(function(res) {
        			if (window.cordova && window.cordova.plugins.settings) {
        			    window.cordova.plugins.settings.open("settings");
        			}
        		});
        	});
            $rootScope.bluetooth.scanDevice();
        }else if(ionic.Platform.isAndroid()){
            ble.isEnabled(function(){
                $rootScope.bluetooth.scanDevice();
            },function(){
				$ionicPopup.alert({
        			title: '提示',
        		    template: '您好，钥匙连接需要使用手机蓝牙，打开后点击主页钥匙图标即可重新连接。',
        		    buttons:[{
        		    	text:'确定',
        		    	type:'button-default'
        		    	
        		    }]
        		});
			});
        }
	}
// test hidden	
	//$scope.scanKeyDevice();
    //2 …………………………………………………………处理状态显示
    var getBluetoothStatus = function(){
    	//$rootScope.timecounter += 1;
    	//$rootScope.openLog = $rootScope.timecounter;
        if($rootScope.bluetooth.deviceId){
            $rootScope.bluetooth.isConnected($rootScope.bluetooth.deviceId,function(res){
                //$rootScope.openLog = 'isConnected:' + JSON.stringify(res) + '->' + $rootScope.timecounter;
                if ($rootScope.bluetooth.notifyError) {
                    $rootScope.bluetooth.reconnect();
                } else {
                    $scope.getKeyDetail();
                    $rootScope.bluetooth.connected = true;
                }
                
            },function(res){
                if ($rootScope.bluetooth.isReconnecting) {
                    $rootScope.bluetooth.reconnect();
                }
            });
        } else {
            if ($rootScope.bluetooth.isReconnecting) {
                $scope.scanKeyDevice();
            }
            
        }
    };
    //3 ……………………………………………………………获取连接钥匙基本信息
    $scope.getKeyDetail = function(){
    	var data = '01 00 00';
    	//$rootScope.openLog = '01码报文发送:' + JSON.stringify(data) + '->' + $rootScope.timecounter;
    	$rootScope.closed += 1;
    	$rootScope.dis = 0;
    	$rootScope.discon = false;
    	$rootScope.bluetooth.sendData1(data, function(res){
    		$rootScope.closed = 0;
    		$rootScope.bluetooth.status = constantDefine.already_connected;//'已连接';
    		//$rootScope.openLog += '01命令码响应:' + JSON.stringify(res) + '->' + $rootScope.timecounter;
    		var responseKeyInfo = $rootScope.bluetooth.keyInfo;
    		if(responseKeyInfo){
    			var firstData = parseInt(responseKeyInfo[8],16);
    			var secondData = parseInt(responseKeyInfo[9],16);
    			var voltage = firstData * 256 + secondData;
    			$rootScope.version = constantDefine.version;//"版本 : version1";
    			if(voltage > 4100){
    				$rootScope.voltage = constantDefine.key_quantity + "100%";
    			} else if(voltage < 3700){
    				$rootScope.voltage = constantDefine.key_quantity + "0%";
    			} else {
    				var quantity = (voltage - 3700) / (0.4 * 1000);
        			$rootScope.voltage = constantDefine.key_quantity + (quantity*100).toFixed(2) + "%";
    			}
    		}
    	}, function(res){
    		//$rootScope.openLog = "发送获取钥匙电量命令失败！！！请尝试重新进行蓝牙连接。"; // 为啥要写这个提示信息呢，害的我否定了所有的努力！！！！ 这里就不打印了，因为下次循环连接成功之后还会进入改函数
    		//$rootScope.bluetooth.status = "已断开";
    	});
    	$rootScope.closedTimer = setTimeout(function(){
    		//$rootScope.openLog += '每次都执行吗？？' + $rootScope.closed;
    		//$rootScope.openLog += '->' + $rootScope.closed;
    		if ($rootScope.closed > 1) {
    			$rootScope.bluetooth.status = constantDefine.connect_close; //'已断开，正在释放资源，请稍后连接……';
    			$rootScope.version = '';
    			$rootScope.voltage = '';
    			$rootScope.voltage = '';
    			/*$rootScope.bluetooth.status = '已断开';
    			$rootScope.bluetooth.disconnectcallback(function(res){
    				$rootScope.bluetooth.status = '已断开le' + JSON.stringify(res);
    				//scanBLE();
    				$rootScope.bluetooth.reconnect();
    			}, function(){});*/
    		}
    	},1000);
    };
    function getBluetoothClosedStatus() {
    	if ($rootScope.closed > 0) {
    		$rootScope.bluetooth.disconnect();
    		$rootScope.bluetooth.isReconnecting = true;
    	}
    }
    function saveCacheData() {
    	if ($rootScope.networkState != 'none') {
    		var userId = window.localStorage.userId;
    		savePubDeviceByCache(userId);
    		savePubHisDataByCache();
    		syncServerTime();
    	}
    	
	}
	function savePubDeviceByCache(userId) {
		var devices = blcache.getPubDeviceByCache();
		if (devices.length > 0) {
			hlService.home.savePubDeviceFromCache().save(devices,function(res){
				savePubLocksetByCache(userId);
	    		//$rootScope.showPopup("设备数据同步成功。");
          	});
		}
	}
	function savePubLocksetByCache(userId) {
		var locksets = blcache.getPubLocksetByCache();
    	if(locksets.length > 0){
    		hlService.home.savePubLocksetFromCache().save(locksets,function(res){
    			refreshAllCache();
	    		//$rootScope.showPopup("锁具数据同步成功。");
          	});
	    }
	}
	function syncServerTime() {
		var now = new Date();
		var random = now.getTime();
		hlService.home.syncSeverTime(random).get(function(res){
			window.localStorage.upateTime = res.time;
		});
		
	}
	function savePubHisDataByCache() {
		var hisRecords = blcache.getPubHisDataByCache();
    	if(hisRecords.length !=0){
	    	hlService.home.savePubHisDataList().save(hisRecords,function(res){
	    		blcache.clearPubHisDataCache();
	    		//$rootScope.showPopup("开锁数据同步成功。");
          	});
	    }
	}
	function refreshAllCache() {
		hlService.user.getPermissionsAndDevicesAndLocksetsByUserId(window.localStorage.userId).get(function(res){
			blcache.refreshAllCache(res);
		},
		function(res){
			// tips:update cache error
			
		});
	}
	function refreshLocation() {
		if ($rootScope.networkState != 'none') {
            CONSTANT.getBaiduMapLocation(function(point){
                if(point){
                    var geoc = new BMap.Geocoder();
                    geoc.getLocation(point, function(rs){
                        
                        var addComp = rs.addressComponents;
                        window.localStorage.longitude = point.lng;
                        window.localStorage.latitude = point.lat;
                        window.localStorage.location = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
                    });
                }
            });
//			var geolocation = new BMap.Geolocation();
//			geolocation.getCurrentPosition(function(r){
//				if(this.getStatus() == BMAP_STATUS_SUCCESS){
//					var geoc = new BMap.Geocoder();
//					var point = new BMap.Point(r.point.lng,r.point.lat);
//					geoc.getLocation(point, function(rs){
//						var addComp = rs.addressComponents;
//						window.localStorage.longitude = r.point.lng;
//						window.localStorage.latitude = r.point.lat;
//						window.localStorage.location = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
//					});
//				}
//			},{enableHighAccuracy: true,timeout: 10000});
		}
		
	}
	if ($rootScope.saveCacheDataTimer == null) {
		//test hidden
 		// $rootScope.saveCacheDataTimer = $interval(function(){
	    // 	saveCacheData();
	    // }, 1000);
	}
    
    if ($rootScope.refreshLocationTimer == null) {
    	// $rootScope.refreshLocationTimer = $interval(function(){
        // 	refreshLocation();
        // }, 180000); // 3m refresh
    }
    
    if ($rootScope.statusTimer == null) {
//test hidden   	
    	// $rootScope.statusTimer = $interval(function(){
        // 	getBluetoothStatus();
        // },1000);
    }
    
    /**
     * 处理页面功能按钮显示
     * */
    $scope.initBtnShow = false;
    $scope.installBtnShow = false;
    $scope.recoverBtnShow = false;
    $scope.mainBtnShow = false;
    var opts = window.localStorage.opt.split(",");
    for(var i=0;i<opts.length;i++){
    	var opt = opts[i];
    	if(opt == 0){
    		$scope.initBtnShow = true;
    	} else if(opt == 1){
    		$scope.installBtnShow = true;
    	} else if(opt == 2){
    		$scope.mainBtnShow = true;
    	}else if(opt ==3){
    		$scope.recoverBtnShow = true;
    	}
    }
    
    //4 ………………………………………………………………开锁记录页面
    $scope.getHisData = function(){
    	if (!blcache.isDevTimeSync()) {
    		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
    		return;
    	}
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = true;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('hisdatas');
    	
    };
    
    //5 ………………………………………………………………用户权限页面
    $scope.getPermData = function(){
    	if (!blcache.isDevTimeSync()) {
    		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
    		return;
    	}
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = true;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('permissions');
    };
    
   //6 ………………………………………………………………地图页面
    $scope.getLocationData = function(){
    	if (!blcache.isDevTimeSync()) {
    		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
    		return;
    	}
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = true;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('locationData');
    };
    
    //7 ………………………………………………………………获取权限记录数量 …………………………未使用
    $scope.getPermissionListCount = function(){
    	var userId = window.localStorage.userId;
    	hlService.home.getPermissionListCount(window.localStorage.userId).get(function(res){
    		var permCount = res.NUM;
    		if(permCount != $rootScope.lockPerm.length){
    			//获取新的权限列表信息	
    			hlService.home.getPermissionListByUserId(window.localStorage.userId).query(function(res){ // 该后台请求方法找那个如果有-100的记录，值返回-100的记录，需要注意使用，不能有效获取权限列表
    				$rootScope.lockPerm = res;
    				window.localStorage.lockPerm = JSON.stringify(res);
    	    	});
    		}
    	});
    };
    
    //8 ………………………………………………………………安装锁具
    $scope.installLockset = function(){
    	if (!blcache.isDevTimeSync()) {
    		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
    		return;
    	}
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = true;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('installLocksetView');
    };
    
    //9 ………………………………………………………………右上角弹出菜单
	$ionicPopover.fromTemplateUrl('pages/menu.html', {
      scope: $scope
    }).then(function(popover) {
        $scope.popover = popover;
    });
    $scope.openPopover = function($event) {
      $scope.popover.show($event);
    };
    $scope.closePopover = function() {
      $scope.popover.hide();
    };
    $scope.$on('$destroy', function() {
      $scope.popover.remove();
    });
    
    //10 ………………………………………………………………新锁具入库操作
    $scope.count = 0;
    $scope.noActive = true;
	$scope.isActive = false;
    $scope.initBtnHandler = function(){
    	if (!blcache.isDevTimeSync()) {
    		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
    		return;
    	}
    	$rootScope.bluetooth.isInit = true;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isReturn = false;
    	$rootScope.bluetooth.switchDepend = 1;
    	$state.go('initLocksetDepend1');
    };
    
    //11 …………………………………………………………………回收操作
    $scope.recoverLockset = function(){
    	if (!blcache.isDevTimeSync()) {
    		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
    		return;
    	}
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = true;
    	$state.go('recoverLocksetView');
    };
    
    //12 ……………………………………………………………………初始化钥匙密钥
    $scope.initKeyBtnHandler = function(){
    	if($rootScope.bluetooth.status == constantDefine.already_connected){
    		$scope.key = {};
    		$scope.showConfirm = function() {
    			var confirmPopup = $ionicPopup.confirm({
    				title: constantDefine.key_param,
    				templateUrl: 'privKeyParams.html',
    				scope: $scope,
    				buttons:[
    				         {text:constantDefine.cancel, onTap: function(e) {return false;}},  //取消
    				         {text:constantDefine.cancel, type: 'button-positive', onTap: function(e) {
    				        	 if($scope.key.baseKey == null) {
    				        		 $rootScope.showPopup(constantDefine.input_base_key);//"请先输入根密钥");
    								 e.preventDefault();
    				        	 } else if ($scope.key.controlKey == null){
    								$rootScope.showPopup(constantDefine.input_control_key);//"请先输入控制密钥");
    								e.preventDefault();
    							 } else {
    								var formate = /^[0-9a-fA-F]{1,2}$/;
    								var inputIds = $scope.key.baseKey.split(" ");
    								if(inputIds.length != 8){
    									$rootScope.showPopup(constantDefine.base_key_error);//"根密钥长度非法!");
    									e.preventDefault();
    								} else {
    									for(var i=0;i<inputIds.length;i++){
    										if(!formate.test(inputIds[i])){
    											$rootScope.showPopup(constantDefine.base_key_bit_error + (i+1));//"根密钥出现非16进制编码!字节位："
    											e.preventDefault();
    										}
    									}
    								}
    								var versions = $scope.key.controlKey.split(" ");
    								if(versions.length != 8){
    									$rootScope.showPopup(constantDefine.control_key_error);//"控制密钥长度非法!");
    									e.preventDefault();
    								} else {
    									for(var i=0;i<versions.length;i++){
    										if(!formate.test(versions[i])){
    											$rootScope.showPopup(constantDefine.control_key_bit_error + (i+1)); //"控制密钥出现非16进制编码!字节位："
    											e.preventDefault();
    										}
    									}
    								}
    								return true;
    							 }
    				         }}
    				] //确认
    			});
        		confirmPopup.then(function(res) {
        			var newBaseKey = $scope.key.baseKey;
        			$rootScope.openLog = constantDefine.input_baseKey + newBaseKey + '<br>'; //"输入的根密钥 ："
    	        	var newControlKey = $scope.key.controlKey;
    	        	$rootScope.openLog = constantDefine.input_controlKey + controlKey + '<br>'; //"输入的控制密钥 ："
    	        	//05码数据段位明文
    	        	var keyData = newBaseKey + " " + newControlKey;
    	        	$rootScope.openLog = constantDefine.code05_data + keyData + '<br>'; //"05码数据段位明文 ："
    	        	//05码数据段加密密钥（动态密钥做高8字节、根密钥做低8字节）
    	        	var secretKey = ($rootScope.bluetooth.key + $rootScope.bluetooth.gKey).split(' ').join('');
    	        	$rootScope.openLog = constantDefine.code05_secret;//"05码数据段加密密钥（动态密钥做高8字节、根密钥做低8字节）：" 
    	        		+ secretKey + '=' + $rootScope.bluetooth.key + '---' + $rootScope.bluetooth.gKey + '<br>';
    	        	//05码数据段进行RC4加密
    	        	var secretData = $rootScope.bluetooth.HloveyRC4($rootScope.bluetooth.stringToBytes(keyData), $rootScope.bluetooth.stringToBytesForNoSpace(secretKey));
    	        	$rootScope.openLog = constantDefine.code05_RC4_secret + secretData + '<br>';//"05码数据段进行RC4加密 ："
    	        	//生成密文校验位
    	        	var checkData =$rootScope.bluetooth.XorCheck(secretData,secretData.length);
    	        	$rootScope.openLog = constantDefine.code05_check_data + checkData + '<br>';//"05码生成密文校验位 ："
    	        	var newSecretData = new Uint8Array(secretData.length + 1);//修改最后一位值为校验位的值{0:248,1:246,2:249,3:244,4:230,5:229}
    	    		for(var i=0;i<secretData.length;i++){
    	    			newSecretData[i] = secretData[i];
    	    		}
    	    		newSecretData[newSecretData.length-1] = checkData; 
    	    		
    	    		var sendDataInfo = [05,16]; //发送数据
    	    		
    	    		for(var i=0;i<newSecretData.length;i++){
    	    			var d = newSecretData[i].toString(16);
    	    			sendDataInfo[i+2] = d;
    	    		}
    	    		$rootScope.openLog = constantDefine.send_05_secretData + sendDataInfo;
    	    		$rootScope.bluetooth.sendData1(sendDataInfo.join(" "),function(res){
    	    			newBaseKey = newBaseKey.split(' ').join('');
    		        	newControlKey = newControlKey.split(' ').join('');
    		        	$rootScope.bluetooth.gKey = newBaseKey;
    		        	$rootScope.bluetooth.controlKey = newControlKey;
    		        	var params = {
    		        		"userId" : window.localStorage.userId,
    		        		"macAddr" : $rootScope.bluetooth.keyName,
    		        		"baseKey" : newBaseKey,
    		        		"controlKey" : newControlKey
    		        	};
    		        	hlService.home.updateKeysByKeyName().save(params,function(res){
    		        		if(res.NUM == -1){
    		          			$rootScope.showPopup(constantDefine.init_key_fail);//"初始化钥匙密钥失败!!!");
    		          		}else{
    		          			$rootScope.showPopup(constantDefine.init_key_success);//"初始化钥匙密钥成功!!!");
    		          		}
    		        	}, function(res){
    		    			$rootScope.showPopup(constantDefine.network_lazy);//"网络偷懒啦!!!");
    		    		});
    	    		});
        		});
    		};
    		$scope.showConfirm();
    	} else {
    		$rootScope.showPopup(constantDefine.init_bluetooth_error);//"请在蓝牙连接状态下进行初始化操作!");
    	}
    };
    
    //13 ……………………………………………………………………初始化锁具信息
    $scope.initLocksetBtnHandler = function(){

    	if($rootScope.bluetooth.status == constantDefine.already_connected){
    		$scope.lock = {};
    		$scope.showConfirm = function() {
				var confirmPopup = $ionicPopup.confirm({
					title: constantDefine.lock_param, //确认对应
					templateUrl: 'inputParams.html',
					scope: $scope,
					buttons:[
					         {text:constantDefine.cancel, onTap: function(e) {return false;}},  //取消
					         {text:constantDefine.confirm, type: 'button-positive', onTap: function(e) {
					        	 if($scope.lock.id == null || $scope.lock.version == null){
									$rootScope.showPopup(constantDefine.lock_input_param);//"请先输入锁具参数");
									e.preventDefault();
								 } else {
									var formate = /^[0-9a-fA-F]{1,2}$/;
									var inputIds = $scope.lock.id.split(" ");
									if(inputIds.length != 4){
										$rootScope.showPopup(constantDefine.device_num_error);//"设备号长度非法!");
										e.preventDefault();
									} else {
										for(var i=0;i<inputIds.length;i++){
											if(!formate.test(inputIds[i])){
												$rootScope.showPopup(constantDefine.device_bit_error + (i+1));//"设备号出现非16进制编码!字节位:"
												e.preventDefault();
											}
										}
									}
									var versions = $scope.lock.version.split(" ");
									if(versions.length != 2){
										$rootScope.showPopup(constantDefine.version_num_error);//"版本号长度非法!");
										e.preventDefault();
									} else {
										for(var i=0;i<versions.length;i++){
											if(!formate.test(versions[i])){
												$rootScope.showPopup(constantDefine.version_bit_error + (i+1));//"版本号出现非16进制编码!字节位:"
												e.preventDefault();
											}
										}
									}
									return true;
								 }
					         }}
					] //确认
				});
				confirmPopup.then(function(res) {
					if(res) {
			        	//06码数据段位明文
			        	var data = $scope.lock.id + " " + $scope.lock.version;
			        	//06码数据段加密密钥（动态密钥做高8字节、根密钥做低8字节）
			        	var secretKey = ($rootScope.bluetooth.key + $rootScope.bluetooth.gKey).split(' ').join('');
			        	//06码数据段进行RC4加密
			        	var secretData = $rootScope.bluetooth.HloveyRC4($rootScope.bluetooth.stringToBytes(data), $rootScope.bluetooth.stringToBytesForNoSpace(secretKey));
			        	//生成密文校验位
			        	var checkData =$rootScope.bluetooth.XorCheck(secretData,secretData.length);
			        	
			        	var newSecretData = new Uint8Array(secretData.length + 1);//修改最后一位值为校验位的值{0:248,1:246,2:249,3:244,4:230,5:229}
			    		for(var i=0;i<secretData.length;i++){
			    			newSecretData[i] = secretData[i];
			    		}
			    		newSecretData[newSecretData.length-1] = checkData; 
			    		
			    		var sendDataInfo = [06,06]; //发送数据
			    		
			    		for(var i=0;i<newSecretData.length;i++){
			    			var d = newSecretData[i].toString(16);
			    			sendDataInfo[i+2] = d;
			    		}
						$rootScope.openLog = constantDefine.send_06_secretData + sendDataInfo;//"发送06命令码密文 ："
						$rootScope.bluetooth.sendData1(sendDataInfo.join(" "),function(res){ 
							
						},function(res){
							$rootScope.openLog = constantDefine.init_lock_send_error;//"初始化锁具命令发送失败!请重试或重新进行蓝牙连接。";
						});
					}
				});
    		};
    		$scope.showConfirm();
    	} else {
    		$rootScope.showPopup(constantDefine.init_bluetooth_error);//"请在蓝牙连接状态下进行初始化操作!");
    	}
    };
    
    //14 ……………………………………………………………………初始化钥匙信息
    $scope.initBLockBtnHandler = function(){

    	if($rootScope.bluetooth.status == constantDefine.already_connected){
    		$scope.key = {};
    		$scope.showConfirm = function() {
				var confirmPopup = $ionicPopup.confirm({
					title: constantDefine.key_params,//"钥匙参数", //确认对应
					templateUrl: 'keyParams.html',
					scope: $scope,
					buttons:[
					         {text:constantDefine.cancel, onTap: function(e) {return false;}},  //取消
					         {text:constantDefine.confirm, type: 'button-positive', onTap: function(e) {
					        	 if($scope.key.id == null || $scope.key.version == null){
									$rootScope.showPopup(constantDefine.lock_input_param);//"请先输入锁具参数");
									e.preventDefault();
								 } else {
									var formate = /^[0-9a-fA-F]{1,2}$/;
									var inputIds = $scope.key.id.split(" ");
									if(inputIds.length != 12){
										$rootScope.showPopup(constantDefine.id_num_error);//"id号长度非法!");
										e.preventDefault();
									} else {
										for(var i=0;i<inputIds.length;i++){
											if(!formate.test(inputIds[i])){
												$rootScope.showPopup(constantDefine.id_bit_error + (i+1) );//"id号出现非16进制编码!字节位:"
												e.preventDefault();
											}
										}
									}
									var versions = $scope.key.version.split(" ");
									if(versions.length != 2){
										$rootScope.showPopup(constantDefine.version_num_error);//"版本号长度非法!");
										e.preventDefault();
									} else {
										for(var i=0;i<versions.length;i++){
											if(!formate.test(versions[i])){
												$rootScope.showPopup(constantDefine.version_bit_error + (i+1));//"版本号出现非16进制编码!字节位:"
												e.preventDefault();
											}
										}
									}
									return true;
								 }
					         }}
					] //确认
				});
				confirmPopup.then(function(res) {
					if(res) {
			        	//07码数据段位明文
			        	var data = $scope.key.id + " " + $scope.key.version;
			        	//07码数据段加密密钥（动态密钥做高8字节、根密钥做低8字节）
			        	var secretKey = ($rootScope.bluetooth.key + $rootScope.bluetooth.gKey).split(' ').join('');
			        	//07码数据段进行RC4加密
			        	var secretData = $rootScope.bluetooth.HloveyRC4($rootScope.bluetooth.stringToBytes(data), $rootScope.bluetooth.stringToBytesForNoSpace(secretKey));
			        	//生成密文校验位
			        	var checkData =$rootScope.bluetooth.XorCheck(secretData,secretData.length);
			        	
			        	var newSecretData = new Uint8Array(secretData.length + 1);//修改最后一位值为校验位的值{0:248,1:246,2:249,3:244,4:230,5:229}
			    		for(var i=0;i<secretData.length;i++){
			    			newSecretData[i] = secretData[i];
			    		}
			    		newSecretData[newSecretData.length-1] = checkData; 
			    		
			    		var sendDataInfo = [07,12]; //发送数据
			    		
			    		for(var i=0;i<newSecretData.length;i++){
			    			var d = newSecretData[i].toString(16);
			    			sendDataInfo[i+2] = d;
			    		}
						$rootScope.openLog = constantDefine.send_07_secretData + sendDataInfo; //"发送07命令码密文 ："
						$rootScope.bluetooth.sendData1(sendDataInfo.join(" "),function(res){ 
							
						},function(res){
							$rootScope.openLog = constantDefine.init_key_send_error;//"初始化钥匙命令发送失败!请重试或重新进行蓝牙连接。";
						});
					}
				});
    		};
    		$scope.showConfirm();
    	} else {
    		$rootScope.showPopup(constantDefine.init_bluetooth_error);//"请在蓝牙连接状态下进行初始化操作!");
    	}
    };
    
    //未上锁设备加载
    hlService.home.getDeviceSelectsByUserId(window.localStorage.userId).query(function(res){
		$scope.deviceList = res;
		window.localStorage.deviceList = JSON.stringify(res);
	},function(res){
		$scope.deviceList = JSON.parse(window.localStorage.deviceList);
	});
    
    //加载侧面子菜单
    $scope.toggleRight = function() {
        $ionicSideMenuDelegate.toggleRight();
        $ionicSideMenuDelegate.canDragContent();
	};
	$scope.appVersion = ENV.version;
    $scope.userName = window.localStorage.userName;
    $scope.keyName = window.localStorage.keyName;
    
    $scope.redirectPages = function(menu){
		if(menu == 0){
			$state.go('resetPassword');
		}
    	if( menu == 1){
    		if (!blcache.isDevTimeSync()) {
        		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
        		return;
        	}
        	$rootScope.bluetooth.isInit = false;
        	$rootScope.bluetooth.isInstalling = false;
        	$rootScope.bluetooth.isMain = true;
        	$rootScope.bluetooth.isReturn = false;
        	$rootScope.bluetooth.switchDepend = 1;
        	$state.go('keyManage');
    	} else if( menu == 2){
    		if (!blcache.isDevTimeSync()) {
        		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
        		return;
        	}
        	$rootScope.bluetooth.isInit = false;
        	$rootScope.bluetooth.isInstalling = false;
        	$rootScope.bluetooth.isMain = true;
        	$rootScope.bluetooth.isReturn = false;
        	$rootScope.bluetooth.switchDepend = 1;
        	$state.go('deviceManage');
    	} else if( menu == 3){
    		if (!blcache.isDevTimeSync()) {
        		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
        		return;
        	}
        	$rootScope.bluetooth.isInit = false;
        	$rootScope.bluetooth.isInstalling = false;
        	$rootScope.bluetooth.isMain = true;
        	$rootScope.bluetooth.isReturn = false;
        	$rootScope.bluetooth.switchDepend = 1;
        	$state.go('userManage');
    	} else if( menu == 4){
    		if (!blcache.isDevTimeSync()) {
        		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
        		return;
        	}
        	$rootScope.bluetooth.isInit = false;
        	$rootScope.bluetooth.isInstalling = false;
        	$rootScope.bluetooth.isMain = true;
        	$rootScope.bluetooth.isReturn = false;
        	$rootScope.bluetooth.switchDepend = 1;
        	$state.go('permissionManage');
    	} else if( menu == 5){
    		if (!blcache.isDevTimeSync()) {
        		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
        		return;
        	}
        	$rootScope.bluetooth.isInit = false;
        	$rootScope.bluetooth.isInstalling = false;
        	$rootScope.bluetooth.isMain = true;
        	$rootScope.bluetooth.isReturn = false;
        	$rootScope.bluetooth.switchDepend = 1;
        	$state.go('areaManage');
    	} else if( menu == 6){
    		if (!blcache.isDevTimeSync()) {
        		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
        		return;
        	}
        	$rootScope.bluetooth.isInit = false;
        	$rootScope.bluetooth.isInstalling = false;
        	$rootScope.bluetooth.isMain = true;
        	$rootScope.bluetooth.isReturn = false;
        	$rootScope.bluetooth.switchDepend = 1;
        	$state.go('groupManage');
    	} else if( menu == 7){
    		if (!blcache.isDevTimeSync()) {
        		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
        		return;
        	}
        	$rootScope.bluetooth.isInit = false;
        	$rootScope.bluetooth.isInstalling = false;
        	$rootScope.bluetooth.isMain = true;
        	$rootScope.bluetooth.isReturn = false;
        	$rootScope.bluetooth.switchDepend = 1;
        	$state.go('titleManage');
    	}
    }
})
.controller('common.hisData',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	
	$scope.getPubHisDataByUserId = function(){
		hlService.home.getPubHisDataListByUserId(window.localStorage.userId).query(function(res){
			for(var i=0;i<res.length;i++){
				var obj = res[i];
				obj.DATE = dateFormate(obj.OPT_DATE);
				res[i] = obj;
			}
			
			$scope.hisDataList = res;
			window.localStorage.hisDataList = JSON.stringify(res);
			$scope.$broadcast('scroll.refreshComplete');
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
			$scope.hisDataList = JSON.parse(window.localStorage.hisDataList);
		});
	};
	$scope.getPubHisDataByUserId();
	
	var dateFormate = function(time){
		var date = new Date(time*1000);
		return date.getFullYear() + "-" + (date.getMonth()+1) + "-" + date.getDate() + " "
				+ date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
	};
})
.controller('common.hisdatas',function($scope,$rootScope,$stateParams,$ionicLoading,$state,$interval,$timeout,hlService,blcache){
	$scope.admin = window.localStorage.admin;
	$scope.domore = false;
	$scope.start = -1;
	$scope.limit = 20;
	$scope.first = true;
	$scope.hisDataList = [];
	$scope.show = function() {
	    $ionicLoading.show({
	    	templateUrl: 'pages/common/loading.html'
	    });
	};
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$scope.doRefresh = function() {
		if ($scope.first) {
			timer = $timeout(function () {
				loadPubHisDataByUserId(); 
            }, 1000);
			$scope.first = false;
		} else {
			loadPubHisDataByUserId(); 
		}
	};
	$scope.getPubHisDataByUserId = function(){
		if ($rootScope.networkState == 'none') {
			$scope.$broadcast('scroll.refreshComplete');
			$rootScope.showPopup(constantDefine.offline_unsearch);//"当前离线模式下无法查看开锁记录");
		} else {
			//$scope.show();
			$scope.start = 0;
			$scope.limit = 20;
			$scope.domore = false;
			hlService.home.getPubHisDataListByUserId(window.localStorage.userId, $scope.start, $scope.limit).query(function(res){
				for(var i=0;i<res.length;i++){
					var obj = res[i];
					obj.date = dateFormate(obj.optDate);
					obj.time = timeFormate(obj.optDate);
					res[i] = obj;
				}
				
				$scope.hisDataList = res;
				$scope.$broadcast('scroll.refreshComplete');
				//$scope.hide();
			},function(res){
				$scope.$broadcast('scroll.refreshComplete');				
			});
		}
		
	};
	//$scope.getPubHisDataByUserId();
	
	$scope.moreHisDatas = function() {
		$state.go('hisDataAdmin');
	};
	function loadPubHisDataByUserId() {
		if ($rootScope.networkState == 'none') {
			$rootScope.showPopup(constantDefine.offline_unsearch);//"当前离线模式下无法查看开锁记录");
			$scope.$broadcast('scroll.infiniteScrollComplete');
			$scope.domore = true;  
		} else {
			$scope.start++;
			var timer = null; 
			hlService.home.getPubHisDataListByUserId(window.localStorage.userId, $scope.start, $scope.limit).query(function(res){
				if (res) {
					if (res.length != 0) {
						for(var i=0;i<res.length;i++){
							var obj = res[i];
							obj.date = dateFormate(obj.optDate);
							obj.time = timeFormate(obj.optDate);
							res[i] = obj;
							$scope.hisDataList.push(res[i]);
						}
						
					}
					if (res.length == 0){
						$scope.domore = true; 
					}
					timer = $timeout(function () {
		                $scope.$broadcast('scroll.infiniteScrollComplete');  
		            }, 1500);
				} else {
					$scope.domore = true;  
	                $scope.$broadcast('scroll.infiniteScrollComplete');
				}
			},function(res){
				$timeout.cancel(timer);
				$scope.domore = true; 
	            $scope.$broadcast('scroll.infiniteScrollComplete');
			});
			 $scope.$on("$destroy", function () {   
	             $timeout.cancel(timer);  
	        });
		}
		
	}
	function dateFormate(time){
		var date = new Date(time*1000);
		return getYmdByDate(date);
	}
	function timeFormate(time){
		var date = new Date(time*1000);
		return getHmsByDate(date);
	}
	// 获取时间的绝对秒
	function getSecondsByDate (date) {
    	return date.getTime() / 1000;
    }
    // yyyy-MM-dd, if middleLine=true :yyyyMMdd
	function getYmdByDate(date, middleLine) {
    	var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    	var ymd = "" + date.getFullYear() + month + day;
    	var format = date.getFullYear()+ "-" + month + "-" + day;
    	if (middleLine) {
    		format = date.getFullYear()+ "" + month + "" + day;
    	}
    	return format;
    }
    // HH:mm:ss ,if middleDot=true : HHmmss
    function getHmsByDate(date, middleDot) {
    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
    	var format = hours + ":" + minutes + ":" + seconds;
    	if (middleDot) {
    		format = hours + "" + minutes + "" + seconds;
    	}
    	return format;
    }
    // yyyy-MM-dd HH:mm:ss
    function getYmdHmsByDate(date) {
    	var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    	var ymd = "" + date.getFullYear() + month + day;
    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
    	var format = date.getFullYear()+ "-" + month + "-" + day + " "
			+ hours + ":" + minutes + ":" + seconds;
    	return format;
    }
})
.controller('common.hisDataAdmin',function($scope,$rootScope,$stateParams,$ionicLoading,$state,$interval,$timeout,hlService,blcache){
	$scope.mode = 'device';
	$scope.deviceActived = "active";
	$scope.userActived = "";
	$scope.domore = false;
	$scope.start = -1;
	$scope.limit = 20;
	$scope.hisDataList = [];
	$scope.first = true;
	$scope.show = function() {
	    $ionicLoading.show({
	    	templateUrl: 'pages/common/loading.html'
	    });
	};
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$scope.toggle = function(mode) {
		$scope.mode = mode;
		if (mode == 'device') {
			$scope.deviceActived = "active";
			$scope.userActived = "";
		} else {
			$scope.deviceActived = "";
			$scope.userActived = "active";
		}
	};
	$scope.doRefresh = function() {
		if ($scope.first) {
			timer = $timeout(function () {
				loadPubHisDataBySysId(); 
            }, 1000);
			$scope.first = false;
		} else {
			loadPubHisDataBySysId(); 
		}
		
	};
	
	$scope.getPubHisDataBySysId = function(){
		if ($rootScope.networkState == 'none') {
			$scope.$broadcast('scroll.refreshComplete');
			$rootScope.showPopup(constantDefine.offline_unsearch);//"当前离线模式下无法查看开锁记录");
		} else {
			$scope.start = 0;
			$scope.limit = 20;
			$scope.domore = false;
			hlService.home.getPubHisDataListBySysId(window.localStorage.sysId, $scope.start, $scope.limit).query(function(res){
				
				for(var i=0;i<res.length;i++){
					var obj = res[i];
					obj.date = dateFormate(obj.optDate);
					obj.time = timeFormate(obj.optDate);
					res[i] = obj;
				}
				
				$scope.hisDataList = res;
				$scope.$broadcast('scroll.refreshComplete');
				//$scope.hide();
			},function(res){
				$scope.$broadcast('scroll.refreshComplete');
			});
		}
		
	};
	//$scope.getPubHisDataBySysId();
	function loadPubHisDataBySysId() {
		if ($rootScope.networkState == 'none') {
			$scope.domore = true;  
            $scope.$broadcast('scroll.infiniteScrollComplete');
			$rootScope.showPopup(constantDefine.offline_unsearch);//"当前离线模式下无法查看开锁记录");
		} else {
			$scope.start++;
			var timer = null; 
			hlService.home.getPubHisDataListBySysId(window.localStorage.sysId, $scope.start, $scope.limit).query(function(res){
				if (res) {
					if (res.length != 0) {
						for(var i=0;i<res.length;i++){
							var obj = res[i];
							obj.date = dateFormate(obj.optDate);
							obj.time = timeFormate(obj.optDate);
							res[i] = obj;
							$scope.hisDataList.push(res[i]);
						}
						
					}
					if (res.length == 0){
						$scope.domore = true; 
					}
					timer = $timeout(function () {
		                $scope.$broadcast('scroll.infiniteScrollComplete');  
		            }, 1500);
				} else {
					$scope.domore = true;  
	                $scope.$broadcast('scroll.infiniteScrollComplete');
				}
			},function(res){
				$timeout.cancel(timer);
				$scope.domore = true;  
	            $scope.$broadcast('scroll.infiniteScrollComplete');
			});
			 $scope.$on("$destroy", function () {   
	             $timeout.cancel(timer);  
	        });
		}
		
	}
	function dateFormate(time){
		var date = new Date(time*1000);
		return getYmdByDate(date);
	}
	function timeFormate(time){
		var date = new Date(time*1000);
		return getHmsByDate(date);
	}
	// 获取时间的绝对秒
	function getSecondsByDate (date) {
    	return date.getTime() / 1000;
    }
    // yyyy-MM-dd, if middleLine=true :yyyyMMdd
	function getYmdByDate(date, middleLine) {
    	var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    	var ymd = "" + date.getFullYear() + month + day;
    	var format = date.getFullYear()+ "-" + month + "-" + day;
    	if (middleLine) {
    		format = date.getFullYear()+ "" + month + "" + day;
    	}
    	return format;
    }
    // HH:mm:ss ,if middleDot=true : HHmmss
    function getHmsByDate(date, middleDot) {
    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
    	var format = hours + ":" + minutes + ":" + seconds;
    	if (middleDot) {
    		format = hours + "" + minutes + "" + seconds;
    	}
    	return format;
    }
    // yyyy-MM-dd HH:mm:ss
    function getYmdHmsByDate(date) {
    	var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    	var ymd = "" + date.getFullYear() + month + day;
    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
    	var format = date.getFullYear()+ "-" + month + "-" + day + " "
			+ hours + ":" + minutes + ":" + seconds;
    	return format;
    }
})
.controller('common.hisDataAdmin1',function($scope,$rootScope,$stateParams,$ionicLoading,$state,$interval,$timeout,hlService,blcache){
	$scope.mode = 'device';
	$scope.deviceActived = "active";
	$scope.userActived = "";
	$scope.domore = false;
	$scope.start = -1;
	$scope.limit = 20;
	$scope.first = true;
	$scope.hisDataList = [];
	$scope.show = function() {
	    $ionicLoading.show({
	    	templateUrl: 'pages/common/loading.html'
	    });
	};
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$scope.toggle = function(mode) {
		$scope.mode = mode;
		if (mode == 'device') {
			$scope.deviceActived = "active";
			$scope.userActived = "";
		} else {
			$scope.deviceActived = "";
			$scope.userActived = "active";
		}
	};
	$scope.doRefresh = function() {
		if ($scope.first) {
			timer = $timeout(function () {
				loadPubHisDataBySysId(); 
            }, 1000);
			$scope.first = false;
		} else {
			loadPubHisDataBySysId(); 
		}
	};
	$scope.getPubHisDataBySysId = function(){
		if ($rootScope.networkState == 'none') {
			$scope.$broadcast('scroll.refreshComplete');
			$rootScope.showPopup(constantDefine.offline_unsearch);//"当前离线模式下无法查看开锁记录");
		} else {
			$scope.start = 0;
			$scope.limit = 20;
			$scope.domore = false;
			hlService.home.getPubHisDataListBySysId(window.localStorage.sysId, $scope.start, $scope.limit).query(function(res){
				
				for(var i=0;i<res.length;i++){
					var obj = res[i];
					obj.date = dateFormate(obj.optDate);
					obj.time = timeFormate(obj.optDate);
					res[i] = obj;
				}
				
				$scope.hisDataList = res;
				$scope.$broadcast('scroll.refreshComplete');
				//$scope.hide();
			},function(res){
				$scope.$broadcast('scroll.refreshComplete');
			});
		}
		
	};
	//$scope.getPubHisDataBySysId();
	function loadPubHisDataBySysId() {
		if ($rootScope.networkState == 'none') {
			$rootScope.showPopup(constantDefine.offline_unsearch);//"当前离线模式下无法查看开锁记录");
			$scope.domore = true;  
            $scope.$broadcast('scroll.infiniteScrollComplete');
		} else {
			$scope.start++;
			var timer = null; 
			hlService.home.getPubHisDataListBySysId(window.localStorage.sysId, $scope.start, $scope.limit).query(function(res){
				if (res) {
					if (res.length != 0) {
						for(var i=0;i<res.length;i++){
							var obj = res[i];
							obj.date = dateFormate(obj.optDate);
							obj.time = timeFormate(obj.optDate);
							res[i] = obj;
							$scope.hisDataList.push(res[i]);
						}
						
					}
					if (res.length == 0){
						$scope.domore = true; 
					}
					timer = $timeout(function () {
		                $scope.$broadcast('scroll.infiniteScrollComplete');  
		            }, 1500);
				} else {
					$scope.domore = true;  
	                $scope.$broadcast('scroll.infiniteScrollComplete');
				}
			},function(res){
				$timeout.cancel(timer);
				$scope.domore = true;  
	            $scope.$broadcast('scroll.infiniteScrollComplete');
			});
			$scope.$on("$destroy", function () {   
	            $timeout.cancel(timer);  
	        });
		}
		
	}
	function dateFormate(time){
		var date = new Date(time*1000);
		return getYmdByDate(date);
	}
	function timeFormate(time){
		var date = new Date(time*1000);
		return getHmsByDate(date);
	}
	// 获取时间的绝对秒
	function getSecondsByDate (date) {
    	return date.getTime() / 1000;
    }
    // yyyy-MM-dd, if middleLine=true :yyyyMMdd
	function getYmdByDate(date, middleLine) {
    	var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    	var ymd = "" + date.getFullYear() + month + day;
    	var format = date.getFullYear()+ "-" + month + "-" + day;
    	if (middleLine) {
    		format = date.getFullYear()+ "" + month + "" + day;
    	}
    	return format;
    }
    // HH:mm:ss ,if middleDot=true : HHmmss
    function getHmsByDate(date, middleDot) {
    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
    	var format = hours + ":" + minutes + ":" + seconds;
    	if (middleDot) {
    		format = hours + "" + minutes + "" + seconds;
    	}
    	return format;
    }
    // yyyy-MM-dd HH:mm:ss
    function getYmdHmsByDate(date) {
    	var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    	var ymd = "" + date.getFullYear() + month + day;
    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
    	var format = date.getFullYear()+ "-" + month + "-" + day + " "
			+ hours + ":" + minutes + ":" + seconds;
    	return format;
    }
}).controller('common.permData',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	
	$scope.getPermListByUserId = function(){
		hlService.home.getPermissionListByUserId(window.localStorage.userId).query(function(res){
			for(var i=0;i<res.length;i++){
				var obj = res[i];
				obj.startDate = dateFormate(obj.startDate);
				obj.endDate = dateFormate(obj.endDate);
				obj.startTime = timeFormate(obj.startTime);
				obj.endTime = timeFormate(obj.endTime);
				obj.typeDesc = reTypeFormate(obj.type);
				obj.reday = reDayFormate(obj.type,obj.reday);
				res[i] = obj;
			}
			
			$scope.lockPermList = res;
			window.localStorage.lockPermList = JSON.stringify(res);
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
			$scope.lockPermList = JSON.parse(window.localStorage.lockPermList);
		});
	};
	$scope.getPermListByUserId();
	
	var dateFormate = function(date){
		date = date + " ";
		var year = date.substring(0,4);
		var month = date.substring(4,6);
		var day = date.substring(6,8);
		return year + "-" + month + "-" + day;
	};
	
	var timeFormate = function(time){
		time = time + "";
		if(time.length == 5){
			var hour = time.substring(0,1);
			var minutes = time.substring(1,3);
			var seconds = time.substring(3,5);
			return hour + ":" + minutes + ":" + seconds;
		}else if(time.length == 6){
			var hour = time.substring(0,2);
			var minutes = time.substring(2,4);
			var seconds = time.substring(4,6);
			return hour + ":" + minutes + ":" + seconds;
		}else{
			return time;
		}
	};
	
	var reTypeFormate = function(type){
		if(type == 0){
			return constantDefine.NO_REPETITION;//"不重复";
		} else if(type == 1){
			return constantDefine.PER_DAY;//"每天";
		} else if(type == 2){
			return constantDefine.PER_WEEK;//"每周";
		} else if(type == 3){
			return constantDefine.PER_MONTH;//"每月";
		}
	};
	
	var reDayFormate = function(type,reDay){
		if(reDay != null){
			if(type == 2){
				var day = ["周日","周一","周二","周三","周四","周五","周六"];
				var reDays = reDay.split(",");
				var format = "";
				for(var i=0;i<reDays.length;i++){
					format += day[reDays[i]] + ",";
				}
				return format.substring(0, format.length-1);
			}else if(type == 3){
				if((reDay.split(",")).length>8){
					var reDays = reDay.split(",");
					var format = "";
					for(var i=0;i<8;i++){
						format += reDays[i] + ",";
					}
					return format+"……";
				}else{
					return reDay + "号";
				}
				
			}
		}else{
			return "";
		}
		
	};
	
})
.controller('common.permissions',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,$ionicLoading,hlService,blcache){
	$scope.domore = false;
	$scope.start = -1;
	$scope.limit = 20;
	$scope.first = true;
	$scope.lockPermList = [];
	$scope.show = function() {
	    $ionicLoading.show({
	    	templateUrl: 'pages/common/loading.html'
	    });
	};
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$scope.doRefresh = function() {
		if ($scope.first) {
			timer = $timeout(function () {
				loadPermPagesByUserId();
            }, 1000);
			$scope.first = false;
		} else {
			loadPermPagesByUserId(); 
		}
	};
	$scope.getPermListByUserId = function(){
		$scope.start = 0;
		$scope.limit = 20;
		$scope.domore = false;
		hlService.home.getPermissionPagesByUserId(window.localStorage.userId,$scope.start, $scope.limit).query(function(res){
			$scope.lockPermList = formatPermissions(res);
			$scope.$broadcast('scroll.refreshComplete');
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
			$scope.lockPermList = formatPermissions(blcache.getDeviceUserRelationByUserId(window.localStorage.userId));
		});
	};
	var loadPermPagesByUserId = function() {
		$scope.start++;
		var timer = null; 
		hlService.home.getPermissionPagesByUserId(window.localStorage.userId, $scope.start, $scope.limit).query(function(res){
			if (res) {
				if (res.length != 0) {
					for(var i=0;i<res.length;i++){
						var obj = res[i];
						obj.startDate = dateFormate(obj.startDate);
						obj.endDate = dateFormate(obj.endDate);
						obj.startTime = timeFormate(obj.startTime);
						obj.endTime = timeFormate(obj.endTime);
						obj.typeDesc = reTypeFormate(obj.type);
						obj.reday = reDayFormate(obj.type,obj.reday);
						res[i] = obj;
						$scope.lockPermList.push(res[i]);
					}
				}
				if (res.length == 0){
					$scope.domore = true; 
				}
				timer = $timeout(function () {
	                $scope.$broadcast('scroll.infiniteScrollComplete');  
	            }, 1500);
			} else {
				$scope.domore = true;  
                $scope.$broadcast('scroll.infiniteScrollComplete');
			}
			$scope.$broadcast('scroll.infiniteScrollComplete'); 
		},function(res){
			$timeout.cancel(timer);
			$scope.lockPermList = formatPermissions(blcache.getDeviceUserRelationByUserId(window.localStorage.userId));
			$scope.domore = true; 
			$scope.$broadcast('scroll.infiniteScrollComplete'); 
		});
		 $scope.$on("$destroy", function () {   
             $timeout.cancel(timer);  
         });
	};
	
	//lockid 共四位长度，不够补位
	var formateLockId = function(lockId){
		if(lockId.length > 8){
			lockId = lockId.substring(0,8);
		} else if(lockId.length ==7){
			lockId = "0" + lockId;
		} else if(lockId.length == 6){
			lockId = "00" + lockId;
		} else if(lockId.length == 5){
			lockId = "000" + lockId;
		} else if(lockId.length == 4){
			lockId = "0000" + lockId;
		} else if(lockId.length == 3){
			lockId = "00000" + lockId;
		} else if(lockId.length == 2){
			lockId = "000000" + lockId;
		} else if(lockId.length == 1){
			lockId = "0000000" + lockId;
		}
		return lockId;
		
	};
	
	var formateSendDataToArray = function(string){
		var array = new Uint8Array(string.length/2);
		 for (var i = 0; i < string.length;) {
			 array[i/2] = string.substring(i,i+2);
			 i = i + 2;

		 }
		 return array;
	}
	
	$scope.sendPermissionData = function(){
		//$scope.lockPermList;
		
		//console.log($scope.lockPermList);

		var lockIds = [];
		var lockStrs = "";
		for(var i=0; i<$scope.lockPermList.length; i++){
			var permission = $scope.lockPermList[i];
			var device = permission.device;
			
			if(device != null){
				//全部设备
				if(device.deviceId == -100){
					//设置所有钥匙均有此权限
				} else {
					var lockId = $rootScope.bluetooth.decimalRadixToHex(device.lockId);
					var startDate = permission.startDate;
					startDate = startDate.replace(/-/g,"");
					startDate = startDate.substring(2,startDate.length);
					var startTime = permission.startTime;
					startTime = startTime.replace(/:/g,"");
					var endDate = permission.endDate;
					endDate = endDate.replace(/-/g,"");
					endDate = endDate.substring(2,endDate.length);
					var endTime = permission.endTime;
					endTime = endTime.replace(/:/g,"");
					
					//直接进行转码存储  ------------------------------ leaf
					lockIds[i] = formateLockId(lockId) + startDate + startTime + endDate + endTime; 
					lockStrs += formateLockId(lockId) + startDate + startTime + endDate + endTime;
				}
			}
			
		}
		
		//console.log(lockIds);
		
		//08码数据段位明文(首位是操作类型 1：新增；2：删除；)
		var length = $rootScope.bluetooth.decimalRadixToHex(lockIds.length);
		var dataLength = length.length < 2 ? ('0'+length):length;
    	var data = dataLength + lockStrs;

    	//    	//08码数据段加密密钥（动态密钥做高8字节、根密钥做低8字节）
    	//var secretKey = ($rootScope.bluetooth.key + $rootScope.bluetooth.gKey).split(' ').join('');
    	//08码数据段进行RC4加密
    	//var secretData = $rootScope.bluetooth.HloveyRC4($rootScope.bluetooth.stringToBytes(data), $rootScope.bluetooth.stringToBytesForNoSpace(secretKey));
    	//生成密文校验位
		//var dataArray = $rootScope.bluetooth.stringToBytesForNoSpace(data);
		var dataArray = formateSendDataToArray(data);

    	var checkData =$rootScope.bluetooth.XorCheck(dataArray,dataArray.length);

    	var newSecretData = new Uint8Array(dataArray.length + 1);//修改最后一位值为校验位的值{0:248,1:246,2:249,3:244,4:230,5:229}
		for(var i=0;i<dataArray.length;i++){
			newSecretData[i] = dataArray[i];
		}
		newSecretData[newSecretData.length-1] = '0x'+$rootScope.bluetooth.decimalRadixToHex(checkData); 

		var length = $rootScope.bluetooth.decimalRadixToHex(2 + 16*lockIds.length);
		var sendDataInfo = [08,length,01]; //发送新增数据
		
		for(var i=0;i<newSecretData.length;i++){
			var d = newSecretData[i];
			if(i == newSecretData.length-1){
				d = newSecretData[i].toString(16);
			}
			
			sendDataInfo[i+3] = d;
		}
		$rootScope.openLog = constantDefine.send_08_secretData + sendDataInfo;//"发送08命令码密文 ："
		
		$rootScope.bluetooth.sendData1(sendDataInfo.join(" "),function(res){ 
			
		},function(res){
			alert(res);
			$rootScope.openLog = constantDefine.send_permissiong_error;//"下发权限失败。";
		});
		
	};
	
	var formatPermissions = function(res) {
		for(var i=0;i<res.length;i++){
			var obj = res[i];
			obj.startDate = dateFormate(obj.startDate);
			obj.endDate = dateFormate(obj.endDate);
			obj.startTime = timeFormate(obj.startTime);
			obj.endTime = timeFormate(obj.endTime);
			obj.typeDesc = reTypeFormate(obj.type);
			obj.reday = reDayFormate(obj.type,obj.reday);
			res[i] = obj;
		}
		return res;
	};
	var dateFormate = function(date){
		date = date + " ";
		var year = date.substring(0,4);
		var month = date.substring(4,6);
		var day = date.substring(6,8);
		return year + "-" + month + "-" + day;
	};
	
	var timeFormate = function(hms){
		if (hms == null || hms === "")return "";
		hms = hms.toString();
		if (hms.length == 1) {
			hms = "00000" + hms;
		} else if (hms.length == 2) {
			hms = "0000" + hms;
		} else if (hms.length == 3) {
			hms = "000" + hms;
		} else if (hms.length == 4) {
			hms = "00" + hms;
		} else if (hms.length == 5) {
			hms = "0" + hms;
		}
		var formatString = hms.substring(0,2)+":"+hms.substring(2,4)+":"+hms.substring(4,6);
		return formatString;
	};
	
	var reTypeFormate = function(type){
		if(type == 0){
			return constantDefine.NO_REPETITION;//"不重复";
		} else if(type == 1){
			return constantDefine.PER_DAY;//"每天";
		} else if(type == 2){
			return constantDefine.PER_WEEK;//"每周";
		} else if(type == 3){
			return constantDefine.PER_MONTH;//"每月";
		}
	};
	
	var reDayFormate = function(type,reDay){
		if(reDay != null){
			if(type == 2){
				var day = ["周日","周一","周二","周三","周四","周五","周六"];
				var reDays = reDay.split(",");
				var format = "";
				for(var i=0;i<reDays.length;i++){
					format += day[reDays[i]] + ",";
				}
				return format.substring(0, format.length-1);
			}else if(type == 3){
				if((reDay.split(",")).length>8){
					var reDays = reDay.split(",");
					var format = "";
					for(var i=0;i<8;i++){
						format += reDays[i] + ",";
					}
					return format+"……";
				}else{
					return reDay + "号";
				}
				
			}
		}else{
			return "";
		}
		
	};
	
}).controller('common.mapData',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache,CONSTANT){
                 
	function initBaiduMap1() {
		if ($rootScope.networkState == 'none') {
			$rootScope.showPopup(constantDefine.load_map_error);//"当前离线模式下无法加载实时地图定位");
    	} else {
    		hlService.home.getPubLocksetByPoint(window.localStorage.userId,0,0,0,0).query(function(res){
    			var map = new BMap.Map("container");
    	        map.addControl(new BMap.MapTypeControl());
    	        map.enableScrollWheelZoom(false);    //启用滚轮放大缩小，默认禁用
    	        map.enableContinuousZoom();    //启用地图惯性拖拽，默认禁用
    	        map.addControl(new BMap.NavigationControl());  //添加默认缩放平移控件 
    	        map.addControl(new BMap.OverviewMapControl()); //添加默认缩略地图控件
    	        map.addControl(new BMap.OverviewMapControl({ isOpen: false, anchor: BMAP_ANCHOR_BOTTOM_RIGHT }));   //右下角，打开    
    	        var localSearch = new BMap.LocalSearch(map);
    	        localSearch.enableAutoViewport(); //允许自动调节窗体大小
                for(var i=0;i<res.length;i++){
               	 var record = res[i];
                    var maker = addMarker(map, new window.BMap.Point(record.LONGITUDE, record.LATITUDE), i,record);  
                    //addInfoWindow(maker, record, i); 
                }
            },function(res){
                //$rootScope.showPopup("当前离线模式下无法加载实时地图定位");
            });
    	}
	}
    function initBaiduMap() {
    	if ($rootScope.networkState == 'none') {
    		$rootScope.showPopup(constantDefine.load_map_error);
    		return;
    	}
        try {
            var lng = $stateParams.lng;
            var lat = $stateParams.lat;

            var map = new BMap.Map("container");
            map.addControl(new BMap.MapTypeControl());
            map.enableScrollWheelZoom(false);    //启用滚轮放大缩小，默认禁用
            map.enableContinuousZoom();    //启用地图惯性拖拽，默认禁用
            map.addControl(new BMap.NavigationControl());  //添加默认缩放平移控件 
            map.addControl(new BMap.OverviewMapControl()); //添加默认缩略地图控件
            map.addControl(new BMap.OverviewMapControl({ isOpen: false, anchor: BMAP_ANCHOR_BOTTOM_RIGHT }));   //右下角，打开    
            var localSearch = new BMap.LocalSearch(map);
            localSearch.enableAutoViewport(); //允许自动调节窗体大小
	   
            if(lng != "" && lat != ""){
                var point = new BMap.Point(lng,lat);
                map.centerAndZoom(point, 20);
                var marker = new BMap.Marker(point);  
                map.addOverlay(marker);  
            } else {
                CONSTANT.getBaiduMapLocation(function(point){
                    if(point){
                        map.centerAndZoom(point,20);
                        var startLng = point.lng - 0.01;
                        var endLng = point.lng + 0.01;
                        var startLat = point.lat - 0.01;
                        var endLat = point.lat + 0.01;
                        //获取方圆范围内的点，后台已舍弃条件删选返回了所有点 -- leaf
                        hlService.home.getPubLocksetByPoint(window.localStorage.userId,startLng,endLng,startLat,endLat).query(function(res){
                            for(var i=0;i<res.length;i++){
                                var record = res[i];
                                var maker = addMarker(map, new window.BMap.Point(record.LONGITUDE, record.LATITUDE), i,record);
                                //addInfoWindow(maker, record, i);
                            }
                        },function(res){
                            $rootScope.showPopup(constantDefine.network_lazy);//"网络偷懒啦!!!");
                        });
                    } else {
                        //获取方圆范围内的点，后台已舍弃条件删选返回了所有点 -- leaf
                        hlService.home.getPubLocksetByPoint(window.localStorage.userId,startLng,endLng,startLat,endLat).query(function(res){
                            if(res.length > 0){
                                map.centerAndZoom(new window.BMap.Point(res[0].LONGITUDE, res[0].LATITUDE),20);
                            }
                            for(var i=0;i<res.length;i++){
                                var record = res[i];
                                var maker = addMarker(map, new window.BMap.Point(record.LONGITUDE, record.LATITUDE), i,record);
                                //addInfoWindow(maker, record, i);
                            }
                        },function(res){
                            $rootScope.showPopup(constantDefine.network_lazy);//"网络偷懒啦!!!");
                        });
                    }
                });
            }
        }catch(err) {
            console.log(err);
            $rootScope.showPopup(constantDefine.offline_loadmap_error);//"当前网络已断开或不稳定，无法开启地图");
        }
    }
    
    
	// 添加标注  
    function addMarker(map, point, index,record) {  
        var myIcon = new BMap.Icon("http://api.map.baidu.com/img/markers.png",  
            new BMap.Size(23, 25), {  
                offset: new BMap.Size(10, 25),  
                imageOffset: new BMap.Size(0, 0 - index * 25)  
            });  
        var marker = new BMap.Marker(point); 
        //pop弹窗标题  
        var title = '<div style="font-weight:bold;color:#CE5521;font-size:14px;text-align:center;">' + record.DEVNAME + '</div>';  
        //pop弹窗信息  
        var html = [];  
        html.push('<table cellspacing="0" style="table-layout:fixed;width:100%;font:12px arial,simsun,sans-serif"><tbody>');  
        html.push('<tr>');  
        html.push('<td style="vertical-align:top;line-height:16px;width:30%;white-space:nowrap;word-break:keep-all">'+constantDefine.location+'</td>');  
        html.push('<td style="vertical-align:top;line-height:16px">' + record.LOCATION + '</td>');  
        html.push('</tr>');
        html.push('<tr>');  
        html.push('<td style="vertical-align:top;line-height:16px;width:30%;margin-top:10px;">'+constantDefine.LOCK_TIME+'</td>');  
        html.push('<td style="vertical-align:top;line-height:16px;margin-top:10px;">' + dateFormate(record.TIME) + ' </td>');  
        html.push('</tr>');  
        html.push('</tbody></table>');  
        var searchInfoWindow = null;
    	searchInfoWindow = new BMapLib.SearchInfoWindow(map, html.join(""), {
			title  : title,      //标题
			width  : 290,             //宽度
			height : 85,              //高度
			panel  : "panel",         //检索结果面板
			enableSendToPhone:false,
			enableAutoPan : true,     //自动平移
			searchTypes   :[
				BMAPLIB_TAB_TO_HERE,  //到这里去
				BMAPLIB_TAB_FROM_HERE, //从这里出发
				BMAPLIB_TAB_SEARCH   //周边检索 
			],
			currentAddr : '上海浦东新区龙东大道3000号'        //自定义属性   -- by leaf
		});
        
    	marker.addEventListener("click", function(e){
    	    searchInfoWindow.open(marker);
        });
        
        
        map.addOverlay(marker);
        marker.setLabel(new BMap.Label(record.DEVNAME,{offset:new BMap.Size(-20,20),position:point}));
        return marker;  
    }  
//
//    // 添加信息窗口  
//    function addInfoWindow(marker, record) {  
//    	
//        //pop弹窗标题  
//        var title = '<div style="font-weight:bold;color:#CE5521;font-size:14px;text-align:center;">' + record.DEVNAME + '</div>';  
//        //pop弹窗信息  
//        var html = [];  
//        html.push('<table cellspacing="0" style="table-layout:fixed;width:100%;font:12px arial,simsun,sans-serif"><tbody>');  
//        html.push('<tr>');  
//        html.push('<td style="vertical-align:top;line-height:16px;width:30%;white-space:nowrap;word-break:keep-all">上锁时间:</td>');  
//        html.push('<td style="vertical-align:top;line-height:16px">' + dateFormate(record.TIME) + ' </td>');  
//        html.push('</tr>');  
//        html.push('<tr>');  
//        html.push('<td style="vertical-align:top;line-height:16px;width:30%;white-space:nowrap;word-break:keep-all">地点:</td>');  
//        html.push('<td style="vertical-align:top;line-height:16px">' + record.LOCATION + '</td>');  
//        html.push('</tr>');
//        html.push('</tbody></table>');  
//        var infoWindow = new BMap.InfoWindow(html.join(""), { title: title, width: 200 });  
//        var openInfoWinFun = function () {  
//            marker.openInfoWindow(infoWindow);  
//        };  
//        marker.addEventListener("click", openInfoWinFun);  
//        return openInfoWinFun;
//    }
   
    var dateFormate = function(time){
		if(time !=0 && time != null){
			var date = new Date(time*1000);
			return date.getFullYear() + "-" + (date.getMonth()+1) + "-" + date.getDate();
		}else{
			return 0;
		}
	};
    initBaiduMap();
    
})
.controller('common.mapLead',['$scope','$rootScope','$stateParams','$interval','$timeout','$ionicPopup','hlService','$state','blcache',
    function($scope,$rootScope,$stateParams,$interval,$timeout,$ionicPopup,hlService,$state, blcache){
	
	
	
	
	
	
	var map = new BMap.Map("leadMap");
    map.addControl(new BMap.MapTypeControl());
    map.enableScrollWheelZoom(false);    //启用滚轮放大缩小，默认禁用
    map.enableContinuousZoom();    //启用地图惯性拖拽，默认禁用
    map.addControl(new BMap.NavigationControl());  //添加默认缩放平移控件 
    map.addControl(new BMap.OverviewMapControl()); //添加默认缩略地图控件
    map.addControl(new BMap.OverviewMapControl({ isOpen: false, anchor: BMAP_ANCHOR_BOTTOM_RIGHT }));   //右下角，打开	
    var localSearch = new BMap.LocalSearch(map);
    localSearch.enableAutoViewport(); //允许自动调节窗体大小
	
    var point = new BMap.Point(121.639940,31.228950);
	map.centerAndZoom(point, 20);
	var marker = new BMap.Marker(point);  
    map.addOverlay(marker);  
    
    
    
    
    
    
}])
.controller('common.installLocksetView',['$scope','$rootScope','$stateParams','$interval','$timeout','$ionicPopup','hlService','$state',
    function($scope,$rootScope,$stateParams,$interval,$timeout,$ionicPopup,hlService,$state){
	var timer = $interval(function(){
		listener();
	},300);
	timer.then(success, error, notify);
	function success(){
		 // nothing
	}
	function error(){
		 // nothing
	} 
	function notify(){
	  // nothing
	}
	function listener() {
		if($rootScope.Lockset != null) {
			$interval.cancel(timer);
			if ($rootScope.Lockset != null  && $rootScope.Lockset.depend == 1) {
				$state.go('installLockset1');
			} else {
				$state.go('installLockset');
			}
		}
	}
	$scope.goback = function() {
		$state.go('home');
	};
	
}])
.controller('common.installLockset',['$scope','$rootScope','$stateParams','$interval','$timeout','$ionicModal','$ionicPopup','$ionicLoading','$ionicNavBarDelegate','$cordovaGeolocation','hlService','$state','blcache','CONSTANT',
    function($scope,$rootScope,$stateParams,$interval,$timeout,$ionicModal,$ionicPopup,$ionicLoading,$ionicNavBarDelegate,$cordovaGeolocation,hlService,$state, blcache,CONSTANT){  //注意：installLockset和installLockset1中的保存过程一模一样，最好能放到一个通用的作用域里处理
	var getFormatLockId = function() {
		return decimalRadixToHex($rootScope.lockId);
	};
	var decimalRadixToHex = function(num){
		return num.toString(16);
	};
	$scope.formatLockId = getFormatLockId();
	var timer = $interval(function(){
		listener();
	},300);
	timer.then(success, error, notify);
	function success(){
		 // nothing
	}
	function error(){
		 // nothing
	} 
	function notify(){
	  // nothing
	}
	function listener() {
		if($rootScope.Lockset != null && $rootScope.Lockset.refresh) {
			
			$rootScope.Lockset.refresh = false;
			loadGPS();
		}
	}
	$scope.show = function() {
	    $ionicLoading.show({
	    	templateUrl: 'pages/common/loading.html'
	    });
	};
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$ionicModal.fromTemplateUrl('pages/common/lastlocation.html', {
	    scope: $scope
	}).then(function(modal) {
	    $scope.modal = modal;
	});
	var dateFormate = function(time){
		if(time !=0 && time != null){
			var date = new Date(time*1000);
			return date.getFullYear() + "-" + (date.getMonth()+1) + "-" + date.getDate();
		}else{
			return 0;
		}
	};
	
	
	// 之前的代码，暂时注释，这里获取pubArea是做什么用呢？--by冯永发 2017-8-11
	/*hlService.home.getPubAreaData().query(function(res){
		$scope.areaList = res;
		window.localStorage.areaDataList = JSON.stringify(res);
	},function(res){
		$scope.areaList = JSON.parse(window.localStorage.areaDataList);
	});*/
	
	// 该功能不要了，挪到selectDevice控制器中进行选择 --by 冯永发 2017-8-16
	/*hlService.home.getDeviceSelectsByUserId(window.localStorage.userId).query(function(res){
		$scope.deviceList = res;
		window.localStorage.deviceList = JSON.stringify(res);
	},function(res){
		$scope.deviceList = JSON.parse(window.localStorage.deviceList); // TODO::这里的缓存没有纳入到最新的缓存机制中！！！
		
	});*/
	
	$scope.saveInstallInfo = function(lockset){
        if (lockset.pubDevice == null || lockset.pubDevice.deviceName == null || lockset.pubDevice.deviceName == '') {
        	$rootScope.showPopup(constantDefine.select_device);//"请先选择设备");
        } else {
        	lockset.deviceName = lockset.pubDevice.deviceName; // 将新的设备名称赋值给原有的设备名，保持一致
        	var pubDevice = {
				lockId : lockset.lockId,
				deviceId : lockset.pubDevice.deviceId,
				deviceName : lockset.deviceName,
				location : lockset.location,
				installer : $rootScope.Lockset.installer,
				time : $rootScope.Lockset.time,
				longitude : lockset.longitude,
				latitude : lockset.latitude,
                depend : lockset.depend
			};
        	$scope.saveInstallLockset(pubDevice);
        }
	};
	$scope.saveInstallLockset  = function(device) {
		hlService.home.updateInstallLocksetData().save(device,function(res){
      		if(res.NUM == -1){
      			$state.go('installLocksetResult', {lockId:$rootScope.lockId,success:false});
      		}else{
      			$state.go('installLocksetResult', {lockId:$rootScope.lockId,success:true});
      		}
      	},function(res){
      		$scope.cacheInstallLockset(device);
      	});
	};
	$scope.cacheInstallLockset = function(device) {
		blcache.installPubDeviceAndPubLockset(device);
		$state.go('installLocksetResult', {lockId:$rootScope.lockId,success:true});
	};
	
	$scope.locationHandler = function(Lockset){
		if(Lockset.longitude!="" && Lockset.longitude!=null && Lockset.longitude!=undefined){
			$state.go("locationData",{lng:Lockset.longitude,lat:Lockset.latitude});
		}
		
	};
	$scope.showDevice = function() {
		$state.go("selectDevice");
	};
	$scope.goback = function() {
		$interval.cancel(timer);
		initInstallStatus();
	};
	$scope.setLastLocation = function(lastLoaction) {
		$rootScope.Lockset.longitude  = lastLoaction.longitude;
 	    $rootScope.Lockset.latitude = lastLoaction.latitude;
 	    $rootScope.Lockset.location = lastLoaction.location;
 	    $scope.modal.hide();
	};
	function loadGPS() {
		if ($rootScope.networkState == 'none') {
			$scope.show();
			var posOptions = {timeout: 10000, enableHighAccuracy: false};
		      $cordovaGeolocation.getCurrentPosition(posOptions)
		       .then(function (position) {
		    	   $rootScope.Lockset.latitude  = position.coords.latitude;
		    	   $rootScope.Lockset.longitude = position.coords.longitude;
		    	   $scope.hide();
		       }, function(err) {
		    	   $scope.hide();
				   showLastLocationModal();
		       });
		} else {
			$scope.show();
            
            CONSTANT.getBaiduMapLocation(function(point){
                if(point){
                    var geoc = new BMap.Geocoder();
                    geoc.getLocation(point, function(rs){
                        var addComp = rs.addressComponents;
                        $rootScope.Lockset.longitude = point.lng;
                        $rootScope.Lockset.latitude = point.lat;
                        $rootScope.Lockset.location = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
                    });
                    $scope.hide();
                } else {
                    $scope.hide();
                    showLastLocationModal();
                    
                }
            });
            
//			var geolocation = new BMap.Geolocation();
//			geolocation.getCurrentPosition(function(r){
//				if(this.getStatus() == BMAP_STATUS_SUCCESS){
//					var geoc = new BMap.Geocoder();
//					var point = new BMap.Point(r.point.lng,r.point.lat);
//					geoc.getLocation(point, function(rs){
//						var addComp = rs.addressComponents;
//						$rootScope.Lockset.longitude = r.point.lng;
//						$rootScope.Lockset.latitude = r.point.lat;
//						$rootScope.Lockset.location = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
//					});
//					$scope.hide();
//				} else {
//					$scope.hide();
//					showLastLocationModal();
//				}
//			},{enableHighAccuracy: true});
		}
	}
	function showLastLocationModal() {
		if (window.localStorage.longitude != null && window.localStorage.longitude != '') {
 		   $scope.lastLocation = {
 			   longitude:   window.localStorage.longitude,
 			   latitude : window.localStorage.latitude,
 			   location : window.localStorage.location  
    	   };
 		   var timer = $timeout(function () {
 			  $scope.modal.show();
           }, 500);
 	   } else {
 		   $rootScope.showPopup(constantDefine.	get_location_error);//"无法获取实时定位信息，请手动输入");
 	   }
	}
	function initInstallStatus() {
		$rootScope.Lockset = null;
		$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = true;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	
		$ionicNavBarDelegate.back();
	}
	
}])
.controller('common.selectDevice',['$scope','$rootScope','$stateParams','$interval','$timeout','$ionicPopup','$ionicNavBarDelegate','hlService','$state','blcache',
    function($scope,$rootScope,$stateParams,$interval,$timeout,$ionicPopup,$ionicNavBarDelegate,hlService,$state, blcache){
	$scope.selectDevice = function(device) {
		$rootScope.Lockset.pubDevice = device;
		$scope.goback();
	};
	$scope.goback = function() {
		$state.go("installLockset");
	};
	$scope.getDevices = function() {
		hlService.home.getDeviceSelectsByUserId(window.localStorage.userId).query(function(res){
			$scope.deviceList = res;
			window.localStorage.deviceList = JSON.stringify(res);
		},function(res){
			$scope.deviceList = JSON.parse(window.localStorage.deviceList); // TODO::这里的缓存没有纳入到最新的缓存机制中！！！
			
		});
	};
	$scope.getDevices();
}])
.controller('common.installLockset1',['$scope','$rootScope','$stateParams','$interval','$timeout','$ionicModal','$ionicPopup','$ionicLoading','$ionicNavBarDelegate','$cordovaGeolocation','hlService','$state','blcache','CONSTANT',
    function($scope,$rootScope,$stateParams,$interval,$timeout,$ionicModal, $ionicPopup,$ionicLoading,$ionicNavBarDelegate,$cordovaGeolocation, hlService,$state, blcache,CONSTANT){
	var getFormatLockId = function() {
		return decimalRadixToHex($rootScope.lockId);
	};
	var decimalRadixToHex = function(num){
		return num.toString(16);
	};
	$scope.formatLockId = getFormatLockId();
	var timer = $interval(function(){
		listener();
	},300);
	timer.then(success, error, notify);
	function success(){
		 // nothing
	}
	function error(){
		 // nothing
	} 
	function notify(){
	  // nothing
	}
	function listener() {
		if($rootScope.Lockset != null && $rootScope.Lockset.refresh) {
			$rootScope.Lockset.refresh = false;
			loadGPS();
		}
	}
	$scope.show = function() {
	    $ionicLoading.show({
	    	templateUrl: 'pages/common/loading.html'
	    });
	};
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$ionicModal.fromTemplateUrl('pages/common/lastlocation.html', {
	    scope: $scope
	}).then(function(modal) {
	    $scope.modal = modal;
	});
	$scope.saveInstallInfo = function(lockset){
        if (lockset.newDeviceName == null || lockset.newDeviceName == '') {
        	$rootScope.showPopup(constantDefine.input_device);//"请先填写设备名称");
        } else {
        	lockset.deviceName = lockset.newDeviceName; // 将新的设备名称赋值给原有的设备名，保持一致
        	var pubDevice = {
				lockId : lockset.lockId,
				deviceId : lockset.deviceId,
				deviceName : lockset.deviceName,
				location : lockset.location,
				installer : $rootScope.Lockset.installer,
				time : $rootScope.Lockset.time,
				longitude : lockset.longitude,
				latitude : lockset.latitude,
                depend : lockset.depend
			};
        	$scope.saveInstallLockset(pubDevice);
        }
	};
	$scope.saveInstallLockset  = function(device) {
		hlService.home.updateInstallLocksetData().save(device,function(res){
      		if(res.NUM == -1){
      			$state.go('installLocksetResult', {lockId:$rootScope.lockId,success:false});
      		}else{
      			$state.go('installLocksetResult', {lockId:$rootScope.lockId,success:true});
      		}
      	},function(res){
      		$scope.cacheInstallLockset(device);
      	});
	};
	$scope.cacheInstallLockset = function(device) {
		$scope.show();
		blcache.installPubDeviceAndPubLockset(device);
		$scope.hide();
		$state.go('installLocksetResult', {lockId:$rootScope.lockId,success:true});
	};
	$scope.locationHandler = function(Lockset){
		if(Lockset.longitude!="" && Lockset.longitude!=null && Lockset.longitude!=undefined){
			$state.go("locationData",{lng:Lockset.longitude,lat:Lockset.latitude});
		}
		
	};
	$scope.goback = function() {
		$interval.cancel(timer);
		initInstallStatus();
	};
	$scope.setLastLocation = function(lastLoaction) {
		$rootScope.Lockset.longitude  = lastLoaction.longitude;
 	    $rootScope.Lockset.latitude = lastLoaction.latitude;
 	    $rootScope.Lockset.location = lastLoaction.location;
 	    $scope.modal.hide();
	};
	function loadGPS() {
		if ($rootScope.networkState == 'none') {
			$scope.show();
			var posOptions = {timeout: 10000, enableHighAccuracy: false};
		      $cordovaGeolocation.getCurrentPosition(posOptions)
		       .then(function (position) {
		    	   $rootScope.Lockset.latitude  = position.coords.latitude;
		    	   $rootScope.Lockset.longitude = position.coords.longitude;
		    	   $scope.hide();
		       }, function(err) {
		    	   $scope.hide();
				   showLastLocationModal();
		       });
		} else {
			$scope.show();
            CONSTANT.getBaiduMapLocation(function(point){
                if(point){
                    var geoc = new BMap.Geocoder();
                    geoc.getLocation(point, function(rs){
                        var addComp = rs.addressComponents;
                        $rootScope.Lockset.longitude = point.lng;
                        $rootScope.Lockset.latitude = point.lat;
                        $rootScope.Lockset.location = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
                    });
                    $scope.hide();
                } else {
                    $scope.hide();
                    showLastLocationModal();
                    
                }
            });
//
//			var geolocation = new BMap.Geolocation();
//			geolocation.getCurrentPosition(function(r){
//				if(this.getStatus() == BMAP_STATUS_SUCCESS){
//					var geoc = new BMap.Geocoder();
//					var point = new BMap.Point(r.point.lng,r.point.lat);
//					geoc.getLocation(point, function(rs){
//						var addComp = rs.addressComponents;
//						$rootScope.Lockset.longitude = r.point.lng;
//						$rootScope.Lockset.latitude = r.point.lat;
//						$rootScope.Lockset.location = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
//					});
//					$scope.hide();
//				} else {
//					$scope.hide();
//					showLastLocationModal();
//				}
//			},{enableHighAccuracy: true,timeout: 10000});
		}
	}
	function showLastLocationModal() {
		if (window.localStorage.longitude != null && window.localStorage.longitude != '') {
 		   $scope.lastLocation = {
 			   longitude:   window.localStorage.longitude,
 			   latitude : window.localStorage.latitude,
 			   location : window.localStorage.location  
    	   };
 		   var timer = $timeout(function () {
 			  $scope.modal.show();
           }, 500);
    	   
 	   } else {
 		   $rootScope.showPopup(constantDefine.get_location_error);
 	   }
	}
	function initInstallStatus() {
		$rootScope.Lockset = null;
		$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = true;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
		$ionicNavBarDelegate.back();
	}
}]).controller('common.installLocksetResult',['$scope','$rootScope','$cordovaToast','$stateParams','$interval','$timeout','$ionicPopup', '$ionicNavBarDelegate','hlService','$state', 'blcache',
    function($scope,$rootScope,$cordovaToast,$stateParams,$interval,$timeout,$ionicPopup,$ionicNavBarDelegate,hlService,$state, blcache){
	
	$scope.lockId = $stateParams.lockId;
	$scope.success = $stateParams.success == 'true' ? true : false;
	var getFormatLockId = function() {
		return decimalRadixToHex($rootScope.lockId);
	};
	var decimalRadixToHex = function(num){
		return num.toString(16);
	};
	$scope.formatLockId = getFormatLockId();
	$scope.goback = function() {
		$rootScope.Lockset = null;
		$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = true;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('installLocksetView');
	};
	function refreshAllCache() {
		hlService.user.getPermissionsAndDevicesAndLocksetsByUserId(window.localStorage.userId).get(function(res){
			blcache.refreshAllCache(res);
		},
		function(res){
			// tips:update cache error
			
		});
	}
	refreshAllCache();
}])
.controller('common.recoverLocksetView',['$scope','$rootScope','$stateParams','$interval','$timeout','$ionicPopup','hlService','$state',
    function($scope,$rootScope,$stateParams,$interval,$timeout,$ionicPopup,hlService,$state){
	var timer = $interval(function(){
		listener();
	},300);
	timer.then(success, error, notify);
	function success(){
		 // nothing
	}
	function error(){
		 // nothing
	} 
	function notify(){
	  // nothing
	}
	function listener() {
		if($rootScope.recover != null) {
			$interval.cancel(timer);
			$state.go('recoverLockset');
		}
	}
	$scope.goback = function() {
		$state.go('home');
	};
}])
.controller('common.recoverLockset',['$scope','$rootScope','$cordovaToast','$stateParams','$interval','$timeout','$ionicPopup', '$ionicNavBarDelegate','hlService','$state', 'blcache',
    function($scope,$rootScope,$cordovaToast,$stateParams,$interval,$timeout,$ionicPopup,$ionicNavBarDelegate,hlService,$state, blcache){
	var getFormatLockId = function(lockId) {
		return decimalRadixToHex(lockId);
	};
	var decimalRadixToHex = function(num){
		return num.toString(16);
	};
	$scope.formatLockId = getFormatLockId($rootScope.lockId);
	$scope.submitRecoverInfo = function(recover){
		var recover = $rootScope.recover;
		if(recover.lockId == "" || recover.lockId == null){
			return;
		}
		hlService.home.updateRecoverLocksetData().save({
			lockId : recover.lockId,
			deviceId : $rootScope.recover.deviceId,
			deviceName : recover.deviceName,
			location : $rootScope.recover.location,
			installer : 0,
			time : $rootScope.recover.time,
			longitude : 0,
			latitude : 0,
			depend:$rootScope.recover.depend
      	},function(res){
      		if(res.NUM == -1){
      			$state.go('recoverLocksetResult', {lockId:recover.lockId,success:false});
      		}else{
      			$state.go('recoverLocksetResult', {lockId:recover.lockId,success:true});
      		}
      	},function(res){
      		blcache.recoverPubDeviceAndPubLockset(getRecoverLocksetDataCache(recover));
      		$state.go('recoverLocksetResult', {lockId:recover.lockId,success:true});
      	});
	};
	function getRecoverLocksetDataCache(recover) {
		var newRecover = {
			lockId : recover.lockId,
			deviceId : $rootScope.recover.deviceId,
			deviceName : recover.deviceName,
			location : $rootScope.recover.location,
			installer : 0,
			time : $rootScope.recover.time,
			longitude : 0,
			latitude : 0,
			depend:$rootScope.recover.depend
		};
		return newRecover;
	}
	$scope.goback = function() {
		$rootScope.recover = null;
		$ionicNavBarDelegate.back();
	};
}]).controller('common.recoverLocksetResult',['$scope','$rootScope','$cordovaToast','$stateParams','$interval','$timeout','$ionicPopup', '$ionicNavBarDelegate','hlService','$state', 'blcache',
    function($scope,$rootScope,$cordovaToast,$stateParams,$interval,$timeout,$ionicPopup,$ionicNavBarDelegate,hlService,$state, blcache){
	$scope.lockId = $stateParams.lockId;
	$scope.success = $stateParams.success == 'true' ? true : false;
	var getFormatLockId = function() {
		return decimalRadixToHex($rootScope.lockId);
	};
	var decimalRadixToHex = function(num){
		return num.toString(16);
	};
	$scope.formatLockId = getFormatLockId($rootScope.lockId);
	$scope.goback = function() {
		$rootScope.recover = null;
		$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = true;
    	$state.go('recoverLocksetView');
	};
	function refreshAllCache() {
		hlService.user.getPermissionsAndDevicesAndLocksetsByUserId(window.localStorage.userId).get(function(res){
			blcache.refreshAllCache(res);
		},
		function(res){
			// tips:update cache error
			
		});
	}
	refreshAllCache();
}])
.controller('common.initLocksetDepend0',['$scope','$rootScope','$cordovaToast','$stateParams','$interval','$timeout','$ionicPopup', '$ionicNavBarDelegate','hlService','$state', 'blcache',
    function($scope,$rootScope,$cordovaToast,$stateParams,$interval,$timeout,$ionicPopup,$ionicNavBarDelegate,hlService,$state, blcache){
	$scope.switchDepend = function() {
		$rootScope.bluetooth.switchDepend = 1;
		$state.go('initLocksetDepend1');
	};
	
}])
.controller('common.initLocksetDepend1',['$scope','$rootScope','$cordovaToast','$stateParams','$interval','$timeout','$ionicPopup', '$ionicNavBarDelegate','hlService','$state', 'blcache',
    function($scope,$rootScope,$cordovaToast,$stateParams,$interval,$timeout,$ionicPopup,$ionicNavBarDelegate,hlService,$state, blcache){
	$scope.switchDepend = function() {
		$rootScope.bluetooth.switchDepend = 0;
		$state.go('initLocksetDepend0');
	};
	
}])
.controller('manage.key',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,$ionicPopup,hlService,blcache){
	
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.blKeyList = [];
	$scope.blkeySearchs = [];
	
	$scope.first = true;
	$scope.start = -1;
	$scope.limit = 20;
	$scope.keyword = null;
	
	$scope.show = function() {
	    $ionicLoading.show({
	    	templateUrl: 'pages/common/loading.html'
	    });
	};
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$scope.doRefresh = function() {
		if ($scope.first) {
			timer = $timeout(function () {
				loadKeyListByUserId(); 
            }, 1000);
			$scope.first = false;
		} else {
			loadKeyListByUserId(); 
		}
	};
	$scope.getKeyListByUserId = function(){
		if ($rootScope.networkState == 'none') {
			$scope.$broadcast('scroll.refreshComplete');
			$rootScope.showPopup(constantDefine.offline_unblkeymanage);//"当前离线模式下无法进行授权管理");
		} else {
			//$scope.show();
			$scope.start = 0;
			$scope.limit = 20;
			$scope.domore = false;
			var keyWord = $scope.keyword == null ? " " : $scope.keyword;
			hlService.home.getPubBlKeyListByUserId(window.localStorage.userId,keyWord, $scope.start, $scope.limit).query(function(res){
				$scope.blKeyList = res;
				$scope.$broadcast('scroll.refreshComplete');
			},function(res){
				$scope.$broadcast('scroll.refreshComplete');				
			});
		}
		
	};
	
	/**
	 * 分页加载
	 * */
	function loadKeyListByUserId() {
		if ($rootScope.networkState == 'none') {
			$rootScope.showPopup(constantDefine.offline_unblkeymanage);//"当前离线模式下无法进行授权管理");
			$scope.$broadcast('scroll.infiniteScrollComplete');
			$scope.domore = true;  
		} else {
			$scope.start++;
			var timer = null; 
			var keyWord = $scope.keyword == null ? " " : $scope.keyword;
			hlService.home.getPubBlKeyListByUserId(window.localStorage.userId,keyWord, $scope.start, $scope.limit).query(function(res){
				if (res) {
					if (res.length != 0) {
						for(var i=0;i<res.length;i++){
							var obj = res[i];
							$scope.blKeyList.push(obj);
						}
					}
					if (res.length == 0){
						$scope.domore = true; 
					}
					timer = $timeout(function () {
		                $scope.$broadcast('scroll.infiniteScrollComplete');  
		            }, 1500);
				} else {
					$scope.domore = true;  
	                $scope.$broadcast('scroll.infiniteScrollComplete');
				}
			},function(res){
				$timeout.cancel(timer);
				$scope.domore = true; 
	            $scope.$broadcast('scroll.infiniteScrollComplete');
			});
			 $scope.$on("$destroy", function () {   
	             $timeout.cancel(timer);  
	        });
		}
		
	}
	
	
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.blkeySearchs = [];
			var timer = null; 
			hlService.home.getPubBlKeyListByUserId(window.localStorage.userId,keyword, 0, 100).query(function(res){
				if (res) {
					if (res.length != 0) {
						for(var i=0;i<res.length;i++){
							var obj = res[i];
							$scope.blkeySearchs.push(obj);
						}
					}
					
					timer = $timeout(function () {
		                $scope.$broadcast('scroll.infiniteScrollComplete');  
		            }, 1500);
				} else {
	                $scope.$broadcast('scroll.infiniteScrollComplete');
				}
			},function(res){
				$timeout.cancel(timer);
	            $scope.$broadcast('scroll.infiniteScrollComplete');
			});
			 $scope.$on("$destroy", function () {   
	             $timeout.cancel(timer);  
	        });
		},1000);
		
	}
	
	/**
	 * 获取用户下所在系统下的所有钥匙信息
	 * */
//	$scope.getKeyListByUserId = function(){
//		hlService.home.getPubBlKeyListByUserId(window.localStorage.userId).query(function(res){
//			$scope.blKeyList = res;
//			$scope.$broadcast('scroll.refreshComplete');
//		},function(res){
//			$scope.$broadcast('scroll.refreshComplete');
//		});
//	}
//	$scope.getKeyListByUserId();
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
  	  	$scope.domore = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.blkeySearchs = [];
  	  	$scope.keyword = null;
  	  	$scope.domore = false;
    }
    
//	$scope.doRefresh = function(){
//		$scope.getKeyListByUserId();
//		$scope.$broadcast('scroll.infiniteScrollComplete'); 
//		$scope.domore = true;
//	};
	
	/**
	 * 添加新锁
	 * */
	$scope.addKey = function(){
		$state.go('addKey',{'keyId':-1,'name':'','macAddr':''});
	}
	
	/**
	 * 
	 * */
	$scope.deleteKey = function(key){
		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要删除该钥匙?',
	       cancelText : '取消',
	       okText : '确认'
	    });
	    confirmPopup.then(function(res) {
	       if(res) {
	    	   hlService.home.deletePubBlKey().save(key,function(res){
	    		   	$rootScope.showPopup(res.msg);
	    		   	if(res.msg == "删除成功！"){
	    		   		$scope.getKeyListByUserId();
	    		   		if($scope.isSearch){
		   					$scope.cancelSearch();
		   				}
	    		   	}
	         	});
	       	}
	    });
	}
	
	$scope.goBack = function(){
		$state.go('home');
	}
})
.controller('manage.addKey',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var id = $stateParams.keyId;
	var name = $stateParams.name;
	var macAddr = $stateParams.macAddr;
	if(id == null || id == undefined){
		$scope.Key = {
			id : -1
		};
	} else {
		$scope.Key = {
			id : id,
			name : name,
			macAddr : macAddr
		};
	}
	var sysId = window.localStorage.sysId;
	$scope.saveBlKeyInfo = function(key){
		
		var pubBlKey = {
			keyId : key.id,
			name : key.name,
			macAddr : key.macAddr,
			sysId : sysId
		}
		
		hlService.home.savePubBlKey().save(pubBlKey,function(res){
			$rootScope.showPopup(res.msg);
			if(res.msg == "保存成功！"){
				history.go(-1);
			}
      	});
		
	};
	
	
})
.controller('manage.device',function($scope,$rootScope,$stateParams,$state,$ionicLoading,$interval,$timeout,$ionicPopup,hlService,blcache){
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.deviceList = [];
	$scope.deviceSearchs = [];
	$scope.keyword = null;
	$scope.start = -1;
	$scope.limit = 20;
	$scope.first = true;
	$scope.show = function(){
		$ionicLoading.show({
			templateUrl : 'pages/common/loading.html'
		});
	};
	
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$scope.doRefresh = function() {
		if ($scope.first) {
			timer = $timeout(function () {
				loadDeviceListByUserId(); 
            }, 1000);
			$scope.first = false;
		} else {
			loadDeviceListByUserId(); 
		}
	};
	
	/**
	 * 获取用户下所有设备信息
	 * 首次加载 0 ~ 20 条
	 * */
	$scope.getDeviceListByUserId = function(){
		if ($rootScope.networkState == 'none') {
			$scope.$broadcast('scroll.refreshComplete');
			$rootScope.showPopup(constantDefine.offline_undevicemanage);//"当前离线模式下无法进行设备管理");
		} else {
			//$scope.show();
			$scope.start = 0;
			$scope.limit = 20;
			$scope.domore = false;
			var keyWord = $scope.keyword == null ? " " : $scope.keyword;
			hlService.home.getPubDeviceListBySysId(window.localStorage.sysId,keyWord, $scope.start, $scope.limit).query(function(res){
				for(var i=0;i<res.length;i++){
					var record = res[i];
					if(record.time != 0){
						record.time = dateFormate(record.time);
					}
					res[i] = record;
				}
				
				$scope.deviceList = res;
				$scope.domore = false;
				$scope.$broadcast('scroll.refreshComplete');
				//$scope.hide();
			},function(res){
				$scope.$broadcast('scroll.refreshComplete');				
			});
		}
		
	};
	/**
	 * 分页加载
	 * */
	function loadDeviceListByUserId() {
		if ($rootScope.networkState == 'none') {
			$rootScope.showPopup(constantDefine.offline_undevicemanage);//"当前离线模式下无法查看开锁记录");
			$scope.$broadcast('scroll.infiniteScrollComplete');
			$scope.domore = true;  
		} else {
			$scope.start++;
			var timer = null; 
			var keyWord = $scope.keyword == null ? " " : $scope.keyword;
			hlService.home.getPubDeviceListBySysId(window.localStorage.sysId,keyWord, $scope.start, $scope.limit).query(function(res){
				if (res) {
					if (res.length != 0) {
						for(var i=0;i<res.length;i++){
							var record = res[i];
							if(record.time != 0){
								record.time = dateFormate(record.time);
							}
							$scope.deviceList.push(record);
						}
						
					}
					if (res.length == 0){
						$scope.domore = true; 
					}
					timer = $timeout(function () {
		                $scope.$broadcast('scroll.infiniteScrollComplete');  
		            }, 1500);
				} else {
					$scope.domore = true;  
	                $scope.$broadcast('scroll.infiniteScrollComplete');
				}
			},function(res){
				$timeout.cancel(timer);
				$scope.domore = true; 
	            $scope.$broadcast('scroll.infiniteScrollComplete');
			});
			 $scope.$on("$destroy", function () {   
	             $timeout.cancel(timer);  
	        });
		}
		
	}
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.deviceSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		var timer = null; 
				hlService.home.getPubDeviceListBySysId(window.localStorage.sysId,keyword, 0, 100).query(function(res){
					if (res) {
						if (res.length != 0) {
							for(var i=0;i<res.length;i++){
								var record = res[i];
								if(record.time != 0){
									record.time = dateFormate(record.time);
								}
								$scope.deviceSearchs.push(record);
							}
							
						}
						
						timer = $timeout(function () {
			                $scope.$broadcast('scroll.infiniteScrollComplete');  
			            }, 1500);
					} else {
		                $scope.$broadcast('scroll.infiniteScrollComplete');
					}
				},function(res){
					$timeout.cancel(timer);
		            $scope.$broadcast('scroll.infiniteScrollComplete');
				});
				 $scope.$on("$destroy", function () {   
		             $timeout.cancel(timer);  
		        });
	    	}
		},1000);
		
	}

	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
		$scope.domore = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
		$scope.domore = false;
  	  	$scope.deviceSearchs = [];
  	  	$scope.keyword = null;
    }

	/**
	 * 添加新设备
	 * */
	$scope.addDevice = function(){
		$state.go('addDevice',{
			'deviceId' : -1,
			'deviceName' : null,
			'areaId' : null,
			'location' : null
		});
	}
	
	/**
	 * 
	 * */
	$scope.deleteDevice = function(device){
		
		if(device.installer != 0){
			$rootScope.showPopup('设备已上锁，请回收后再进行操作！');
			return;
		}
		
		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要删除该设备?',
	       cancelText : '取消',
	       okText : '确认'
	    });
	    confirmPopup.then(function(res) {
	       if(res) {
	    	   hlService.home.deletePubDevice().save(device.deviceId,function(res){
	   			$rootScope.showPopup(res.msg);
	   			if(res.msg == "删除成功！"){
	   				$scope.getDeviceListByUserId();
	   				if($scope.isSearch){
	   					$scope.cancelSearch();
	   				}
	   			}
	         	});
	       }
	    });
		
		
	}
	
	var dateFormate = function(time){
		var date = new Date(time*1000);
		return date.getFullYear() + "-" + (date.getMonth()+1) + "-" + date.getDate() + " "
				+ date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
	};
	
	$scope.goBack = function(){
		$state.go('home');
	}
})
.controller('manage.addDevice',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var deviceId = $stateParams.deviceId;
	var deviceName = $stateParams.deviceName;
	var areaId = $stateParams.areaId;
	var location = $stateParams.location;
	
	if(deviceId == null || deviceId == undefined){
		$scope.Device = {
			deviceId : -1
		};
	} else {
		$scope.Device = {
			'deviceId' : deviceId,
			'deviceName' : deviceName,
			'areaId' : areaId,
			'location' : location
		};
	}
	var sysId = window.localStorage.sysId;
	$scope.savePubDeviceInfo = function(device){
		var areaId = $scope.selectedArea.areaId;
		var pubDevice = {
			deviceId : device.deviceId,
			deviceName : device.deviceName,
			areaId :areaId,
			location : device.location,
			sysId : sysId
		}
		hlService.home.savePubDevice().save(pubDevice,function(res){
			$rootScope.showPopup(res.msg);
			if(res.msg == "保存成功！"){
				history.go(-1);
			}
      	});
		
	};
	
	$scope.loadArea = function(initId){
		hlService.home.getPubAreaDataBySysId(sysId).query(function(res){
			$scope.areaList = res;
			if(initId){
				for(var i=0;i<res.length;i++){
					var record = res[i];
					if(initId == record.areaId){
						$scope.selectedArea = record;
						break;
					}
				}
			} else {
				$scope.selectedArea = res[0];
			}
		},function(res){
			$scope.areaList = [];
		});
	}
	
	$scope.loadArea(areaId);
	
})
.controller('manage.user',function($scope,$rootScope,$ionicPopup,$stateParams,$state,$interval,$timeout,hlService,blcache){
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.teamUserList = [];
	$scope.teamUserSearchs = [];
	/**
	 * 用户新增和编辑时全局班组参数
	 * */
	window.localStorage.selectedUserGroup = '';
	window.localStorage.selectedUserTitle = '';
	
	
	$scope.keyword = null;
	$scope.start = -1;
	$scope.limit = 20;
	$scope.first = true;
	$scope.show = function(){
		$ionicLoading.show({
			templateUrl : 'pages/common/loading.html'
		});
	};
	
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$scope.doRefresh = function() {
		if ($scope.first) {
			timer = $timeout(function () {
				loadDeviceListByUserId(); 
            }, 1000);
			$scope.first = false;
		} else {
			loadDeviceListByUserId(); 
		}
	};
	
	/**
	 * 获取用户所在系统下所有用户信息
	 * 首次加载 0 ~ 20 条
	 * */
	$scope.getTeamUserListByUserId = function(){
		if ($rootScope.networkState == 'none') {
			$scope.$broadcast('scroll.refreshComplete');
			$rootScope.showPopup(constantDefine.offline_unusermanage);//"当前离线模式下无法进行用户管理");
		} else {
			//$scope.show();
			$scope.start = 0;
			$scope.limit = 20;
			$scope.domore = false;
			var keyWord = $scope.keyword == null ? " " : $scope.keyword;
			hlService.home.getTeamUserListBySysId(window.localStorage.sysId,keyWord, $scope.start, $scope.limit).query(function(res){
				for(var i=0;i<res.length;i++){
					var record = res[i];
					record.formatOpt = $scope.formatOperation(record.opt);
					res[i] = record;
				}
				
				$scope.teamUserList = res;
				$scope.domore = false;
				$scope.$broadcast('scroll.refreshComplete');
				//$scope.hide();
			},function(res){
				$scope.$broadcast('scroll.refreshComplete');				
			});
		}
		
	};
	/**
	 * 分页加载
	 * */
	function loadDeviceListByUserId() {
		if ($rootScope.networkState == 'none') {
			$rootScope.showPopup(constantDefine.offline_unusermanage);//"当前离线模式下无法进行用户管理");
			$scope.$broadcast('scroll.infiniteScrollComplete');
			$scope.domore = true;  
		} else {
			$scope.start++;
			var timer = null; 
			var keyWord = $scope.keyword == null ? " " : $scope.keyword;
			hlService.home.getTeamUserListBySysId(window.localStorage.sysId,keyWord, $scope.start, $scope.limit).query(function(res){
				if (res) {
					if (res.length != 0) {
						for(var i=0;i<res.length;i++){
							var record = res[i];
							record.formatOpt = $scope.formatOperation(record.opt);
							$scope.teamUserList.push(record);
						}
						
					}
					if (res.length == 0){
						$scope.domore = true; 
					}
					timer = $timeout(function () {
		                $scope.$broadcast('scroll.infiniteScrollComplete');  
		            }, 1500);
				} else {
					$scope.domore = true;  
	                $scope.$broadcast('scroll.infiniteScrollComplete');
				}
			},function(res){
				$timeout.cancel(timer);
				$scope.domore = true; 
	            $scope.$broadcast('scroll.infiniteScrollComplete');
			});
			 $scope.$on("$destroy", function () {   
	             $timeout.cancel(timer);  
	        });
		}
		
	}
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.teamUserSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		var timer = null; 
				hlService.home.getTeamUserListBySysId(window.localStorage.sysId,keyword, 0, 100).query(function(res){
					if (res) {
						if (res.length != 0) {
							for(var i=0;i<res.length;i++){
								var record = res[i];
								record.formatOpt = $scope.formatOperation(record.opt);
								$scope.teamUserSearchs.push(record);
							}
							
						}
						
						timer = $timeout(function () {
			                $scope.$broadcast('scroll.infiniteScrollComplete');  
			            }, 1500);
					} else {
		                $scope.$broadcast('scroll.infiniteScrollComplete');
					}
				},function(res){
					$timeout.cancel(timer);
		            $scope.$broadcast('scroll.infiniteScrollComplete');
				});
				 $scope.$on("$destroy", function () {   
		             $timeout.cancel(timer);  
		        });
	    	}
		},1000);
		
	}
	
	
	$scope.formatOperation = function(value){
		if(value == "" || value == undefined){
			return "-";
		} else{
			var opts = value.split(",");
			var optFormatter = [];
			for(var i=0;i<opts.length;i++){
				var v = opts[i];
				if(v == 0){
					optFormatter.push("初始化入库");
				} else if(v == 1){
					optFormatter.push("挂锁");
				} else if(v == 2){
					optFormatter.push("开锁维护");
				} else if(v == 3){
					optFormatter.push("锁具回收");
				}
			}
			
			return optFormatter.join("， ");
		}
	}
	
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
  	  	$scope.domore = false;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.teamUserSearchs = [];
  	  	$scope.domore = true;
  	  	$scope.keyword = null;
    }
	
	/**
	 * 添加新用户
	 * */
	$scope.addUser = function(){
		var user = {
			userId : -1,
			name : null,
			realName : null,
			userGroup : null,
			userTitle : null,
			admin : 0
		}
		$state.go('addUser',{
			'user' : JSON.stringify(user)
		});
	}
	
	/**
	 * 
	 * */
	$scope.deleteUser = function(user){
		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要删除该用户?',
	       cancelText : '取消',
	       okText : '确认'
	    });
	    confirmPopup.then(function(res) {
	       if(res) {
	    	   hlService.home.deleteTeamUser().save(user.userId,function(res){
	   			$rootScope.showPopup(res.msg);
	   			if(res.msg == "删除成功！"){
	   				$scope.getTeamUserListByUserId();
	   				if($scope.isSearch){
	   					$scope.cancelSearch();
	   				}
	   			}
	         	});
	       }
	    });
		
		
	}

	$scope.initUsersPassword = function(user){
		var params = {
			userId : user.userId,
			name : user.name
		};
		var confirmPopup = $ionicPopup.confirm({
			title: '提示',
			template: '此操作会将该用户密码初始化为与账号一致，确定要进行操作吗?',
			cancelText : '取消',
			okText : '确认'
		 });

		 confirmPopup.then(function(res) {
			if(res) {
				hlService.user.initUsersPassword().save(params,function(res){
					
					if(res.status){
						if(user.userId == window.localStorage.userId){ //改当前用户，跳回登录界面
							$state.go("login");
						} else {
							$rootScope.showPopup("初始化成功，注意要及时通知该用户。");
						}
					} else {
						$rootScope.showPopup(res.message);
					}
					

					// if(res.msg == "初始化成功！"){
					// 	$scope.getTeamUserListByUserId();
					// 	if($scope.isSearch){ 
					// 		$scope.cancelSearch();
					// 	}
					// }
				  });
			}
		 });
	}
	
	var dateFormate = function(time){
		var date = new Date(time*1000);
		return date.getFullYear() + "-" + (date.getMonth()+1) + "-" + date.getDate() + " "
				+ date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
	};
	
	$scope.goBack = function(){
		$state.go('home');
	}
	
})
.controller('manage.addUser',function($scope,$rootScope,$ionicPopup,$stateParams,$state,$interval,$timeout,hlService,blcache,HLVALIDATE){
	$scope.user = JSON.parse($stateParams.user);
	var blKeyList = [];
	$scope.selectedUserGroup = $scope.user.userGroup;
	$scope.selectedUserTitle = $scope.user.userTitle;
	$scope.selectedBlKey = $scope.user.pubBlKey;
	$scope.upName = false;
	if($scope.user.userId != -1){
		$scope.upName = true;
	}
	
	//初始化用户类型
	if($scope.user.admin == 0){
		$scope.userType = false;
	} else { //管理员
		$scope.userType = true;
	}
	
	//初始化操作权限
	opt = $scope.user.opt;
	$scope.selectedCheck = [];
	if(opt){
		if(opt.indexOf(0) != -1){ //初始化入库
			$scope.selectedCheck.push(0);
			$scope.optInit = true;
		} 
		if(opt.indexOf(1) != -1){ //挂锁
			$scope.selectedCheck.push(1);
			$scope.optInstall = true;
		}
		if(opt.indexOf(2) != -1){ //开锁维护
			$scope.selectedCheck.push(2);
			$scope.optOpen = true;
		}
		if(opt.indexOf(3) != -1){ //锁具回收
			$scope.selectedCheck.push(3);
			$scope.optRecover = true
		}
	} else {
		$scope.selectedCheck.push(1);
		$scope.optInstall = true;
		$scope.selectedCheck.push(2);
		$scope.optOpen = true;
		$scope.selectedCheck.push(3);
		$scope.optRecover = true
	}
	
	
	//控制用户类型单选框选择
	$scope.selectedUserType = function(value){
		
		if(value == 1){
			$scope.userType = true;
		} else if(value == 0){
			$scope.userType = false;
		}
	}

	$scope.checkHandler = function(flag,value){
		var hasKey = false;
		for(var i=0; i<$scope.selectedCheck.length; i++){
			var check = $scope.selectedCheck[i];
			if(check == value){
				hasKey = true;
				break;
			}
		}
		if(flag){
			if(!hasKey){
				$scope.selectedCheck.push(value);
			}
		} else {
			if(hasKey){
				$scope.selectedCheck.splice($scope.selectedCheck.indexOf(value), 1);
			}
		}
	}
	var sysId = window.localStorage.sysId;
	$scope.saveTeamUserInfo = function(){
		$scope.user.sysId = sysId;
		//用户名不能为空
		if($scope.user.name == null || $scope.user.name == ''){
			$rootScope.showPopup('请先输入账号!');
			return;
		}

		if( !HLVALIDATE.judge_Account($scope.user.name,"账号") ){
			$rootScope.showPopup(HLVALIDATE.errorMsg);
			return ;
		}
		if($scope.user.realName == null || $scope.user.realName == ''){
			$rootScope.showPopup('请先输入姓名!');
			return;
		}
		if($scope.user.groupId == null || $scope.user.groupId == undefined){
			$rootScope.showPopup('请先选择班组！');
			return;
		}
		if($scope.user.titleId == null || $scope.user.titleId == undefined){
			$rootScope.showPopup('请先选择职务！');
			return;
		}
		if($scope.user.keyId == null || $scope.user.keyId == undefined){
			$rootScope.showPopup('请先选择所持钥匙！');
			return;
		}
		//处理操作权限
		if($scope.selectedCheck.length > 0){
			var optString = $scope.selectedCheck.toString();
			$scope.user.opt = optString;
			delete $scope.user.formatOpt;
		} else {
			$rootScope.showPopup('请选择操作权限!');
			return;
		}
		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要保存参数配置?',
	       cancelText : '取消',
	       okText : '确认'
	    });
	    confirmPopup.then(function(res) {
	       if(res) {
			
	    	  hlService.home.saveTeamUserData().save($scope.user,function(res){
	    		  $rootScope.showPopup(res.msg);
	    		  if(res.msg == '保存成功！'){
	    			  $state.go("userManage");
	    		  }
	    	  });
	       }
	    });
		
	};
	
	$scope.showUserGroup = function(){
		$state.go("userGroupList",{'user' : JSON.stringify($scope.user)});
	}
	$scope.showUserTitle = function(){
		$state.go("userTitleList",{'user' : JSON.stringify($scope.user)});
	}
	$scope.showBlKey = function(){
		$state.go("blKeyList",{'user' : JSON.stringify($scope.user)});
	}
	
	$scope.goBack = function(){
		$state.go("userManage");
	}
})
.controller('manage.userGroupList',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var user = JSON.parse($stateParams.user);
	
	if(user != null && user != ''){
		$scope.userGroup = user.userGroup;
	}
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.userGroupList = [];
	$scope.userGroupSearchs = [];
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.userGroupSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		for(var i=0; i<$scope.userGroupList.length; i++){
	    			var record = $scope.userGroupList[i];
	    			var group = record.description;
	    			if(group.indexOf(keyword) != -1){
	    				$scope.userGroupSearchs.push(record);
	    			}
	    		}
	    	}
		},1000);
	}
	
	/**
	 * 获取用户下所有班组信息
	 * */
	$scope.getUserGroupListBySysId = function(){
		$scope.userGroupList = [];
		hlService.home.getUserGroupBySysId(window.localStorage.sysId).query(function(res){
			for(var i=0; i<res.length; i++){
				var record = res[i];
				if($scope.userGroup && $scope.userGroup.groupId == record.groupId){
					record.selected = true;
				} else {
					record.selected = false;
				}
				$scope.userGroupList.push(record);
			}
			
			if($scope.userGroup == null || $scope.userGroup == undefined){
				$scope.userGroupList[0].selected = true;
			}
			
			$scope.$broadcast('scroll.refreshComplete');
			
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.userGroupSearchs = [];
  	  	$scope.keyword = null;
    }
    
	$scope.doRefresh = function(){
		$scope.getUserGroupListBySysId();
		$scope.$broadcast('scroll.infiniteScrollComplete'); 
		$scope.domore = true;
	};
	
	
	$scope.selectedGroupItem = function(userGroup){
		for(var i=0; i<$scope.userGroupList.length; i++){
			var record = $scope.userGroupList[i];
			if(userGroup.groupId == record.groupId){
				$scope.userGroupList[i].selected = true;
			} else {
				$scope.userGroupList[i].selected = false;
			}
		}
	}
	
	$scope.saveSelectedInfo = function(){
		for(var i=0; i<$scope.userGroupList.length; i++){
			var record = $scope.userGroupList[i];
			if(record.selected){
				user.userGroup = record;
				delete user.userGroup.selected;
				user.groupId = record.groupId;
			}
		}
		$state.go("addUser",{'user' : JSON.stringify(user)});
	}
	
})
.controller('manage.userTitleList',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var user = JSON.parse($stateParams.user);
	
	if(user != null && user != ''){
		$scope.userTitle = user.userTitle;
	}
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.userTitleList = [];
	$scope.userTitleSearchs = [];
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.userTitleSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		for(var i=0; i<$scope.userTitleList.length; i++){
	    			var record = $scope.userTitleList[i];
	    			var title = record.description;
	    			if(title.indexOf(keyword) != -1){
	    				$scope.userTitleSearchs.push(record);
	    			}
	    		}
	    	}
		},1000);
	}
	
	/**
	 * 获取用户下所有班组信息
	 * */
	$scope.getUserTitleListBySysId = function(){
		$scope.userTitleList = [];
		hlService.home.getUserTitleBySysId(window.localStorage.sysId).query(function(res){
			for(var i=0; i<res.length; i++){
				var record = res[i];
				if($scope.userTitle && $scope.userTitle.titleId == record.titleId){
					record.selected = true;
				} else {
					record.selected = false;
				}
				$scope.userTitleList.push(record);
			}
			
			if($scope.userTitle == null || $scope.userTitle == undefined){
				$scope.userTitleList[0].selected = true;
			}
			
			$scope.$broadcast('scroll.refreshComplete');
			
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.userTitleSearchs = [];
  	  	$scope.keyword = null;
    }
    
	$scope.doRefresh = function(){
		$scope.getUserTitleListBySysId();
		$scope.$broadcast('scroll.infiniteScrollComplete'); 
		$scope.domore = true;
	};
	
	
	$scope.selectedTitleItem = function(userTitle){
		for(var i=0; i<$scope.userTitleList.length; i++){
			var record = $scope.userTitleList[i];
			if(userTitle.titleId == record.titleId){
				$scope.userTitleList[i].selected = true;
			} else {
				$scope.userTitleList[i].selected = false;
			}
		}
	}
	
	$scope.saveSelectedInfo = function(){
		for(var i=0; i<$scope.userTitleList.length; i++){
			var record = $scope.userTitleList[i];
			if(record.selected){
				user.userTitle = record;
				delete user.userTitle.selected;
				user.titleId = record.titleId;
			}
		}
		$state.go("addUser",{'user' : JSON.stringify(user)});
	}
	
})
.controller('manage.blKeyList',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var user = JSON.parse($stateParams.user);
	
	if(user != null && user != ''){
		$scope.pubBlKey = user.pubBlKey;
	}
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.blKeyList = [];
	$scope.blKeySearchs = [];
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.blKeySearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		for(var i=0; i<$scope.blKeyList.length; i++){
	    			var record = $scope.blKeyList[i];
	    			var macAddr = record.macAddr;
	    			if(macAddr.indexOf(keyword) != -1){
	    				$scope.blKeySearchs.push(record);
	    			}
	    		}
	    	}
		},1000);
	}
	
	/**
	 * 获取用户下所有班组信息
	 * */
	$scope.getBlKeyListBySysId = function(){
		$scope.blKeyList = [];
		hlService.home.getPubBlKeyListByUserId(window.localStorage.userId, " ", 0, 100).query(function(res){
			for(var i=0; i<res.length; i++){
				var record = res[i];
				if($scope.pubBlKey && $scope.pubBlKey.keyId == record.keyId){
					record.selected = true;
				} else {
					record.selected = false;
				}
				$scope.blKeyList.push(record);
			}
			
			if($scope.pubBlKey == null || $scope.pubBlKey == undefined){
				$scope.blKeyList[0].selected = true;
			}
			$scope.$broadcast('scroll.refreshComplete');
			
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.blKeySearchs = [];
  	  	$scope.keyword = null;
    }
    
	$scope.doRefresh = function(){
		$scope.getBlKeyListBySysId();
		$scope.$broadcast('scroll.infiniteScrollComplete'); 
		$scope.domore = true;
	};
	
	
	$scope.selectedBlKeyItem = function(pubBlKey){
		for(var i=0; i<$scope.blKeyList.length; i++){
			var record = $scope.blKeyList[i];
			if(pubBlKey.keyId == record.keyId){
				$scope.blKeyList[i].selected = true;
			} else {
				$scope.blKeyList[i].selected = false;
			}
		}
	}
	
	$scope.saveSelectedInfo = function(){
		for(var i=0; i<$scope.blKeyList.length; i++){
			var record = $scope.blKeyList[i];
			if(record.selected){
				user.pubBlKey = record;
				delete user.pubBlKey.selected;
				delete user.pubBlKey.userId;
				user.keyId = record.keyId;
			}
		}
		$state.go("addUser",{'user' : JSON.stringify(user)});
	}
	
})
.controller('manage.permission',function($scope,$rootScope,$ionicPopup,$stateParams,$state,$interval,$timeout,hlService,blcache){
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.permissionList = [];
	$scope.permissionSearchs = [];
	$scope.domore = false;
	$scope.first = true;
	$scope.start = -1;
	$scope.limit = 20;
	$scope.keyword = null;
	
	$scope.show = function() {
	    $ionicLoading.show({
	    	templateUrl: 'pages/common/loading.html'
	    });
	};
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$scope.doRefresh = function() {
		if ($scope.first) {
			timer = $timeout(function () {
				loadPermissionListByUserId(); 
            }, 1000);
			$scope.first = false;
		} else {
			loadPermissionListByUserId(); 
		}
	};
	$scope.getPermissionListBySysId = function(){
		if ($rootScope.networkState == 'none') {
			$scope.$broadcast('scroll.refreshComplete');
			$rootScope.showPopup(constantDefine.offline_unpermissionmanage);//"当前离线模式下无法进行授权管理");
		} else {
			//$scope.show();
			$scope.start = 0;
			$scope.limit = 20;
			$scope.domore = false;
			var keyWord = $scope.keyword == null ? " " : $scope.keyword;
			hlService.home.getPermissionListBySysId(window.localStorage.sysId,keyWord, $scope.start, $scope.limit).query(function(res){
				
				for(var i=0;i<res.length;i++){
					var obj = res[i];
					
					obj.startDate = dateFormate(obj.startDate);
					obj.endDate = dateFormate(obj.endDate);
					obj.startTime = timeFormate(obj.startTime);
					obj.endTime = timeFormate(obj.endTime);
					obj.typeDesc = reTypeFormate(obj.type);
					obj.reday = reDayFormate(obj.type,obj.reday);
					res[i] = obj;
				}
				
				$scope.permissionList = res;
				$scope.$broadcast('scroll.refreshComplete');
			},function(res){
				$scope.$broadcast('scroll.refreshComplete');				
			});
		}
		
	};
	
	/**
	 * 分页加载
	 * */
	function loadPermissionListByUserId() {
		if ($rootScope.networkState == 'none') {
			$rootScope.showPopup(constantDefine.offline_unpermissionmanage);//"当前离线模式下无法进行授权管理");
			$scope.$broadcast('scroll.infiniteScrollComplete');
			$scope.domore = true;  
		} else {
			$scope.start++;
			var timer = null; 
			var keyWord = $scope.keyword == null ? " " : $scope.keyword;
			hlService.home.getPermissionListBySysId(window.localStorage.sysId,keyWord, $scope.start, $scope.limit).query(function(res){
				if (res) {
					if (res.length != 0) {
						for(var i=0;i<res.length;i++){
							var obj = res[i];
							
							obj.startDate = dateFormate(obj.startDate);
							obj.endDate = dateFormate(obj.endDate);
							obj.startTime = timeFormate(obj.startTime);
							obj.endTime = timeFormate(obj.endTime);
							obj.typeDesc = reTypeFormate(obj.type);
							obj.reday = reDayFormate(obj.type,obj.reday);
							$scope.permissionList.push(obj);
						}
						
					}
					if (res.length == 0){
						$scope.domore = true; 
					}
					timer = $timeout(function () {
		                $scope.$broadcast('scroll.infiniteScrollComplete');  
		            }, 1500);
				} else {
					$scope.domore = true;  
	                $scope.$broadcast('scroll.infiniteScrollComplete');
				}
			},function(res){
				$timeout.cancel(timer);
				$scope.domore = true; 
	            $scope.$broadcast('scroll.infiniteScrollComplete');
			});
			 $scope.$on("$destroy", function () {   
	             $timeout.cancel(timer);  
	        });
		}
		
	}
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.permissionSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		
	    		var timer = null; 
				hlService.home.getPermissionListBySysId(window.localStorage.sysId,keyword, 0, 100).query(function(res){
					if (res) {
						if (res.length != 0) {
							for(var i=0;i<res.length;i++){
								var obj = res[i];
								obj.startDate = dateFormate(obj.startDate);
								obj.endDate = dateFormate(obj.endDate);
								obj.startTime = timeFormate(obj.startTime);
								obj.endTime = timeFormate(obj.endTime);
								obj.typeDesc = reTypeFormate(obj.type);
								obj.reday = reDayFormate(obj.type,obj.reday);
								$scope.permissionSearchs.push(obj);
							}
							
						}
						
						timer = $timeout(function () {
			                $scope.$broadcast('scroll.infiniteScrollComplete');  
			            }, 1500);
					} else {
		                $scope.$broadcast('scroll.infiniteScrollComplete');
					}
				},function(res){
					$timeout.cancel(timer);
		            $scope.$broadcast('scroll.infiniteScrollComplete');
				});
				 $scope.$on("$destroy", function () {   
		             $timeout.cancel(timer);  
		        });
	    		
	    	}
		},1000);
		
	}
	
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.domore = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.domore = false;
  	  	$scope.permissionSearchs = [];
  	  	$scope.keyword = null;
    }
	
	/**
	 * 添加新权限
	 * */
	$scope.addPermission = function(){
		var obj = {
			'id' : -1,
			'userId' : null,
			'deviceId' : null	
		}
		$state.go('addPermission',{'permission' : JSON.stringify(obj)});
	}
	
	/**
	 * 
	 * */
	$scope.deletePermission = function(permission){
		
		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要删除该授权关系?',
	       cancelText : '取消',
	       okText : '确认'
	    });
	    confirmPopup.then(function(res) {
	       if(res) {
	    	   hlService.home.deleteDeviceUserRelations().save(permission.id,function(res){
	   			$rootScope.showPopup(res.msg);
	   			if(res.msg == "删除成功！"){
	   				$scope.getPermissionListBySysId();
	   				
	   				if($scope.isSearch){
	   					$scope.cancelSearch();
	   				}
	   			}
	         	});
	       }
	    });
		
	}
	
	var dateFormate = function(date){
		date = date + " ";
		var year = date.substring(0,4);
		var month = date.substring(4,6);
		var day = date.substring(6,8);
		return year + "-" + month + "-" + day;
	};
	
	var timeFormate = function(time){
		time = time + "";
		
		var len = time.length;
	    while(len < 6) {
	      time = "0" + time;
	      len++;
	    }
	    
		if(time.length == 5){
			var hour = time.substring(0,1);
			var minutes = time.substring(1,3);
			var seconds = time.substring(3,5);
			return hour + ":" + minutes + ":" + seconds;
		}else if(time.length == 6){
			var hour = time.substring(0,2);
			var minutes = time.substring(2,4);
			var seconds = time.substring(4,6);
			return hour + ":" + minutes + ":" + seconds;
		} else{
			return time;
		}
	};
	
	var reTypeFormate = function(type){
		if(type == 0){
			return constantDefine.NO_REPETITION;//"不重复";
		} else if(type == 1){
			return constantDefine.PER_DAY;//"每天";
		} else if(type == 2){
			return constantDefine.PER_WEEK;//"每周";
		} else if(type == 3){
			return constantDefine.PER_MONTH;//"每月";
		}
	};
	
	var reDayFormate = function(type,reDay){
		if(reDay != null){
			if(type == 2){
				var day = ["周日","周一","周二","周三","周四","周五","周六"];
				var reDays = reDay.split(",");
				var format = "";
				for(var i=0;i<reDays.length;i++){
					format += day[reDays[i]] + ",";
				}
				return format.substring(0, format.length-1);
			}else if(type == 3){
				if((reDay.split(",")).length>8){
					var reDays = reDay.split(",");
					var format = "";
					for(var i=0;i<8;i++){
						format += reDays[i] + ",";
					}
					return format+"……";
				}else{
					return reDay + "号";
				}
				
			}
		}else{
			return "";
		}
		
	};
	
	$scope.goBack = function(){
		$state.go("home");
	}
	
})
.controller('manage.addPerm',['$scope','$rootScope','$ionicPopup','$stateParams','$state','$interval','$timeout','hlService','blcache','ionicDatePicker','ionicTimePicker',function($scope,$rootScope,$ionicPopup,$stateParams,$state,$interval,$timeout,hlService,blcache,ionicDatePicker,ionicTimePicker){
	$scope.permission = JSON.parse($stateParams.permission);
	var permissionList = [];
	$scope.id = $scope.permission.id;
	$scope.deviceId = $scope.permission.deviceId;
	$scope.userId = $scope.permission.userId;
	
	var now = new Date();
	var month = now.getMonth()+1;
	if(month < 10){
		month = "0" + month;
	}
	var day = now.getDate();
	if(day < 10){
		day = "0" + day;
	}
	var nowFormateDate = now.getFullYear() + "-" + month + "-" + day;
	if($scope.deviceId == -100){
		$scope.permission.startDate = nowFormateDate;
		$scope.permission.endDate = "2030-12-29";
		$scope.permission.startTime = '0';
		$scope.permission.endTime = "23:59:59";
		$scope.permission.type = 1; //每日重复
		
		
	}
	
	var startInputDate = new Date();
	if($scope.permission.startDate) {
		startInputDate = new Date($scope.permission.startDate);
	}
    var startOption = {
  		weeksList : ['日','一','二','三','四','五','六'],
  		monthsList : ["1月", "2月", "3月", "4月", "5月", "6月", "7月", "8月", "9月", "10月", "11月", "12月"],
  		inputDate: startInputDate,      
  		mondayFirst: false,         
  		dateFormat: 'yyyy-MM-dd',
  		closeOnSelect: true,    
  		closeLabel : '关闭',
  		currentYear : (new Date()).getFullYear(),
  		templateType: 'modal',
  		callback: function (val) {
  			var time = new Date(val);
  			var month = time.getMonth()+1;
  			if(month < 10){
  				month = "0" + month;
  			}
  			var day = time.getDate();
  			if(day < 10){
  				day = "0" + day;
  			}
  			var formateDate = time.getFullYear() + "-" + month + "-" + day;
  			
  			if($scope.permission.endDate < formateDate){
  				$rootScope.showPopup("起始日期大于结束日期，请重新选择!");
  			} else {
  				$scope.permission.startDate = formateDate;
  			}
  		}
	};
    
    var endInputDate = new Date();
	if($scope.permission.endDate) {
		endInputDate = new Date($scope.permission.endDate);
	}
	
    var endOption = {
  		weeksList : ['日','一','二','三','四','五','六'],
  		monthsList : ["1月", "2月", "3月", "4月", "5月", "6月", "7月", "8月", "9月", "10月", "11月", "12月"],
  		inputDate: endInputDate,      
  		mondayFirst: false,         
  		dateFormat: 'yyyy-MM-dd',
  		closeOnSelect: true,    
  		closeLabel : '关闭',
  		currentYear : (new Date()).getFullYear(),
  		templateType: 'modal',
  		callback: function (val) {
  			var time = new Date(val);
  			var month = time.getMonth()+1;
  			if(month < 10){
  				month = "0" + month;
  			}
  			var day = time.getDate();
  			if(day < 10){
  				day = "0" + day;
  			}
  			var formateDate = time.getFullYear() + "-" + month + "-" + day;
  			
  			if($scope.permission.startDate > formateDate){
  				$rootScope.showPopup("结束日期不能小于起始日期，请重新选择!");
  			} else {
  				$scope.permission.endDate = formateDate;
  			}
  		}
	};
    	      
	//打开时间控件
	$scope.openDatePicker = function(type){
		if($scope.permission.deviceId == -100){
			return;
		}
		if(type == 0){
			ionicDatePicker.openDatePicker(startOption);
		} else if(type == 1){
			ionicDatePicker.openDatePicker(endOption);
		}
	    
	};
	var startHour = 0;
	var startMinutes = 0;
	if($scope.permission.startTime){
		var times = $scope.permission.startTime.split(':');
		startHour = times[0];
		startMinutes = times[1] == null ? 0 : times[1];
	}
	var startTimeOption = {
		inputTime : ((startHour * 60 * 60) + (startMinutes * 60)),
		format : 24,
		step : 5,
		setLabel : '确认',
		closeLabel : '关闭',
		callback : function (val) {      //Mandatory
		      if (typeof (val) != 'undefined') {
		    	  var selectedTime = new Date(val * 1000);
		    	  var hour = selectedTime.getUTCHours();
		    	  if(hour < 10){
		    		  hour = "0" + hour;
		    	  }
		    	  var minutes = selectedTime.getUTCMinutes();
		    	  if(minutes < 10){
		    		  minutes = "0" + minutes;
		    	  }
		    	  if($scope.permission.endTime <= (hour + ":" + minutes + ":00") ){
		    		  $rootScope.showPopup("开始时间不能大于结束时间，请重新选择!");
		    	  } else {
		    		  $scope.permission.startTime = hour + ":" + minutes + ":00";
		    	  }
		      }
		 }
	}
	
	var endHour = 0;
	var endMinutes = 0;
	if($scope.permission.endTime){
		var times = $scope.permission.endTime.split(':');
		endHour = times[0];
		endMinutes = times[1] == null ? '0' : times[1];
	}
	var endTimeOption = {
		inputTime : ((endHour * 60 * 60) + (endMinutes * 60)),
		format : 24,
		step : 5,
		setLabel : '确认',
		closeLabel : '关闭',
		callback : function (val) {      //Mandatory
		      if (typeof (val) != 'undefined') {
		    	  var selectedTime = new Date(val * 1000);
		    	  var hour = selectedTime.getUTCHours();
		    	  if(hour < 10){
		    		  hour = "0" + hour;
		    	  }
		    	  var minutes = selectedTime.getUTCMinutes();
		    	  if(minutes < 10){
		    		  minutes = "0" + minutes;
		    	  }
		    	  if($scope.permission.startTime >= (hour + ":" + minutes + ":00") ){
		    		  $rootScope.showPopup("结束时间不能小于起始时间，请重新选择!");
		    	  } else {
		    		  $scope.permission.endTime = hour + ":" + minutes + ":00";
		    	  }
		      }
		 }
	}
	
	$scope.openTimePicker = function(type){
		if($scope.permission.deviceId == -100){
			return;
		}
		if(type == 0){
			ionicTimePicker.openTimePicker(startTimeOption);
		} else if(type == 1){
			ionicTimePicker.openTimePicker(endTimeOption);
		}
		 
	}
	//类型下拉框常量定义
	$scope.typeList = [
       {id : 0, description : '不重复'},
       {id : 1, description : '每日重复'},
       {id : 2, description : '按周重复'},
       {id : 3, description : '按月重复'}
    ];
	$scope.selectedType = $scope.typeList[0];
	//类型下拉框初始值赋值
	if($scope.permission.type){
		for(var i=0;i<$scope.typeList.length;i++){
			var record = $scope.typeList[i];
			if(record.id == $scope.permission.type){
				$scope.selectedType = record;
				break;
			}
		}
	}
	
	$scope.typeSelectChange = function(selectedType){
		$scope.selectedType = selectedType;
	}
	
	var sysId = window.localStorage.sysId;
	$scope.savePermissionInfo = function(){
		
		//用户名不能为空
		if($scope.permission.device == null || $scope.permission.deviceId == ''){
			$rootScope.showPopup('请先选择设备!');
			return;
		}
		if($scope.permission.teamUser == null || $scope.permission.userId == ''){
			$rootScope.showPopup('请先选择用户!');
			return;
		}
		if($scope.permission.startDate == null || $scope.permission.startDate == undefined){
			$rootScope.showPopup('请先选择起始日期！');
			return;
		}
		if($scope.permission.endDate == null || $scope.permission.endDate == undefined){
			$rootScope.showPopup('请先选择结束日期！');
			return;
		}
		if($scope.permission.startTime == null || $scope.permission.startTime == undefined){
			$rootScope.showPopup('请先选择开始时间！');
			return;
		}
		if($scope.permission.endTime == null || $scope.permission.endTime == undefined){
			$rootScope.showPopup('请先选择结束时间！');
			return;
		}
		
		//处理重复类型
		if($scope.selectedType){
			$scope.permission.type = $scope.selectedType.id;
			delete $scope.permission.typeDesc;
		} else {
			$rootScope.showPopup('请先选择重复类型!');
			return;
		}
		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要保存参数配置?',
	       cancelText : '取消',
	       okText : '确认'
	    });
		
		//根据实体类添加响应参数
		$scope.permission.operator = window.localStorage.userId;
		$scope.permission.optTime = (new Date()).getTime()/1000;
		
		
	    confirmPopup.then(function(res) {
	       if(res) {
	    	  var permissionObj = $scope.permission;
	    	  permissionObj.startDate = permissionObj.startDate.replace(/-/g,'');
	    	  permissionObj.endDate = permissionObj.endDate.replace(/-/g,'');
	    	  permissionObj.startTime = permissionObj.startTime.replace(/:/g,'');
	    	  permissionObj.endTime = permissionObj.endTime.replace(/:/g,'');
	    	  
	    	  hlService.home.savePermissionData().save(permissionObj,function(res){
	    		  $rootScope.showPopup(res.msg);
	    		  if(res.msg == '保存成功！'){
	    			  $state.go("permissionManage");
	    		  }
	    	  });
	       }
	    });
	};
	
	$scope.showPermDevice = function(val){
		$state.go("selectDeviceList",{'permission' : JSON.stringify($scope.permission)});
	}
	
	$scope.showPermUser = function(val){
		$state.go("selectUserList",{'permission' : JSON.stringify($scope.permission)});
	}
	
	$scope.goBack = function(){
		$state.go("permissionManage");
	}
	
}]).controller('manage.selectDevice',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var permission = JSON.parse($stateParams.permission);
	
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.deviceList = [];
	$scope.deviceSearchs = [];
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.deviceSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		for(var i=0; i<$scope.deviceList.length; i++){
	    			var record = $scope.deviceList[i];
	    			var devName = record.deviceName;
	    			if(devName.indexOf(keyword) != -1){
	    				$scope.deviceSearchs.push(record);
	    			}
	    		}
	    	}
		},1000);
	}
	
	/**
	 * 获取用户所在系统下所有设备信息
	 * */
	$scope.getDeviceListBySysId = function(){
		$scope.deviceList = [];
		hlService.home.getPubDeviceListBySysId(window.localStorage.sysId," ",0,500).query(function(res){
			var all = {
				'deviceId' : -100,
				'deviceName' : '全部设备',
				'location' : '选择此项拥有所有设备的操作权限',
				
			}
			$scope.deviceList.push(all);
			for(var i=0; i<res.length; i++){
				var record = res[i];
				if(permission.deviceId && permission.deviceId == record.deviceId){
					record.selected = true;
				} else {
					record.selected = false;
				}
				$scope.deviceList.push(record);
			}
			if(permission.device == undefined || permission.deviceId == null){
				$scope.deviceList[0].selected = true;
			}
			$scope.$broadcast('scroll.refreshComplete');
			
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.deviceSearchs = [];
  	  	$scope.keyword = null;
    }
    
	$scope.doRefresh = function(){
		$scope.getDeviceListBySysId();
		$scope.$broadcast('scroll.infiniteScrollComplete'); 
		$scope.domore = true;
	};
	
	
	$scope.selectedDeviceItem = function(device){
		for(var i=0; i<$scope.deviceList.length; i++){
			var record = $scope.deviceList[i];
			if(device.deviceId == record.deviceId){
				$scope.deviceList[i].selected = true;
			} else {
				$scope.deviceList[i].selected = false;
			}
		}
	}
	
	$scope.saveSelectedInfo = function(){
		for(var i=0; i<$scope.deviceList.length; i++){
			var record = $scope.deviceList[i];
			if(record.selected){
				permission.device = record;
				delete permission.device.selected;
				permission.deviceId = record.deviceId;
			}
		}
		$state.go("addPermission",{'permission' : JSON.stringify(permission)});
	}
	
}).controller('manage.selectUser',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var permission = JSON.parse($stateParams.permission);
	
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.teamUserList = [];
	$scope.teamUserSearchs = [];
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.teamUserSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		for(var i=0; i<$scope.teamUserList.length; i++){
	    			var record = $scope.teamUserList[i];
	    			var userName = record.name;
	    			if(userName.indexOf(keyword) != -1){
	    				$scope.teamUserSearchs.push(record);
	    			}
	    		}
	    	}
		},1000);
	}
	
	/**
	 * 获取用户所在系统下所有用户信息
	 * */
	$scope.getTeamUserListBySysId = function(){
		$scope.teamUserList = [];
		hlService.home.getTeamUserListBySysId(window.localStorage.sysId," ",0,500).query(function(res){
			for(var i=0; i<res.length; i++){
				var record = res[i];
				if(permission.userId && permission.userId == record.userId){
					record.selected = true;
				} else {
					record.selected = false;
				}
				$scope.teamUserList.push(record);
			}
			if(permission.teamUser == undefined || permission.userId == null){
				$scope.teamUserList[0].selected = true;
			}
			$scope.$broadcast('scroll.refreshComplete');
			
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.teamUserSearchs = [];
  	  	$scope.keyword = null;
    }
    
	$scope.doRefresh = function(){
		$scope.getTeamUserListBySysId();
		$scope.$broadcast('scroll.infiniteScrollComplete'); 
		$scope.domore = true;
	};
	
	
	$scope.selectedTeamUserItem = function(teamUser){
		for(var i=0; i<$scope.teamUserList.length; i++){
			var record = $scope.teamUserList[i];
			if(teamUser.userId == record.userId){
				$scope.teamUserList[i].selected = true;
			} else {
				$scope.teamUserList[i].selected = false;
			}
		}
	}
	
	$scope.saveSelectedInfo = function(){
		for(var i=0; i<$scope.teamUserList.length; i++){
			var record = $scope.teamUserList[i];
			if(record.selected){
				permission.teamUser = record;
				delete permission.teamUser.selected;
				permission.userId = record.userId;
			}
		}
		$state.go("addPermission",{'permission' : JSON.stringify(permission)});
	}
	
})

.controller('manage.area',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,$ionicPopup,hlService,blcache){
	
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.areaList = [];
	$scope.areaSearchs = [];
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.areaSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		for(var i=0; i<$scope.areaList.length; i++){
	    			var record = $scope.areaList[i];
	    			var description = record.description;
	    			if(description.indexOf(keyword) != -1){
	    				$scope.areaSearchs.push(record);
	    			}
	    		}
	    	}
		},1000);
		
	}
	
	/**
	 * 获取用户下所在系统下的所有钥匙信息
	 * */
	$scope.getAreaListBySysId = function(){
		$scope.areaList = [];
		hlService.home.getPubAreaDataBySysId(window.localStorage.sysId).query(function(res){
			$scope.areaList = res;
			$scope.$broadcast('scroll.refreshComplete');
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	$scope.getAreaListBySysId();
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.areaSearchs = [];
  	  	$scope.keyword = null;
    }
    
	$scope.doRefresh = function(){
		$scope.getAreaListBySysId();
		$scope.$broadcast('scroll.infiniteScrollComplete'); 
		$scope.domore = true;
	};
	
	/**
	 * 添加新区域
	 * */
	$scope.addArea = function(){
		$state.go('addArea',{'areaId':-1,'description':''});
	}
	
	/**
	 * 
	 * */
	$scope.deleteArea = function(area){

		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要删除该区域?',
	       cancelText : '取消',
	       okText : '确认'
	    });
	    confirmPopup.then(function(res) {
	       if(res) {
	    	   hlService.home.deletePubAreaData().save(area.areaId,function(res){
	    		   	$rootScope.showPopup(res.msg);
	    		   	if(res.msg == "删除成功！"){
	    		   		$scope.getAreaListBySysId();
	    		   		if($scope.isSearch){
		   					$scope.cancelSearch();
		   				}
	    		   	}
	         	});
	       	}
	    });
	}
	
	$scope.goBack = function(){
		$state.go('home');
	}
})
.controller('manage.addArea',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var areaId = $stateParams.areaId;
	var description = $stateParams.description;
	if(areaId == null || areaId == undefined){
		$scope.area = {
			areaId : -1
		};
	} else {
		$scope.area = {
			areaId : areaId,
			description : description
		};
	}
	var sysId = window.localStorage.sysId;
	$scope.saveAreaInfo = function(area){
		area.sysId = sysId;
		hlService.home.savePubArea().save(area,function(res){
			$rootScope.showPopup(res.msg);
			if(res.msg == "保存成功！"){
				history.go(-1);
			}
      	});
	};
})

.controller('manage.group',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,$ionicPopup,hlService,blcache){
	
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.groupList = [];
	$scope.groupSearchs = [];
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.groupSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		for(var i=0; i<$scope.groupList.length; i++){
	    			var record = $scope.groupList[i];
	    			var description = record.description;
	    			if(description.indexOf(keyword) != -1){
	    				$scope.groupSearchs.push(record);
	    			}
	    		}
	    	}
		},1000);
		
	}
	
	/**
	 * 获取用户下所在系统下的所有钥匙信息
	 * */
	$scope.getGroupListBySysId = function(){
		hlService.home.getUserGroupBySysId(window.localStorage.sysId).query(function(res){
			$scope.groupList = res;
			$scope.$broadcast('scroll.refreshComplete');
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	$scope.getGroupListBySysId();
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.groupSearchs = [];
  	  	$scope.keyword = null;
    }
    
	$scope.doRefresh = function(){
		$scope.getGroupListBySysId();
		$scope.$broadcast('scroll.infiniteScrollComplete'); 
		$scope.domore = true;
	};
	
	/**
	 * 添加新锁
	 * */
	$scope.addGroup = function(){
		$state.go('addGroup',{'groupId':-1,'description':''});
	}
	
	/**
	 * 
	 * */
	$scope.deleteGroup = function(group){
		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要删除该班组?',
	       cancelText : '取消',
	       okText : '确认'
	    });
	    confirmPopup.then(function(res) {
	       if(res) {
	    	   hlService.home.deleteUserGroupData().save(group.groupId,function(res){
	    		   	$rootScope.showPopup(res.msg);
	    		   	if(res.msg == "删除成功！"){
	    		   		$scope.getGroupListBySysId();
	    		   		if($scope.isSearch){
		   					$scope.cancelSearch();
		   				}
	    		   	}
	         	});
	       	}
	    });
	}
	
	$scope.goBack = function(){
		$state.go('home');
	}
})
.controller('manage.addGroup',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var groupId = $stateParams.groupId;
	var description = $stateParams.description;
	if(groupId == null || groupId == undefined){
		$scope.group = {
			groupId : -1
		};
	} else {
		$scope.group = {
			groupId : groupId,
			description : description
		};
	}
	var sysId = window.localStorage.sysId;
	$scope.saveUserGroupInfo= function(group){
		group.sysId = sysId;
		hlService.home.saveUserGroup().save(group,function(res){
			$rootScope.showPopup(res.msg);
			if(res.msg == "保存成功！"){
				history.go(-1);
			}
      	});
	};
})

.controller('manage.title',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,$ionicPopup,hlService,blcache){
	
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.titleList = [];
	$scope.titleSearchs = [];
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.titleSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		for(var i=0; i<$scope.titleList.length; i++){
	    			var record = $scope.titleList[i];
	    			var description = record.description;
	    			if(description.indexOf(keyword) != -1){
	    				$scope.titleSearchs.push(record);
	    			}
	    		}
	    	}
		},1000);
		
	}
	
	/**
	 * 获取用户下所在系统下的所有钥匙信息
	 * */
	$scope.getTitleListBySysId = function(){
		hlService.home.getUserTitleBySysId(window.localStorage.sysId).query(function(res){
			$scope.titleList = res;
			$scope.$broadcast('scroll.refreshComplete');
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	$scope.getTitleListBySysId();
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.titleSearchs = [];
  	  	$scope.keyword = null;
    }
    
	$scope.doRefresh = function(){
		$scope.getTitleListBySysId();
		$scope.$broadcast('scroll.infiniteScrollComplete'); 
		$scope.domore = true;
	};
	
	/**
	 * 添加新锁
	 * */
	$scope.addTitle = function(){
		$state.go('addTitle',{'titleId':-1,'description':''});
	}
	
	/**
	 * 
	 * */
	$scope.deleteTitle = function(title){
		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要删除该职务?',
	       cancelText : '取消',
	       okText : '确认'
	    });
	    confirmPopup.then(function(res) {
	       if(res) {
	    	   hlService.home.deleteUserTitleData().save(title.titleId,function(res){
	    		   	$rootScope.showPopup(res.msg);
	    		   	if(res.msg == "删除成功！"){
	    		   		$scope.getTitleListBySysId();
	    		   		if($scope.isSearch){
		   					$scope.cancelSearch();
		   				}
	    		   	}
	         	});
	       	}
	    });
	}
	
	$scope.goBack = function(){
		$state.go('home');
	}
})
.controller('manage.addTitle',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var titleId = $stateParams.titleId;
	var description = $stateParams.description;
	if(titleId == null || titleId == undefined){
		$scope.title = {
			titleId : -1
		};
	} else {
		$scope.title = {
			titleId : titleId,
			description : description
		};
	}
	var sysId = window.localStorage.sysId;
	$scope.saveTitleInfo = function(title){
		
		title.sysId = sysId;
		
		hlService.home.saveUserTitle().save(title,function(res){
			$rootScope.showPopup(res.msg);
			if(res.msg == "保存成功！"){
				history.go(-1);
			}
      	});
		
	};
}).controller('common.forget',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	
$scope.nameErrLog = null;
	$scope.errLog = null;
	$scope.repassErrLog = null;

	$scope.valideUsername = function(username){
		if( !HLVALIDATE.judge_Account(username,"用户名") ){
			
			$scope.nameErrLog = HLVALIDATE.errorMsg;
			$scope.errLog = null;
			$scope.repassErrLog = null;
			return false;
		}

		return true;
	}
	$scope.validePassword = function(password){
		
		if( !HLVALIDATE.judge_Account(password,"新密码") ){
			if($scope.nameErrLog == null){
				$scope.errLog = HLVALIDATE.errorMsg;
				$scope.repassErrLog = null;
			}
			return false;
		}

		return true;
	};

	$scope.valideRepassword = function(password,repassword){
		if(repassword != password){
			if($scope.nameErrLog == null && $scope.errLog == null){
				$scope.repassErrLog = "确认密码与新密码不一致。";
			}
			
			return false;
		}

		return true;
	};

	$scope.resetValideMsg = function(type){
		if(type == 0){
			$scope.nameErrLog = null;
		} else if(type == 1){
			$scope.errLog = null;
		} else if(type == 2){
			$scope.repassErrLog = null;
		} else {

		}
		
		
	}

	$scope.submitResetData = function(username,password,repassword){
		
		if(!$scope.valideUsername(username) || !$scope.validePassword(password) || !$scope.valideRepassword(password,repassword)){
			return;
		}
		
		var params = {
			name : username,
			password : hex_md5(password)
		};
		
		 //修改密码
		 hlService.user.resetPasswordByName().save(params,function(res){
			
			if(res.status){
				
				$state.go("login");
			} else {
				$scope.errLog = res.message;
			}
			
		},function(error){
			CONSTANT.msgShow("网络好像失联了。");
			
		});
		
	}

	$scope.goback = function() {
		$state.go('login');
	};


}).controller('common.resetPassword',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,HLVALIDATE,CONSTANT){

	$scope.oldPasErrLog = null;
	$scope.errLog = null;
	$scope.repassErrLog = null;

	$scope.valideUsername = function(username){
		if( !HLVALIDATE.judge_Account(username,"用户名") ){
			
			$scope.oldPasErrLog = HLVALIDATE.errorMsg;
			$scope.errLog = null;
			$scope.repassErrLog = null;
			return false;
		}

		return true;
	}
	$scope.validePassword = function(oldPassword,password){
		if(oldPassword == null || oldPassword == undefined || oldPassword == ""){
			$scope.oldPasErrLog = "请先输入旧密码。";
			$scope.errLog = null;
			$scope.repassErrLog = null;
			return false;
		}
		if(oldPassword == password){
			if($scope.oldPasErrLog == null){
				$scope.errLog = "新密码不能与旧密码相同";
				$scope.repassErrLog = null;
			}
			return false;
		}
		
		if( !HLVALIDATE.judge_Account(password,"新密码") ){
			if($scope.oldPasErrLog == null){
				$scope.errLog = HLVALIDATE.errorMsg;
				$scope.repassErrLog = null;
			}
			return false;
		}
		return true;
	};

	$scope.valideRepassword = function(password,repassword){
		if(repassword != password){
			if($scope.oldPasErrLog == null && $scope.errLog == null){
				$scope.repassErrLog = "确认密码与新密码不一致。";
			}
			
			return false;
		}

		return true;
	};

	$scope.resetValideMsg = function(type){
		if(type == 0){
			$scope.oldPasErrLog = null;
		} else if(type == 1){
			$scope.errLog = null;
		} else if(type == 2){
			$scope.repassErrLog = null;
		} else {

		}
		
		
	}

	$scope.submitResetData = function(oldPassword,password,repassword){
		if(!$scope.validePassword(oldPassword,password) || !$scope.valideRepassword(password,repassword)){
			return;
		}
		if ($rootScope.networkState == 'none') {
			$scope.$broadcast('scroll.refreshComplete');
			$rootScope.showPopup(constantDefine.offline_unusermanage);//"当前离线模式下无法进行用户管理");
			return;
		}
		
		var params = {
			name : window.localStorage.userName,
			oldPassword :  hex_md5(oldPassword),
			password : hex_md5(password),
			sysId : window.localStorage.sysId
		};
		
		 //修改密码
		 hlService.user.updatePasswordByOldPassword().save(params,function(res){
			
			if(res.status){
				
				$state.go("login");
			} else {
				$scope.errLog = res.message;
			}
			
		},function(error){
			CONSTANT.msgShow("网络好像失联了。");
			
		});
		
	}

	$scope.goback = function() {
		$state.go('home');
	};


});

angular.module('btapp.factorys',[]).factory('ssBlKey', function($rootScope,$cordovaToast,hlService) {
		
		var Bluetooth = {
			/**
			 * 蓝牙设备连接名
			 * */
			keyName : '',
			/**
	    	 * 蓝牙设备id
	    	 * */
	    	deviceId : '',
	    	/**
    		 * 是否进行蓝牙扫描
    		 * */
	    	scanFlag : true,
	    	/**
	    	 * 是否网络在线
	    	 * */
	    	online : true, 
	    	/**
	    	 * 是否连接过
	    	 * */
	    	connected : false, 
	    	/**
	    	 * 是否为挂锁模式
	    	 * */
	    	isInstalling : false,
	    	/**
	    	 * 是否初始化入库模式
	    	 * */
	    	isInit : false,
	    	/**
	    	 * 是否维护模式
	    	 * */
	    	isMain : true, 
	    	/**
	    	 * 是否回收模式
	    	 * */
	    	isReturn : false,
	    	/**
	    	 * 异或校验算法钥匙信息
	    	 * */
	    	key : "00 01 02 03 04 05 06 07",
	    	/**
	    	 * 通信连接状态
	    	 * */
	    	status : '',
	    	
		    scanDevice : function(){
		    	//$rootScope.Object = this;
		    	ble.scan([], 5,this.onScanDevice, this.scanError);
		    },
		    
		    onScanDevice : function(device){
		    	if(device.name == $rootScope.bluetooth.keyName){
		    		$rootScope.bluetooth.deviceId = device.id;
		    		$rootScope.bluetooth.connect();
		    	}
		    },
		    
		    scanError : function(res){
		    	$rootScope.bluetooth.status = "扫描失败";
		    	
		    },
		    connError : function(res){
		    	$rootScope.bluetooth.status = "扫描连接失败";
		    },
		    
		    
		    onError : function(reason){
		    	$rootScope.bluetooth.status = "通信出错";
		    	//$rootScope.bluetooth.disconnect();
		    },
		    
		    connect: function() {
		        ble.connect(this.deviceId, this.onConnect, this.connError);
		    },
		    /**
			 * 蓝牙通讯连接后启动通道监听
			 * */
			onConnect : function(peripheral){
				$rootScope.bluetooth.determineServiceType(peripheral);
				ble.startNotification($rootScope.bluetooth.deviceId, $rootScope.bluetooth.serviceUUID, $rootScope.bluetooth.notifyCharacteristicUUID, $rootScope.bluetooth.onData, $rootScope.bluetooth.onError);
				$rootScope.bluetooth.status = "已连接";
			},
			/**
			 * 通道信息解析
			 * */
			determineServiceType: function(peripheral) {
				peripheral.characteristics.filter(function(element) {
					var properties = element.properties;
					for(var i=0;i<properties.length;i++){
						var prop = properties[i];
						if("notify" == prop.toLowerCase()){
							$rootScope.bluetooth.serviceUUID = element.service;
							$rootScope.bluetooth.notifyCharacteristicUUID = element.characteristic;
						} else if("write" == prop.toLowerCase()){
							$rootScope.bluetooth.serviceUUID = element.service;
							$rootScope.bluetooth.characteristicUUID = element.characteristic;
						}
					}
					if($rootScope.bluetooth.notifyCharacteristicUUID && $rootScope.bluetooth.characteristicUUID){
						return;
					}
		        })[0];
		    },
			/**
			 * 通知监听处理
			 * */
		    onData : function(buffer){
		    	$rootScope.bluetooth.parseResult($rootScope.bluetooth.bytesToString(buffer));
		    },
		    /**
		     * 参数： 十六进制数
		     * 异或校验运算 结果返回十进制数
		     * */
		    XorCheck : function(Data,Length){
	    	    var sum=0,i;
	    	    for(var i=0; i<Length; i++)
	    	    {
	    	        sum ^= Data[i]; 
	    	    }
	    	    return sum;
	    	},
	    	/**
	    	 * 参数： 十六进制数
	    	 * 加密算法  结果返回十进制数
	    	 * */
		    HloveyRC4 : function(aInput, aKey) {
		    	var iS = new Uint8Array(256);
	    	    var iK = new Uint8Array(256);
	    	    for (var i = 0; i < 256; i++)
	    	        iS[i] = i;
	    	    var j = 1;
	    	    for (var i = 0; i < 256; i++){
	    	        iK[i] = aKey[(i % aKey.length)];
	    	    }
	    	    j = 0;
	    	    for (var i = 0; i < 256; i++) {
	    	        j = (j + iS[i]&0xff + iK[i]&0xff) % 256;
	    	        var temp = iS[i];
	    	        iS[i] = iS[j];
	    	        iS[j] = temp;
	    	    }
	    	    var i = 0;
	    	    j = 0;
	    	    var iOutputChar = new Uint8Array(aInput.length);
	    	    for (var x = 0; x < iOutputChar.length; x++) {
	    	        i = (i + 1) % 256;
	    	        j = (j + iS[i]&0xff) % 256;
	    	        var temp = iS[i]&0xff;
	    	        iS[i] = iS[j];
	    	        iS[j] = temp;
	    	        var t = (iS[i] + (iS[j]&0xff % 256)) % 256;
	    	        var iY = iS[t]&0xff;
	    	        var iCY =  iY;
	    	        iOutputChar[x] = aInput[x] ^ iCY;
	    	    }
	    	    return iOutputChar;
			},
			/**
			 * 参数：ArrayBuffer
			 * 结果：十进制转十六进制
			 * */
		    bytesToString : function(buffer) {
		    	var a = new Uint8Array(buffer);
				 var data = [];
				 for(var i=0;i<a.length;i++){
					 data[i] = $rootScope.bluetooth.decimalRadixToHex(a[i]);
				 }
				 return data;
			},
			/**
			 * 参数：十六进制参数字符串，已空格分开
			 * 结果：无符号十六进制数数组
			 * */
			stringToBytes : function(string) {
				 var arr = string.split(" ");
				 var array = new Uint8Array(arr.length);
				 for (var i = 0; i < arr.length;i++) {
					 array[i] = '0x' + arr[i];
				 }
				 return array;
			},
			/**
			 * 十六进制转十进制数
			 * 参数：十六进制数
			 * 结果：十进制数
			 * */
			hexRadixToDecimal : function(num){
				return parseInt(num, 16);
			},
			/**
			 * 十进制数转十六进制数
			 * 参数：十进制数
			 * 结果：十六进制数
			 * */
			decimalRadixToHex : function(num){
				return num.toString(16);
			},
			
			/**
			 * 安装锁具地址信息获取操作
			 * */
			installLock : function(installTime,timeFormate){
				if(this.online){
					var geolocation = new BMap.Geolocation();
	    			geolocation.getCurrentPosition(function(r){
	    				if(this.getStatus() == BMAP_STATUS_SUCCESS){
	    					var geoc = new BMap.Geocoder();  
	    					var point = new BMap.Point(r.point.lng,r.point.lat);
	    					geoc.getLocation(point, function(rs){
	    						var addComp = rs.addressComponents;
	    						
		    					$rootScope.Lockset = {
		    						lockId : $rootScope.lockId,
		    						installer : window.localStorage.userId,
		    						installName : window.localStorage.userName,
		    						time : installTime,
		    						timeFormate : timeFormate,
		    						longitude : r.point.lng,
		    						latitude : r.point.lat,
		    						location : addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber
		    					}
	    					});
	    				} else {
	    					$rootScope.showPopup("地址定位失败：" + this.getStatus());
	    				}        
	    			},{enableHighAccuracy: true});
				} else {
					$rootScope.Lockset = {
						lockId : $rootScope.lockId,
						installer : window.localStorage.userId,
						installName : window.localStorage.userName,
						time : installTime,
						timeFormate : timeFormate
						//longitude : r.point.lng,
						//latitude : r.point.lat,
						//location : addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber
					}
				}
			},
			/**
			 * 回收锁具参数设置
			 * */
			setRecoverParams : function(res){
				var device = res.device;
    			var time = res.device["time"] * 1000;
				var dateTime = new Date(time);
				var m = (dateTime.getMonth()+1) < 10 ? '0'+(dateTime.getMonth()+1) : (dateTime.getMonth()+1);
		    	var d = dateTime.getDate() < 10 ? '0'+ dateTime.getDate() : dateTime.getDate();
		    	var h = dateTime.getHours() < 10 ? '0' + dateTime.getHours() : dateTime.getHours();
		    	var min = dateTime.getMinutes() < 10 ? '0' + dateTime.getMinutes() : dateTime.getMinutes();
		    	var s = dateTime.getSeconds() < 10 ? '0' + dateTime.getSeconds() : dateTime.getSeconds();
				var timeFormate = dateTime.getFullYear()+"-"+m+"-"+d+" "
								+ h + ":" + min + ":" + s;
				
				$rootScope.recover = {
					lockId : $rootScope.lockId,
					deviceId : device.deviceId,
					deviceName : device.deviceName,
					installer : device.installer,
					installName : device.installUser.name,
					time : device.time,
					timeFormate : timeFormate,
					longitude : device.longitude,
					latitude : device.latitude,
					location : device.location
				}
			},
			/**
			 * 接收报文解析
			 * */
		    parseResult : function(result){
		    	var that = this;
		    	if(result[0] == 6){
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n接收到报文—— (1)");
		    		var dataLength = parseInt(result[1]);//报文数据长度
		    		var bwDatas = [];
		    		for(var i=0;i<dataLength;i++){
		    			var bwData = result[i+2];
		    			bwDatas.push(bwData);  //十六进制数据位
		    		}
		    		var secretData = that.HloveyRC4(that.stringToBytes(bwDatas.join(" ")), that.stringToBytes(that.key));
		    		var secretCheck = that.XorCheck(secretData.subarray(0,secretData.length-1), secretData.length-1);
		    		var newSecretData = new Uint8Array(secretData.length + 1);
		    		secretData[secretData.length-1] = secretCheck; //修改最后一位值为校验位的值{0:248,1:246,2:249,3:244,4:230,5:229}
		    		var sendDataInfo = [04,05]; //发送数据
		    		for(var i=0;i<secretData.length;i++){
		    			var d = secretData[i].toString(16);
		    			sendDataInfo[i+2] = d;
		    		}
		    		var j = 2 + dataLength;
		    		var checkData = result[j]; //校验位16进制
		    		var judgeCheck = that.XorCheck(that.stringToBytes(bwDatas.join(" ")), bwDatas.length); //十进制
		    		if(that.decimalRadixToHex(judgeCheck) != checkData){
		    			$rootScope.showPopup("报文数据校验位不一致，操作终止!!!");
		    		} else {
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n校验位校验成功—— (2)");
		    			var date = new Date();
	    				var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
	    				var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    			    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    			    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    			    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
// var logDate = date.getFullYear()+"-"+month+"-"+day+" "
//	+ hours + ":" + minutes + ":" + seconds;   			    	
			    		//解析报文获取锁具编码
			    		var lockId = "";
			    		lockId = that.hexRadixToDecimal(result[2])*Math.pow(256,3) 
			    					+ that.hexRadixToDecimal(result[3])*Math.pow(256,2) 
			    					+ that.hexRadixToDecimal(result[4])*256 
			    					+ that.hexRadixToDecimal(result[5]);
			    		$rootScope.lockId = lockId;
			    		//是否初始化入库状态
			    		if(that.isInit){
			    			if(that.online){
			    				
			    				hlService.home.savePubLocksetData().save({               
				    				lockId : lockId,
				    				lockName : '新锁'+ that.decimalRadixToHex(lockId),
				    				compId : window.localStorage.groupId
				    	      	},function(res){
				    	      		if(res.NUM == -1){
				    	      			$rootScope.showPopup("锁具已在库中!!!");
				    	      		}else{
				    	      			that.sendData(sendDataInfo.join(" "));
				    	      			$rootScope.showPopup("入库成功!!!");
				    	      		}
				    	      	},function(res){
				    	      		$rootScope.showPopup("网络偷懒啦!!!");
				    	      	});
			    			} else{
			    				$rootScope.showPopup("离线状态不支持该功能操作!!!");
			    			}
			    			
			    		} else { //非入库状态
			    			
			    			//判断锁具状态
				    		hlService.home.getPubLocksetByLockId(lockId).get(function(res){
				    			if(res.lockId == null || res.lockId ==""){
				    				$rootScope.showPopup("该锁具未入库，请先入库操作!");
				    				return;
				    			}
				    			var installStatus = res.installStatus;
				    			var assignStatus = res.assignStatus;
				    			if(assignStatus != 1){
				    				$rootScope.showPopup("该锁具未分配,请联系主站管理员!");
				    			} else {
				    				//挂锁模式
					    			if(that.isInstalling){
					    				var installTime = (date/1000).toFixed(0);
					    				if(installStatus == 1 ){
					    					$rootScope.showPopup("该锁具已使用,不用进行此操作!");
					    				} else {
					    					//判断该锁具是否在用户名下
					    					hlService.home.getLockUserRelByUserIdLockId(lockId,window.localStorage.userId).get(function(res){
					    						if(res.id == null){
					    							$rootScope.showPopup("该锁具未分配到用户下，操作终止!");
					    						}else{
					    							$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
					    							var timeFormate = date.getFullYear()+"-"+month+"-"+day+" "
													+ hours + ":" + minutes + ":" + seconds;
					    							that.installLock((date/1000).toFixed(0),timeFormate);
					    						}
					    					},function(res){
					    						$cordovaToast.showShortCenter("已转离线模式");
					    						var locksets = JSON.parse(window.localStorage.locksets);
					    						var isContain = false;
					    						for(var i=0;i<locksets.length;i++){
					    							var lockset = locksets[i];
					    							if(lockset.lockId == lockId){
					    								isContain = true;
					    								break;
					    							}
					    						}
					    						if(isContain){
					    							$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
					    							var timeFormate = date.getFullYear()+"-"+month+"-"+day+" "
													+ hours + ":" + minutes + ":" + seconds;
					    							that.installLock((date/1000).toFixed(0),timeFormate);
					    						}else{
					    							$rootScope.showPopup("该锁具未分配到用户下，操作终止!");
					    						}
					    					});
					    				}
					    			}else { //回收和开锁维护模式
					    				if(installStatus != 1){
					    					$rootScope.showPopup("该锁具未使用安装,不进行此操作!");
					    				}else{
					    					//权限判断
					    					hlService.home.getDeviceUserRelByUserIdLockId(lockId,window.localStorage.userId).get(function(res){
					    						if(res.id == null){
					    							$rootScope.showPopup("用户对该设备无操作权限,请联系管理员!");
					    						} else{
					    							var ymd = "" + date.getFullYear() + month + day;
							    			    	var hms = "" + hours + minutes + seconds;
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限判断操作开始—— (3)");   		
							    			    	if(ymd >= res.startDate && ymd <= res.endDate){ //判断是否在规定时间段内维护
							    			    		if(res.type == 0 || res.type == 1){ //每天仅判断时分秒
							        			    		if(hms > res.startTime && hms < res.endTime){
							    	    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限校验通过，发送报文—— (4)");							        			    			
							    	    			    		that.sendData(sendDataInfo.join(" "));
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n报文发送成功，开锁结束:" + logDate + "—— (5)\r\n\r\n"); 
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n发送报文—— " + sendDataInfo.join(" "));
							    	    			    		if(that.isReturn){ // 回收模式，加载数据
							    	    			    			that.setRecoverParams(res);
							    	    			    		}
							    	    			    	}else{
							    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    	    			    	}
							    	    			    } else if(res.type == 2){//每周
							    	    			    	var reDay = res.reday;
							    	    			    	var reDays = reDay.split(",");
							    	    			    	var weekDay = date.getDay();
							    	    			    	var isPerm = false;
							    	    			    	for(var i=0;i<reDays.length;i++){
							    	    			    		if(weekDay == reDays[i]){
							    	    			    			isPerm = true;
							    	    			    			break;
							    	    			    		}
							    	    			    	}
							    	    			    	if(isPerm){
							    	    			    		if(hms > res.startTime && hms < res.endTime){
							    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限校验通过，发送报文—— (4)");							        			    			
								    	    			    		that.sendData(sendDataInfo.join(" "));
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n报文发送成功，开锁结束:" + logDate + "—— (5)\r\n\r\n"); 
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n发送报文—— " + sendDataInfo.join(" "));
							    		    			    		if(that.isReturn){ // 回收模式，加载数据
								    	    			    			that.setRecoverParams(res);
								    	    			    		}
							    		    			    	}else{
							    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    		    			    	}
							    	    			    	}else{
							    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    	    			    	}
							    	    			    }else if(res.type == 3){ //每月
							        			    		var reDay = res.reday;
							        			    		var reDays = reDay.split(",");
							        			    		var isPerm = false;
							    	    			    	for(var i=0;i<reDays.length;i++){
							    	    			    		if(day == reDays[i]){
							    	    			    			isPerm = true;
							    	    			    			break;
							    	    			    		}
							    	    			    	}
							        			    		if(isPerm){
							        			    			if(hms > res.startTime && hms < res.endTime){
							    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限校验通过，发送报文—— (4)");							        			    			
								    	    			    		that.sendData(sendDataInfo.join(" "));
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n报文发送成功，开锁结束:" + logDate + "—— (5)"); 
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n发送报文—— " + sendDataInfo.join(" "));
							    		    			    		if(that.isReturn){ // 回收模式，加载数据
								    	    			    			that.setRecoverParams(res);
								    	    			    		}
							    		    			    	}else{
							    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    		    			    	}
							        			    		}else{
							        			    			$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							        			    		}
							    	    			    }
							    			    		
							    			    	}else{
							    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    			    	}
					    						}
					    					},function(res){
					    						$rootScope.showPopup("网络偷懒啦!");
					    					});
					    				}
					    			}
				    			}
				    		},function(res){
				    			
				    			$cordovaToast.showShortCenter("网络连接不可用");
				    			//挂锁模式
				    			if(that.isInstalling){
				    				var locksets = JSON.parse(window.localStorage.locksets);
					    			var isContain = false;
					    			for(var i=0;i<locksets.length;i++){
					    				var record = locksets[i];
					    				if(record.lockId == $rootScope.lockId){
					    					isContain = true;
					    					$rootScope.outLineLockSet = record;
					    					break;
					    				}
					    			}
					    			if(!isContain){
					    				$rootScope.showPopup("该锁具不在库中或你没权限操作，请联网后再进一步操作!");
					    				$rootScope.outLineLockSet = null;
					    			} else {
					    				//判断锁具是否已使用且已在缓存数据中
					    				var hisRecord = JSON.parse(window.localStorage.lockInstallData);
				    		    		var lockContain = false;
				    		    		
				    		    		for(var i=0;i<hisRecord.length;i++){
				    		    			var record = hisRecord[i];
				    		    			if(record.lockId == lockId){
				    		    				lockContain = true;
				    		    			}
				    		    		}
				    		    		if(lockContain){
				    		    			$rootScope.showPopup("该锁具已使用且缓存，请重新选择!!!");
				    		    		} else{
				    		    			var installTime = (date/1000).toFixed(0);
						    				if($rootScope.outLineLockSet.lockSet.installStatus == 1 ){
						    					$rootScope.showPopup("该锁具已使用,不再进行此操作!");
						    				} else {
				    							$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
				    							var timeFormate = date.getFullYear()+"-"+month+"-"+day+" "
												+ hours + ":" + minutes + ":" + seconds;
				    							that.installLock((date/1000).toFixed(0),timeFormate);
						    				}
				    		    		}
					    			}
				    			}else{  // 开关维护及回收模式
				    				var devices = JSON.parse(window.localStorage.lockPerm);
				    				var isContain = false;
				    				for(var i=0;i<devices.length;i++){
				    					var record = devices[i];
				    					var realLockId = record.device.lockId;
				    					if(realLockId == lockId){
				    						isContain = true;
				    						$rootScope.outLineDevice = record;
				    						break;
				    					}
				    				}
				    				if(!isContain){
				    					$rootScope.showPopup("该锁具未安装或用户对该设备无操作权限，请联网后再进一步操作。");
				    					$rootScope.outLineDevice = null;
				    				}else{
				    					
				    					var ymd = "" + date.getFullYear() + month + day;
				    			    	var hms = "" + hours + minutes + seconds;
				    			    	if(ymd >= $rootScope.outLineDevice.startDate && ymd <= $rootScope.outLineDevice.endDate){ //判断是否在规定时间段内维护
				    			    		if($rootScope.outLineDevice.type == 0 || $rootScope.outLineDevice.type == 1){ //每天仅判断时分秒
				        			    		if(hms > $rootScope.outLineDevice.startTime && hms < $rootScope.outLineDevice.endTime){
				    	    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
				    	    			    		that.sendData(sendDataInfo.join(" "));
				    	    			    		if(that.isReturn){ // 回收模式，加载数据
				    	    			    			that.setRecoverParams($rootScope.outLineDevice);
				    	    			    		}
				    	    			    	}else{
				    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    	    			    	}
				    	    			    } else if($rootScope.outLineDevice.type == 2){//每周
				    	    			    	var reDay = $rootScope.outLineDevice.reday;
				    	    			    	var reDays = reDay.split(",");
				    	    			    	var weekDay = date.getDay();
				    	    			    	var isPerm = false;
				    	    			    	for(var i=0;i<reDays.length;i++){
				    	    			    		if(weekDay == reDays[i]){
				    	    			    			isPerm = true;
				    	    			    			break;
				    	    			    		}
				    	    			    	}
				    	    			    	if(isPerm){
				    	    			    		if(hms > $rootScope.outLineDevice.startTime && hms < $rootScope.outLineDevice.endTime){
				    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
				    		    			    		that.sendData(sendDataInfo.join(" "));
				    		    			    		if(that.isReturn){ // 回收模式，加载数据
					    	    			    			that.setRecoverParams(res);
					    	    			    		}
				    		    			    	}else{
				    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    		    			    	}
				    	    			    	}else{
				    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    	    			    	}
				    	    			    }else if($rootScope.outLineDevice.type == 3){ //每月
				        			    		var reDay = $rootScope.outLineDevice.reday;
				        			    		var reDays = reDay.split(",");
				        			    		var isPerm = false;
				    	    			    	for(var i=0;i<reDays.length;i++){
				    	    			    		if(day == reDays[i]){
				    	    			    			isPerm = true;
				    	    			    			break;
				    	    			    		}
				    	    			    	}
				        			    		if(isPerm){
				        			    			if(hms > $rootScope.outLineDevice.startTime && hms < $rootScope.outLineDevice.endTime){
				    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
				    		    			    		that.sendData(sendDataInfo.join(" "));
				    		    			    		if(that.isReturn){ // 回收模式，加载数据
					    	    			    			that.setRecoverParams(res);
					    	    			    		}
				    		    			    	}else{
				    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    		    			    	}
				        			    		}else{
				        			    			$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				        			    		}
				    	    			    }
				    			    	}else{
				    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    			    	}
				    			    	
				    				}
				    				
				    			}
				    			
				    		});
			    		}
		    		}
		    	}
		    	else if(result[0]==1){
		    		that.keyInfo = result;
		    	}
		    	else if(result[0]==4){
		    		var date = new Date();
					var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
			    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
			    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
			    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
			    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
		    		//判断是否开锁维护状态
		    		if(that.isMain){
		    			var ymd = date.getFullYear() + "-" + month + "-" + day;
				    	var hms = hours + ":" + minutes + ":" + seconds;
			    		$rootScope.openLog = "用户" + window.localStorage.userName + "于" + ymd + " " + hms +"有开启智能锁。"
			    		if(that.online){

			    			hlService.home.savePubHisData().save({
				          		userId : window.localStorage.userId, 
				          		lockId : $rootScope.lockId,
				          		optDate : (date/1000).toFixed(0)
				          	},function(res){
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n保存开锁日志—— (6)\r\n\r\n");
				          	});
			    		}else{
			    			var hisRecord = JSON.parse(window.localStorage.hisData);
			    			var record = {
		    					userId : window.localStorage.userId, 
				          		lockId : $rootScope.lockId,
				          		optDate : (date/1000).toFixed(0)	
			    			}
		    				window.localStorage.hisData = JSON.stringify(hisRecord.concat(record));
		    				$rootScope.showPopup("已缓存开锁记录!!!");
			    		}
		    		}
		    	}
		    },
		    /**
			 * 写数据,外传回调函数
			 * */
		    sendData1 : function(data, fn, efn){
				ble.write($rootScope.bluetooth.deviceId, $rootScope.bluetooth.serviceUUID, $rootScope.bluetooth.characteristicUUID,
	    				$rootScope.bluetooth.stringToBytes(data).buffer, fn,efn);
			},
		    /**
			 * 写数据
			 * */
		    sendData : function(data){
				ble.write($rootScope.bluetooth.deviceId, $rootScope.bluetooth.serviceUUID, $rootScope.bluetooth.characteristicUUID,
	    				$rootScope.bluetooth.stringToBytes(data).buffer, function(res){
				},$rootScope.bluetooth.onError);
			},
		    disconnect : function(){
		    	ble.disconnect($rootScope.bluetooth.deviceId,function(){
		    		$rootScope.bluetooth.status = "未连接";
				},function(){});
		    },
		    isConnected : function(deviceId,fn,efn){
		    	ble.isConnected(deviceId,fn,efn);
		    }
	    };
		return Bluetooth;
	
});

angular.module('btapp.factorys').factory('ssSecondBlKey', function($rootScope,$cordovaToast,$log,blcache, hlService) {
		//用 Factory 就是创建一个对象，为它添加属性，
		//然后把这个对象返回出来。你把 service 传进 controller 之后，
		//在 controller 里这个对象里的属性就可以通过 factory 使用了。
		//工厂方法，返回一个bluetooth对象
		var Bluetooth = {
			/**
			 * 蓝牙设备连接名
			 * */
			keyName : '',
			/**
	    	 * 蓝牙设备id
	    	 * */
	    	deviceId : '',
	    	/**
    		 * 是否进行蓝牙扫描
    		 * */
	    	scanFlag : true,
	    	/**
	    	 * 是否网络在线
	    	 * */
	    	online : true, 
	    	/**
	    	 * 是否扫描到指定设备
	    	 * */
	    	isScanSuccess : false,
	    	/**
	    	 * 是否连接过
	    	 * */
	    	connected : false,
	    	/**
	    	 * 已经连接但是通讯监听异常，该标志用来是否重新连接。
	    	 */
	    	notifyError : false,
	    	/**
	    	 * 是否重连标志（如果一次扫描完成可以设置为true，代表可以重连，否则需要等待）
	    	 */
	    	isReconnecting : false,
	    	/**
	    	 * 是否为挂锁模式
	    	 * */
	    	isInstalling : false,
	    	/**
	    	 * 是否初始化入库模式
	    	 * */
	    	isInit : false,
	    	/**
	    	 * 是否维护模式
	    	 * */
	    	isMain : true, 
	    	/**
	    	 * 是否回收模式
	    	 * */
	    	isReturn : false,
	    	/**
	    	 * 异或校验算法钥匙信息
	    	 * */
	    	key : "00 01 02 03 04 05 06 07",
	    	/**
	    	 * 根秘钥
	    	 * */
	    	gKey : "a0a1a2a3a4a5a6a7",
	    	/**
	    	 * 控制秘钥
	    	 * */
	    	controlKey : 'b0b1b2b3b4b5b6b7',
	    	/**
	    	 * 通信连接状态
	    	 * */
	    	status : '',
	    	/**
	    	 * 入库方式0-锁设备分离，1-锁设备关联
	    	 */
	    	switchDepend : 0,
	    	 /**
		     * 随机生成8位动态密钥-->例如,29 ac 43 23 a2 3b 6c 8c
		     * */
		    initDynamicSecretKey : function(){
		    	var num = '';
		    	 for (i = 0; i < 16; i++)
		    	 {
		    	    var tmp = Math.ceil(Math.random()*15);//--->[0-15]对应16进制
		    	    if(tmp > 9){//--->16进制中10-15分别用a,b,c,d,e,f表示
		    	           switch(tmp){ 
		    	               case(10):
		    	                   num+='a';
		    	                   break;
		    	               case(11):
		    	                   num+='b';
		    	                   break;
		    	               case(12):
		    	                   num+='c';
		    	                   break;
		    	               case(13):
		    	                   num+='d';
		    	                   break;
		    	               case(14):
		    	                   num+='e';
		    	                   break;
		    	               case(15):
		    	                   num+='f';
		    	                   break;
		    	           }
		    	        }else{
		    	           num+=tmp;
		    	        }
		    	 }
		    	 num = num.replace(/(.{2})/g, "$1 ");
		    	 return(num);
		    },
		    /**
		     * 参数： 十六进制数
		     * 异或校验运算 结果返回十进制数
		     * */
		    XorCheck : function(Data,Length){
	    	    var sum=0,i;
	    	    for(var i=0; i<Length; i++)
	    	    {
	    	        sum ^= Data[i]; 
	    	        
	    	    }
	    	    return sum;
	    	},
	    	/**
	    	 * 参数： 十六进制数
	    	 * 加密算法  结果返回十进制数
	    	 * */
		    HloveyRC4 : function(aInput, aKey) {
		    	var iS = new Uint8Array(256);
	    	    var iK = new Uint8Array(256);
	    	    for (var i = 0; i < 256; i++)
	    	        iS[i] = i;
	    	    var j = 1;
	    	    for (var i = 0; i < 256; i++){
	    	        iK[i] = aKey[(i % aKey.length)];
	    	    }
	    	    j = 0;
	    	    for (var i = 0; i < 256; i++) {
	    	        j = (j + iS[i]&0xff + iK[i]&0xff) % 256;
	    	        var temp = iS[i];
	    	        iS[i] = iS[j];
	    	        iS[j] = temp;
	    	    }
	    	    var i = 0;
	    	    j = 0;
	    	    var iOutputChar = new Uint8Array(aInput.length);
	    	    for (var x = 0; x < iOutputChar.length; x++) {
	    	        i = (i + 1) % 256;
	    	        j = (j + iS[i]&0xff) % 256;
	    	        var temp = iS[i]&0xff;
	    	        iS[i] = iS[j];
	    	        iS[j] = temp;
	    	        var t = (iS[i] + (iS[j]&0xff % 256)) % 256;
	    	        var iY = iS[t]&0xff;
	    	        var iCY =  iY;
	    	        iOutputChar[x] = aInput[x] ^ iCY;
	    	    }
	    	    return iOutputChar;
			},
			
			/**
			 * 参数：ArrayBuffer
			 * 结果：十进制转十六进制
			 * */
		    bytesToString : function(buffer) {
		    	var a = new Uint8Array(buffer);
				 var data = [];
				 for(var i=0;i<a.length;i++){
					 data[i] = $rootScope.bluetooth.decimalRadixToHex(a[i]);
				 }
				 return data;
			},
			/**
			 * 参数：十六进制参数字符串，已空格分开
			 * 结果：无符号十六进制数数组
			 * ee de ac 12 
			 * */
			stringToBytes : function(string) {
				 var arr = string.split(" ");
				 var array = new Uint8Array(arr.length);
				 for (var i = 0; i < arr.length;i++) {
					 array[i] = '0x' + arr[i];
				 }
				 return array;
			},
			
			/**
			 * 参数：十进制参数字符串，未加空格分开
			 * 结果：无符号十六进制数数组
			 *  eedeac12 长度32 16个字节
			 * */
			stringToBytesForNoSpace : function(string) {
				 var array = new Uint8Array(string.length/2);
				 for (var i = 0; i < string.length;) {
					 array[i/2] = '0x' + string.substring(i,i+2);
					 i = i + 2;
	
				 }
				 return array;
			},
			
			/**
			 * 十六进制转十进制数
			 * 参数：十六进制数
			 * 结果：十进制数
			 * */
			hexRadixToDecimal : function(num){
//$rootScope.openLog += "测试码 ：" + num + "/" + parseInt(num,16) + "@@";
				return parseInt(num, 16);
			},
			
			/**
			 * 十进制数转十六进制数
			 * 参数：十进制数
			 * 结果：十六进制数
			 * */
			decimalRadixToHex : function(num){
				return num.toString(16);
			},
			/**
			 * num - 数据
			 * n - 位数
			 */
			pad : function(num, n) {
				num = '' + num;
				return Array(n>num.length?(n-(''+num).length+1):0).join(0)+num; 
			},
	    	scanError : function(res){
		    	this.status = constantDefine.scan_error;//"扫描失败";
		    },
		    
		    scanDevice : function(){
		    	var that = this;
		    	that.isReconnecting = false;
		    	that.stopScanCallback(function(){
		    		that.scan();
		    	}, function(){
		    		that.scan();
		    	});
		    	
		    },
		    scan : function() {
		    	var that = this;
		    	ble.scan([], 5,function(device){
		    		that.onScanDevice(device);
		    	}, function(res){
		    		that.scanError(res);
		    		that.isReconnecting = true;
		    	});
		    	// 确保6秒后再打开重连标志
		    	that.reconnTimer = setTimeout(function(){
		    		that.isReconnecting = true;
		    	},6000);
		    },
		    clearReconnTimer : function() {
		    	if (this.reconnTimer) {
		    		clearTimeout(this.reconnTimer);
		    	}
		    },
		    onScanDevice : function(device){
		    	var that = this;
		    	//$rootScope.openLog = device.name + 'key:' + that.keyName;
		    	if(device.name == that.keyName){
		    		//$rootScope.openLog += '匹配了';
		    		that.isReconnecting = false;
		    		that.deviceId = device.id;
		    		window.localStorage.bleDeviceId = device.id;
		    		that.clearReconnTimer();
		    		that.stopScan();
		    		//that.connect();
		    	}
		    },
		    
		    connError : function(res){
		    	this.status = constantDefine.scan_error;//"扫描连接失败";
		    	this.isReconnecting = true;
		    },
		    
		    onError : function(reason){
		    	var that = this;
		    	that.status = constantDefine.communication_error;//"通信出错";
		    	that.notifyError = true;
		    	that.isReconnecting = true;
		    },
		    stopScanCallback : function(fn, en) {
		    	ble.stopScan(fn, en);
		    },
		    stopScan : function() {
		    	var that = this;
		    	ble.stopScan(function(){
		    		//$rootScope.openLog = '已经找到，停止扫描:' + that.deviceId;
		    		that.isReconnecting = false;
		    		that.connect();
		    	},function(){
		    		//$rootScope.openLog = '失败了，停止扫描:' + that.deviceId;
		    		that.isReconnecting = true;
		    	});
		    },
		    connect: function() {
		    	var that = this;
		        ble.connect(that.deviceId, function(peripheral){
		        	that.onConnect(peripheral);
		        }, function(res){
		        	//$rootScope.openLog += '连接失败了！' + JSON.stringify(res);
		        	that.connError(res);
		        });
		        //$rootScope.openLog += '+++connected';
		    },
		    /**
			 * 蓝牙通讯连接后启动通道监听
			 * */
			onConnect : function(peripheral){
				var that = this;
				that.determineServiceType(peripheral);
				ble.startNotification(that.deviceId, that.serviceUUID, that.notifyCharacteristicUUID, function(buffer){
					that.onData(buffer);
				}, function(reason){
					//$rootScope.openLog += constantDefine.monitor_error +  JSON.stringify(reason); //'监听通知出错了：'
					that.onError(reason);
				});
				that.onConnectHandler();
			},
			onConnectHandler : function() {
				var that = this;
				//that.status = "已连接";
				setTimeout(function(){
					var dynamicSecretKey = that.initDynamicSecretKey();
					var checkData =that.XorCheck(that.stringToBytes(dynamicSecretKey),8);
					var sendDataInfo = "02 08 " + dynamicSecretKey + " " + checkData; //发送数据
					that.key = dynamicSecretKey;
					//$rootScope.openLog += "发送动态密钥 ：" + sendDataInfo;
					that.sendData(sendDataInfo);
				},1000);
			},
			/**
			 * 通道信息解析(这个写死的目的是什么呢？？？？？）
			 * */
			determineServiceType: function(peripheral) {
				var that = this;
				peripheral.characteristics.filter(function(element) {
					var properties = element.properties;
					for(var i=0;i<properties.length;i++){
						var prop = properties[i];
//						if("notify" == prop.toLowerCase()){
//							$rootScope.bluetooth.serviceUUID = element.service;
//							$rootScope.bluetooth.notifyCharacteristicUUID = element.characteristic;
//						} else if("write" == prop.toLowerCase()){
//							$rootScope.bluetooth.serviceUUID = element.service;
//							$rootScope.bluetooth.characteristicUUID = element.characteristic;
//						}s
						that.serviceUUID = 'f000c0e0-0451-4000-b000-000000000000';
						that.notifyCharacteristicUUID = 'f000c0e1-0451-4000-b000-000000000000';
						that.characteristicUUID = 'f000c0e2-0451-4000-b000-000000000000';
					}
					if(that.notifyCharacteristicUUID && that.characteristicUUID){
						return;
					}
		        })[0];
		    },
			/**
			 * 通知监听处理
			 * */
		    onData : function(buffer){
		    	this.notifyError = false;
		    	//$rootScope.openLog += 'startNotification:' + JSON.stringify(buffer);
		    	this.parseResult(this.bytesToString(buffer));
                //this.testParseResult(this.bytesToString(buffer));
		    },
			
			/**
			 * 安装锁具地址信息获取操作
			 * */
			installLock : function(installTime,timeFormate, device){
				$rootScope.Lockset = {
					lockId : $rootScope.lockId,
					installer : window.localStorage.userId,
					installName : window.localStorage.userName,
					time : installTime,
					timeFormate : timeFormate,
					sysId : window.localStorage.sysId,
					refresh:true
				};
				if (device != null) {
					$rootScope.Lockset.deviceId = device.deviceId;
					$rootScope.Lockset.depend = device.depend;
				}
			},
			/**
			 * 回收锁具参数设置
			 * */
			setRecoverParams : function(res){
				var device = res;
				var dateTime = new Date();
				var timeFormate = this.getYmdHmsByDate(dateTime);
				$rootScope.recover = {
					lockId : $rootScope.lockId,
					deviceId : device.deviceId,
					deviceName : device.deviceName,
					installer : device.installer,
					installName : device.installUser ? device.installUser.name : device.installer,
					time : device.time,
					timeFormate : timeFormate,
					longitude : device.longitude,
					latitude : device.latitude,
					location : device.location,
					depend : device.depend
				};
			},
			testParseResult : function(result){
				var that = this;
				var ret = result[0] - 0; // 动作状态
		    	switch(ret) {
			    	case 1:
			    		
			    		//$rootScope.openLog += "（01命令码）信息: " + result;
			    		break;
			    	case 2:
			    		$rootScope.openLog += "（02命令码）信息: " + result;
			    		break;
			    	case 3:
			    		$rootScope.openLog += "（03命令码）信息: " + result;
			    		/************************报文校验（直接数据位密文校验）*****************************/
				    	var checkData = that.getCommandCheckText(result);
			    		var datas = that.getCommandText(result);

			    		
			    		if(!that.validateCommandText(datas, checkData)){
			    			$rootScope.showPopup(constantDefine.check_error);//"报文数据校验位不一致，操作终止!!!");
			    		} else {
			    			var object = that.getParseCommand03Text(datas);
			    			// 在全局页面开锁是使用
				    		$rootScope.lockId = object.lockId;
				    		$rootScope.openLog += '$rootScope.lockId:' + object.lockId;
//			    			//是否初始化入库状态
//				    		if(that.isInit){
//				    			that.savePubLockset(object.lockId, object.sendDataInfo);
//				    		} else { //非入库状态 : 开锁或者挂锁或者回收锁的操作
//				    			that.openOrRecoverOrInstallLockset(object.lockId, object.sendDataInfo);
//				    		}
			    		}
			    		break;
			    	case 4:
			    		$rootScope.openLog += "（04命令码）信息: " + result;
			    		break;
			    	case 5:
			    		$rootScope.openLog += "（05命令码）信息: " + result;
			    		break;
			    	case 6:
			    		$rootScope.openLog += "（06命令码）信息: " + result;
			    		break;
			    	case 7:
			    		$rootScope.openLog += "（07命令码）信息: " + result;
			    		break;
			    	case 8:
			    		$rootScope.openLog += "（08命令码）信息: " + result;
			    		break;
			    	case 9:
			    		$rootScope.openLog += "（09命令码）信息: " + result;
			    		break;
			    	case 10:
			    		$rootScope.openLog += "（10命令码）信息: " + result;
			    		break;
			    	default:
			    		$rootScope.showPopup(constantDefine.unknown_order);//"未知命令，结束操作");
			    		break;
		    	}
			},
			parseResultYs : function(result){
				var that = this;
				if(result[0] == 3){
					
//alert($rootScope.bluetooth.gKey);

//alert($rootScope.bluetooth.controlKey);
					
					$rootScope.openLog = "（03命令码）上传锁设备信息: " + result;
					
					var dataLength = parseInt(result[1]);//报文数据长度
		    		var bwDatas = [];
		    		for(var i=0;i<4;i++){      //前4位为锁设备号
		    			var bwData = result[i+2];
		    			bwDatas.push(bwData);  //十六进制数据位
		    		}
		    		//添加开锁动作位
		    		bwDatas.push(1);
		    		//that.key = "84 64 4c 5d 77 f1 7b d5";
$rootScope.openLog += " <br> 动态key值：" + that.key;
					var openKey = (that.key + that.controlKey).split(' ').join('');
$rootScope.openLog += " <br> 开关锁拼接key值：" + openKey;

// 去空格进行MD5加密
					var md5OpenKey = hex_md5(openKey);
$rootScope.openLog += " <br> 加密后key值：" + md5OpenKey;
					
$rootScope.openLog += "&&加密后key值十六进制数：" + JSON.stringify(that.stringToBytesForNoSpace(hex_md5(openKey)));

					//var secretData = that.HloveyRC4(that.stringToBytes(bwDatas.join(" ")), that.stringToBytes(that.key));
		    		var secretData = that.HloveyRC4(that.stringToBytes(bwDatas.join(" ")), that.stringToBytesForNoSpace(hex_md5(openKey)));

		    		var secretCheck = that.XorCheck(secretData, secretData.length);
		   
		    		var newSecretData = new Uint8Array(secretData.length + 1);//修改最后一位值为校验位的值{0:248,1:246,2:249,3:244,4:230,5:229}
		    		for(var i=0;i<secretData.length;i++){
		    			newSecretData[i] = secretData[i];
		    		}
		    		newSecretData[newSecretData.length-1] = secretCheck; 
		    		
		    		var sendDataInfo = [04,05]; //发送数据
		    		
		    		for(var i=0;i<newSecretData.length;i++){
		    			var d = newSecretData[i].toString(16);
		    			sendDataInfo[i+2] = d;
		    		}
					
					$rootScope.openLog += " <br> 04开锁命令码: " + sendDataInfo;
					this.sendData(sendDataInfo.join(" "));
				}
				else if(result[0]==1){
		    		that.keyInfo = result;
		    		//$rootScope.openLog += "（01命令码）返回钥匙设备信息:" + result;
		    	}
				else if(result[0]==2){
		    		//that.keyInfo = result;
		    		$rootScope.openLog += "（02命令码）返回动态密钥同步结果:" + result;
		    	}
		    	else if(result[0]==4){
		    		$rootScope.openLog += " <br>（04命令码）返回开关锁结果信息: " + result;
		    	}
			},
			
		    // 解析报文结果并执行相应的操作
		    parseResult : function(result) {
		    	var ret = result[0] - 0; // 动作状态
		    	switch(ret) {
			    	case 1:
			    		this.parseCommand01Code(result);
			    		break;
			    	case 2:
			    		this.parseCommand02Code(result);
			    		break;
			    	case 3:
			    		this.parseCommand03Code(result);
			    		break;
			    	case 4:
			    		this.parseCommand04Code(result);
			    		break;
			    	case 5:
			    		this.parseCommand05Code(result);
			    		break;
			    	case 6:
			    		this.parseCommand06Code(result);
			    		break;
			    	case 7:
			    		this.parseCommand07Code(result);
			    		break;
			    	case 8:
			    		this.parseCommand08Code(result);
			    		break;
			    	case 9:
			    		this.parseCommand09Code(result);
			    		break;
			    	
			    	default:
			    		$rootScope.showPopup(constantDefine.unknown_order);//"未知命令，结束操作");
			    		break;
		    	}
		    },
		    parseCommand01Code : function(result) {
		    	//$rootScope.openLog += "（01命令码）信息: " + result;
		    	this.keyInfo = result;
		    },
		    parseCommand02Code : function(result) {
		    	//$rootScope.openLog += "（02命令码）信息: " + result;
		    },
		    parseCommand03Code : function(result) {
		    	//$rootScope.openLog += "（03命令码）信息: " + result;
		    	var that = this;
		    	/************************报文校验（直接数据位密文校验）*****************************/
		    	var checkData = that.getCommandCheckText(result);
	    		var datas = that.getCommandText(result);

	    		
	    		if(!that.validateCommandText(datas, checkData)){
	    			$rootScope.showPopup(constantDefine.check_error);//"报文数据校验位不一致，操作终止!!!");
	    		} else {
	    			var object = that.getParseCommand03Text(datas);
	    			// 在全局页面开锁是使用
		    		$rootScope.lockId = object.lockId;
		    		//$rootScope.openLog = '$rootScope.lockId:' + object.lockId;
	    			//是否初始化入库状态
		    		if(that.isInit){
		    			that.savePubLockset(object.lockId, object.sendDataInfo);
		    		} else { //非入库状态 : 开锁或者挂锁或者回收锁的操作
		    			that.openOrRecoverOrInstallLockset(object.lockId, object.sendDataInfo);
		    		}
	    		}
		    },
		    testF: function() {
		    	this.isInit = false;
		    	this.isInstalling = false;
		    	var object = {
		    		lockId:8337,
		    		sendDataInfo:'fengyf'
		    	};
		    	var abc = blcache.getPubLocksetByLockId(object.lockId);
		    	console.log(abc);
		    	//this.openOrRecoverLockset(object.lockId, object.sendDataInfo);
		    },
		    // 获取报文长度  => result[1]中存储的是报文长度
		    getCommandTextLength : function(result) {
		    	var dataLength = parseInt(result[1]);//报文数据长度
		    	return dataLength;
		    },
		    // 获取报文的校验位 => 16进制
		    getCommandCheckText : function(result) {
		    	var j = 2 + this.getCommandTextLength(result);
	    		var checkData = result[j]; //校验位16进制
	    		return checkData;
		    },
		    // 从返回的结果中获取报文实际内容
		    getCommandText : function(result) {
		    	var dataLength = this.getCommandTextLength(result);
	    		var datas = [];
	    		for(var i=0;i<dataLength;i++){
	    			var data = result[i+2];
	    			datas.push(data);
	    		}
	    		return datas;
		    },
		    // 验证报文的合法性，是否是有效的报文
		    validateCommandText : function(datas, checkData) {
		    	var that = this;
	    		var judgeCheck = that.XorCheck(that.stringToBytes(datas.join(" ")), datas.length); //十进制
	    		if(that.decimalRadixToHex(judgeCheck) != checkData){
	    			return false;
	    		}
	    		return true;
		    },
		    // 解析03的报文内容，组装发送的报文内容和获取解析的lockId
		    // {lockId:newXXX, sendDataInfo : data}
		    getParseCommand03Text : function(datas) {
		    	var that = this;
		    	/**********************解密报文参数******************************/
    			var decryptData = that.getDecryptData(datas);
	    		/*************************拼接开锁命令码**********************************/
	    		var bwDatas = that.getOpenLockCommand(decryptData);
	    		/***********************为开锁报文数据段进行加密操作*************************************/
	    		var secretData = that.getEncodeSecretData(bwDatas);
	    		/***********************为开锁密文生成校验位用于校验*************************************/
	    		var secretCheck = that.getSecretCheck(secretData);
	    		/***********************重新组装发送报文 锁设备号+开关锁动作+校验位**********************/
	    		var newSecretData = that.buildNewSecretData(secretData, secretCheck);
	    		/***********************添加报文头[04，05] 锁设备号+开关锁动作+校验位*******************/
	    		var sendDataInfo = that.buildSendDataInfo(newSecretData);
    			/***********************以下所有为平台相关权限判断，是否发送该开锁命令码****************/ 	
	      		var lockId = that.getLockIdInfoByOpenCommand(bwDatas);
	      		return {
	      			lockId : lockId,
	      			sendDataInfo : sendDataInfo
	      		};
		    },
		    //解密密钥使用 动态密钥做高8字节、根密钥做低8字节组合成的新密要直接使用
		    getDecryptKey : function() {
		    	var that = this;
		    	//$rootScope.openLog += " <br> 动态key值：" + that.key;
		    	//$rootScope.openLog += " <br> 根key值：" + that.gKey;
    			var decryptKey = (that.key + that.gKey).split(" ").join('');
    			return decryptKey;
		    },
		    //开锁数据段加密密钥为动态密钥作为高8位+控制密钥作为低8位组合成的新密钥，经MD5加密后使用
		    getOpenKey : function() {
		    	var that = this;
		    	//$rootScope.openLog += " <br> 动态key值：" + that.key;
		    	//$rootScope.openLog += " <br> 控制key值：" + that.controlKey;
		    	var openKey = (that.key + that.controlKey).split(' ').join('');
		    	//$rootScope.openLog += " <br> 开关锁拼接key值：" + openKey;
		    	return openKey;
		    },
		    //解密得到报文数据位明文
		    getDecryptData : function(datas) {
		    	//$rootScope.openLog += " <br> 报文数据：" + JSON.stringify(datas);
		    	var that = this;
		    	var decryptKey = that.getDecryptKey();
		    	//$rootScope.openLog += " <br> 解密密钥：" + decryptKey;
		    	var decryptData = that.HloveyRC4(that.stringToBytes(datas.join(" ")), that.stringToBytesForNoSpace(decryptKey));
		    	//$rootScope.openLog += " <br> RC4解密明文(decryptData)：" + JSON.stringify(decryptData);
		    	return decryptData;
		    },
		    
		    // 拼接开锁命令码
		    getOpenLockCommand : function(decryptData) {
		    	var that = this;
		    	var bwDatas = [];
	    		for(var i=0;i<4;i++){
	    			var bwData = decryptData[i];
	    			bwDatas.push(that.decimalRadixToHex(bwData));  //十六进制数据位
	    		}
	    		//添加开锁动作位  1表示开锁，目前只有开锁动作
	    		bwDatas.push(that.decimalRadixToHex(1));
	    		//$rootScope.openLog += " <br> 开锁命令码(openLockCmd)：" + JSON.stringify(bwDatas);
	    		return bwDatas;
		    },
		    // 为开锁报文数据段进行加密操作
		    getEncodeSecretData : function(bwDatas) {
		    	var that = this;
		    	var openKey = that.getOpenKey();
		    	var secretData = that.HloveyRC4(that.stringToBytes(bwDatas.join(" ")), that.stringToBytesForNoSpace(hex_md5(openKey)));
		    	//$rootScope.openLog += " <br> 开锁加密报文数据(openLockSecData)：" + JSON.stringify(secretData);
		    	return secretData;
		    },
		    // 为开锁密文生成校验位用于校验
		    getSecretCheck : function(secretData) {
		    	var that = this;
	    		var secretCheck = that.XorCheck(secretData, secretData.length);
	    		//$rootScope.openLog += " <br> 开锁校验位(CheckBit)：" + JSON.stringify(secretCheck);
	    		return secretCheck;
		    },
		    //重新组装发送报文 锁设备号+开关锁动作+校验位
		    buildNewSecretData : function(secretData, secretCheck) {
		    	var newSecretData = new Uint8Array(secretData.length + 1);
	    		for(var i=0;i<secretData.length;i++){
	    			newSecretData[i] = secretData[i];
	    		}
	    		newSecretData[newSecretData.length-1] = secretCheck;
	    		//$rootScope.openLog += " <br> 最终开锁的报文内容(New)：" + JSON.stringify(newSecretData);
	    		return newSecretData;
		    },
		    // 添加报文头[04，05] 锁设备号+开关锁动作+校验位
		    buildSendDataInfo : function(newSecretData) {
		    	var sendDataInfo = [04,05]; 
	    		for(var i=0;i<newSecretData.length;i++){
	    			var d = newSecretData[i].toString(16);
	    			sendDataInfo[i+2] = d;
	    		}
	    		//$rootScope.openLog += " <br> 添加报文头[04，05] 锁设备号+开关锁动作+校验位(OK)：" + JSON.stringify(sendDataInfo);
	    		return sendDataInfo;
		    },
		    // 从报文中解析锁具编码
		    getLockIdInfoByOpenCommand : function(bwDatas) {
		    	var that = this;
		    	var lockId = "";
	    		var firstFourBytes = bwDatas.splice(0, 4);
	    		var fullBytes = '';
	      		for (var i =0; i < firstFourBytes.length; i++) {
	      			fullBytes += that.pad(firstFourBytes[i], 2);
	      		}
	      		lockId = that.hexRadixToDecimal(fullBytes);
	      		return lockId;
		    },
		    parseCommand04Code : function(result) {
		    	//$rootScope.openLog += "（04命令码）信息: " + result;
		    	var that = this;
		    	var date = new Date();
	    		//判断是否开锁维护状态
	    		if(that.isMain){
	    			var ymd = that.getYmdByDate(date);
			    	var hms = that.getHmsByDate(date);
			    	$rootScope.openLog = window.localStorage.userName +constantDefine.open_lock + ymd + " " + hms;
		    		//$rootScope.openLog = "用户" + window.localStorage.userName + "于" + ymd + " " + hms +"有开启智能锁。";
		    		if ($rootScope.networkState == 'none') {
		    			var record = {
	    					userId : window.localStorage.userId, 
			          		lockId : $rootScope.lockId,
			          		optDate : that.getSecondsByDate(date)	
		    			};
	    				blcache.insertPubHisData(record);
	    				$rootScope.showPopup(constantDefine.cache_records);//"已缓存开锁记录");
		    		} else {
		    			hlService.home.savePubHisData().save({
			          		userId : window.localStorage.userId, 
			          		lockId : $rootScope.lockId,
			          		optDate : that.getSecondsByDate(date)
			          	},function(res){
			          		// noting
			          	},function(res){
			          		var record = {
		    					userId : window.localStorage.userId, 
				          		lockId : $rootScope.lockId,
				          		optDate : that.getSecondsByDate(date)	
			    			};
		    				blcache.insertPubHisData(record);
		    				$rootScope.showPopup(constantDefine.cache_records);//"已缓存开锁记录");
			          	});
		    		}
	    		}
		    },
		    parseCommand05Code : function(result) {
		    	//$rootScope.openLog += "接收05命令码返回报文：" + result;
		    },
		    parseCommand06Code : function(result) {
		    	//$rootScope.openLog += "接收06命令码返回报文：" + result;
		    },
		    parseCommand07Code : function(result) {
		    	//$rootScope.openLog += "接收07命令码返回报文：" + result;
		    },
		    parseCommand08Code : function(result) {
		    	$rootScope.openLog += "接收08命令码返回报文：" + result;
		    },
		    parseCommand09Code : function(result) {
		    	$rootScope.openLog += "接收09命令码钥匙上传日志：" + result;
		    	
			    	//$rootScope.openLog += "（03命令码）信息: " + result;
			    	var that = this;
			    	/************************报文校验（直接数据位密文校验）*****************************/
			    	var checkData = that.getCommandCheckText(result);
		    		var datas = that.getCommandText(result);

		    		alert("数据段：");
		    		alert(datas);
		    		
		    		if(!that.validateCommandText(datas, checkData)){
		    			$rootScope.showPopup(constantDefine.check_error);//"报文数据校验位不一致，操作终止!!!");
		    		} else {
//		    			var object = that.getParseCommand03Text(datas);
//		    			// 在全局页面开锁是使用
//			    		$rootScope.lockId = object.lockId;
//			    		//$rootScope.openLog = '$rootScope.lockId:' + object.lockId;
//		    			//是否初始化入库状态
//			    		if(that.isInit){
//			    			that.savePubLockset(object.lockId, object.sendDataInfo);
//			    		} else { //非入库状态 : 开锁或者挂锁或者回收锁的操作
//			    			that.openOrRecoverOrInstallLockset(object.lockId, object.sendDataInfo);
//			    		}
		    			
		    			//解析数据段，入库开锁日志
		    		}
		    	
		    },
		    // 入库操作
		    savePubLockset : function(lockId, sendDataInfo) {
		    	var that = this;
		    	if($rootScope.networkState != 'none'){
    				hlService.home.savePubLocksetData().save({               
	    				lockId : lockId,
	    				lockName : '新锁'+ that.decimalRadixToHex(lockId),
	    				compId : window.localStorage.groupId,
	    				depend : that.switchDepend,
	    				sysId : window.localStorage.sysId
	    	      	},function(res){
	    	      		if(res.NUM == -1){
	    	      			$rootScope.showPopup(constantDefine.intostorage_log);//"该锁具已经入库，无需操作");
	    	      		}else if(res.NUM == -2){
	    	      			$rootScope.showPopup(constantDefine.no_authority_log);//"该锁具超出授权范围,无权限操作");
	    	      		} else {
	    	      			that.sendData(sendDataInfo.join(" "));
	    	      			$rootScope.showPopup(constantDefine.intostorage_success);//"已成功入库");
	    	      		}
	    	      	},function(res){
	    	      		$rootScope.showPopup(constantDefine.intostorage_fail);//"入库失败");
	    	      	});
    			} else{
    				$rootScope.showPopup(constantDefine.init_network_error);//"当前网络异常，请检查网络，新锁入库必须网络在线");
    			}
		    },
		    // 进行开锁，回收锁，挂锁等操作
		    openOrRecoverOrInstallLockset : function(lockId, sendDataInfo) {
		    	var that = this;
		    	if (!blcache.isDevTimeSync()) {
		    		$rootScope.showPopup(constantDefine.operation_time_error);
		    		return;
		    	}
		    	that.getPubLocksetByLockId(lockId, function(lockset){
		    		if(lockset == null || lockset.lockId == null || lockset.lockId ==""){
	    				$rootScope.showPopup(constantDefine.un_instorage_log);//"该锁具未入库，请先入库操作，如果当前网络不可用，请链接网络重新操作");
	    			} else {
	    				if(that.locksetIsXSystem(lockset)){ //// 判断该锁具是否是当前用户所属系统范围内的锁具
	    					that.openOrRecoverOrInstallLocksetByLockset(lockset, sendDataInfo);
	    				} else {
	    					$rootScope.showPopup(constantDefine.no_authority_log);//"该锁具超出授权范围,无权限操作");
	    				}	
	    			}
		    	});
		    },
		    // 判断锁具是否是当前用户所属系统内的锁具
		    locksetIsXSystem : function(lockset) {
		    	if (lockset.sysId == window.localStorage.sysId) {
		    		return true;
		    	}
		    	return false;
		    },
		    // 根据已经获取到的锁具进行正常的开锁，回收锁，挂锁等操作：： 取消之前的锁具分配的判断
		    openOrRecoverOrInstallLocksetByLockset : function(lockset, sendDataInfo) {
		    	var that = this;
		    	//挂锁模式
    			if(that.isInstalling){
    				that.installLockset(lockset, sendDataInfo);
    			} else { // 开锁或者回收锁
    				that.openOrRecoverLockset(lockset, sendDataInfo);
    			}
		    },
		    // 挂锁操作
		    installLockset : function(lockset, sendDataInfo) {
		    	var that = this;
		    	if(that.installedByLockset(lockset)){
					$rootScope.showPopup(constantDefine.lock_used_log);//"该锁具已使用,不用进行此操作");
				} else {
					that.installLocksetAndRefreshDeviceUserRela(lockset, sendDataInfo);
				}
		    },
		    // 挂锁并更新用户和设备授权关系
		    installLocksetAndRefreshDeviceUserRela : function(lockset, sendDataInfo) {
		    	var that = this;
		    	that.getDeviceUserRelByUserId(window.localStorage.userId, function(res){
		    		that.installLockByDeviceUserRelations(lockset, res, sendDataInfo);
		    	});
		    },
		    // 开锁或者回收锁操作
		    openOrRecoverLockset : function(lockset, sendDataInfo) {
		    	var that = this;
		    	if(that.installedByLockset(lockset)){
					that.openOrRecoverLocksetByDeviceUserRela(lockset, sendDataInfo);
				} else {
					$rootScope.showPopup(constantDefine.lock_unused_log);//"该锁具未使用安装,不进行此操作!");
				}
		    },
		    // 根据锁和设备的对应关系进行开锁或者回收锁操作
		    openOrRecoverLocksetByDeviceUserRela : function(lockset, sendDataInfo) {
		    	var that = this;
		    	that.getDeviceUserRelByUserIdLockId(lockset, sendDataInfo);
		    },
		    // 判断锁具是否已经分配
		    assignedByLockset : function(lockset) {
    			var assignStatus = lockset.assignStatus;//锁具--分配状态
    			if(assignStatus != 1){
    				return false;
    			}
    			return true;
		    },
		    // 是否已经安装？1=已安装，0=未安装
		    installedByLockset : function(lockset) {
		    	var installStatus = lockset.installStatus; // 锁具--安装状态
		    	if (installStatus == 1) {
		    		return true;
		    	}
		    	return false;
		    },
		    // 判断当前锁具是否入库并将入库结果获取处理
		    getPubLocksetByLockId : function(lockId, callback) {
		    	var that = this;
		    	if ($rootScope.networkState == 'none') {
		    		var lockset = that.getCachePubLocksetByLockId(lockId);
		    		callback(lockset);
		    	} else {
		    		hlService.home.getPubLocksetByLockId(lockId).get(function(res){
		    			callback(res);
			    	},function(res){
			    		var lockset = that.getCachePubLocksetByLockId(lockId);
			    		callback(lockset);
			    	});
		    	}
		    	
		    },
		    // 从缓存文件中获取该用户所属系统的所有锁具
		    getCachePubLocksetByLockId : function(lockId) {
		    	var lockset = blcache.getPubLocksetByLockId(lockId);
		    	return lockset;
		    },
		    // 先从回收锁的缓存中读取锁的信息
		    getCacheRecoverLocksetDataByLockId : function(lockId) {
		    	var recoverData = null;
		    	var datas = JSON.parse(window.localStorage.recoverData);
		    	if(datas != null && datas.length > 0) {
			    	for(var i = 0, len = datas.length; i < len; i++) {
			    		recoverData = datas[i];
			    		if (recoverData.lockId == lockId) {
			    			break;
			    		}
			    	}
			    	return recoverData;
		    	}
		    },
		    // 如果回收锁的缓存中没有对应的记录，则从登录时缓存的锁具列表中获得
		    getCacheLocksetDataByLockId : function(lockId, recoverData) {
		    	var locksets = JSON.parse(window.localStorage.locksets);
		    	if (locksets == null || locksets.length == 0) {
		    		return null;
		    	}
		    	var lockset = null;
		    	for(var i = 0, len = locksets.length; i < len; i++) {
		    		lockset = locksets[i];
		    		if (lockset.lockId == lockId) {
		    			break;
		    		}
		    	}
		    	// 如果当前锁已经被回收到缓存中，则需要将原有锁的信息状态更新为未安装标志
		    	if (lockset != null && recoverData != null) {
		    		if (recoverData.lockId == lockset.lockId) {
		    			lockset.installStatus = 0; // 标志为未安装
		    		}
		    	}
		    	return lockset;
		    },
		    // 开锁或者回收锁
		    openOrRecoverLock : function(devicerela, sendDataInfo) {
		    	if (this.allowedDateTimeRange(devicerela)) {
		    		if(devicerela.type == 0 || devicerela.type == 1){  //每天仅判断时分秒
		    			this.openOrRecoverLockByEventDayOfHms(devicerela, sendDataInfo);
		    		} else if(devicerela.type == 2){//每周
		    			this.openOrRecoverLockByEvenyWeek(devicerela, sendDataInfo);
		    		} else if(devicerela.type == 3){ //每月
		    			this.openOrRecoverLockByEvenyMonth(devicerela, sendDataInfo);
		    		} else {
		    			// nothing
		    		}
		    	} else {
		    		$rootScope.showPopup(constantDefine.not_at_work_time);
		    	}
		    },
		    // type = 0 or 1:
		    openOrRecoverLockByEventDayOfHms : function (devicerela, sendDataInfo) {
		    	var that = this;
		    	var date = new Date();
		    	var hms = that.getHmsByDate(date, true);
		    	if(hms > devicerela.startTime && hms < devicerela.endTime){
		    		that.sendData(sendDataInfo.join(" "));
		    		if(that.isReturn){ // 回收模式，加载数据
		    			that.setRecoverParams(devicerela.device);
		    		}
		    	}else{
		    		$rootScope.showPopup(constantDefine.not_at_work_time);
		    	}
		    },
		    // type= 2
		    openOrRecoverLockByEvenyWeek : function(devicerela, sendDataInfo) {
		    	var that = this;
		    	var reDay = devicerela.reday;
		    	var reDays = reDay.split(",");
		    	var date = new Date();
		    	var weekDay = date.getDay();
		    	var isPerm = false;
		    	var hms = that.getHmsByDate(date, true);
		    	for(var i=0;i<reDays.length;i++){
		    		if(weekDay == reDays[i]){
		    			isPerm = true;
		    			break;
		    		}
		    	}
		    	if(isPerm){
		    		if(hms > devicerela.startTime && hms < devicerela.endTime){					        			    			
			    		that.sendData(sendDataInfo.join(" "));
			    		if(that.isReturn){ // 回收模式，加载数据
			    			that.setRecoverParams(devicerela.device);
			    		}
			    	}else{
			    		$rootScope.showPopup(constantDefine.not_at_work_time);//"超出授权时段范围，不予操作");
			    	}
		    	}else{
		    		$rootScope.showPopup(constantDefine.not_at_work_time);
		    	}
		    },
		    // type = 3
		    openOrRecoverLockByEvenyMonth : function(devicerela, sendDataInfo) {
		    	var that = this;
		    	var reDay = devicerela.reday;
	    		var reDays = reDay.split(",");
	    		var isPerm = false;
	    		var date = new Date();
		    	var day = date.getDate();
		    	var hms = that.getHmsByDate(date, true);
		    	for(var i=0;i<reDays.length;i++){
		    		if(day == reDays[i]){
		    			isPerm = true;
		    			break;
		    		}
		    	}
	    		if(isPerm){
	    			if(hms > devicerela.startTime && hms < devicerela.endTime){						        			    			
			    		that.sendData(sendDataInfo.join(" "));
			    		if(that.isReturn){ // 回收模式，加载数据
			    			that.setRecoverParams(devicerela.device);
			    		}
			    	}else{
			    		$rootScope.showPopup(constantDefine.not_at_work_time);
			    	}
	    		}else{
	    			$rootScope.showPopup(constantDefine.not_at_work_time);
	    		}
		    },
		    // 判断开锁时间是否在开锁允许的时间范围内
		    allowedDateTimeRange : function(devicerela) {
		    	var that = this;
		    	var date = new Date();
		    	var ymd = that.getYmdByDate(date, true);
		    	if(ymd >= devicerela.startDate && ymd <= devicerela.endDate){  //判断是否在规定时间段内维护
		    		return true;
		    	}
		    	return false;
		    },
		    // 根据用户id获取当前用户和设备的授权信息列表
		    getDeviceUserRelByUserId : function(userId, callback) {
		    	var that = this;
		    	if($rootScope.networkState == 'none') {
		    		var deviceUserRela = that.getCacheDeviceUserRela(userId);
		    		callback(deviceUserRela);
		    	} else {
		    		hlService.home.getDeviceUserRelByUserId(window.localStorage.userId).query(function(res){
			    		callback(res);
			    	}, function(res){
			    		var deviceUserRela = that.getCacheDeviceUserRela(userId);
			    		callback(deviceUserRela);
			    	});
		    	}
		    },
		    // 根据用户id从缓存中获取当前用户和设备的授权信息列表。
		    getCacheDeviceUserRela : function(userId) {
		    	var deviceUserRela = blcache.getDeviceUserRelationByUserId(userId);
		    	return deviceUserRela;
		    },
		    // 获取用户对设备的授权信息，并进行开锁或者回收锁
		    getDeviceUserRelByUserIdLockId : function(lockset, sendDataInfo) {
		    	var that = this;
		    	that.getDeviceUserRelByUserId(window.localStorage.userId, function(deviceUserRela){
		    		if (that.hasAllPermissions(deviceUserRela)){ // 拥有-100，则直接开锁或者挂锁
		    			that.getDeviceByLockset(lockset, function(device){
		    				that.sendData(sendDataInfo.join(" "));
				    		if(that.isReturn){ // 回收模式，加载数据
				    			that.setRecoverParams(device);
				    		}
			    		},true);
		    			
		    		} else { // 如果不拥有-100，则进行权限判断之后再进行开锁或者回收锁
		    			var devicerela = that.getDeviceUserRelByLockId(lockset.lockId, deviceUserRela);
		    			if (devicerela == null) {
		    				$rootScope.showPopup(constantDefine.device_permission_log);//"用户对该设备无操作权限,请联系管理员");
		    			} else {
		    				that.openOrRecoverLock(devicerela, sendDataInfo);
		    			}
		    		}
		    	});
		    },
		    hasAllPermissions : function(deviceUserRelations) {
		    	if (deviceUserRelations == null || deviceUserRelations.length == 0) {
		    		return false;
		    	}
		    	for (var i = 0;i < deviceUserRelations.length; i++) {
		    		var deviceUserRela = deviceUserRelations[i];
		    		if (deviceUserRela.deviceId == -100) { // -100代表拥有所有权限，直接返回true
		    			return true;
		    		}
		    	}
		    	return false;
		    },
		    getDeviceUserRelByLockId : function(lockId, deviceUserRelations) {
		    	if (deviceUserRelations == null || deviceUserRelations.length == 0) {
		    		return null;
		    	}
		    	for (var i = 0, len = deviceUserRelations.length; i < len; i++) {
		    		var deviceUserRela = deviceUserRelations[i];
		    		var device = deviceUserRela.device;
		    		if (lockId == device.lockId) {
		    			return deviceUserRela;
		    		}
		    	}
		    	return null;
		    },
		    /*
		     * 挂锁的时候根据界面配合情况来做的话，权限判断有问题，不应该判断权限
		     * 1.对于depend=1的情况，最大的作用就是事先不知道挂那个设备，因此在这个环节强制判断权限最终的效果就是不知所云。
		     * 2.对于depend=0的情况，为了判断权限，也应该在界面选择设备的时候再判断是否有权限，然后给与提示有否，也不应该在这里进行处理
		     * 
		     * 总结：对于depend=1的情况，就不要判断权限
		     *     对于depend=2的情况，在选择设备的时候判断权限
		     *     
		     * 改动结果：下面这个方法实际执行的内容，只要else的语句即可。
		     */ 
		    installLockByDeviceUserRelations : function(lockset, deviceUserRelations, sendDataInfo) {
		    	var that = this;
		    	var date = new Date();
		    	if (that.hasAllPermissions(deviceUserRelations)){ // 拥有-100，则直接挂锁
		    		that.getDeviceByLockset(lockset, function(device){ // 根据lockset中的depend判断如何加载设备 
		    			$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
						that.installLock(that.getSecondsByDate(date),that.getYmdHmsByDate(date),device);
		    		});
		    	} else { //如果不拥有-100，则进行权限判断之后在进行设备的挂锁操作---暂时不判断，逻辑上有点别扭
		    		if (lockset.depend == 0) {
			    		var device = {
			    			lockId:lockset.lockId,
			    			depend:0
			    		};
			    		$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
						that.installLock(that.getSecondsByDate(date),that.getYmdHmsByDate(date),device);
			    	} else { // 如果有人为的脏数据，有可能得不到device信息，正常入库模式（depend=1）操作的，设备信息肯定能获取到
			    		//判断用户是否对设备拥有权限 -------------by leaf
			    		var devicerela = that.getDeviceUserRelByLockId(lockset.lockId, deviceUserRelations);
		    			if (devicerela == null) {
		    				$rootScope.showPopup(constantDefine.device_permission_log);//"用户对该设备无操作权限,请联系管理员");
		    			} else {
		    				that.getDeviceByLockId(lockset.lockId, function(device){
				    			$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
								that.installLock(that.getSecondsByDate(date),that.getYmdHmsByDate(date),device);
				    		});
		    			}
			    	}
		    	}
		    },
		    // 先判断lockset中的depend的状态是否为0，如果为0则直接返回没有设备id，设备名的设备
		    // openRecoverFlag :代表回收或者开锁，当这两种模式的时候，直接从数据库中获取设备信息，必须有，如果没有记录，就是不正常的开锁或者挂锁
		    getDeviceByLockset : function(lockset, callback, openRecoverFlag) {
		    	var that = this;
		    	if (openRecoverFlag) {
		    		that.getDeviceByLockId(lockset.lockId, function(device){
		    			callback(device);
		    		});
		    	} else {
		    		if (lockset.depend == 0) {
			    		var device = {
			    			lockId:lockset.lockId,
			    			depend:0
			    		};
			    		callback(device);
			    	} else { // 如果有人为的脏数据，有可能得不到device信息，正常入库模式（depend=1）操作的，设备信息肯定能获取到
			    		that.getDeviceByLockId(lockset.lockId, function(device){
			    			callback(device);
			    		});
			    	}
		    	}
		    	
		    },
		    // 该方法的目的，就是为了找depend=1的设备信息
		    getDeviceByLockId : function(lockId, callback) {
		    	var that = this;
		    	if ($rootScope.networkState == 'none') {
		    		var device = that.getCachePubDeviceByLockId(lockId);
		    		callback(device);
		    	} else {
		    		hlService.home.getDeviceByLockId(lockId).get(function(res){
			    		callback(res);
			    	}, function(res){
			    		var device = that.getCachePubDeviceByLockId(lockId);
			    		callback(device);
			    	});
		    	}
		    	
		    },
		    // 从缓存的设备列表中获取设备信息，这里一般depend=1的情况，depend=0的情况不会走到这个缓存中，因此忽略
		    getCachePubDeviceByLockId : function(lockId) {
		    	var device = blcache.getPubDeviceByLockId(lockId);
		    	return device;
		    },
		    // 获取时间的绝对秒
		    getSecondsByDate : function(date) {
		    	return date.getTime() / 1000;
		    },
		    // yyyy-MM-dd, if middleLine=true :yyyyMMdd
		    getYmdByDate : function(date, middleLine) {
		    	var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
		    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
		    	var ymd = "" + date.getFullYear() + month + day;
		    	var format = date.getFullYear()+ "-" + month + "-" + day;
		    	if (middleLine) {
		    		format = date.getFullYear()+ "" + month + "" + day;
		    	}
		    	return format;
		    },
		    // HH:mm:ss ,if middleDot=true : HHmmss
		    getHmsByDate : function(date, middleDot) {
		    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
		    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
		    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
		    	var format = hours + ":" + minutes + ":" + seconds;
		    	if (middleDot) {
		    		format = hours + "" + minutes + "" + seconds;
		    	}
		    	return format;
		    },
		    // yyyy-MM-dd HH:mm:ss
		    getYmdHmsByDate : function(date) {
		    	var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
		    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
		    	var ymd = "" + date.getFullYear() + month + day;
		    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
		    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
		    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
		    	var format = date.getFullYear()+ "-" + month + "-" + day + " "
					+ hours + ":" + minutes + ":" + seconds;
		    	return format;
		    },
		    /**
			 * 写数据,外传回调函数
			 * */
		    sendData1 : function(data, fn, efn){
		    	var that = this;
				ble.write(that.deviceId, that.serviceUUID, that.characteristicUUID,
						that.stringToBytes(data).buffer, fn,efn);
			},
		    /**
			 * 写数据
			 * */
		    sendData : function(data){
		    	var that = this;
				ble.write(that.deviceId, that.serviceUUID, that.characteristicUUID,
	    				that.stringToBytes(data).buffer, function(res){
					
				},function(res){
					//$rootScope.openLog = "命令发送失败!请重试或重新进行蓝牙连接。";
					//$rootScope.openLog += '<=sendData:' + JSON.stringify(res);
					that.status = constantDefine.send_data_error;//"传送数据失败";
					that.notifyError = true;
					that.isReconnecting = true;
				});
			},
		    disconnect : function(){
		    	var that = this;
		    	ble.disconnect(that.deviceId,function(){
		    		that.status = constantDefine.no_connect;//"未连接";
				},function(){});
		    },
		    disconnectcallback : function(fn, en) {
		    	var that = this;
		    	ble.disconnect(that.deviceId,fn,en);
		    },
		    reconnect : function() {
		    	var that = this;
		    	ble.disconnect(that.deviceId,function(){
		    		that.status = constantDefine.scan_connection//"扫描连接中……";
		    		//$rootScope.openLog = '重连-》' + $rootScope.timecounter;
		    		that.scanDevice();
				},function(){
					//$rootScope.openLog = '重连关闭失败了-》' + $rootScope.timecounter;
				});
		    },
		    isConnected : function(deviceId,fn,efn){
		    	ble.isConnected(deviceId,fn,efn);
		    }
	    };
		return Bluetooth;
	
});

angular.module('btapp.factorys').factory('ysBlKey', function($rootScope,$cordovaToast,hlService) {
		
		var Bluetooth = {
			/**
			 * 蓝牙设备连接名
			 * */
			keyName : '',
			/**
	    	 * 蓝牙设备id
	    	 * */
	    	deviceId : '',
	    	/**
    		 * 是否进行蓝牙扫描
    		 * */
	    	scanFlag : true,
	    	/**
	    	 * 是否网络在线
	    	 * */
	    	online : true, 
	    	/**
	    	 * 是否扫描到指定设备
	    	 * */
	    	isScanSuccess : false,
	    	/**
	    	 * 是否连接过
	    	 * */
	    	connected : false, 
	    	/**
	    	 * 是否为挂锁模式
	    	 * */
	    	isInstalling : false,
	    	/**
	    	 * 是否初始化入库模式
	    	 * */
	    	isInit : false,
	    	/**
	    	 * 是否维护模式
	    	 * */
	    	isMain : true, 
	    	/**
	    	 * 是否回收模式
	    	 * */
	    	isReturn : false,
	    	/**
	    	 * 异或校验算法钥匙信息
	    	 * */
	    	key : "00 01 02 03 04 05 06 07",
	    	/**
	    	 * 根秘钥
	    	 * */
	    	gKey : "a0a1a2a3a4a5a6a7",
	    	/**
	    	 * 控制秘钥
	    	 * */
	    	controlKey : 'b0b1b2b3b4b5b6b7',
	    	/**
	    	 * 通信连接状态
	    	 * */
	    	status : '',
	    	
	    	scanError : function(res){
		    	$rootScope.bluetooth.status = "扫描失败";
		    },
		    
		    scanDevice : function(){
		    	//$rootScope.Object = this;
		    	ble.scan([], 5,this.onScanDevice, this.scanError);
		    },
		    
		    onScanDevice : function(device){
		    	if(device.name == $rootScope.bluetooth.keyName){
		    		$rootScope.bluetooth.deviceId = device.id;
		    		$rootScope.bluetooth.connect();
		    		
		    	} 
		    },
		    
		    connError : function(res){
		    	$rootScope.bluetooth.status = "扫描连接失败";
		    },
		    
		    onError : function(reason){
		    	$rootScope.bluetooth.status = "通信出错";
		    	//$rootScope.bluetooth.disconnect();
		    },
		    
		    connect: function() {
		        ble.connect(this.deviceId, this.onConnect, this.connError);
		    },
		    /**
			 * 蓝牙通讯连接后启动通道监听
			 * */
			onConnect : function(peripheral){
				$rootScope.bluetooth.determineServiceType(peripheral);
				ble.startNotification($rootScope.bluetooth.deviceId, $rootScope.bluetooth.serviceUUID, $rootScope.bluetooth.notifyCharacteristicUUID, $rootScope.bluetooth.onData, $rootScope.bluetooth.onError);
				$rootScope.bluetooth.status = "已连接";
				var dynamicSecretKey = $rootScope.bluetooth.initDynamicSecretKey();
				var sendDataInfo = "02 08 " + dynamicSecretKey; //发送数据
				$rootScope.bluetooth.key = dynamicSecretKey;
				//$rootScope.openLog += "发送动态密钥 ：" + sendDataInfo;
				$rootScope.bluetooth.sendData(sendDataInfo);
			},
			/**
			 * 通道信息解析
			 * */
			determineServiceType: function(peripheral) {
				peripheral.characteristics.filter(function(element) {
					var properties = element.properties;
					for(var i=0;i<properties.length;i++){
						var prop = properties[i];
						if("notify" == prop.toLowerCase()){
							$rootScope.bluetooth.serviceUUID = element.service;
							$rootScope.bluetooth.notifyCharacteristicUUID = element.characteristic;
						} else if("write" == prop.toLowerCase()){
							$rootScope.bluetooth.serviceUUID = element.service;
							$rootScope.bluetooth.characteristicUUID = element.characteristic;
						}
					}
					if($rootScope.bluetooth.notifyCharacteristicUUID && $rootScope.bluetooth.characteristicUUID){
						return;
					}
		        })[0];
		    },
			/**
			 * 通知监听处理
			 * */
		    onData : function(buffer){
		    	$rootScope.bluetooth.parseResult($rootScope.bluetooth.bytesToString(buffer));
		    },
		    /**
		     * 随机生成8位动态密钥
		     * */
		    initDynamicSecretKey : function(){
		    	var num = '';
		    	 for (i = 0; i < 16; i++)
		    	 {
		    	    var tmp = Math.ceil(Math.random()*15);
		    	    if(tmp > 9){
		    	           switch(tmp){ 
		    	               case(10):
		    	                   num+='a';
		    	                   break;
		    	               case(11):
		    	                   num+='b';
		    	                   break;
		    	               case(12):
		    	                   num+='c';
		    	                   break;
		    	               case(13):
		    	                   num+='d';
		    	                   break;
		    	               case(14):
		    	                   num+='e';
		    	                   break;
		    	               case(15):
		    	                   num+='f';
		    	                   break;
		    	           }
		    	        }else{
		    	           num+=tmp;
		    	        }
		    	 }
		    	 num = num.replace(/(.{2})/g, "$1 ");
		    	 return(num);
		    },
		    /**
		     * 参数： 十六进制数
		     * 异或校验运算 结果返回十进制数
		     * */
		    XorCheck : function(Data,Length){
	    	    var sum=0,i;
	    	    for(var i=0; i<Length; i++)
	    	    {
	    	        sum ^= Data[i]; 
	    	    }
	    	    return sum;
	    	},
	    	/**
	    	 * 参数： 十六进制数
	    	 * 加密算法  结果返回十进制数
	    	 * */
		    HloveyRC4 : function(aInput, aKey) {
		    	var iS = new Uint8Array(256);
	    	    var iK = new Uint8Array(256);
	    	    for (var i = 0; i < 256; i++)
	    	        iS[i] = i;
	    	    var j = 1;
	    	    for (var i = 0; i < 256; i++){
	    	        iK[i] = aKey[(i % aKey.length)];
	    	    }
	    	    j = 0;
	    	    for (var i = 0; i < 256; i++) {
	    	        j = (j + iS[i]&0xff + iK[i]&0xff) % 256;
	    	        var temp = iS[i];
	    	        iS[i] = iS[j];
	    	        iS[j] = temp;
	    	    }
	    	    var i = 0;
	    	    j = 0;
	    	    var iOutputChar = new Uint8Array(aInput.length);
	    	    for (var x = 0; x < iOutputChar.length; x++) {
	    	        i = (i + 1) % 256;
	    	        j = (j + iS[i]&0xff) % 256;
	    	        var temp = iS[i]&0xff;
	    	        iS[i] = iS[j];
	    	        iS[j] = temp;
	    	        var t = (iS[i] + (iS[j]&0xff % 256)) % 256;
	    	        var iY = iS[t]&0xff;
	    	        var iCY =  iY;
	    	        iOutputChar[x] = aInput[x] ^ iCY;
	    	    }
	    	    return iOutputChar;
			},
			
			/**
			 * 参数：ArrayBuffer
			 * 结果：十进制转十六进制
			 * */
		    bytesToString : function(buffer) {
		    	var a = new Uint8Array(buffer);
				 var data = [];
				 for(var i=0;i<a.length;i++){
					 data[i] = $rootScope.bluetooth.decimalRadixToHex(a[i]);
				 }
				 return data;
			},
			/**
			 * 参数：十六进制参数字符串，已空格分开
			 * 结果：无符号十六进制数数组
			 * ee de ac 12 
			 * */
			stringToBytes : function(string) {
				 var arr = string.split(" ");
				 var array = new Uint8Array(arr.length);
				 for (var i = 0; i < arr.length;i++) {
					 array[i] = '0x' + arr[i];
				 }
				 return array;
			},
			
			/**
			 * 参数：十六进制参数字符串，未加空格分开
			 * 结果：无符号十六进制数数组
			 *  eedeac12 长度32 16个字节
			 * */
			stringToBytesForNoSpace : function(string) {
				 var array = new Uint8Array(string.length/2);
				 for (var i = 0; i < string.length;) {
					 array[i/2] = '0x' + string.substring(i,i+2);
					 i = i + 2;
	
				 }
				 return array;
			},
			
			/**
			 * 十六进制转十进制数
			 * 参数：十六进制数
			 * 结果：十进制数
			 * */
			hexRadixToDecimal : function(num){
				return parseInt(num, 16);
			},
			/**
			 * 十进制数转十六进制数
			 * 参数：十进制数
			 * 结果：十六进制数
			 * */
			decimalRadixToHex : function(num){
				return num.toString(16);
			},
			
			/**
			 * 安装锁具地址信息获取操作
			 * */
			installLock : function(installTime,timeFormate){
				if(this.online){
					var geolocation = new BMap.Geolocation();
	    			geolocation.getCurrentPosition(function(r){
	    				if(this.getStatus() == BMAP_STATUS_SUCCESS){
	    					var geoc = new BMap.Geocoder();  
	    					var point = new BMap.Point(r.point.lng,r.point.lat);
	    					geoc.getLocation(point, function(rs){
	    						var addComp = rs.addressComponents;
	    						
		    					$rootScope.Lockset = {
		    						lockId : $rootScope.lockId,
		    						installer : window.localStorage.userId,
		    						installName : window.localStorage.userName,
		    						time : installTime,
		    						timeFormate : timeFormate,
		    						longitude : r.point.lng,
		    						latitude : r.point.lat,
		    						location : addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber
		    					}
	    					});
	    				} else {
	    					$rootScope.showPopup("地址定位失败：" + this.getStatus());
	    				}        
	    			},{enableHighAccuracy: true});
				} else {
					$rootScope.Lockset = {
						lockId : $rootScope.lockId,
						installer : window.localStorage.userId,
						installName : window.localStorage.userName,
						time : installTime,
						timeFormate : timeFormate
						//longitude : r.point.lng,
						//latitude : r.point.lat,
						//location : addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber
					}
				}
			},
			/**
			 * 回收锁具参数设置
			 * */
			setRecoverParams : function(res){
				var device = res.device;
    			var time = res.device["time"] * 1000;
				var dateTime = new Date(time);
				var m = (dateTime.getMonth()+1) < 10 ? '0'+(dateTime.getMonth()+1) : (dateTime.getMonth()+1);
		    	var d = dateTime.getDate() < 10 ? '0'+ dateTime.getDate() : dateTime.getDate();
		    	var h = dateTime.getHours() < 10 ? '0' + dateTime.getHours() : dateTime.getHours();
		    	var min = dateTime.getMinutes() < 10 ? '0' + dateTime.getMinutes() : dateTime.getMinutes();
		    	var s = dateTime.getSeconds() < 10 ? '0' + dateTime.getSeconds() : dateTime.getSeconds();
				var timeFormate = dateTime.getFullYear()+"-"+m+"-"+d+" "
								+ h + ":" + min + ":" + s;
				
				$rootScope.recover = {
					lockId : $rootScope.lockId,
					deviceId : device.deviceId,
					deviceName : device.deviceName,
					installer : device.installer,
					installName : device.installUser.name,
					time : device.time,
					timeFormate : timeFormate,
					longitude : device.longitude,
					latitude : device.latitude,
					location : device.location
				}
			},
			
			parseResultYs : function(result){
				var that = this;
				if(result[0] == 3){
					
//alert($rootScope.bluetooth.gKey);

//alert($rootScope.bluetooth.controlKey);
					
					$rootScope.openLog = "（03命令码）上传锁设备信息: " + result;
					
					var dataLength = parseInt(result[1]);//报文数据长度
		    		var bwDatas = [];
		    		for(var i=0;i<4;i++){      //前4位为锁设备号
		    			var bwData = result[i+2];
		    			bwDatas.push(bwData);  //十六进制数据位
		    		}
		    		//添加开锁动作位
		    		bwDatas.push(1);
$rootScope.openLog += " <br> 动态key值：" + that.key;
					var openKey = (that.key + that.controlKey).split(' ').join('');
$rootScope.openLog += " <br> 开关锁拼接key值：" + openKey;

// 去空格进行MD5加密
					var md5OpenKey = hex_md5(openKey);
$rootScope.openLog += " <br> 加密后key值：" + md5OpenKey;
					
//$rootScope.openLog += "&&加密后key值十六进制数：" + JSON.stringify(that.stringToBytesForNoSpace(hex_md5(that.key + " " + that.controlKey)));

					//var secretData = that.HloveyRC4(that.stringToBytes(bwDatas.join(" ")), that.stringToBytes(that.key));
		    		var secretData = that.HloveyRC4(that.stringToBytes(bwDatas.join(" ")), that.stringToBytesForNoSpace(hex_md5(openKey)));

		    		var secretCheck = that.XorCheck(secretData, secretData.length);
		   
		    		var newSecretData = new Uint8Array(secretData.length + 1);//修改最后一位值为校验位的值{0:248,1:246,2:249,3:244,4:230,5:229}
		    		for(var i=0;i<secretData.length;i++){
		    			newSecretData[i] = secretData[i];
		    		}
		    		newSecretData[newSecretData.length-1] = secretCheck; 
		    		
		    		var sendDataInfo = [04,05]; //发送数据
		    		
		    		for(var i=0;i<newSecretData.length;i++){
		    			var d = newSecretData[i].toString(16);
		    			sendDataInfo[i+2] = d;
		    		}
					
					$rootScope.openLog += " <br> 04开锁命令码: " + sendDataInfo;
					$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
				}
				else if(result[0]==1){
		    		that.keyInfo = result;
		    		//$rootScope.openLog += "（01命令码）返回钥匙设备信息:" + result;
		    	}
				else if(result[0]==2){
		    		//that.keyInfo = result;
		    		$rootScope.openLog += "（02命令码）返回动态密钥同步结果:" + result;
		    	}
		    	else if(result[0]==4){
		    		$rootScope.openLog += " <br>（04命令码）返回开关锁结果信息: " + result;
		    	}
			},
			/**
			 * 接收报文解析
			 * */
		    parseResult : function(result){
		    	var that = this;
		    	if(result[0] == 3){
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n接收到报文—— (1)");
		    		var dataLength = parseInt(result[1]);//报文数据长度
		    		var bwDatas = [];
		    		for(var i=0;i<4;i++){
		    			var bwData = result[i+2];
		    			bwDatas.push(bwData);  //十六进制数据位
		    		}
		    		//添加开锁动作位  1表示开锁，目前只有开锁动作
		    		bwDatas.push(1);  
		    		//开锁密钥为动态密钥作为高8位+控制密钥作为低8位组合成的新密钥，经MD5加密后使用
		    		var openKey = (that.key + that.controlKey).split(' ').join('');
		    		var secretData = that.HloveyRC4(that.stringToBytes(bwDatas.join(" ")), that.stringToBytesForNoSpace(hex_md5(openKey)));
		    		//重新生成校验码
		    		var secretCheck = that.XorCheck(secretData, secretData.length);
		    		
		    		//重新组装发送报文 锁设备号+开关锁动作+校验位
		    		var newSecretData = new Uint8Array(secretData.length + 1);
		    		var sendDataInfo = [04,05]; 
		    		for(var i=0;i<secretData.length;i++){
		    			newSecretData[i] = secretData[i];
		    		}
		    		newSecretData[newSecretData.length-1] = secretCheck;
		    		for(var i=0;i<newSecretData.length;i++){
		    			var d = newSecretData[i].toString(16);
		    			sendDataInfo[i+2] = d;
		    		}
		    		
		    		
		    		var j = 2 + dataLength;
		    		var checkData = result[j]; //校验位16进制
		    		var datas = [];
		    		for(var i=0;i<dataLength;i++){
		    			var data = result[i+2];
		    			datas.push(data);
		    		}
		    		var judgeCheck = that.XorCheck(that.stringToBytes(datas.join(" ")), datas.length); //十进制
		    		if(that.decimalRadixToHex(judgeCheck) != checkData){
		    			$rootScope.showPopup("报文数据校验位不一致，操作终止!!!");
		    		} else {
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n校验位校验成功—— (2)");
		    			var date = new Date();
	    				var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
	    				var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    			    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    			    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    			    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
// var logDate = date.getFullYear()+"-"+month+"-"+day+" "
//	+ hours + ":" + minutes + ":" + seconds;   			    	
			    		//解析报文获取锁具编码
			    		var lockId = "";
			    		lockId = that.hexRadixToDecimal(result[2])*Math.pow(256,3) 
			    					+ that.hexRadixToDecimal(result[3])*Math.pow(256,2) 
			    					+ that.hexRadixToDecimal(result[4])*256 
			    					+ that.hexRadixToDecimal(result[5]);
			    		$rootScope.lockId = lockId;
			    		//是否初始化入库状态
			    		if(that.isInit){
			    			if(that.online){
			    				
			    				hlService.home.savePubLocksetData().save({               
				    				lockId : lockId,
				    				lockName : '新锁'+ that.decimalRadixToHex(lockId),
				    				compId : window.localStorage.groupId
				    	      	},function(res){
				    	      		if(res.NUM == -1){
				    	      			$rootScope.showPopup("锁具已在库中!!!");
				    	      		}else{
				    	      			that.sendData(sendDataInfo.join(" "));
				    	      			$rootScope.showPopup("入库成功!!!");
				    	      		}
				    	      	},function(res){
				    	      		$rootScope.showPopup("网络偷懒啦!!!");
				    	      	});
			    			} else{
			    				$rootScope.showPopup("离线状态不支持该功能操作!!!");
			    			}
			    			
			    		} else { //非入库状态
			    			
			    			//判断锁具状态
				    		hlService.home.getPubLocksetByLockId(lockId).get(function(res){
				    			if(res.lockId == null || res.lockId ==""){
				    				$rootScope.showPopup("该锁具未入库，请先入库操作!");
				    				return;
				    			}
				    			var installStatus = res.installStatus;
				    			var assignStatus = res.assignStatus;
				    			if(assignStatus != 1){
				    				$rootScope.showPopup("该锁具未分配,请联系主站管理员!");
				    			} else {
				    				//挂锁模式
					    			if(that.isInstalling){
					    				var installTime = (date/1000).toFixed(0);
					    				if(installStatus == 1 ){
					    					$rootScope.showPopup("该锁具已使用,不用进行此操作!");
					    				} else {
					    					//判断该锁具是否在用户名下
					    					hlService.home.getLockUserRelByUserIdLockId(lockId,window.localStorage.userId).get(function(res){
					    						if(res.id == null){
					    							$rootScope.showPopup("该锁具未分配到用户下，操作终止!");
					    						}else{
					    							$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
					    							var timeFormate = date.getFullYear()+"-"+month+"-"+day+" "
													+ hours + ":" + minutes + ":" + seconds;
					    							that.installLock((date/1000).toFixed(0),timeFormate);
					    						}
					    					},function(res){
					    						$cordovaToast.showShortCenter("已转离线模式");
					    						var locksets = JSON.parse(window.localStorage.locksets);
					    						var isContain = false;
					    						for(var i=0;i<locksets.length;i++){
					    							var lockset = locksets[i];
					    							if(lockset.lockId == lockId){
					    								isContain = true;
					    								break;
					    							}
					    						}
					    						if(isContain){
					    							$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
					    							var timeFormate = date.getFullYear()+"-"+month+"-"+day+" "
													+ hours + ":" + minutes + ":" + seconds;
					    							that.installLock((date/1000).toFixed(0),timeFormate);
					    						}else{
					    							$rootScope.showPopup("该锁具未分配到用户下，操作终止!");
					    						}
					    					});
					    				}
					    			}else { //回收和开锁维护模式
					    				if(installStatus != 1){
					    					$rootScope.showPopup("该锁具未使用安装,不进行此操作!");
					    				}else{
					    					//权限判断
					    					hlService.home.getDeviceUserRelByUserIdLockId(lockId,window.localStorage.userId).get(function(res){
					    						if(res.id == null){
					    							$rootScope.showPopup("用户对该设备无操作权限,请联系管理员!");
					    						} else{
					    							var ymd = "" + date.getFullYear() + month + day;
							    			    	var hms = "" + hours + minutes + seconds;
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限判断操作开始—— (3)");   		
							    			    	if(ymd >= res.startDate && ymd <= res.endDate){ //判断是否在规定时间段内维护
							    			    		if(res.type == 0 || res.type == 1){ //每天仅判断时分秒
							        			    		if(hms > res.startTime && hms < res.endTime){
							    	    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限校验通过，发送报文—— (4)");							        			    			
							    	    			    		that.sendData(sendDataInfo.join(" "));
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n报文发送成功，开锁结束:" + logDate + "—— (5)\r\n\r\n"); 
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n发送报文—— " + sendDataInfo.join(" "));
							    	    			    		if(that.isReturn){ // 回收模式，加载数据
							    	    			    			that.setRecoverParams(res);
							    	    			    		}
							    	    			    	}else{
							    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    	    			    	}
							    	    			    } else if(res.type == 2){//每周
							    	    			    	var reDay = res.reday;
							    	    			    	var reDays = reDay.split(",");
							    	    			    	var weekDay = date.getDay();
							    	    			    	var isPerm = false;
							    	    			    	for(var i=0;i<reDays.length;i++){
							    	    			    		if(weekDay == reDays[i]){
							    	    			    			isPerm = true;
							    	    			    			break;
							    	    			    		}
							    	    			    	}
							    	    			    	if(isPerm){
							    	    			    		if(hms > res.startTime && hms < res.endTime){
							    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限校验通过，发送报文—— (4)");							        			    			
								    	    			    		that.sendData(sendDataInfo.join(" "));
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n报文发送成功，开锁结束:" + logDate + "—— (5)\r\n\r\n"); 
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n发送报文—— " + sendDataInfo.join(" "));
							    		    			    		if(that.isReturn){ // 回收模式，加载数据
								    	    			    			that.setRecoverParams(res);
								    	    			    		}
							    		    			    	}else{
							    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    		    			    	}
							    	    			    	}else{
							    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    	    			    	}
							    	    			    }else if(res.type == 3){ //每月
							        			    		var reDay = res.reday;
							        			    		var reDays = reDay.split(",");
							        			    		var isPerm = false;
							    	    			    	for(var i=0;i<reDays.length;i++){
							    	    			    		if(day == reDays[i]){
							    	    			    			isPerm = true;
							    	    			    			break;
							    	    			    		}
							    	    			    	}
							        			    		if(isPerm){
							        			    			if(hms > res.startTime && hms < res.endTime){
							    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限校验通过，发送报文—— (4)");							        			    			
								    	    			    		that.sendData(sendDataInfo.join(" "));
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n报文发送成功，开锁结束:" + logDate + "—— (5)"); 
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n发送报文—— " + sendDataInfo.join(" "));
							    		    			    		if(that.isReturn){ // 回收模式，加载数据
								    	    			    			that.setRecoverParams(res);
								    	    			    		}
							    		    			    	}else{
							    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    		    			    	}
							        			    		}else{
							        			    			$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							        			    		}
							    	    			    }
							    			    		
							    			    	}else{
							    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    			    	}
					    						}
					    					},function(res){
					    						$rootScope.showPopup("网络偷懒啦!");
					    					});
					    				}
					    			}
				    			}
				    		},function(res){
				    			
				    			$cordovaToast.showShortCenter("网络连接不可用");
				    			that.online = false;
				    			//挂锁模式
				    			if(that.isInstalling){
				    				var locksets = JSON.parse(window.localStorage.locksets);
					    			var isContain = false;
					    			for(var i=0;i<locksets.length;i++){
					    				var record = locksets[i];
					    				if(record.lockId == $rootScope.lockId){
					    					isContain = true;
					    					$rootScope.outLineLockSet = record;
					    					break;
					    				}
					    			}
					    			if(!isContain){
					    				$rootScope.showPopup("该锁具不在库中或你没权限操作，请联网后再进一步操作!");
					    				$rootScope.outLineLockSet = null;
					    			} else {
					    				//判断锁具是否已使用且已在缓存数据中
					    				var hisRecord = JSON.parse(window.localStorage.lockInstallData);
				    		    		var lockContain = false;
				    		    		
				    		    		for(var i=0;i<hisRecord.length;i++){
				    		    			var record = hisRecord[i];
				    		    			if(record.lockId == lockId){
				    		    				lockContain = true;
				    		    			}
				    		    		}
				    		    		if(lockContain){
				    		    			$rootScope.showPopup("该锁具已使用且缓存，请重新选择!!!");
				    		    		} else{
				    		    			var installTime = (date/1000).toFixed(0);
						    				if($rootScope.outLineLockSet.lockSet.installStatus == 1 ){
						    					$rootScope.showPopup("该锁具已使用,不再进行此操作!");
						    				} else {
				    							$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
				    							var timeFormate = date.getFullYear()+"-"+month+"-"+day+" "
												+ hours + ":" + minutes + ":" + seconds;
				    							that.installLock((date/1000).toFixed(0),timeFormate);
						    				}
				    		    		}
					    			}
				    			}else{  // 开关维护及回收模式
				    				var devices = JSON.parse(window.localStorage.lockPerm);
				    				var isContain = false;
				    				for(var i=0;i<devices.length;i++){
				    					var record = devices[i];
				    					var realLockId = record.device.lockId;
				    					if(realLockId == lockId){
				    						isContain = true;
				    						$rootScope.outLineDevice = record;
				    						break;
				    					}
				    				}
				    				if(!isContain){
				    					$rootScope.showPopup("该锁具未安装或用户对该设备无操作权限，请联网后再进一步操作。");
				    					$rootScope.outLineDevice = null;
				    				}else{
				    					
				    					var ymd = "" + date.getFullYear() + month + day;
				    			    	var hms = "" + hours + minutes + seconds;
				    			    	if(ymd >= $rootScope.outLineDevice.startDate && ymd <= $rootScope.outLineDevice.endDate){ //判断是否在规定时间段内维护
				    			    		if($rootScope.outLineDevice.type == 0 || $rootScope.outLineDevice.type == 1){ //每天仅判断时分秒
				        			    		if(hms > $rootScope.outLineDevice.startTime && hms < $rootScope.outLineDevice.endTime){
				    	    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
				    	    			    		that.sendData(sendDataInfo.join(" "));
				    	    			    		if(that.isReturn){ // 回收模式，加载数据
				    	    			    			that.setRecoverParams($rootScope.outLineDevice);
				    	    			    		}
				    	    			    	}else{
				    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    	    			    	}
				    	    			    } else if($rootScope.outLineDevice.type == 2){//每周
				    	    			    	var reDay = $rootScope.outLineDevice.reday;
				    	    			    	var reDays = reDay.split(",");
				    	    			    	var weekDay = date.getDay();
				    	    			    	var isPerm = false;
				    	    			    	for(var i=0;i<reDays.length;i++){
				    	    			    		if(weekDay == reDays[i]){
				    	    			    			isPerm = true;
				    	    			    			break;
				    	    			    		}
				    	    			    	}
				    	    			    	if(isPerm){
				    	    			    		if(hms > $rootScope.outLineDevice.startTime && hms < $rootScope.outLineDevice.endTime){
				    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
				    		    			    		that.sendData(sendDataInfo.join(" "));
				    		    			    		if(that.isReturn){ // 回收模式，加载数据
					    	    			    			that.setRecoverParams(res);
					    	    			    		}
				    		    			    	}else{
				    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    		    			    	}
				    	    			    	}else{
				    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    	    			    	}
				    	    			    }else if($rootScope.outLineDevice.type == 3){ //每月
				        			    		var reDay = $rootScope.outLineDevice.reday;
				        			    		var reDays = reDay.split(",");
				        			    		var isPerm = false;
				    	    			    	for(var i=0;i<reDays.length;i++){
				    	    			    		if(day == reDays[i]){
				    	    			    			isPerm = true;
				    	    			    			break;
				    	    			    		}
				    	    			    	}
				        			    		if(isPerm){
				        			    			if(hms > $rootScope.outLineDevice.startTime && hms < $rootScope.outLineDevice.endTime){
				    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
				    		    			    		that.sendData(sendDataInfo.join(" "));
				    		    			    		if(that.isReturn){ // 回收模式，加载数据
					    	    			    			that.setRecoverParams(res);
					    	    			    		}
				    		    			    	}else{
				    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    		    			    	}
				        			    		}else{
				        			    			$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				        			    		}
				    	    			    }
				    			    	}else{
				    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    			    	}
				    			    	
				    				}
				    				
				    			}
				    			
				    		});
			    		}
		    		}
		    	}
		    	else if(result[0]==1){
		    		that.keyInfo = result;
		    		//$rootScope.openLog = result;
		    	}
		    	else if(result[0]==4){
		    		var date = new Date();
					var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
			    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
			    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
			    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
			    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
		    		//判断是否开锁维护状态
		    		if(that.isMain){
		    			var ymd = date.getFullYear() + "-" + month + "-" + day;
				    	var hms = hours + ":" + minutes + ":" + seconds;
			    		$rootScope.openLog = "用户" + window.localStorage.userName + "于" + ymd + " " + hms +"有开启智能锁。";
			    		if(that.online){

			    			hlService.home.savePubHisData().save({
				          		userId : window.localStorage.userId, 
				          		lockId : $rootScope.lockId,
				          		optDate : (date/1000).toFixed(0)
				          	},function(res){
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n保存开锁日志—— (6)\r\n\r\n");
				          	});
			    		}else{
			    			var hisRecord = JSON.parse(window.localStorage.hisData);
			    			var record = {
		    					userId : window.localStorage.userId, 
				          		lockId : $rootScope.lockId,
				          		optDate : (date/1000).toFixed(0)	
			    			}
		    				window.localStorage.hisData = JSON.stringify(hisRecord.concat(record));
		    				$rootScope.showPopup("已缓存开锁记录!!!");
			    		}
		    		}
		    	}
		    },
		    /**
			 * 写数据,外传回调函数
			 * */
		    sendData1 : function(data, fn, efn){
				ble.write($rootScope.bluetooth.deviceId, $rootScope.bluetooth.serviceUUID, $rootScope.bluetooth.characteristicUUID,
	    				$rootScope.bluetooth.stringToBytes(data).buffer, fn,efn);
			},
		    /**
			 * 写数据
			 * */
		    sendData : function(data){
				ble.write($rootScope.bluetooth.deviceId, $rootScope.bluetooth.serviceUUID, $rootScope.bluetooth.characteristicUUID,
	    				$rootScope.bluetooth.stringToBytes(data).buffer, function(res){
					
				},function(){
					$rootScope.bluetooth.status = "传送数据失败";
				});
			},
		    disconnect : function(){
		    	ble.disconnect($rootScope.bluetooth.deviceId,function(){
		    		$rootScope.bluetooth.status = "未连接";
				},function(){});
		    },
		    isConnected : function(deviceId,fn,efn){
		    	ble.isConnected(deviceId,fn,efn);
		    }
	    };
		return Bluetooth;
	
});

angular.module('btapp.controllers').service('CONSTANT', function($ionicLoading,$rootScope,$ionicPopup) {
	this.msg = "提示信息";
	this.duration = 3000;
    this.currentLat = "";
    this.currentLon = "";
	this.showConfirm = function(msg){
        $ionicPopup.confirm({
            title: '提示',
            template: msg,
            buttons : [{
                text : '确定',
                onTap : function(e){
                    alert("确定");
                }
            }]
        });
    };
	this.msgShow = function(msg,duration) {
		if(msg != null){
			this.msg = msg;
		}
		if(duration != null){
			this.duration = duration;
		}
		$ionicPopup.show({
            title : constantDefine.tips,
			template : this.msg,
			buttons : [{
                text : '确认',
                type: 'button-default',
                onTap : function(e){

                }
            }]
		});
    };
    
    this.msgHide = function(){
       $ionicLoading.hide();
	};
    
    this.getBaiduMapLocation = function(fn){
        var that = this;
        
        if(window.cordova != undefined){
            
            //先尝试gps定位，再用百度地图API功能 定位
            window.cordova.plugins.diagnostic.isLocationAvailable(function(available){
                
                if(available){
                    if(navigator.geolocation ){
                
                        navigator.geolocation.getCurrentPosition(function(position){
                            that.translatePoint(position,fn);
                        },function(res){
                        
                            if(res.code == 1){
                                that.msgShow("提示：地理位置授权未开启，请在手机设置中将应用权限打开,否则会影响部分功能使用。");
                                fn(null);
                            } else if(res.code == 2){
                            that.msgShow("提示：地理位置获取异常。");
                                fn(null);
                            } else if(res.code == 3){
                                that.msgShow("提示:GPS信号弱。");
                                fn(null);
                            } else {
                                that.locationError(res);
                            }
                            
                        },{ timeout:30000,enableHighAccuracy:true }); //通过手机的webKit定位（目前ios系统对非https网站不提供支持）,所以在locationError（）中使用BMap.Geolocation()
                    }
                    else{
                        
                        that.msgShow('浏览器不支持html5来获取地理位置信息');
                    }
                } else {
                    
                    that.msgShow("地理位置功能未开启,请在设置中将本应用的地理位置权限开启,否则会影响部分功能使用。");
                    
                }
            }, function(error){
                
                that.msgShow("地理位置功能未开启,请在设置中将本应用的地理位置权限开启，否则会影响部分功能使用。");
            });
        }
        
    };
    
    this.translatePoint = function(position,fn){
        
        currentLat = position.coords.latitude;
        currentLon = position.coords.longitude;
       
        var gpsPoint = new BMap.Point(currentLon, currentLat);
       
        window.BMap.Convertor.translate(gpsPoint, 0, function(point){
           
            fn(point);
        }); //转换坐标

    };
    
    this.locationError = function(fn){
        var geolocation = new BMap.Geolocation();
        geolocation.getCurrentPosition(function(r){
            if(this.getStatus()== BMAP_STATUS_SUCCESS){
                currentLat = r.point.lat;
                currentLon = r.point.lng;
                var gpsPoint = new BMap.Point(currentLon, currentLat);
                BMap.Convertor.translate(gpsPoint, 0, function(point){
                    fn(point);
                }); //转换坐标
            }
        });
    };
    this.privateMsg = "<p>&nbsp;&nbsp;&nbsp;&nbsp;  欢迎使用华立云锁App，您在使用本产品前，请认真阅读本<a href='javascript:void(0);' ng-click='"
                    + 'openLink("https://www.epowerplat.com/bllock/index.html")'
                    + "'><<隐私政策>></a>，通过隐私政策向您说明如下内容：</p>"
                    + "<p>一、我们如何收集和使用您的个人信息</p>"
                    + "<p>二、我们如何共享、转让、公开披露您的个人信息</p>"
                    + "<p>三、我们如何如何保护您的个人信息</p>"
                    + "<p>四、您管理个人信息的权力</p>"
                    + "<p>五、未成年人个人信息保护</p>"
                    + "<p>六、隐私政策的适用范围</p>"
                    + "<p>七、隐私政策的变更和修订</p>"
                    + "<p>八、如何联系我们</p>"
                    + "<p>九、隐私政策的生效</p>"
                    + "<p>&nbsp;&nbsp;&nbsp;&nbsp;  我们将按业界成熟的安全标准，采取相应的安全保护措施来保护您的个人信息，请您放心授权并同意我们收集和处理您的个人信息。若您不同意本隐私政策，将会影响应用的使用。</p>"
                    ;
    this.showPrivateMsg = function(){
        
        $ionicPopup.show({
            title: '温馨提示',
            template: this.privateMsg,
            buttons : [{
                text : '不同意',
                type: 'button-default',
                onTap : function(e){
                    console.log("不同意");
                }
            },{
                text : '同意',
                type: 'button-positive',
                onTap : function(e){
                    window.localStorage.firstFlag=true;
                    console.log("同意");
                }
            }]
        });
    };
	
    return this;
});

//2018-12-14
(function(){        //闭包
function load_script(xyUrl, callback){
    var head = document.getElementsByTagName('head')[0];
    var script = document.createElement('script');
    script.type = 'text/javascript';
    script.src = xyUrl;
    //借鉴了jQuery的script跨域方法
    script.onload = script.onreadystatechange = function(){
        if((!this.readyState || this.readyState === "loaded" || this.readyState === "complete")){
            callback && callback();
            // Handle memory leak in IE
            script.onload = script.onreadystatechange = null;
            if ( head && script.parentNode ) {
                head.removeChild( script );
            }
        }
    };
    // Use insertBefore instead of appendChild  to circumvent an IE6 bug.
    head.insertBefore( script, head.firstChild );
}
function translate(point,type,callback){
    var callbackName = 'cbk_' + Math.round(Math.random() * 10000);    //随机函数名
    var xyUrl = "https://api.map.baidu.com/ag/coord/convert?from="+ type + "&to=4&x=" + point.lng + "&y=" + point.lat + "&callback=BMap.Convertor." + callbackName;
    //动态创建script标签
    load_script(xyUrl);
    BMap.Convertor[callbackName] = function(xyResult){
        console.log(xyResult.x + "," + xyResult.y);
        delete BMap.Convertor[callbackName];    //调用完需要删除改函数
        var point = new BMap.Point(xyResult.x, xyResult.y);
        callback && callback(point);
    }
}

window.BMap = window.BMap || {};
BMap.Convertor = {};
BMap.Convertor.translate = translate;
})();
angular.module('btapp.services').factory('APIHandler', function($resource, $log, ENV) {

  var isLocal = ENV.api === "local";

  return {
    handle: function(apiName, params, method, responseType) {
      var url = ENV.api + "/" + apiName;
      if (isLocal) {
        url = "data/" + apiName + ".json";
      }
      method = method || "get";
      responseType = responseType || "json";
      if (isLocal) {
        return $resource(url);

      } else {
        if (method === "post") {
          return $resource(url, {}, {
            apiName: {
              params: params,
              method: method,
              responseType : responseType
            }
          });
        } else {
          return $resource(url, params, {
            apiName: {
              method: method,
              responseType : responseType
            }
          });
        }
      }
    }
  };
});
/*
 * --leaf 2020-04-26 --
 * 1.创建service(服务),可以在整个应用中共享，只需要导入服务名即可。
 * 2.作用：获取分页数据。
 * 3.用法：;
 */
angular.module('btapp.services').factory('HLPages', function() {
	var hl_pages = {

		/**
		 * 起始页
		 */
		start : 0,

		/**
		 * 每页显示限制量
		 */
		limit : 10,

		noData : false,

	  	hasNextPage : false,
	 
		dataList : [],
		  
		queryDataList : function(getDataList,params,success,error){
			var that = this;
			getDataList(params).query(function(res){
				
				if(res){
					if(res.length == 0){
						that.noData = true;
						that.hasNextPage = false;
						if(that.dataList.length == 0){
							that.noData = true; //无相关分页结果集
						} else {
							that.noData = false; 
						}
					} else {
						if(res.length < that.limit){
							that.hasNextPage = false;
						} else {
							that.hasNextPage = true;
						}
						that.noData = false;
						for(var i=0;i<res.length;i++){
							that.dataList.push(res[i]);
						}

					}
				} else {
					that.hasNextPage = false;
					that.noData = true;
				}

				success(that.dataList);

			},function(res){
				error();
			});
		},

		doRefresh : function(getDataList,params,success,error){
			
			var that = this;
			that.dataList = [];
			that.start = 0;
			params.start = that.start;
			if(params.limit == null){
				params.limit = that.limit;
			}
			that.queryDataList(getDataList,params,success,error);
		},

		doLoadMore : function(getDataList,params,success,error){
			
			var that = this;
			if(params.limit == null){
				params.limit = that.limit;
			}
			if(that.dataList.length !=0 ){
				that.start = params.start + 1;
				params.start = that.start;
			}else{
				that.start = 0;
				params.start = that.start;
			}
			that.queryDataList(getDataList,params,success,error);
		}
	  
		
	};
    return hl_pages;
});
/*
 * --leaf 2020-04-24 --
 * 1.创建service(服务),可以在整个应用中共享，只需要导入服务名即可。
 * 2.作用：参数非法判断。
 * 3.用法：;
 */
angular.module('btapp.services').factory('HLVALIDATE', function() {
	var hl_validate = {

		/**
		 * 非法描述
		 */
		errorMsg : 'leaf',

		/**
		 * 必须包含字母数字特殊符号三种组合的正则表达式，8~20位
		 */
		NAME_REGX : /^(?=.*\d)(?=.*[a-zA-Z])(?=.*[~!@#$%^&*])[\da-zA-Z~!@#$%^&*]{8,20}$/,

		/**
		 * 手机号验证
		 */
		PHONE_REGX : /^1(3|4|5|7|8|9)\d{9}$/,

		/***
		 * 用户名或密码信息复杂度判断：
		 * 
		 * 至少大写字母、小写字母、数字、特殊字符中的三种组合
		 * 长度下限不能低于8位
		 * 长度上限不能超过20位
		 * 
		 * account: 待校验字符串
		 * 
		 * desc : 待校验字符串描述，用于信息提示中
		 
		 */
		judge_Account : function(account,desc){
			var that = this;			
			var paramDesc = "用户名";

			if(desc != null){
				paramDesc = desc;
			}
		
			if(account == null || account == "" || account == undefined){
				that.errorMsg = "请先输入" + paramDesc;
				
				return false;
			}
			
			if(account.length < 8){
				that.errorMsg = paramDesc + "长度不能低于8位";
				return false;
			}
			if(account.length > 20){
				that.errorMsg = paramDesc + "长度不能高于20位";
				return false;
			}

			if(!account.match(that.NAME_REGX)){
				that.errorMsg = paramDesc + "必须由字母数字及特殊符号组成，特殊符号包括~!@#$%^&";
				return false;
			}

			return true;
		},

		/**
		 * 密码除信息复杂度验证外，与用户名的相关判断
		 * 禁止用户口令与用户名相同
		 * 禁止用户口令包含用户名 
		 */
		judge_passwordSameName : function(password,userName){
			var that = this;
			if( password == userName || password.indexOf(userName) != -1 ){
				that.errorMsg = "密码不能与用户名相同或包含用户名";
				return true;
			}
			return false;
		},

		/**
		 * 判断手机号是否合法
		 */
		judge_isPhoneNum : function(number){
			var that = this;
			if(number == null){
				that.errorMsg = "请先输入手机号";
				return false;
			}
			if(!number.match(that.PHONE_REGX)){
				that.errorMsg = "请填写正确手机号";
				return false;
			}
			return true;
		} 


	};
    return hl_validate;
});
angular.module('btapp.services').factory('hlService', function(APIHandler) {
	return {
		//首页模块
		home:{
		  getDeviceByLockId : function(lockId){
			  return APIHandler.handle("home/getDeviceByLockId/:lockId",{
				  lockId : lockId
			  });
		  },			
		  //开锁记录  新版模块(管理查看权限扩展)---start----fangrong.wu--2017-7-11
		  getPubHisDataListByAdminPeople : function(sysId){
			  return APIHandler.handle("home/getPubHisDataListByAdminPeople/:sysId",{
				  sysId : sysId
			  });
		  },
		  getPubHisDataListByAdminPeopleByUserId : function(userId){
			  return APIHandler.handle("home/getPubHisDataListByAdminPeopleByUserId/:userId",{
				  userId : userId
			  });
		  },
		  getPubHisDataListByAdminDevice : function(sysId){
			  return APIHandler.handle("home/getPubHisDataListByAdminDevice/:sysId",{
				  sysId : sysId
			  });
		  },
		  getPubHisDataListByAdminDeviceByDeviceId : function(deviceId){
			  return APIHandler.handle("home/getPubHisDataListByAdminDeviceByDeviceId/:deviceId",{
				  deviceId : deviceId
			  });
		  },
		  //----------开锁记录  新版模块--------------end---------------fangrong.wu
		  
		  //-----------新版开锁模块：--start--根据钥匙获取的锁的ID，到这张表里面匹配lockid，能够匹配到就能打开锁
		  getDeviceIsOpenByLockId : function(lockId,sysId){
			  return APIHandler.handle("home/getDeviceIsOpenByLockId/:lockId/:sysId",{
				  lockId : lockId,
				  sysId : sysId
			  });
		  },		  
		  //--------新版开锁模块------end------------------------------
		  
		  getPermissionListCount : function(userId){
			  return APIHandler.handle("home/getPermissionCountByUserId/:userId",{
				  userId : userId
			  });
		  },
		  getPermissionListByUserId : function(userId){
			  return APIHandler.handle("home/getPermissionListByUserId/:userId",{
				  userId : userId
			  });
		  },
		  getPermissionPagesByUserId : function(userId, start, limit) {
			  return APIHandler.handle("home/getPermissionPagesByUserId/:userId/:start/:limit",{
				  userId : userId,
				  start : start,
				  limit : limit
			  });
		  },
		  getPubHisDataListByUserId : function(userId, start, limit){
			  return APIHandler.handle("home/getPubHisDataListByUserId/:userId/:start/:limit",{
				  userId : userId,
				  start : start,
				  limit : limit
			  });
		  },
		  getPubHisDataListBySysId : function(sysId, start, limit){
			  return APIHandler.handle("home/getPubHisDataListBySysId/:sysId/:start/:limit",{
				  sysId : sysId,
				  start : start,
				  limit : limit
			  });
		  },
		  getPubLocksetByUserId : function(userId){
			  return APIHandler.handle("home/getPubLocksetByUserId/:userId",{
				  userId : userId
			  });
		  },
		  getDeviceSelectsByUserId : function(userId){
			  return APIHandler.handle("home/getDeviceSelectsByUserId/:userId",{
				 userId : userId 
			  });
		  },
		  getPubLocksetNumByLockId : function(lockId){
			  return APIHandler.handle("home/getPubLocksetNumByLockId/:lockId",{
				 lockId : lockId 
			  });
		  },
		  getPubLocksetByLockId : function(lockId){
			  return APIHandler.handle("home/getPubLocksetByLockId/:lockId",{
				 lockId : lockId 
			  });
		  },
		  getPubAreaData : function(){
			  return APIHandler.handle("home/getPubAreaData");
		  },
		  savePubHisData : function(){
			  return APIHandler.handle("home/savePubHisDataByUserLockId",{},'post');
		  },
		  savePubHisDataList : function(){
			  return APIHandler.handle("home/savePubHisDataList",{},"post");
		  },
		  savePubLocksetData : function(){
			  return APIHandler.handle("home/savePubLocksetData",{},"post");
		  },
		  savePubLocksetFromCache : function() {
			  return APIHandler.handle("home/savePubLocksetFromCache",{},"post");
		  },
		  savePubDeviceFromCache : function() {
			  return APIHandler.handle("home/savePubDeviceFromCache",{},"post");
		  },
		  //------挂锁旧模块：接口保存，旧版使用--2017-7-11
		  updateInstallLocksetData : function(){
			  return APIHandler.handle("home/updateInstallLocksetData",{},"post");
		  },
		  //-----挂锁新版模块：新版使用。select-->input:update->insert--fangrong.wu--2017-7-11
		  saveInstallLocksetData : function(){
			  return APIHandler.handle("home/saveInstallLocksetData",{},"post");
		  },
		  updateRecoverLocksetData : function(){
			  return APIHandler.handle("home/updateRecoverLocksetData",{},"post");
		  },
		  updateRecoverLocksetDataList : function(){
			  return APIHandler.handle("home/updateRecoverLocksetDataList",{},"post");
		  },
		  updateKeysByKeyName : function(){
			  return APIHandler.handle("home/updateKeysByKeyName",{},"post");
		  },
		  savePubDeviceDataList : function(){
			  return APIHandler.handle("home/savePubDeviceDataList",{},"post");
		  },
		  getPubLocksetByPoint : function(userId,startLng,endLng,startLat,endLat){
			  return APIHandler.handle("home/getPubLocksetByPoint/:userId/:startLng/:endLng/:startLat/:endLat",{
				  userId : userId,
				  startLng : startLng,
				  endLng : endLng,
				  startLat : startLat,
				  endLat : endLat
			  });
		  },
		  getLockUserRelByUserIdLockId : function(lockId,userId){
			  return APIHandler.handle("home/getLockUserRelByUserIdLockId/:lockId/:userId",{
				 lockId : lockId,
				 userId : userId
			  });
		  },
		  getDeviceUserRelByUserIdLockId : function(lockId,userId){
			  return APIHandler.handle("home/getDeviceUserRelByUserIdLockId/:lockId/:userId",{
				 lockId : lockId,
				 userId : userId
			  });
		  },
		  getDeviceUserRelByUserId : function(userId){
			  return APIHandler.handle("home/getDeviceUserRelByUserId/:userId",{
				 userId : userId
			  });
		  },		  
		  getDeviceInstalled : function(deviceId){
			  return APIHandler.handle("home/getDeviceInstalled/:deviceId",{
				 deviceId : deviceId
			  });
		  },
		  syncSeverTime : function(random) {
			  return APIHandler.handle("home/syncSeverTime/:random",{
				  random : random
			  });
		  },
		  /**
		   * 用户所在系统下所有钥匙参数
		   * */
		  getPubBlKeyListByUserId : function(userId,keyWord,start,limit){
			  return APIHandler.handle("home/getPubBlKeyPagesList/:userId/:keyWord/:start/:limit",{
				  userId : userId,
				  keyWord : keyWord,
				  start : start,
				  limit : limit
			  });
		  },
		  savePubBlKey : function(){
			  return APIHandler.handle("home/savePubBlKey",{},"post");
		  },
		  deletePubBlKey : function(){
			  return APIHandler.handle("home/deletePubBlKey",{},"post");
		  },
		  /**
		   * 获取用户所在系统下所有设备参数
		   * */
		  getPubDeviceListBySysId : function(sysId,devName,start,limit){
			  return APIHandler.handle("home/getPubDeviceListBySysIdAndPages/:sysId/:devName/:start/:limit",{
				  sysId : sysId,
				  devName : devName,
				  start : start,
				  limit : limit
			  });
		  },
		  savePubDevice : function(){
			  return APIHandler.handle("home/savePubDevice",{},"post");
		  },
		  deletePubDevice : function(){
			  return APIHandler.handle("home/deletePubDevice",{},"post");
		  },
		  /**
		   * 获取用户所在系统下所有区域参数
		   * */
		  getPubAreaDataBySysId : function(sysId){
			  return APIHandler.handle("home/getPubAreaDataBySysId/:sysId",{
				  sysId : sysId
			  });
		  },
		  getTeamUserListBySysId : function(sysId,name,start,limit){
			  return APIHandler.handle("home/getTeamUserListBySysIdAndPages/:sysId/:name/:start/:limit",{
				  sysId : sysId,
				  name : name,
				  start : start,
				  limit : limit
			  });
		  },
		  /**
		   * 获取班组参数
		   * */
		  getUserGroupBySysId : function(sysId){
			  return APIHandler.handle("home/getUserGroupBySysId/:sysId",{
				  sysId : sysId
			  });
		  },
		  /**
		   * 获取职务参数
		   * */
		  getUserTitleBySysId : function(sysId){
			  return APIHandler.handle("home/getUserTitleBySysId/:sysId",{
				  sysId : sysId
			  });
		  },
		  /**
		   * 保存用户参数配置
		   * */
		  saveTeamUserData : function(){
			  return APIHandler.handle("home/saveTeamUserData",{},"post");
		  },
		  /**
		   * 删除用户信息
		   * */
		  deleteTeamUser : function(){
			  return APIHandler.handle("home/deleteTeamUser",{},"post");
		  },
		  getPermissionListBySysId : function(sysId,keyWord,start,limit){
			  return APIHandler.handle("home/getPermissionListBySysIdAndPages/:sysId/:keyWord/:start/:limit",{
				  sysId : sysId,
				  keyWord : keyWord,
				  start : start,
				  limit : limit
			  });
		  },
		  deleteDeviceUserRelations : function(){
			  return APIHandler.handle("home/deleteDeviceUserRelations",{},"post");
		  },
		  /**
		   * 保存权限参数配置
		   * */
		  savePermissionData : function(){
			  return APIHandler.handle("home/saveDeviceUserRelationData",{},"post");
		  },
		  /**
		   * 保存区域参数配置
		   * */
		  savePubArea : function(){
			  return APIHandler.handle("home/savePubArea",{},"post");
		  },
		  deletePubAreaData : function(){
			  return APIHandler.handle("home/deletePubAreaData",{},"post");
		  },
		  /**
		   * 保存班组参数配置
		   * */
		  saveUserGroup : function(){
			  return APIHandler.handle("home/saveUserGroup",{},"post");
		  },
		  deleteUserGroupData : function(){
			  return APIHandler.handle("home/deleteUserGroupData",{},"post");
		  },
		  /**
		   * 保存职务参数配置
		   * */
		  saveUserTitle : function(){
			  return APIHandler.handle("home/saveUserTitle",{},"post");
		  },
		  deleteUserTitleData : function(){
			  return APIHandler.handle("home/deleteUserTitleData",{},"post");
		  }
		},
	    //用户模块
	    user: {
	      //获取用户摘要信息,包含 用户信息，告警信息数量，任务数量...
	      summary: function(userId) {
	        return APIHandler.handle("user_summary", {
	          userId: userId
	        });
	      },

	      //获取用户详细信息
	      info: function(userId) {
	        return APIHandler.handle("auth/info/:userId", {
	          userId: userId
	        });
	      },

	      //获取用户电站信息
	      station: function(stattionId) {
	        return APIHandler.handle("user_station", {
	          userId: userId
	        });
	      },

	      //用户消息设置
	      messageSetting: function(userId) {
	        return APIHandler.handle("user_message_setting", {
	          userId: userId
	        });
	      },

	      //用户任务设置
	      taskSetting: function(userId) {
	        return APIHandler.handle("user_task_setting", {
	          userId: userId
	        });
	      },

	      //修改用户名
	      updateUserName: function(userId, userName) {
	        return APIHandler.handle("user_update_userName", {
	          userId: userId,
	          userName: userName
	        }, "post");
	      },

	      //修改用户密码
	      updatePassword: function(userId, password) {
	        return APIHandler.handle("user_update_password", {
	          userId: userId,
	          password: password
	        }, "post");
		  },
		  

	      //修改用户信息,包含 手机号码，邮箱，以及其他信息
	      updateUserInfo: function(userId, userInfo) {
	        return APIHandler.handle("user_update_userInfo", {
	          userId: userId,
	          userInfo: userInfo
	        }, "post");
	      },

	      //用户登录
	      /*login: function(groupName, userName, password) {
	        return APIHandler.handle("user_login", {
	          userName: userName,
	          password: password,
	          groupname: '用电用户',
	          isDebug : 'true'
	        },"POST");
	      },*/
	      
			// 用户登录
		  login : function() {
			return APIHandler.handle("auth/login",{},'post');
		  },
		  //根据用户名修改密码
		  resetPasswordByName : function(){
			return APIHandler.handle("auth/updatePasswordByName", {},"post");
		  },

		  //根据旧密码修改密码
		  updatePasswordByOldPassword : function(){
			  return APIHandler.handle("auth/updatePasswordByOldPassword", {},"post");
		  },
		  initUsersPassword : function(){
			return APIHandler.handle("auth/initUsersPassword", {},"post");
		  },
				
	      //用户退出
	      logout: function() {
	        return APIHandler.handle("user_logout");
	      },

	      //忘记密码
	      forgetPassword: function(userName) {
	        return APIHandler.handle("user_forget", {
	          userName: userName
	        });
	      },

	      //注册
	      register: function(userInfo) {
	        return APIHandler.handle("user_register", {
	          userInfo: userInfo
	        }, "post");
	      },
		  getPermissionsAndDevicesAndLocksetsByUserId : function(userId) {
			  return APIHandler.handle("auth/getPermissionsAndDevicesAndLocksetsByUserId/:userId",{
				  userId : userId
			  });
		  }
	    },
	    // app 版本
	    appVersion : {
	    	// 获取发布的版本
	    	release : function(downloadDir) {
	    		return APIHandler.handle("version/release/:downloadDir",{
	    			downloadDir : downloadDir
	    		});
	    	}
	    },
	    // 实时数据请求
	    proxyToWebHmi : {
	    	request : function(para) {
	    		return APIHandler.handle("proxyToWebHmi/request/:para", {
		          para: para
		        });
	    	}
	    }
	  };
});
